package com.connor.hs2.plm.PFMEA.design;

import java.awt.BorderLayout;
import java.awt.Color;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.UUID;

import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.plaf.metal.MetalProgressBarUI;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFCommand;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.commands.reserve.ReserveOperation;
import com.teamcenter.rac.kernel.TCAccessControlService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentGroup;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentMEProcess;
import com.teamcenter.rac.kernel.TCComponentRole;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class DesignPFMEACommand extends AbstractAIFCommand {

	private TCSession session;
	private AbstractAIFApplication app;
	private InterfaceAIFComponent comp;
	private TCComponentItem meprocess;
	private TCComponentItemRevision pfmeaRev;
	private TCComponentItem item;
	private boolean isOwning = false;
	private JFrame frame = new JFrame("ڼ...");//
	private JProgressBar progressBar = new JProgressBar();//
	private String[] properName = new String[] { 
			"hs2_companyName",//˾
			"hs2_project", // Ŀ
			"hs2_address",// ַ
			"hs2_pfmeaStart_date",// PFMEAʼ
			"hs2_pfmeaUpdate_date",// PFMEA޶
			"hs2_processDuty",// ְ
			"hs2_customerName",// ˿
			"hs2_pfmeaKey_date",// ܼ
			"hs2_modelPlatform",// /ƽ̨
			"hs2_functionalTeams" // ְŶ
			,"hs2_productCode"};//Ʒ

	private Map<int[], int[]> combineMap = new HashMap<int[], int[]>();// źϲԪ
	//private Map<int[], int[]> combineMap2 = new HashMap<int[], int[]>();// źϲԪ
//	private TCProperty[] properties;
	private TCProperty[] itemProperties;
	// private List<List<Integer>> processRowList = new
	// ArrayList<List<Integer>>();
	private List<Integer> processRows = new ArrayList<Integer>();
	private TCComponentUser user;// ǰ¼û
	private List<List<Object>> dataList = new ArrayList<List<Object>>();// PFMEAе
	private List<List<String>> dataList2 = new ArrayList<List<String>>();// PFMEAݿе

	private List<String> plmeidList = new ArrayList<String>();// ItemId
	private String UID;
	private boolean isRelease=false;
	private boolean isReimport;
	public DesignPFMEACommand() {
		super();
	}

	public DesignPFMEACommand(AbstractAIFApplication app, TCSession session,String UID,
			TCComponentItem meprocess,boolean isReimport,TCComponent comp) {
		this.session = session;
		this.app = app;
		this.comp = comp;
		this.pfmeaRev = (TCComponentItemRevision)comp;
		this.user = session.getUser();
		this.UID=UID;
		this.meprocess = meprocess;
		this.isReimport = isReimport;
	}
	/**
	 * ȡݿе
	 */
	private void getData() {
		// TODO Auto-generated method stub
		ResultSet rs = null;
		ResultSet rs2 = null;
		ResultSet rs21 = null;
		InputStream input = null;
		try {
			// ȡݿ
			SqlUtilT.getTCConnection();
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			if (meprocess != null) {
				String sql = String.format(pro.getProperty("SETPFMEASELECT"),
						meprocess.getUid(),comp.getUid());
				rs = SqlUtilT.read(sql);
				String sql2 = String.format(pro.getProperty("PFMEALIBRARYSELECT2"),
						comp.getUid());
				rs2 = SqlUtilT.read(sql2);
				//1
				int num=rs.getFetchSize()/80;
				int num1=1;
				int num2=0;
				while (rs.next()) {
					//++++
					if(num2==num*num1) {
						progressBar.setValue(num1+10);
						num1++;
					}
					num2++;
					//+++
					List<Object> rowList = new ArrayList<Object>();
					rowList.add(rs.getString("PLMEID"));
					rowList.add(rs.getString("GYBH"));//GYBHš⡱
					rowList.add(rs.getString("GCMC"));//GCMCʷȨ
					rowList.add(rs.getString("STATION"));
					rowList.add(rs.getString("REQUIREMENT"));
					rowList.add(rs.getString("QZSXMS"));
					rowList.add(rs.getString("QZSXHG"));
					rowList.add(rs.getString("YZD"));
					rowList.add(rs.getString("JB"));
					rowList.add(rs.getString("QZSXQY"));
					rowList.add(rs.getString("XXGCKZYF"));
					rowList.add(rs.getString("PDS"));
					rowList.add(rs.getString("XXGCKZTC"));
					rowList.add(rs.getString("TCD"));
					rowList.add(rs.getString("RPN"));
					rowList.add(rs.getString("JYCS"));
					rowList.add(rs.getString("ZZR"));
					rowList.add(rs.getString("JHWCRQ"));
					rowList.add(rs.getString("CQDCS"));
					rowList.add(rs.getString("NEW_SEV"));
					rowList.add(rs.getString("NEW_OCC"));
					rowList.add(rs.getString("NEW_DET"));
					rowList.add(rs.getString("NEW_RPN"));
					rowList.add(rs.getString("IDEAL_STATE"));
					rowList.add(rs.getString("SPECIAL"));
					rowList.add(rs.getInt("HH"));//25
					rowList.add(rs.getString("HBDYG"));//26
					rowList.add(rs.getInt("HHC"));//27
					rowList.add(rs.getString("OCCURRRENCE"));
					rowList.add(rs.getString("DETECTION"));
					rowList.add(rs.getString("PRIORITY"));
					rowList.add(rs.getString("P1"));
					rowList.add(rs.getString("P2"));
					rowList.add(rs.getString("P3"));
					rowList.add(rs.getString("P4"));
					rowList.add(rs.getString("P5"));
					rowList.add(rs.getString("NO"));
					dataList.add(rowList);
				}
				
				//2
				while(rs2.next()) {
					List<String> rowList2=new ArrayList<String>();
					rowList2.add(rs2.getString("PLMID"));
					rowList2.add(rs2.getString("NUM"));
					rowList2.add(rs2.getString("P1"));
					rowList2.add(rs2.getString("P2"));
					rowList2.add(rs2.getString("P3"));
					rowList2.add(rs2.getString("P4"));
					rowList2.add(rs2.getString("P5"));
					rowList2.add(rs2.getString("P6"));
					rowList2.add(rs2.getString("P7"));
					rowList2.add("");
					rowList2.add("");
//					rowList2.add(rs2.getString("HBDYG")); //9
//					Integer sscInteger=rs2.getInt("HHC");
//					rowList2.add(sscInteger.toString()); //10
					dataList2.add(rowList2);
				}
				System.out.println("dataList2.size()"+dataList2.size());
				if(dataList2.size()==0) {
					Date now = new Date();
//			        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//Է޸ڸʽ
					SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyyMMddHHmmss");
					String time = dateFormat1.format(now);
					UUID uuid = UUID.randomUUID();
					String uid=uuid.toString().replace("-", "");
					//ݵݿ
					String insert = "insert into AHMC_PFMEALIBRARY values(?,?,?,?,?,?,?,?,?,?,?,?)";
					SqlUtilT.getTCConnection();
					SqlUtilT.write(new String[] {uid,comp.getUid(),null,null,null,null,null,null,null,null,null,time}
							,insert);
					List<String> rowList2=new ArrayList<String>();
					rowList2.add(uid);
					rowList2.add(time);
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					rowList2.add("");
					dataList2.add(rowList2);
				}
				// е,ȡǰû޸ĵк
				String userName = pfmeaRev.getReferenceProperty("owning_user")
						.getStringProperty("user_id");
//				// жǷ񷢲
//				boolean isRelease = item.getLatestItemRevision().getProperty(
//						"release_status_list") != "";
				
				//+++
				for (int i = 0; i < dataList.size(); i++) {
					// кŲ
//					dataList.get(i).set(27,i- Integer.parseInt(dataList.get(i).get(25).toString()));
					if(user.getGroups()[0].getGroupName().equals("dba"))
					{
						isOwning = true;
						processRows.add(i);
						plmeidList.add(dataList.get(i).get(0).toString());
						continue;
					}
					else if (isRelease && !user.getGroups()[0].getGroupName().equals("dba")) 
					{
						continue;
					}
					if (user.getUserId().equals(userName)) {
						isOwning = true;
						processRows.add(i);
						plmeidList.add((String) dataList.get(i).get(0));
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}
	}


	public void getCombineMap() {
		try {
			if (dataList != null && dataList.size() > 0) {
				for (int i = 0; i < dataList.size(); i++) {
					if (dataList.get(i).get(26) != null
							&& !dataList.get(i).get(26).equals("")) {
						String sombine = dataList.get(i).get(26).toString();
						int rowDif = Integer.parseInt(dataList.get(i).get(27)
								.toString());
						String[] sombines;
						if (sombine.indexOf("-") >= 0) {
							sombines = sombine.split("-");
						} else {
							sombines = new String[] { sombine };
						}
						for (int j = 0; j < sombines.length; j++) {
							if (sombines[j].indexOf("/") >= 0) {
								int[] row;
								int[] cloumn;
								String[] cells = sombines[j].split("/");
								if (cells[0].indexOf(",") >= 0) {
									String[] rows = cells[0].split(",");
									row = new int[rows.length];
									for (int k = 0; k < rows.length; k++) {
										row[k] = Integer.parseInt(rows[k])
												+ rowDif;
									}
								} else {
									row = new int[] { Integer
											.parseInt(cells[0]) + rowDif };
								}
								if (cells[1].indexOf(",") >= 0) {
									String[] cloumns = cells[1].split(",");
									cloumn = new int[cloumns.length];
									for (int k = 0; k < cloumns.length; k++) {
										cloumn[k] = Integer
												.parseInt(cloumns[k]);
									}
								} else {
									cloumn = new int[] { Integer
											.parseInt(cells[1]) };
								}
								this.combineMap.put(row, cloumn);
							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public void executeModal() throws Exception {
		//+++++++жǷ񷢲
		 isRelease= comp.getProperty(
				"release_status_list") != "";
		//++++ûisReleaseΪfalseͿǷдȨ
		if(!isRelease) {
			  try {
			   TCComponentUser user = session.getUser();
			   TCComponentGroup group = session.getCurrentGroup();
			   TCComponentRole role = session.getCurrentRole();

			   TCComponent coms[] = { user, group, role };
			   TCAccessControlService service = session
			     .getTCAccessControlService();
			   boolean[] flags = service.checkAccessorsPrivileges(coms, (TCComponent) app.getTargetComponent(),
			     new String[] { "WRITE" });
			   for (boolean b : flags) {
			    if (!b) {
			    	//ûдȨ޾isReleaseΪtrueͲ༭
			    	isRelease = true;
			     break;
			    }
			   }
			  } catch (TCException e) {
			   e.printStackTrace();
			  }
		}
		if(!isRelease) {
			//жǷǩ
			if(((TCComponent) comp).isCheckedOut()) {
				MessageBox.post("PFMEAڱ༭(ǩ)", "", MessageBox.ERROR);
				return;
			}
			//ûǩڴʱǩ
			new ReserveOperation(new AIFComponentContext(comp,
						comp, "context")).executeModeless();
		}
		
		
		
		// ȡ汾
		try {
			
			
			//+++ӽ
			   frame.setSize(300, 70);
		       frame.setLocationRelativeTo(null);
		       frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		       frame.setLayout(new BorderLayout());
		       progressBar.setOrientation(JProgressBar.HORIZONTAL);
		       progressBar.setSize(300, 50);
		       progressBar.setMinimum(0);
		       progressBar.setMaximum(100);
		       progressBar.setBorderPainted(true);
		       progressBar.setUI(new MetalProgressBarUI());
		       progressBar.setBackground(Color.white);
		       progressBar.setForeground(Color.green);
		       progressBar.setStringPainted(true);
		       frame.setAlwaysOnTop(true);
		       frame.add(progressBar);
		       frame.setVisible(true);
		       progressBar.setValue(1);
		       //+++
			// ȡݿ
			ResultSet rs0 = null;
			ResultSet rs = null;
//			InputStream input = null;
			SqlUtilT.getTCConnection();
			InputStream input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			
			String revisionID=app.getTargetComponent().getProperty("item_revision_id");
			TCComponent[] Revisions=(((TCComponent) comp).getReferenceListProperty("revision_list"));
			
			//鿴ѡĿǷǵһδ򿪣޶İ汾Ͱ°汾ݸƸ
			String sql0 = String.format(pro.getProperty("SETPFMEASELECT"),
					meprocess.getUid(),comp.getUid());
			rs0 = SqlUtilT.read(sql0);
			
			int revs = ((TCComponentItemRevision)comp).getItem().getReferenceListProperty("revision_list").length;
			if(!revisionID.equalsIgnoreCase("01")&&!rs0.next()&&revs>1) {
				List<List<String>> addData=new ArrayList<List<String>>();
				try {
					SqlUtilT.getTCConnection();
					String sql = String.format(pro.getProperty("SETPFMEASELECT"),
							meprocess.getUid(),Revisions[Revisions.length-2].getUid());
					rs = SqlUtilT.read(sql);
					while (rs.next()) {
						List<String> rowList = new ArrayList<String>();
						rowList.add(UUID.randomUUID().toString().replace("-", ""));
						rowList.add(rs.getString("PROCESSPUID"));
						rowList.add(rs.getString("MEOPID"));
						rowList.add(rs.getString("GYBH"));
						rowList.add(rs.getString("GCMC"));
						rowList.add(rs.getString("STATION"));
						rowList.add(rs.getString("REQUIREMENT"));
						rowList.add(rs.getString("QZSXMS"));
						rowList.add(rs.getString("QZSXHG"));
						rowList.add(rs.getString("YZD"));
						rowList.add(rs.getString("JB"));
						rowList.add(rs.getString("QZSXQY"));
						rowList.add(rs.getString("XXGCKZYF"));
						rowList.add(rs.getString("PDS"));
						rowList.add(rs.getString("XXGCKZTC"));
						rowList.add(rs.getString("TCD"));
						rowList.add(rs.getString("RPN"));
						rowList.add(rs.getString("JYCS"));
						rowList.add(rs.getString("ZZR"));
						rowList.add(rs.getString("JHWCRQ"));
						rowList.add(rs.getString("CQDCS"));
						rowList.add(rs.getString("NEW_SEV"));
						rowList.add(rs.getString("NEW_OCC"));
						rowList.add(rs.getString("NEW_DET"));
						rowList.add(rs.getString("NEW_RPN"));
						rowList.add(rs.getString("IDEAL_STATE"));
//						Integer ssInteger=rs.getInt("HH");
						rowList.add(rs.getString("HH"));//rowList.add(rs.getInt("HH"));
						rowList.add(rs.getString("HBDYG"));
//						Integer sscInteger=rs.getInt("HHC");
						rowList.add(rs.getString("HHC"));//rowList.add(rs.getInt("HHC"));
						rowList.add(rs.getString("SPECIAL"));
						rowList.add(rs.getString("TYPE"));
						rowList.add(rs.getString("BAK"));
						rowList.add(rs.getString("OCCURRRENCE"));
						rowList.add(rs.getString("DETECTION"));
						rowList.add(rs.getString("PRIORITY"));
						rowList.add(rs.getString("P1"));
						rowList.add(rs.getString("P2"));
						rowList.add(rs.getString("P3"));
						rowList.add(rs.getString("P4"));
						rowList.add(rs.getString("P5"));
						rowList.add(comp.getUid());//ѡĶpuidݿREVISIONID
						rowList.add(rs.getString("NO"));
						addData.add(rowList);
					}
				}catch (Exception e) {
					MessageBox.post(e.toString(), "", MessageBox.ERROR);
					e.printStackTrace();
				}  finally {
					if (rs != null) {
						SqlUtilT.free(rs);
					}
					if (input != null) {
						try {
							input.close();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
					SqlUtilT.freeAll();
				}
				System.out.println(addData.toString());
				for(int i=0;i<addData.size();i++) {
					List<String> data=new ArrayList<String>();
					data=addData.get(i);
					String[] dataString=data.toArray(new String[]{});
					SqlUtilT.getTCConnection();
					String insertSQL = pro.getProperty("INSERTPFMEA");
					SqlUtilT.write(dataString, insertSQL);
				}
				
				getPropertys(Revisions[Revisions.length-2].getUid(),comp.getUid());
				
			}
			progressBar.setValue(5);
			//++++++++
			if(!isRevise) {
				getPropertys();
			}

			progressBar.setValue(10);
			
			if(isReimport) {
				Map<String,String> MEOPIDToNO  = new HashMap<String,String>();//ID
				List<String> meops = new ArrayList<String>();// ݿеĹID
				List<String> meopNos = new ArrayList<String>();// ݿеĹID
				List<String> meoplist = new ArrayList<String>();// ݿеĹID
				String sql = String.format(pro.getProperty("SETPFMEASELECT"),
						meprocess.getUid(),comp.getUid());
				ResultSet read = SqlUtilT.read(sql);
				while (read.next()) {
					
					MEOPIDToNO.put(read.getString("P4"), read.getString("P5"));
					meoplist.add(read.getString("P4"));
					
				}
				if(read!=null) {
					read.close();
				}
				SqlUtilT.freeAll();
				List<List<String>> properties = TMomMethodUtil.getPFMEABomPropertys(session, meprocess);
				for(List<String> propertie:properties) {
					meops.add(propertie.get(propertie.size()-2));
					meopNos.add(propertie.get(1));
				}
				
				for(int i=0;i<meoplist.size();i++) {
					if(!meops.contains(meoplist.get(i))) {
						// ȡݿ
						String deleteSQL = String.format("delete from AHMC_PFMEA where PROCESSPUID = '%s' AND P4='%s'",
								meprocess.getUid(),meoplist.get(i) );
						SqlUtilT.getTCConnection();
						SqlUtilT.delete(deleteSQL);
						SqlUtilT.freeAll();
					}
				}
				
				for(int i=0;i<meops.size();i++) {
					
					if(meoplist.contains(meops.get(i))) {
						String meopsNO = meopNos.get(i);
						if(!MEOPIDToNO.get(meops.get(i)).equals(meopsNO)) {
							String updateSQL = String.format("update AHMC_PFMEA set P5 = ? where PROCESSPUID = '%s' AND P4='%s'"
								, meprocess.getUid(),meops.get(i));
							SqlUtilT.getTCConnection();
							SqlUtilT.update(new String[] {meopsNO},
									updateSQL);
						}
					}else {
						InputStream input1 = null;
						input1 = new BufferedInputStream(getClass().getResourceAsStream(
								"/sql.properties"));
						Properties pro1 = new Properties();
						pro1.load(input1);
						String insertPFMEA = pro1.getProperty("INSERTPFMEA");
						// PFMEA
//							SqlUtilT.getTCConnection();
						SqlUtilT.write(new String[] {
								UUID.randomUUID().toString().replace("-", ""),
								meprocess.getUid(), properties.get(i).get(0), "",(properties.get(i).get(2).indexOf("/") >=0 ? properties.get(i).get(2).replace("/", "\n") : properties.get(i).get(2)),"",
								"", "", "", "", "",
								 "", "", "", "", "", "", "", "", "", "", "",
								"", "", "", "","", "", "", "", "", "","","","","","","",properties.get(i).get(properties.get(i).size()-2),properties.get(i).get(1) ,comp.getUid(),properties.get(i).get(4)},
								insertPFMEA);

					}

				}
				
			}
			
			
			//δӹ
			getData();
			if(dataList==null||dataList.size()==0) {
				//ûİ汾Ҫͬbom
				if(comp.getProperty("release_status_list")==null||((TCComponent)comp).getReferenceListProperty("release_status_list").length==0) {
					System.out.println("δ");
					SavePfmea savePfmea = new SavePfmea(session, meprocess,comp);
					savePfmea.insertData();
				}
				dataList2.clear();
				getData();
			}
			//System.out.println("=========dataListΪ"+dataList.toString());
			getCombineMap();
//			if (properties == null) {
//				return;
//			}
			
			//ȡ
			final PFMEABean pfmeaBean = new PFMEABean();
			pfmeaBean.setPfmeaNumber(pfmeaRev.getStringProperty("item_id"));

			progressBar.setValue(95);

			progressBar.setValue(96);
//			ĿƻȡƷĿͻĿrb3_khxmh

//			ڶӦһ汾ırb3_bianzhiriqi
//			ڶӦ·汾İ汾ϵıڣ
			
//			ƶӦPFMEAһ汾ırb3_bianzhi
//			ӲƷͺţӦƷitem_id
//			ͻͼŶӦƷrb3_khth
//			PFMEAŶӦPFMEAitem_id
			//ȡPFMEA汾

			final List<List<String>> changValueList = new ArrayList<List<String>>();

			progressBar.setValue(100);
			new Thread() {
				@Override
				public void run() {
					System.out.println("propertyList==>"+propertyList.toString());
					DesignPFMEADialog dialog = new DesignPFMEADialog(
							app, session, processRows,
							(TCComponentItemRevision) comp, meprocess,
							propertyList,pfmeaBean,itemProperties,changValueList, combineMap, dataList,dataList2,plmeidList,
							isOwning,UID,firstFlag);
					frame.dispose();
				}
			}.start();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		super.executeModal();
	}
	private boolean isRevise = false;
	private boolean firstFlag = false;
	List<String> propertyList = new ArrayList<String>();
	private void getPropertys() {
		// TODO Auto-generated method stub
		
//		"hs2_companyName",//˾
//		"hs2_project", // Ŀ
//		"hs2_address",// ַ
//		"hs2_pfmeaStart_date",// PFMEAʼ
//		"hs2_pfmeaUpdate_date",// PFMEA޶
//		"hs2_processDuty",// ְ
//		"hs2_customerName",// ˿
//		"hs2_pfmeaKey_date",// ܼ
//		"hs2_modelPlatform",// /ƽ̨
//		"hs2_functionalTeams" // ְŶ
//		,"hs2_productCode"};//Ʒ
		
		SqlUtilT.getTCConnection();
		ResultSet rs = null;
		try {
			String sqlString = "select * from AHMC_PROPERTY where COMPUID = '"+comp.getUid()+"'";
			
			System.out.println("sqlString ==> "+sqlString);
			
			rs = SqlUtilT.read(sqlString);
			
			while (rs.next()) {
				
				propertyList.add(rs.getString("companyName"));
				propertyList.add(rs.getString("project"));
				propertyList.add(rs.getString("address"));
				propertyList.add(rs.getString("pfmeaStart_date"));
				propertyList.add(rs.getString("pfmeaUpdate_date"));
				propertyList.add(rs.getString("processDuty"));
				propertyList.add(rs.getString("customerName"));
				propertyList.add(rs.getString("pfmeaKey_date"));
				propertyList.add(rs.getString("modelPlatform"));
				propertyList.add(rs.getString("functionalTeams"));
				propertyList.add(rs.getString("productCode"));
				
//				addData.add(rowList);
			}
			
			if(propertyList.size()==0) {
				firstFlag = true;
				for(int i=0;i<11;i++) {
					propertyList.add("");
				}
				
			}
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}

			SqlUtilT.freeAll();
		}
		
	}
	
	private void getPropertys(String oldUid,String newUid) {
		// TODO Auto-generated method stub
		
//		"hs2_companyName",//˾
//		"hs2_project", // Ŀ
//		"hs2_address",// ַ
//		"hs2_pfmeaStart_date",// PFMEAʼ
//		"hs2_pfmeaUpdate_date",// PFMEA޶
//		"hs2_processDuty",// ְ
//		"hs2_customerName",// ˿
//		"hs2_pfmeaKey_date",// ܼ
//		"hs2_modelPlatform",// /ƽ̨
//		"hs2_functionalTeams" // ְŶ
//		,"hs2_productCode"};//Ʒ
		
		SqlUtilT.getTCConnection();
		ResultSet rs = null;
		try {
			String sqlString = "select * from AHMC_PROPERTY where COMPUID = '"+oldUid+"'";
			
			
			
			System.out.println("sqlString 22 ==> "+sqlString);
			
			rs = SqlUtilT.read(sqlString);
			
			while (rs.next()) {
				
				propertyList.add(rs.getString("companyName"));
				propertyList.add(rs.getString("project"));
				propertyList.add(rs.getString("address"));
				propertyList.add(rs.getString("pfmeaStart_date"));
				propertyList.add(rs.getString("pfmeaUpdate_date"));
				propertyList.add(rs.getString("processDuty"));
				propertyList.add(rs.getString("customerName"));
				propertyList.add(rs.getString("pfmeaKey_date"));
				propertyList.add(rs.getString("modelPlatform"));
				propertyList.add(rs.getString("functionalTeams"));
				propertyList.add(rs.getString("productCode"));
				
//				addData.add(rowList);
			}
			
			if(propertyList.size()==0) {
				firstFlag = true;
				for(int i=0;i<11;i++) {
					propertyList.add("");
				}
			}
			System.out.println(propertyList +" ==propertyList ");
			System.out.println(newUid + "==newUid");
			isRevise =true;
//			
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}

			SqlUtilT.freeAll();
		}
		SqlUtilT.getTCConnection();

		try {
			
//			if(firstFlag) {
				
				
			String sqlString2 = "INSERT INTO AHMC_PROPERTY VALUES(?,?,?,?,?,?,?,?,?,?,?,?)";
			SqlUtilT.write2(new String[] {propertyList.get(0),propertyList.get(1),propertyList.get(2),propertyList.get(3)
					,propertyList.get(4),propertyList.get(5),propertyList.get(6),propertyList.get(7),
					propertyList.get(8),propertyList.get(9),
					"",newUid},sqlString2);
//			}
			
			
			
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			try {
				SqlUtilT.connection.commit();
				
				SqlUtilT.freeAll();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
		}
		
		
	}

}
