package com.connor.hs2.plm.PFMEA.design;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.Set;
import java.util.Timer;
import java.util.TimerTask;
import java.util.UUID;
import java.util.Vector;

import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.JViewport;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import javax.swing.RowFilter;
import javax.swing.UIManager;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.ClientAnchor;
import org.apache.poi.ss.usermodel.Drawing;
import org.apache.poi.ss.usermodel.Picture;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFClientAnchor;
import org.apache.poi.xssf.usermodel.XSSFDrawing;
import org.apache.poi.xssf.usermodel.XSSFPicture;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFShape;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.jdesktop.swingx.renderer.DefaultTableRenderer;
import org.jdesktop.swingx.renderer.FormatStringValue;
import org.jdesktop.swingx.renderer.StringValue;
import org.jdesktop.swingx.table.DatePickerCellEditor;

import com.connor.renben.process.plm.util.Adapter;
import com.connor.renben.process.plm.util.Adapter1;
import com.connor.renben.process.plm.util.CTMap;
import com.connor.renben.process.plm.util.CTMap2;
import com.connor.renben.process.plm.util.CTable;
import com.connor.renben.process.plm.util.CTextField;
import com.connor.renben.process.plm.util.ExcelUtil;
import com.connor.renben.process.plm.util.ExcelUtil07;
import com.connor.renben.process.plm.util.MultiComboBox;
import com.connor.renben.process.plm.util.MyTableModel;
import com.connor.renben.process.plm.util.TextAreaCellEditor;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCComponentListOfValuesType;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.DateButton;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.services.rac.core.ReservationService;

public class DesignPFMEADialog  extends JFrame implements ActionListener {
	private AbstractAIFApplication app;
	private InterfaceAIFComponent comp;
	private TCSession session;
//	private TCProperty[] properties;
	private PFMEABean pfmeaBean;
	private TCProperty[] itemProperties;
	private List<List<String>> changValueList;
	private CTMap map;
	private CTMap2 map2;
	static JScrollPane scrollPane;
	private Timer timer;
	
	//4
//	private String[] header = new String[] { "PLMEID", "", "ʷ/\nȨ(ʱ)", "1. ϵ\nͳϵͳ\nҪػ\n",
//			"2. ̲\nλź͹\nעҪ", "3. ̹\nҪ 4M", "1.\nϵͳ\nϵͳҪ\nػ̵Ĺ\n", "2.̲\nĹܺͲƷ\nԣֵΪ\nѡ",
//			"3.̹\nҪصĹܺ\n", "1.һ\n߼Ҫ\n/նû\nʧЧӰ죨F\nE", "ʧЧӰ\nضȣS", "2.עҪ\nʧЧģʽ(\nFM)", "3.Ҫ\nʧЧ\nFC",
//			"ʧЧ\nǰԤ\nPC", "ʧЧƵ\nȣO", "ʧЧ\nʧЧģʽĵ\nǰ̽ƣ\nDC", "ʧЧ/ʧ\nЧģʽĿ̽\nȣD", "PFMEA\nʩȼ", "Ʒ",
//			"ɸѡ루\nѡ", "Ԥʩ", "̽ʩ", "", "Ŀ", "״̬", "ȡ֤\nĴʩ", "", "ضȣS\nSeverity(S)",
//			"ƵȣO\nOccurrence\n(O)", "̽\nD\nDetection\n(D)", "Ʒ", "PFMEA AP ", "ע","ұ" };
	private String[] header = new String[] { "PLMEID", "", "̲(λź͹עҪ)", "̹Ҫ4",
			"ƵĹ", "̲蹦ܺͲƷ", "̹ҪصĹܺ͹", "һϵͳʧ\nЧӰ\nӰ(FE)",
			"ضs", "עҪʧЧģʽFM", "ҪʧЧFC", "ǰĶʧЧԤ\nʩ", "ʧЧģʽƵo",
			"ǰʧЧģ/ʧЧģʽ̽ʩ", "̽ȣ", "PFMEAʩȼ", "", "ɸѡ", "Ԥʩ",
			"̽ʩ", "", "Ŀ\n", "״̬", "ȡ֤\nĴʩ", "\nʱ", "ض",
			"Ƶ", "̽","PFMEAʩŻAP", "","ע","p","ڵid" };
	private String[] pfmeaHeader =  new String[] { "PLMEID", "", "̲(λź͹עҪ)", "̹Ҫ4",
			"ƵĹ", "̲蹦ܺͲƷ", "̹ҪصĹܺ͹", "һϵͳʧ\nЧӰ\nӰ(FE)",
			"ضs", "עҪʧЧģʽFM", "ҪʧЧFC", "ǰĶʧЧԤ\nʩ", "ʧЧģʽƵo",
			"ǰʧЧģ/ʧЧģʽ̽ʩ", "̽ȣ", "PFMEAʩȼ", "", "ɸѡ", "Ԥʩ",
			"̽ʩ", "", "Ŀ\n", "״̬", "ȡ֤\nĴʩ", "\nʱ", "ض",
			"Ƶ", "̽","PFMEAʩŻAP", "","ע","p","ڵid"};
	private String[] pfmeaKuHeader =  new String[] { "PLMEID", "ѡ", "", "̲(λź͹עҪ)", "̹Ҫ4",
			"ƵĹ", "̲蹦ܺͲƷ", "̹ҪصĹܺ͹", "һϵͳʧ\nЧӰ\nӰ(FE)",
			"ضs", "עҪʧЧģʽFM", "ҪʧЧFC", "ǰĶʧЧԤ\nʩ", "ʧЧģʽƵo",
			"ǰʧЧģ/ʧЧģʽ̽ʩ", "̽ȣ", "PFMEAʩȼ", "", "ɸѡ", "Ԥʩ",
			"̽ʩ", "", "Ŀ\n", "״̬", "ȡ֤\nĴʩ", "\nʱ", "ض",
			"Ƶ", "̽","PFMEAʩŻAP", "" ,"ע","p","ڵid" };
//	private String[] pfmeaHeader = new String[] { "PLMEID", "ID", "1. " + "ϵͳϵͳҪػ",
//			"2. ̲" + "λź͹עҪ", "3. ̹Ҫ 4M", "1.Ĺ" + "ϵͳϵͳҪػ̵Ĺ", "2.̲ĹܺͲƷ" + "ֵΪѡ",
//			"3.̹ҪصĹܺ͹", "1.һϸ߼Ҫ/նûʧЧӰ죨FE", "ʧЧӰضȣS", "2.עҪصʧЧģʽ(FM)", "3.ҪصʧЧFC",
//			"ʧЧĵǰԤƣPC", "ʧЧƵȣO", "ʧЧʧЧģʽĵǰ̽ƣDC", "ʧЧ/ʧЧģʽĿ̽ȣD", "PFMEAʩȼ", "Ʒ",
//			"ɸѡ루ѡ", "Ԥʩ", "̽ʩ", "", "Ŀ", "״̬", "ȡ֤ݵĴʩ", "", "ضȣSSeverity(S)",
//			"ƵȣOOccurrence(O)", "̽ȣDDetection(D)", "Ʒ", "PFMEA AP ", "ע", "ڵID" };
//	private String[] pfmeaHeader = new String[] { "PLMEID","ID", "Station", "Ҫ",
//			"ǱʧЧģʽ", "ǱʧЧ", "ضS", "", "ǱʧЧ/", "й̿Ԥ", "ƵO",
//			"й̿̽", "̽D", "RPN", "ʩ", "", "ƻ", "ȡĴʩ",
//			"New_SEV", "New_OCC", "New_DET", "New_RPN", "Ideal_State", "ڵID",
//			"λ" };//,"Ƶ","Ƶ","ȼ"};
	private String[] recordHeader = new String[] { "PLMID","","", "½", "޶ԭ", "޶", "޶汾", "/޶", "׼" };
	private String[] leftHeader = new String[] { "PLMEID", "ID", "", "" };
	private Map<int[], int[]> combineMap;// źϲԪ
	//private Map<int[], int[]> combineMap2;// źϲԪ
	private Map<int[], int[]> excelCombineMap = new HashMap<int[], int[]>();// źϲԪ
	private TCComponentItemRevision itemRevision;// ѡжİ汾
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-M-dd");
	private TCComponentItem meprocess;// ѡڵĹ
	// private List<List<Integer>> processRowList;//ǰû޸ĵк
	private List<Integer> processRows;// ǰû޸ĵк
	private List<List<Object>> dataList;
	private List<List<String>> dataList2;
	private List<List<Object>> excelDataList = new ArrayList<List<Object>>();
	private List<String> itemList = new ArrayList<String>();
	private List<String> plmeidList;
	private List<String> deleteRows = new ArrayList<String>();
	private SpecialDialog specialDialog;
	private LibraryDialog libraryDialog;
	private Properties pro = new Properties();
	private boolean isComplete = false;
	private boolean isOwning;
	private int selectRow = -1;
	private int selectColumn = -1;
	private int recordSelectRow = -1;
	private int recordSelectColumn = -1;
	
	//2˵
	private static JPopupMenu menu2;
	private JMenuItem addItem2;
	private JMenuItem remItem2;
	private JMenuItem upItem2;
	// жϵԪʾǷȡ
	private boolean isFocusOwner = false;
	// жԪʾǷȡ
	private boolean recordIsFocusOwner = false;

	// ؼ
	private JPanel titlePanel;// 
	private JLabel titleLabel;

	private JPanel mainPanel;// д

	private JLabel companyNameLabel;// ˾
	private CTextField companyNameField;
	private JLabel projectLabel;// Ŀ
	private CTextField projectField;
	private JLabel pfmeaIdLabel;// PFMEA ID
	private CTextField pfmeaIdField;
	private JLabel addressLabel;// ַ
	private CTextField addressField;

	private JLabel pfmeaStartLabel;// PFMEAʼ
	private DateButton pfmeaStartButton;
	private JLabel pfmeaUpdateLabel;// PFMEA޶
	private DateButton pfmeaUpdateButton;
	private JLabel processDutyLabel;// ְ
	private CTextField processDutyField;

	private JLabel customerNameLabel;// ˿
	private JTextField customerNameField;
	private JLabel securityClassificationLabel;// ܼ
	private CTextField securityClassificationField;
	private JLabel modelPlatformLabel;// /ƽ̨
	private CTextField modelPlatformField;
	private JLabel functionalTeamsLabel;// ְŶ
	private CTextField functionalTeamsField;
//	private JLabel expiryDateLabel; //
//	private DateButton expiryDateButton;

	// ʾѡеԪ
	private JTextPane showValuePane;
	private JTextPane showRecordValuePane;// 

	// ǩҳ
	private JTabbedPane tabbedPane;
	// һҳ
	private JPanel firstPanel;// ؼ
	private static CTable table;
	// ڶҳ
	private int selectMainRow2=-1;
	private JPanel secondPanel;// ؼ
	private JTable table2;

	//frameSize
	private JButton reSetSize;// ýС
	//frameSize
//	private JButton refreshBtn;// ýС
	private int[] SizeLoca=new int[4];
	private int[] table1Size=new int[29];
	private int[] table2Size=new int[7];
	private int initRowHeight = 50;
	private String userName="";
	private String type="";
	private boolean isFirstOpen=false;//жǷǵһδ򿪣ͬʱǵһδ򿪣һαݿisFirstOpenfalseٱʱֻ£ظ	
	private boolean isReSet=false;
		
	
	
	
	// Ҽ˵
	private static JPopupMenu menu;
	// Ҽ˵
	private JMenuItem openLibarary;
	private JMenuItem addRowItem;
	private JMenuItem addRowsItem;
	private JMenuItem addItem;
	private JMenuItem addCombineRowsItem;
	private JMenuItem remItem;
	private JMenuItem comBineItem;
	//private JMenuItem comBineItem2;
	private JMenuItem splitItem;
	private JMenuItem shrinkColumnItem;
	private JMenuItem celShrinkColumnItem;
	// private JMenuItem deleteSpecialItem;
	private JPanel rootPanel;// ť
//	private JButton addButton;// 
//	private JButton remButton;// Ƴ
//	private JButton comBinebutton;// ϲ
//	private JButton splitButton;// 
	private JButton saveButton;// 
	private JButton completeButton;// 
	private JButton clearData;// 
	// private JButton addSpecialButton;// 
//	private JButton deleteSpecialButton;// Ƴ
	private JButton libraryButton;// PFME
	private JButton RefreshButton;// ɾݺˢ°ť
	private JTextField setHeightTxt;// ɾݺˢ°ť
	private JButton setHeightBtn;// ɾݺˢ°ť
	private String UID;
	private boolean firstFlag;
	List<String> tstxList = new ArrayList<String>();
	List<File> dsUidList = new ArrayList<File>();
	// PFMEA
	private List<String> properties;
	public DesignPFMEADialog(AbstractAIFApplication app, TCSession session, List<Integer> processRows,
			TCComponentItemRevision itemRevision, TCComponent meprocess, List<String> propertyList, PFMEABean pfmeaBean,
			TCProperty[] itemProperties, List<List<String>> changValueList, Map<int[], int[]> combineMap,
			List<List<Object>> dataList,List<List<String>> dataList2, List<String> plmeidList, boolean isOwning,String UID
			,boolean firstFlag) {
		super();
		// this.processRowList = processRowList;
		this.processRows = processRows;
		this.dataList = dataList;
		this.dataList2 = dataList2;
		this.plmeidList = plmeidList;
		this.combineMap = combineMap;
		//this.combineMap2=combineMap2;
		this.itemRevision = itemRevision;
		this.meprocess = (TCComponentItem) meprocess;
		this.properties = propertyList;
		this.pfmeaBean = pfmeaBean;
		this.itemProperties = itemProperties;
		this.changValueList = changValueList;
		this.app = app;
		this.session = session;
		this.userName=this.session.getUser().toString();
		this.type="PFMEADialog";
		this.isOwning = isOwning;
		System.out.println("isOwning ==> "+isOwning);
//		this.isOwning=true;
		this.UID=UID;
		this.firstFlag=firstFlag;
		//ȡѡж
		this.comp = app.getTargetComponent();
		runTask();
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringValues("ZF6_PFMEA_TSTX"); 
		
		tstxList.add("");
		
		for(String str:strs) {
			
			if(str.contains(":")) {
				String[] split = str.split(":");
				tstxList.add(split[0]);
				try {
					TCComponentDataset ds = (TCComponentDataset) session.stringToComponent(split[1]);
					String[] fileNames = ds.getFileNames("");
					if (fileNames.length > 0) {
						dsUidList.add(ds.getFile("", fileNames[0], System.getenv("TEMP")));
					}
					
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
		}
		init();
		this.processRows = processRows;
		// setProcessRows(this.processRowList);
		comBine();
	}
	
	
	public void getFrameSize() {
		// ȡݿ
		SqlUtilT.getTCConnection();
		ResultSet rs = null;
		ResultSet rs0 = null;
		InputStream input = null;
		input = new BufferedInputStream(getClass().getResourceAsStream(
				"/sql.properties"));
		Properties pro = new Properties();
		try {
			pro.load(input);
			String sql = String.format("select * from AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'",userName,type);
			rs = SqlUtilT.read(sql);
			List<String> rowList = new ArrayList<String>();
			while (rs.next()) {
				rowList.add(rs.getString("FRAMESIZE"));//Сλ
				rowList.add(rs.getString("TABLE1SIZE"));//һп
				rowList.add(rs.getString("TABLE2SIZE"));//ڶп
				rowList.add(rs.getString("ROWHEIGHT"));//1и
				break;
			}
			if(rowList.size()==4) {//Сλãп
				analyticSize(rowList);
			}else {
				String sql0 = String.format("select * from AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'","iniUser",type);
				rs0 = SqlUtilT.read(sql0);
				while (rs0.next()) {
					rowList.add(rs0.getString("FRAMESIZE"));//Сλ
					rowList.add(rs0.getString("TABLE1SIZE"));//һп
					rowList.add(rs0.getString("TABLE2SIZE"));//ڶп
					rowList.add(rs0.getString("ROWHEIGHT"));//1и
					break;
				}
				if(rowList.size()<=0) {
					MessageBox.post("(ݿ)δýߴ磬ã", "", MessageBox.ERROR);
					return;
				}else {
					isFirstOpen=true;
					analyticSize(rowList);
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if(rs0 != null) {
				SqlUtilT.free(rs0);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}
}
	
	//
	public void analyticSize(List<String> rowList) {
		if(rowList.get(0).indexOf("/")>-1) {//ȡСλ
			String[] data=rowList.get(0).split("/");
			for(int i=0;i<4;i++) {
				SizeLoca[i]=Integer.parseInt(data[i]);
			}
		}
		if(rowList.get(1).indexOf("/")>-1) {
			String[] data=rowList.get(1).split("/");
			for(int i=0;i<29;i++) {
				table1Size[i]=Integer.parseInt(data[i]);
			}
		}
		if(rowList.get(2).indexOf("/")>-1) {
			String[] data=rowList.get(2).split("/");
			for(int i=0;i<7;i++) {
				table2Size[i]=Integer.parseInt(data[i]);
			}
		}
		
		if(!rowList.get(3).equals("")) {
			initRowHeight = Integer.valueOf(rowList.get(3));
		}
		
		
	}
	
	
	

	public void comBine() {
		// TODO Auto-generated method stub
		if (combineMap != null && combineMap.size() != 0) {
			Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry<int[], int[]> entry = it.next();
				map.combine(entry.getKey(), entry.getValue());
			}
		}
		
	}
	
//	private JLabel expiryDateLabel;
//	private JTextField expiryTextField;
	private void init() {
		getFrameSize();
		//ȡʻ
		Locale defaultLocale=Locale.getDefault();
		ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
		this.setTitle(rb.getString("txPFMEA10_display.TITLE"));
		// this.setLocationRelativeTo(null);
		// this.setUndecorated(true);
		this.setPreferredSize(new Dimension(SizeLoca[0], SizeLoca[1]));
		this.setLocation(SizeLoca[2], SizeLoca[3]);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				if(!isOwning) {
					DesignPFMEADialog.this.dispose();
				}else {
				int i = JOptionPane.showConfirmDialog(null, "Ƿ񱣴棿", "", JOptionPane.YES_NO_OPTION);
				if (i == JOptionPane.YES_OPTION) {
					okEvent(true, true);
					DesignPFMEADialog.this.dispose();
				} else if (i == JOptionPane.NO_OPTION) {
					DesignPFMEADialog.this.dispose();
					}
				}
			}
		});
		// ʼⲿֿؼ
		this.titlePanel = new JPanel();
		this.titleLabel = new JLabel(rb.getString("qzsxmsjhgfx10_display.TITLE"));
		this.titleLabel.setFont(new Font("", 1, 18));
		this.titlePanel.add(titleLabel);
		// ʼ˵ֿؼ
		this.mainPanel = new JPanel(new PropertyLayout());
		this.companyNameLabel = new JLabel(rb.getString("gsmc10_display.TITLE"));
		this.companyNameField = new CTextField(this.properties.get(0));

		this.companyNameField.setPreferredSize(new Dimension(160, 20));
		this.projectLabel = new JLabel("Ŀ");
		this.projectLabel.setPreferredSize(new Dimension(90, 20));
		this.projectField = new CTextField(this.properties.get(1));
		this.projectField.setPreferredSize(new Dimension(160, 20));
		this.pfmeaIdLabel = new JLabel("PFMEA");// PFMEA
		this.pfmeaIdField = new CTextField(this.pfmeaBean.getPfmeaNumber());
		this.pfmeaIdField.setPreferredSize(new Dimension(160, 20));
		this.addressLabel = new JLabel("Ŀص");
		this.addressField = new CTextField(this.properties.get(2));
		this.addressField.setPreferredSize(new Dimension(160, 20));

		this.pfmeaStartLabel = new JLabel("PFMEAʼ");
		
		this.pfmeaStartButton = new DateButton(dateFormat);
		this.pfmeaStartButton.setText(this.properties.get(3));
		this.pfmeaStartButton.setPreferredSize(new Dimension(160, 20));
		this.pfmeaUpdateLabel = new JLabel(rb.getString("PFMEAxdrq10_display.TITLE"));
		this.pfmeaUpdateLabel.setPreferredSize(new Dimension(90, 20));
		this.pfmeaUpdateButton = new DateButton(dateFormat);
		this.pfmeaUpdateButton.setText(this.properties.get(4));
		this.pfmeaUpdateButton.setPreferredSize(new Dimension(160, 20));
		this.processDutyLabel = new JLabel("");
		this.processDutyLabel.setPreferredSize(new Dimension(80, 20));
		this.processDutyField = new CTextField(this.properties.get(5));
		this.processDutyField.setPreferredSize(new Dimension(160, 20));

		this.customerNameLabel = new JLabel("ͻ");
		this.customerNameField = new CTextField(this.properties.get(6));
		this.customerNameLabel.setPreferredSize(new Dimension(80, 20));
		this.customerNameField.setPreferredSize(new Dimension(160, 20));

		this.securityClassificationLabel = new JLabel(rb.getString("bmjb10_display.TITLE"));
		this.securityClassificationLabel.setPreferredSize(new Dimension(90, 20));
		this.securityClassificationField =new CTextField(this.properties.get(7)); 
//		this.securityClassificationField.setText(this.properties.get(7));
		this.securityClassificationField.setPreferredSize(new Dimension(160, 20));
		this.modelPlatformLabel = new JLabel("/ƽ̨");
		this.modelPlatformLabel.setPreferredSize(new Dimension(90, 20));
		this.modelPlatformField = new CTextField(this.properties.get(8));
		this.modelPlatformField.setPreferredSize(new Dimension(160, 20));
		this.functionalTeamsLabel = new JLabel("繦Ŷ");
		this.functionalTeamsLabel.setPreferredSize(new Dimension(80, 20));
		this.functionalTeamsField = new CTextField(this.properties.get(9));
		this.functionalTeamsField.setPreferredSize(new Dimension(160, 20));

		this.mainPanel.add("1.1.left.top", this.companyNameLabel);
		this.mainPanel.add("1.2.left.top", this.companyNameField);
		this.mainPanel.add("1.3.left.top", this.projectLabel);
		this.mainPanel.add("1.4.left.top", this.projectField);
		this.mainPanel.add("1.5.left.top", this.pfmeaIdLabel);
		this.mainPanel.add("1.6.left.top", this.pfmeaIdField);
		this.mainPanel.add("1.7.left.top", this.addressLabel);
		this.mainPanel.add("1.8.left.top", this.addressField);

		this.mainPanel.add("2.1.left.top", this.pfmeaStartLabel);
		this.mainPanel.add("2.2.left.top", this.pfmeaStartButton);
		this.mainPanel.add("2.3.left.top", this.pfmeaUpdateLabel);
		this.mainPanel.add("2.4.left.top", this.pfmeaUpdateButton);
		this.mainPanel.add("2.5.left.top", this.processDutyLabel);
		this.mainPanel.add("2.6.left.top", this.processDutyField);
		this.mainPanel.add("2.7.left.top", this.customerNameLabel);
		this.mainPanel.add("2.8.left.top", this.customerNameField);

		this.mainPanel.add("3.1.left.top", this.securityClassificationLabel);
		this.mainPanel.add("3.2.left.top", this.securityClassificationField);
		this.mainPanel.add("3.3.left.top", this.modelPlatformLabel);
		this.mainPanel.add("3.4.left.top", this.modelPlatformField);
		this.mainPanel.add("3.5.left.top", this.functionalTeamsLabel);
		this.mainPanel.add("3.6.left.top", this.functionalTeamsField);

		if(isOwning) {
			mainPanel.setEnabled(false);
		}
		JPanel topPanel = new JPanel(new PropertyLayout());
		topPanel.add("1.1.left.top", this.mainPanel);

		this.firstPanel = new JPanel(new BorderLayout());
		this.table = getjTable(null, null, header, null);
		for(int i=1;i<=table1Size.length;i++) {
			this.table.getColumnModel().getColumn(i).setPreferredWidth(table1Size[i-1]);;
		}
		this.table.addMouseListener(new MouseAdapter() {

			@Override
			public void mouseClicked(MouseEvent mouseevent) {
				// TODO Auto-generated method stub
				selectMainRow2 = table.getSelectedRow();
			}
		});
		TableCellEditor cellEditor = this.table.getColumnModel().getColumn(16).getCellEditor(); //16 29
		
		// Ӽ̼
		this.table.addKeyListener(new KeyAdapter() {
			@Override
			public void keyPressed(KeyEvent arg0) {
				// TODO Auto-generated method stub
				//delete
				
				if (arg0.getKeyCode() == KeyEvent.VK_DELETE) {
					int[] selectRows = table.getSelectedRows();
					int[] selectColumns = table.getSelectedColumns();
					for (int i = 0; i < selectRows.length; i++) {
						if (processRows != null && processRows.size() != 0 && !(processRows.contains(selectRows[i]))) {
							continue;
						}
						for (int j = 0; j < selectColumns.length; j++) {
							if(selectColumns.length==table.getColumnCount()) {//Ctrl+Aȫѡʱ
								if(j>0&&j<table.getColumnCount()-1&&j!=4) {
									table.setValueAt("", selectRows[i], selectColumns[j]);
								}
							}else {
								table.setValueAt("", selectRows[i], selectColumns[j]);
							}
						}
					}
				
				}
				if (arg0.getKeyCode()==16) {//shift16Ӽ
					comBineCell();
			}
			if (arg0.getKeyCode()==20) {//caps_lock20Ӽ
				splitCell();
			}
			if (arg0.getKeyCode() == KeyEvent.VK_V) { // Copy              
                System.out.println("here");
                Clipboard localAIFClipboard =  Toolkit.getDefaultToolkit().getSystemClipboard();
				      Transferable localTransferable = localAIFClipboard.getContents(null);
				//          localTransferable.
				      String transferData;
				  try {
					transferData = (String)localTransferable.getTransferData(DataFlavor.stringFlavor);
					 int selectRow=table.getSelectedRow();//ѡе
					 int selectRows=table.getSelectedRowCount();//ѡе
					 int selectColumn=table.getSelectedColumn();//ѡе
					 int selectColumns=table.getSelectedColumnCount();//ѡе
					 
					 
//					 //+++ݸԶ
					  table.setRowSelectionInterval(selectRow+selectRows-1, selectRow+selectRows-1);//λѡеһ
					  if(transferData.indexOf("$")>-1) {
						  if(selectRows<transferData.split("\\$").length) {
							   for (int i1 = 0; i1 < transferData.split("\\$").length-selectRows; i1++) {
							    addRow();
							   }
							 };
					  }else {
						  //excelƵת£ÿ$
						 // System.out.println("fuzhidao:"+transferData);
						  String[] values = transferData.split("\"");
				             StringBuffer sb = new StringBuffer();
				             //滻ExcelеĻз
				             for (int i = 0; i < values.length; i++) {
				            	 System.out.println(i+values[i]);
				            	 if(i % 2 ==0 && values[i].indexOf("\n") >= 0)
				            	 {
				            		 sb.append(values[i].replace("\n", " $")); 
				            	 }
				            	 else
				            	 {
				            		 sb.append(values[i]); 
				            	 }
							}
				             //System.out.println("sb++++++++"+sb.toString());
				             
				             if(sb.indexOf("$")>-1) {
								  if(selectRows<sb.toString().split("\\$").length) {
									   for (int i1 = 0; i1 < sb.toString().split("\\$").length-selectRows; i1++) {
									    addRow();
									   }
									 };
							  }
					  }
					  table.revalidate();
					  table.repaint();
					  table.setRowSelectionInterval(selectRow, selectRow);//λѡеĵһ
//			
					  int index = 0;
				  //+++excelԶϲԪ
				  if(localTransferable.isDataFlavorSupported(DataFlavor.fragmentHtmlFlavor)) {//жǷexcelĸݣǵĻԴӡxmlݹϲϢ
					  String transferData1 = (String)localTransferable.getTransferData(DataFlavor.fragmentHtmlFlavor);
						 //System.out.println("ӡexcelԣ"+transferData1);
					  Map<String, Integer> widMap = new HashMap< String,Integer>();
					  	String[] widString = transferData1.split("<col width=");
					  	for(int t = 0; t<widString.length ;t++) {
					  		String wid = widString[t];
					  		if(wid.contains(" style='mso-width")) {
					  			String string = wid.split(" style='mso-width")[0];
					  			widMap.put(string,t);
					  		}
//					  		
					  	}
						 String[] s=transferData1.split("<tr");
					        for (int i = 0; i < s.length; i++) {
					            //System.out.println("====>"+s[i]);
					            if(s[i].indexOf("rowspan")>0||s[i].indexOf("colspan")>0){
					                //System.out.println("===>"+i+"У");
					                String[] ss=s[i].split("<td");
					                boolean as = false;
					                for (int j = 0; j < ss.length; j++) {
					                    if(ss[j].indexOf("rowspan")>0||ss[j].indexOf("colspan")>0){
					                    	int combineRow=1;
					                    	int combineColumn=1;
					                        if(getIndex(ss[j],"rowspan")>0){//кϲֵ򷵻غϲ,ϲоͷgetIndexΪ2
					                        	combineRow=getIndex(ss[j],"rowspan");
					                           // System.out.println(""+j+"У");
					                            //System.out.println("ϲ"+getIndex(ss[j],"rowspan"));
					                        }
					                        if(getIndex(ss[j],"colspan")>0){
					                        	combineColumn=getIndex(ss[j],"colspan");
					                            //System.out.println("ϲ"+getIndex(ss[j],"colspan"));
					                        }
					                      //combineRowҪ1.Ϊ統ϲʱ2ʱcombineRowΪ2ֻҪѡУҪcombineRow-1
					                        //ûкϲлʱ1-1Ϊ0൱ھֻѡһлһ
					                        String[] split = ss[j].split(" width=");
					                        if(split.length==2) {
					                        	String[] split2 = split[1].split(" style=");
//						                        if(spl)
						                        Integer integer = 0;
						                        if(widMap.containsKey(split2[0])) {
						                        	integer = widMap.get(split2[0]);
						                        }
						                        
						                        table.setRowSelectionInterval(selectRow+i-1, selectRow+i-1+combineRow-1);
						                        table.setColumnSelectionInterval(selectColumn-1+integer, selectColumn-1+integer+combineColumn-1);
					                        	System.out.println("rowselecttion"+(selectRow+i-1)+"end"+(selectRow+i-1+combineRow-1));
					                        	System.out.println(integer +"column select"+(selectColumn+integer-1)+"end"+(selectColumn-1+integer+combineColumn-1));
					                        	if(combineRow > 2) {
					                        		as = true;
						                        }
					                        	comBineCell();
					                        }
					                        
					                    }
					                }
//					                if(as) {
//					                	index = index+1;
//					                }
					            }
					        }
					        //Ҫѡеклعʼ״̬Ա
					        table.setRowSelectionInterval(selectRow, selectRow+selectRows-1);
					        table.setColumnSelectionInterval(selectColumn, selectColumn+selectColumns-1);
				  }
					//+++
					 // System.out.println(transferData);
				} catch (UnsupportedFlavorException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
            }
			
				super.keyPressed(arg0);
			}
		});
		
		 //++++лԪ񳬳Ӽ
		this.table.getModel().addTableModelListener(new TableModelListener() {
          @Override
          public void tableChanged(TableModelEvent e) {
              if (e.getType() == TableModelEvent.UPDATE){
                  int row = table.getSelectedRow();
                  int col = table.getSelectedColumn();
                  if(row>-1&&col>-1) {
                	 // String value=(String) table.getValueAt(row, col).toString();
                	  String value=String.valueOf(table.getValueAt(row, col));//Խnullת
                	 // System.out.println("޸ĺ=>" + value.getBytes().length);
                	  if(value.getBytes().length>512) {
                		  table.setValueAt(subStringByte(value,512), row, col);
                		  MessageBox.post(""+(row+1)+"У"+col+""+"д,ѽֶɾ¼顣", "", MessageBox.ERROR);
                	  }
                  } 
                  
                  if(e.getColumn() == 16 || e.getColumn() == 29) {
                	String newvalue = table.getModel().getValueAt(e.getLastRow(),e.getColumn()).toString();
  					if(!tstxList.contains(newvalue.trim()) && !newvalue.trim().equals("")){
  						System.out.println(tstxList.toString());
  						table.getModel().setValueAt("",e.getLastRow(),e.getColumn());
  						MessageBox.post("ѡδȷд","ʾ",2);
//  						table.getModel().setValueAt(newvalue, row, col);
  					}
  					
                  }
              }
          	}
		});
		
		
		
		// ӹ
		JScrollPane scrollPane = new JScrollPane(this.table);// this.table
		scrollPane.getVerticalScrollBar().setUnitIncrement(10);
		this.firstPanel.add(scrollPane, BorderLayout.CENTER);

		this.secondPanel = new JPanel(new BorderLayout());
		this.table2 = getjTable2(null, null, recordHeader, null);
		for(int i=2;i<=table2Size.length+1;i++) {
			this.table2.getColumnModel().getColumn(i).setPreferredWidth(table2Size[i-2]);;
		}
//		if (changValueList.size() == 0) {
//			this.table2 = getNewjTable(null, null, recordHeader, 1, true);
//		} else {
//			this.table2 = getNewjTable(null, null, recordHeader, itemProperties.length, true);
//		}
		// Ӽ
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
		StringValue sv = new FormatStringValue(df);
		TableCellRenderer r = new DefaultTableRenderer(sv);
		
		table2.getColumnModel().getColumn(2).setCellEditor(new DatePickerCellEditor(df));
		table2.getColumnModel().getColumn(2).setCellRenderer(r);
		this.table2.addMouseListener(new MouseAdapter() {

			@Override
			public void mouseClicked(MouseEvent mouseevent) {
				// TODO Auto-generated method stub
				
//				System.out.println("selectMainRow2"+"--------"+selectMainRow2);
//				if (mouseevent.getClickCount() == 2) {
//					if(table2.getSelectedColumn()==2) {
//						int selectRow = table2.getSelectedRow();
//						if(selectRow!=-1) {
//							Date now = new Date();
////					        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//Է޸ڸʽ
//							SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//							String time = dateFormat1.format(now);
//							table2.setValueAt(time, selectRow, 2);
//							table2.invalidate();
//						}
//					}
//				}
				if (mouseevent.getClickCount() == 1) {
					((CTMap2) table2.getModel()).setRow(table2.getSelectedRow());
					if(table2.getSelectedColumn()>=2) {
						((CTMap2) table2.getModel()).setColumn(table2.getSelectedColumn());
					}
//
					if (recordIsFocusOwner && recordSelectRow != -1 && recordSelectColumn != -1) {
						table2.setValueAt(showRecordValuePane.getText(), recordSelectRow, recordSelectRow);
					}

					if (table2.getValueAt(table2.getSelectedRow(), table2.getSelectedColumn()) != null) {
						showRecordValuePane.setText("");
						showRecordValuePane.setText(
								table2.getValueAt(table2.getSelectedRow(), table2.getSelectedColumn()).toString());
					} else {
						showRecordValuePane.setText("");
					}
						
				}
				recordSelectRow = table2.getSelectedRow();
				recordSelectColumn = table2.getSelectedColumn();
				recordIsFocusOwner = false;
				if (mouseevent.getButton() == MouseEvent.BUTTON3) {
					if(isOwning) {
						menu2.show(table2.getTableHeader(), mouseevent.getX(), mouseevent.getY());
						menu2.show(table2, mouseevent.getX(), mouseevent.getY());
					}
				}
			}
		});
		table2.setRowHeight(40);
		// Ӽ̼
		this.table2.addKeyListener(new KeyAdapter() {
			
			@Override
			public void keyPressed(KeyEvent arg0) {
				// TODO Auto-generated method stub
				//delete
				if (arg0.getKeyChar() == KeyEvent.VK_DELETE) {
				}
				super.keyPressed(arg0);
			}
		});
		
		
// (֮ǰ)+++++++++++++++++++
		this.secondPanel.add(new JScrollPane(this.table2), BorderLayout.CENTER);

		this.showValuePane = new JTextPane();
		this.showValuePane.addFocusListener(new FocusListener() {
			@Override
			public void focusLost(FocusEvent focusevent) {
				// TODO Auto-generated method stub
//				if(selectRow != -1 && selectColumn != -1)
//				{
//					table.setValueAt(showValuePane.getText(), selectRow, selectColumn);
//				}
			}

			@Override
			public void focusGained(FocusEvent focusevent) {
				// TODO Auto-generated method stub
				isFocusOwner = true;
				// this.row = table.getSelectedRow();
				// this.column = table.getSelectedColumn();
			}
		});
		showValuePane.setPreferredSize(new Dimension(800, 40));
		// JScrollPane js = new JScrollPane(this.showValuePane);
		// ʾѡеԪֵ
		this.showRecordValuePane = new JTextPane();
		this.showRecordValuePane.addFocusListener(new FocusListener() {
			// private int row;
			// private int column;
			@Override
			public void focusLost(FocusEvent focusevent) {
				// TODO Auto-generated method stub
//				if(recordSelectRow != -1 && recordSelectColumn != -1)
//				{
//					table2.setValueAt(showRecordValuePane.getText(), recordSelectRow, recordSelectColumn);
//				}
			}

			@Override
			public void focusGained(FocusEvent focusevent) {
				// TODO Auto-generated method stub
				recordIsFocusOwner = true;
				// this.row = table2.getSelectedRow();
				// this.column = table2.getSelectedColumn();
			}
		});
		showRecordValuePane.setPreferredSize(new Dimension(800, 40));

		JSplitPane showSeleceCellValuePanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		showSeleceCellValuePanel.setOneTouchExpandable(true);// ÷ָʾͷ
		showSeleceCellValuePanel.setContinuousLayout(true);// ͷػͼ
		showSeleceCellValuePanel.setTopComponent(new JScrollPane(showValuePane));
		showSeleceCellValuePanel.setBottomComponent(new JScrollPane(this.firstPanel));

		JSplitPane showRecordSeleceCellValuePanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		showRecordSeleceCellValuePanel.setOneTouchExpandable(true);// ÷ָʾͷ
		showRecordSeleceCellValuePanel.setContinuousLayout(true);// ͷػͼ
		showRecordSeleceCellValuePanel.setTopComponent(new JScrollPane(showRecordValuePane));
		showRecordSeleceCellValuePanel.setBottomComponent(new JScrollPane(this.secondPanel));

		this.tabbedPane = new JTabbedPane();
		this.tabbedPane.add("PFMEA", showSeleceCellValuePanel);
		this.tabbedPane.add("PFMEA", showRecordSeleceCellValuePanel);

		// ʼҼ˵
		// Ҽ˵
		menu = new JPopupMenu();
		addRowItem = new JMenuItem(rb.getString("tjh_display.TITLE"));
		addRowsItem = new JMenuItem(rb.getString("tjdh_display.TITLE"));
		addItem = new JMenuItem(rb.getString("tjhbh_display.TITLE"));
		addCombineRowsItem = new JMenuItem(rb.getString("tjdghbh_display.TITLE"));
		comBineItem = new JMenuItem(rb.getString("hbh_display.TITLE"));
		splitItem = new JMenuItem(rb.getString("cfhbdyg_display.TITLE"));
		remItem = new JMenuItem(rb.getString("yczh_display.TITLE"));
		shrinkColumnItem = new JMenuItem(rb.getString("sxxzl_display.TITLE"));
		celShrinkColumnItem = new JMenuItem(rb.getString("qxsxxzl_display.TITLE"));
		openLibarary = new JMenuItem("PFMEA");
		
		//comBineItem2 = new JMenuItem(rb.getString("hbh_display.TITLE"));
		// deleteSpecialItem = new JMenuItem("Ƴ");
		
		// menu.add(deleteSpecialItem);
		menu2 = new JPopupMenu();
		addItem2 = new JMenuItem("");
		remItem2 = new JMenuItem("Ƴ");
		if(isOwning) {
			menu.add(addRowItem);
			menu.add(addRowsItem);
			menu.add(addItem);
			menu.add(addCombineRowsItem);
			menu.add(remItem);
			menu.add(comBineItem);
			menu.add(splitItem);
			menu.add(shrinkColumnItem);
			menu.add(celShrinkColumnItem);
			menu2.add(addItem2);
			menu2.add(remItem2);
			menu.add(openLibarary);
			//menu2.add(comBineItem2);
		}
		
		
		this.rootPanel = new JPanel(new FlowLayout());
//		this.addButton = new JButton("");
//		this.remButton = new JButton("Ƴ");
//		this.comBinebutton = new JButton("ϲ");
//		this.splitButton = new JButton("");
		this.saveButton = new JButton(rb.getString("bc_display.TITLE"));
		this.clearData = new JButton(rb.getString("qksj_display.TITLE"));
		this.completeButton = new JButton(rb.getString("dcPFMEA10_display.TITLE"));
		// this.addSpecialButton = new JButton("");
//		this.deleteSpecialButton = new JButton("Ƴ");
		this.libraryButton = new JButton(rb.getString("PFMEAc10_display.TITLE"));
		this.RefreshButton = new JButton("¼");
		this.setHeightTxt = new JTextField(); 
		this.setHeightTxt.setPreferredSize(new Dimension(160, 20));
		this.setHeightBtn = new JButton("и");
//		this.refreshBtn = new JButton("ˢ¹");
		this.reSetSize = new JButton("ýС");
		// this.sendbutton = new JButton("");
		// this.sendbutton.addActionListener(this);
//		this.rootPanel.add(addButton);
//		this.rootPanel.add(remButton);
//		this.rootPanel.add(comBinebutton);
//		this.rootPanel.add(splitButton);
		//++++
		if (isOwning) {
			this.rootPanel.add(completeButton);
			this.rootPanel.add(RefreshButton);
			this.rootPanel.add(saveButton);
			this.rootPanel.add(clearData);
			this.rootPanel.add(completeButton);
			this.rootPanel.add(libraryButton);
			this.rootPanel.add(reSetSize);
			this.rootPanel.add(setHeightTxt);
			this.rootPanel.add(setHeightBtn);
//			this.rootPanel.add(refreshBtn);
		} else {
			this.rootPanel.add(reSetSize);
			this.rootPanel.add(completeButton);
			setPanelEnabled(mainPanel,false);
		}
		//++++
		setHeightBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String selectedText = setHeightTxt.getText();
				try {
//					Double valueOf = Double.valueOf(selectedText);
					Integer valueOf = Integer.valueOf(selectedText);
					if(valueOf>10 || valueOf<1) {
						MessageBox.post("и߽1-10֮","ʾ",2);
					}
					int rowCount = table.getRowCount();
					int rowHeight = 40;
					System.out.println("valueOf"+valueOf+"rowHeight"+rowHeight);
					rowHeight = (int) (rowHeight*valueOf);
					System.out.println("new rowHeight"+rowHeight);
					table.setRowHeight(rowHeight);
//					mainTable.invalidate();
				} catch (Exception e2) {
					// TODO: handle exception
					e2.printStackTrace();
//					System.out.println("");
				}
				
				
			}
		});
	
		JPanel centerPanel = new JPanel(new BorderLayout());
		centerPanel.add(titlePanel, BorderLayout.NORTH);
		centerPanel.add(topPanel, BorderLayout.CENTER);

		JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		splitPane.setOneTouchExpandable(true);// ÷ָʾͷ
		splitPane.setContinuousLayout(true);// ͷػͼ
		splitPane.setTopComponent(centerPanel);
		splitPane.setBottomComponent(tabbedPane);
		// JPanel centerPanel2 = new JPanel(new BorderLayout());
		// centerPanel2.add(centerPanel,BorderLayout.NORTH);
		// centerPanel2.add(tabbedPane, BorderLayout.CENTER);

		// JSplitPane splitPane = new JSplitPane();
		// splitPane.setOneTouchExpandable(true);//÷ָʾͷ
		// splitPane.setContinuousLayout(true);//ͷػͼ
		// splitPane.setLeftComponent(centerPanel2);
		// splitPane.setRightComponent(treePanel);

		// 
		this.createActionEvent();
		this.setLayout(new BorderLayout());
		// this.add(centerPanel, BorderLayout.NORTH);
		// this.add(centerPanel2, BorderLayout.CENTER);
		this.add(splitPane, BorderLayout.CENTER);
		// dialog.add(tablePanel, BorderLayout.CENTER);
		this.add(rootPanel, BorderLayout.SOUTH);
		// this.add(utilPanel, BorderLayout.EAST);
		this.pack();
		this.show();
	}

	//ֽڽȡַ
		public static String subStringByte(String source, int length) {
		    StringBuffer buffer = new StringBuffer();
		    char[] chars = source.toCharArray();
		    char c;
		    for (int i = 0;; i++) {
		      if (length <= 0) {
		        break;
		      }
		      c = source.charAt(i);
		      buffer.append(c);
		      length -= String.valueOf(c).getBytes().length;
		      if (i + 1 < chars.length) {
		        if (String.valueOf(chars[i + 1]).getBytes().length > length) {
		          break;
		        };
		      }
		    }
		    return buffer.toString();
		  }
	
	
	
	// Ӽ
	public void createActionEvent() {
		this.addItem2.addActionListener(this);
		this.remItem2.addActionListener(this);
		this.openLibarary.addActionListener(this);
		this.addRowItem.addActionListener(this);
		this.addRowsItem.addActionListener(this);
		this.addCombineRowsItem.addActionListener(this);
		this.addItem.addActionListener(this);
		this.remItem.addActionListener(this);
		this.comBineItem.addActionListener(this);
		//this.comBineItem2.addActionListener(this);
		this.splitItem.addActionListener(this);
		this.shrinkColumnItem.addActionListener(this);
		this.celShrinkColumnItem.addActionListener(this);
		this.saveButton.addActionListener(this);
		this.reSetSize.addActionListener(this);
		// this.addSpecialButton.addActionListener(this);
		// this.deleteSpecialItem.addActionListener(this);
		this.libraryButton.addActionListener(this);
		this.RefreshButton.addActionListener(this);
		this.clearData.addActionListener(this);
		this.completeButton.addActionListener(this);
	}

	//excelʱǷкϲкС"rowspan"ǺϲУ"colspan"ǺϲСȻ󷵻rowspan(colspan)=ֵ
		public static int getIndex(String tag1,String tag2){
	        int loca=0;
	        if(tag1.indexOf(tag2)>0){
	            int l=tag1.indexOf(tag2);
	            while(!tag1.substring(l,l+1).equals("=")){
	                l++;
	            }
	            int start=++l;
	            while(!tag1.substring(l,l+1).equals(" ")){
	                    l++;
	            }
	            loca=Integer.valueOf(tag1.substring(start,l));
	        }
	        return loca;
	    }
	
	
	
	//ÿؼȨ
		public void setPanelEnabled(JPanel panel, boolean enabled) {
			for (int i = 0; i < panel.getComponentCount(); i++) {
				if (panel.getComponent(i) instanceof JPanel) {
					JPanel chidPanel = (JPanel) panel.getComponent(i);
					for (int j = 0; j < chidPanel.getComponentCount(); j++) {

						chidPanel.getComponent(j).setEnabled(enabled);//һ
						if (chidPanel.getComponent(j) instanceof MultiComboBox) {
							MultiComboBox multiComboBox = (MultiComboBox) chidPanel.getComponent(j);
							multiComboBox.editor.enable(enabled);
							if(enabled) {multiComboBox.popup.show();}else {multiComboBox.popup.hide();}
						}
						if (chidPanel.getComponent(j) instanceof JScrollPane) {
							JScrollPane scrollPane = (JScrollPane) chidPanel.getComponent(j);
							JViewport jViewport = scrollPane.getViewport();
							jViewport.getView().setEnabled(enabled);
						}
					}
				}
				panel.getComponent(i).setEnabled(enabled);
				if (panel.getComponent(i) instanceof MultiComboBox) {
					MultiComboBox multiComboBox = (MultiComboBox) panel.getComponent(i);
				
					multiComboBox.editor.enable(enabled);
					if(enabled) {multiComboBox.popup.show();}else {multiComboBox.popup.hide();}
				}
				if (panel.getComponent(i) instanceof JScrollPane) {
					JScrollPane scrollPane = (JScrollPane) panel.getComponent(i);
					JViewport jViewport = scrollPane.getViewport();
					jViewport.getView().setEnabled(enabled);
				}
			}
		}
	
	
	/**
	 * дݵJtable
	 * һ
	 */
	private void setJTable() {
		for (int i = 0; i < dataList.size(); i++) {
			List<Object> rowList = dataList.get(i);
			int c = dataList.size();
			for (int j = 0; j < header.length; j++) {
				if (j > 24) {
					map.setValueAt(rowList.get(j + 3), i, j);
				} else {
					map.setValueAt(rowList.get(j), i, j);
				}
			}
		}
	}
	/**
	 * дݵJtable
	 * ڶ
	 */
	private void setJTable2() {
		for (int i = 0; i < dataList2.size(); i++) {
			List<String> rowList = dataList2.get(i);
			int c = dataList2.size();
			for (int j = 0; j < recordHeader.length; j++) {
					map2.setValueAt(rowList.get(j), i, j);
			}
		}
	}
	public CTable getNewjTable(CTable partsTable, DefaultTableModel dtm, Object[] titleNames, int rows,
			boolean isEditable) {
		int simpleLen = 100;
		int totleLen = 1000;
		if (partsTable == null) {
			final CTMap2 map = new CTMap2(rows, titleNames.length);
			map.setColumnIdentifiers(titleNames);
			map.setEditable(isEditable);
			partsTable = new CTable(map,false,tstxList);
			partsTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			partsTable.setRowHeight(50);
			// ʾȾ
			TableCellTextAreaRenderer2 renderer = new TableCellTextAreaRenderer2();
			partsTable.setDefaultRenderer(Object.class, renderer);

			if (simpleLen * titleNames.length >= totleLen) {
				for (int i = 0; i < titleNames.length; i++) {
					partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
				}
				partsTable.setAutoResizeMode(0);
			} else {
				partsTable.setAutoResizeMode(1);
			}
		}
		return partsTable;
	}
	// Jtableͨ÷
//	public JTable getNewjTable(JTable partsTable, DefaultTableModel dtm, Object[] titleNames, int rows,
//			boolean isEditable,int xxx) {
//		int simpleLen = 100;
//		int totleLen = 1000;
//		if (partsTable == null) {
//			final CTMap2 map = new CTMap2(rows, titleNames.length);
//			map.setColumnIdentifiers(titleNames);
//			map.setEditable(isEditable);
//			partsTable = new JTable(map);
//			partsTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
//			partsTable.setRowHeight(50);
//			// ʾȾ
//			TableCellTextAreaRenderer2 renderer = new TableCellTextAreaRenderer2();
//			partsTable.setDefaultRenderer(Object.class, renderer);
//
//			if (simpleLen * titleNames.length >= totleLen) {
//				for (int i = 0; i < titleNames.length; i++) {
//					partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
//				}
//				partsTable.setAutoResizeMode(0);
//			} else {
//				partsTable.setAutoResizeMode(1);
//			}
//		}
//		return partsTable;
//	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		this.timer.cancel();
		super.dispose();
		//رȨ޸
		closePermission();
	}

	// Jtableͨ÷
	public CTable getjTable(CTable partsTable, DefaultTableModel dtm, Object[] titleNames, Object[][] values) {
		int simpleLen = 100;
		int totleLen = 1000;
		if (partsTable == null) {
			this.map = new CTMap(dataList.size(), titleNames.length);
			map.setColumnIdentifiers(titleNames);
			this.map.setEditable(true);
			if (processRows != null && processRows.size() > 0) {
				this.map.setProcessRowList(processRows);
			}
//			partsTable = new CTable(map);
//			partsTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
//			Adapter adapter = new Adapter(partsTable);
			setJTable();
			
			partsTable = new CTable(map,true,tstxList);
//			{
//				public boolean isCellEditable(int row,int column){  
//				    if(column == 0){  
//				       return false;  
//				    }else{  
//				       return true;  
//				    }  
//				}
//			};
			partsTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			Adapter1 adapter = new Adapter1(partsTable);
			
			if(initRowHeight==0) {
				partsTable.setRowHeight(50);
			}else {
				partsTable.setRowHeight(initRowHeight);
			}
			
			// 
			partsTable.HiddenCell(0);
			partsTable.HiddenCell(titleNames.length-2);
			partsTable.HiddenCell(titleNames.length-1);
			// //ʾȾ
			TableCellTextAreaRenderer renderer = new TableCellTextAreaRenderer();
			renderer.setProcessRows(processRows);
			// //þ
			partsTable.setDefaultRenderer(Object.class, renderer);
			

			// Ӽ
			partsTable.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent mouseevent) {
					// TODO Auto-generated method stub
					if (mouseevent.getClickCount() == 1) {
						map.setRow(table.getSelectedRow());
						map.setColumn(table.getSelectedColumn());
						if (isFocusOwner && selectRow != -1 && selectColumn != -1) {
							table.setValueAt(showValuePane.getText(), selectRow, selectColumn);
						}
	
						if (table.getValueAt(table.getSelectedRow(), table.getSelectedColumn()) != null) {
							showRecordValuePane.setText("");
							showValuePane.setText(
									table.getValueAt(table.getSelectedRow(), table.getSelectedColumn()).toString());
						} else {
							showValuePane.setText("");
						}
						selectRow = table.getSelectedRow();
						selectColumn = table.getSelectedColumn();
						isFocusOwner = false;
					}
					if (mouseevent.getButton() == MouseEvent.BUTTON3) {
						if(isOwning) {
						menu.show(table, mouseevent.getX(), mouseevent.getY());
						}
					}
				}
			});
			// //ñ༭Ⱦ
			// this.textAreaCellEditor = new TextAreaCellEditor();
			// partsTable.setDefaultEditor(Object.class,
			// this.textAreaCellEditor);
			if (simpleLen * titleNames.length >= totleLen) {
				for (int i = 0; i < titleNames.length; i++) {
					partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
				}
				partsTable.setAutoResizeMode(0);
			} else {
				partsTable.setAutoResizeMode(1);
			}
		}
		if(!isOwning) {
			partsTable.setEnabled(false);
		}
		
		
		//++
		MultiLineHeaderRenderer renderer = new MultiLineHeaderRenderer();
        Enumeration e = partsTable.getColumnModel().getColumns();
        while (e.hasMoreElements()) {
            ( (TableColumn) e.nextElement()).setHeaderRenderer(renderer);
        }
		//++
		return partsTable;
	}
	
	// Jtableͨ÷
		public JTable getjTable2(JTable partsTable, DefaultTableModel dtm, Object[] titleNames, Object[][] values) {
			int simpleLen = 100;
			int totleLen = 1000;
			if (partsTable == null) {
				System.out.println("-----init() map2 -------"+dataList2.toString());
				this.map2 = new CTMap2(dataList2.size(), titleNames.length);
				map2.setColumnIdentifiers(titleNames);
				this.map2.setEditable(true);
				
				partsTable = new JTable(map2);
				partsTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
				Adapter adapter = new Adapter(partsTable);
				partsTable.setRowHeight(50);
				setJTable2();
				
				// 
				HiddenCell(1,partsTable);
				HiddenCell(0,partsTable);
//				partsTable.HiddenCell(0);
//				partsTable.HiddenCell(1);
				// //ʾȾ
				TableCellTextAreaRenderer renderer = new TableCellTextAreaRenderer();
				if (processRows != null && processRows.size() > 0) {
					List<Integer> dataList2List = new ArrayList<Integer>();
					for(int i2=0;i2<dataList2.size();i2++) {
						dataList2List.add(new Integer(i2));
					}
					this.map2.setProcessRowList(dataList2List);
					renderer.setProcessRows(dataList2List);
				}
				
				partsTable.setDefaultRenderer(Object.class, renderer);
				
				// //ñ༭Ⱦ
				// this.textAreaCellEditor = new TextAreaCellEditor();
				// partsTable.setDefaultEditor(Object.class,
				// this.textAreaCellEditor);
				if (simpleLen * titleNames.length >= totleLen) {
					for (int i = 0; i < titleNames.length; i++) {
						partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
					}
					partsTable.setAutoResizeMode(0);
				} else {
					partsTable.setAutoResizeMode(1);
				}
			}
			if(!isOwning) {
				partsTable.setEnabled(false);
			}
//			partsTable.setEnabled(true);
			//++
			MultiLineHeaderRenderer rendererM = new MultiLineHeaderRenderer();
	        Enumeration e = partsTable.getColumnModel().getColumns();
	        while (e.hasMoreElements()) {
	            ( (TableColumn) e.nextElement()).setHeaderRenderer(rendererM);
	        }
//	        partsTable.setRowHeight(40);
			//++
			return partsTable;
			
		}

	private void HiddenCell(int column,JTable table) {
		
		TableColumn tc = table.getTableHeader().getColumnModel().getColumn(column);
		tc.setMaxWidth(0);
		tc.setPreferredWidth(0);
		tc.setWidth(0);
		tc.setMinWidth(0);
		table.getTableHeader().getColumnModel().getColumn(column).setMaxWidth(0);
		table.getTableHeader().getColumnModel().getColumn(column).setMinWidth(0);
		
	}


	@Override
	public void actionPerformed(ActionEvent arg0) {
		Object source = arg0.getSource();
		if(source.equals(this.addItem2)) {
			if (!isOwning) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			JTable table = this.table2;
			if (table.getSelectedRow() > -1) {
				((CTMap2) table.getModel()).insertRow(table2.getRowCount());
				Date now = new Date();
		        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//Է޸ڸʽ
//				map2.setValueAt(dateFormat.format(now), table2.getRowCount()-1, 2);
				SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyyMMddHHmmss");
				String time = dateFormat1.format(now);
//				map2.setValueAt(Long.valueOf(time), table2.getRowCount()-1, 1);
				UUID uuid = UUID.randomUUID();
				String uid=uuid.toString().replace("-", "");
				map2.setValueAt(uid, table2.getRowCount()-1, 0);
				//ݵݿ
				SqlUtilT.getTCConnection();
				String insert = "insert into AHMC_PFMEALIBRARY values(?,?,?,?,?,?,?,?,?,?,?,?)";
				SqlUtilT.write(new String[] {uid,UID,null,null,null,null,null,null,null,null,null,time}
						,insert);
			}
			
		}else if (source.equals(this.openLibarary)) {
			
			CTable table = this.table;
//			int selectMainRow2 = table.getSelectedRow();
			System.out.println(selectMainRow2+"-------");
			if(selectMainRow2!=-1) {
				System.out.println("ǰѡеrow"+selectMainRow2);
				
//				if (this.libraryDialog == null) {
					System.out.println(table.getSelectedRow() + "===" + table.getSelectedColumn());
					String valueAt = (String) table.getValueAt(selectMainRow2, 4);
					System.out.println(valueAt+"valueAt");
					this.libraryDialog = new LibraryDialog(valueAt);
//				} 
//				else {
//					System.out.println(table.getSelectedRow() + "===" + table.getSelectedColumn());
//					this.libraryDialog.show();
//				}
			}
			
			
		}
		else if(source.equals(this.remItem2)) {
			if (!isOwning) {
				MessageBox.post("ȨɾУ", "", MessageBox.ERROR);
				return;
			}
			int i=JOptionPane.showConfirmDialog(null, "ǷɾѡУ", "ɾ", JOptionPane.YES_NO_OPTION);
	        if(i!=JOptionPane.YES_OPTION){
	        	return;
	        }
					JTable table = this.table2;
//					if(table.getRowCount() == 1) {
//						
//					}
					if (table.getSelectedRow() >= 0
							&& table.getSelectedColumn() > 1) {
						(table.getCellEditor(table.getSelectedRow(),
								table.getSelectedColumn())).stopCellEditing();
						if (((CTMap2) table.getModel()).getValueAt(
								table.getSelectedRow(), 0) != null) {
							//plmidɾݿѡеϢ
							String delete = String
									.format("delete from AHMC_PFMEALIBRARY where PLMID = \'%s\'",table.getValueAt(table.getSelectedRow(), 0).toString());		
							SqlUtilT.getTCConnection();
							SqlUtilT.delete(delete);
						}
						((CTMap2) table.getModel()).removeRow(table
								.getSelectedRow());
						table.revalidate();
						table.repaint();
						if(table.getRowCount()==0) {
//							table.addR
							((CTMap2) table.getModel()).addRow();
						}
						table.revalidate();
						table.repaint();
						//this.tabbedPane.updateUI();
					}
					
		}else if (source.equals(this.addRowItem)) {
			if (!isOwning) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			addRow();
		} else if (source.equals(this.addRowsItem)) {
			if (!isOwning) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			if (this.tabbedPane.getSelectedIndex() == 1) {
				AddRowsDialog addRowsDialog = new AddRowsDialog(source);
			} else {
				int row = table.getSelectedRow();
				if (this.processRows != null && this.processRows.size() == 0 && !(this.processRows.contains(row))) {
					MessageBox.post("ȨУ", "", MessageBox.ERROR);
					return;
				}
				AddRowsDialog addRowsDialog = new AddRowsDialog(source);
			}
		} else if (source.equals(this.addCombineRowsItem)) {
			if (!isOwning) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			if (this.tabbedPane.getSelectedIndex() == 1) {
				AddRowsDialog addRowsDialog = new AddRowsDialog(source);
			} else {
				int row = table.getSelectedRow();
				if (this.processRows != null && this.processRows.size() == 0 && !(this.processRows.contains(row))) {
					MessageBox.post("ȨУ", "", MessageBox.ERROR);
					return;
				}
				AddRowsDialog addRowsDialog = new AddRowsDialog(source);
			}
		} else if (source.equals(this.addItem)) {
			if (!isOwning) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			addCombineRow();
		} else if (source.equals(this.remItem)) {
			if (!isOwning) {
				MessageBox.post("ȨɾУ", "", MessageBox.ERROR);
				return;
			}
			int i = JOptionPane.showConfirmDialog(null, "ǷɾѡУ", "ɾ", JOptionPane.YES_NO_OPTION);
			if (i != JOptionPane.YES_OPTION) {
				return;
			}
			remRow();
		} else if (source.equals(this.comBineItem)) {
			if (!isOwning) {
				MessageBox.post("Ȩ޺ϲУ", "", MessageBox.ERROR);
				return;
			}
			comBineCell();
		} else if (source.equals(this.splitItem)) {
			if (!isOwning) {
				MessageBox.post("Ȩ޲У", "", MessageBox.ERROR);
				return;
			}
			splitCell();
		} else if (source.equals(this.saveButton)) {
			if(isOwning) {
				okEvent(true, true);
				//this.dispose();
			}else {
				MessageBox.post("Ȩޱ棡", "", MessageBox.ERROR);
			}
			
		}
		else if (source.equals(this.clearData)) {
			if (!isOwning) {
				MessageBox.post("Ȩޣ", "", MessageBox.ERROR);
				return;
			}
			clearDatas();
		}

		else if (source.equals(shrinkColumnItem)) {
			for (int i = 0; i < table.getSelectedColumns().length; i++) {
				table.getColumnModel().getColumn(table.getSelectedColumns()[i]).setPreferredWidth(5);
			}
			table.revalidate();
			table.repaint();
		} else if (source.equals(celShrinkColumnItem)) {
			for (int i = 0; i < table.getSelectedColumns().length; i++) {
				table.getColumnModel().getColumn(table.getSelectedColumns()[i]).setPreferredWidth(100);
			}
			table.revalidate();
			table.repaint();
		} else if (source.equals(libraryButton)) {
			if (!isOwning) {
				MessageBox.post("Ȩ޲鿴", "", MessageBox.ERROR);
				return;
			}
			
			if (this.libraryDialog == null) {
				System.out.println(table.getSelectedRow() + "===" + table.getSelectedColumn());
				this.libraryDialog = new LibraryDialog();
			} else {
				System.out.println(table.getSelectedRow() + "===" + table.getSelectedColumn());
				this.libraryDialog.show();
			}
		} else if (source.equals(completeButton)) {
			isComplete = true;
			if(isOwning) {
			okEvent(false, true);
			// this.disposeDialog();
			}else {
				//MessageBox.post("Ȩޱ棡", "", MessageBox.ERROR);
				PFMEABean pfmeaBean = new PFMEABean();
				pfmeaBean.setCompanyName((String)this.companyNameField.getText());
				pfmeaBean.setProject(this.projectField.getText());
				pfmeaBean.setAddress(this.addressField.getText());
				pfmeaBean.setPfmeaStartDate(this.pfmeaStartButton.getText());
				pfmeaBean.setPfmeaUpdateDate(this.pfmeaUpdateButton.getText());
				pfmeaBean.setProcessDuty(this.processDutyField.getText());
				pfmeaBean.setCustomerName(this.customerNameField.getText());
				pfmeaBean.setSecurityClassification(this.securityClassificationField.getText());
				pfmeaBean.setModelPlatform(this.modelPlatformField.getText());
				pfmeaBean.setFunctionalTeams(this.functionalTeamsField.getText());
//				pfmeaBean.setProductCode(this.expiryTextField.getText());
				try {
					pfmeaBean.setPfmeaNumber(itemRevision.getStringProperty("item_id"));
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				getData();
				getCombineMap();
				//ȡtable2ݱ
				String[][] dataValue = new String[this.table2.getRowCount()][8];
				for (int i = 0; i < this.table2.getRowCount(); i++) {
					for (int j = 0; j < 8; j++) {
						if(j==0) {
							dataValue[i][j]=this.table2.getValueAt(i, 0).toString();
				}else {
						dataValue[i][j] = this.table2.getValueAt(i, j+1) == null ? ""
								: this.table2.getValueAt(i, j+1).toString();
						}
					}
				}
				try {
					String name = this.itemRevision.getStringProperty("object_name");
					new selectExportPath(pfmeaBean, this.excelDataList, dataValue,name);
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
			this.dispose();
		}else if (source.equals(reSetSize)) {
			int i=JOptionPane.showConfirmDialog(null, "ǷýСǡ´δ򿪽ʱЧ", "", JOptionPane.YES_NO_OPTION);
	        if(i==JOptionPane.YES_OPTION){
					SqlUtilT.getTCConnection();
					InputStream input = new BufferedInputStream(getClass().getResourceAsStream(
							"/sql.properties"));
					Properties pro = new Properties();
					try {
						pro.load(input);
						String deleteSQL = String.format(
								"DELETE FROM AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'",userName,type);
						SqlUtilT.delete(deleteSQL);
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					isReSet=true;
					SqlUtilT.freeAll();
	     }
		}
		else if (source.equals(RefreshButton)) {
			
			
			this.dispose();
			DesignPFMEACommand command = new DesignPFMEACommand(app,
					session,UID,meprocess,true,(TCComponent)itemRevision);
			try {
				command.executeModal();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		} 
		else {
			// this.disposeDialog();
			this.dispose();
		}
	}

	private void okEvent(boolean isSave, boolean isAuto) {
		// TODO Auto-generated method stub
		//ȡĻߴλ+++++
		String list1=String.valueOf(((int)this.getSize().getWidth()))+"/"+String.valueOf((int)this.getSize().getHeight())
						+"/"+String.valueOf(((int)this.getLocation().getX()))+"/"+String.valueOf((((int)this.getLocation().getY())));
		
		String list2="";
		for(int i=1;i<table.getColumnModel().getColumnCount()-1;i++) {
			if(i==table.getColumnModel().getColumnCount()-2) {
				list2+=String.valueOf(((int)table.getColumnModel().getColumn(i).getWidth()));
			}else {
				list2+=(String.valueOf(((int)table.getColumnModel().getColumn(i).getWidth()))+"/");
			}
		}
		String list3="";
		for(int i=2;i<table2.getColumnModel().getColumnCount();i++) {
			if(i==table2.getColumnModel().getColumnCount()-1) {
				list3+=String.valueOf(((int)table2.getColumnModel().getColumn(i).getWidth()));
			}else {
				list3+=(String.valueOf(((int)table2.getColumnModel().getColumn(i).getWidth()))+"/");
			}
		}
		SqlUtilT.getTCConnection();
		InputStream input = null;
		input = new BufferedInputStream(getClass().getResourceAsStream(
				"/sql.properties"));
		Properties pro = new Properties();
		try {
			pro.load(input);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		System.out.println("this.userName====>"+this.userName);
		System.out.println("this.type====>"+this.type);
		System.out.println("list1====>"+list1.toString());
		System.out.println("list2====>"+list2.toString());
		System.out.println("list3====>"+list3.toString());
		if(isFirstOpen) {
			String insertSQL = "INSERT INTO AHMC_PFMEAFRAME_SIZE VALUES(?,?,?,?,?,?,?)";
			SqlUtilT.write(new String[] {
					UUID.randomUUID().toString().replace("-", ""),
					this.userName,this.type,list1,list2,list3,String.valueOf(table.getRowHeight())}, insertSQL);
			System.out.println("insertSQL====>"+insertSQL);
			isFirstOpen=false;
		}else if(!isReSet){
			String updateSQL = String.format(
					"update AHMC_PFMEAFRAME_SIZE set FRAMESIZE = ?, TABLE1SIZE = ?, TABLE2SIZE = ?,ROWHEIGHT = ? WHERE USERNAME ='%s' AND TYPE = '%s'",userName,type);
			SqlUtilT.update(
					new String[] {list1,list2,list3,String.valueOf(table.getRowHeight())},updateSQL);
		}
		SqlUtilT.freeAll();
		///++++++
		
		
		
		
		// ݱ浽
		try {
//			if(table.getRowCount()!=0) {
//				if(table.getValueAt(0,0)=="") {
//				MessageBox.post("ʧȫݱ","",MessageBox.ERROR);
//				return;
//			}}
			if (table.getSelectedRow() >= 0 && table.getSelectedColumn() >= 0) {
				(table.getCellEditor(table.getSelectedRow(), table.getSelectedColumn())).stopCellEditing();
			}
			if (table2.getSelectedRow() >= 0 && table2.getSelectedColumn() >= 0) {
				(table2.getCellEditor(table2.getSelectedRow(), table2.getSelectedColumn())).stopCellEditing();
			}
			PFMEABean pfmeaBean = new PFMEABean();
			
			pfmeaBean.setCompanyName((String)this.companyNameField.getText());
			pfmeaBean.setProject(this.projectField.getText());
			pfmeaBean.setAddress(this.addressField.getText());
			pfmeaBean.setPfmeaStartDate(this.pfmeaStartButton.getText());
			pfmeaBean.setPfmeaUpdateDate(this.pfmeaUpdateButton.getText());
			pfmeaBean.setProcessDuty(this.processDutyField.getText());
			pfmeaBean.setCustomerName(this.customerNameField.getText());
			pfmeaBean.setSecurityClassification(this.securityClassificationField.getText());
			pfmeaBean.setModelPlatform(this.modelPlatformField.getText());
			pfmeaBean.setFunctionalTeams(this.functionalTeamsField.getText());
			pfmeaBean.setPfmeaNumber(itemRevision.getStringProperty("item_id"));
//			pfmeaBean.setProductCode(this.expiryTextField.getText());
			
			// ȡJTableе
			List<List<String>> dataValeList = getTableValue();
			
			
			System.out.println(dataValeList.toString());
			DesignPFMEAOperation operation = new DesignPFMEAOperation(this.itemRevision, this.meprocess,
					this.session, null, this.itemProperties, pfmeaBean, dataValeList, plmeidList,
					deleteRows, isOwning,comp,UID,firstFlag);
			operation.executeOperation();
			for (int j = 0; j < processRows.size(); j++) {
				plmeidList.add(table.getValueAt(processRows.get(j), 0).toString());
			}
			//ȡtable2ݱ
//			String[][] dataValue = new String[this.table2.getRowCount()][8];
//			for (int i = 0; i < this.table2.getRowCount(); i++) {
//				for (int j = 0; j < 8; j++) {
//					if(j==0) {
//						dataValue[i][j]=this.table2.getValueAt(i, 0).toString();
//					}
//					else if (j==1) {
//						Object valueO =  this.table2.getValueAt(i, j+1);
//						if(valueO instanceof String) {
//							dataValue[i][j] = (String) valueO;
//						}else if (valueO instanceof Date) {
////							System.out.println(valueO  + "String"+ (String) this.table2.getValueAt(i, j+2));
//							SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
//				            String time = dateFormat1.format((Date)valueO);
//				            dataValue[i][j] = time;
//				            System.out.println(time);
//						}
//					}
//					else {
//						System.out.println(this.table2.getValueAt(i, j+1));
//						dataValue[i][j] = this.table2.getValueAt(i, j+1) == null ? ""
//							: this.table2.getValueAt(i, j+1).toString();
//					}
//				}
//			}
////			System.out.println("dataValue ==========>"+dataValue);
//			for(int i=0;i<dataValue.length;i++) {
//				String updateSql = String
//						.format(updateSql = "update AHMC_PFMEALIBRARY set P1 = ?, P2 = ?,P3 = ?,P4 = ?,P5 = ?,P6 = ?,P7 = ? where PLMID = \'%s\'",
//								dataValue[i][0]);
//				SqlUtilT.getTCConnection();
//				SqlUtilT.write(new String[] {  dataValue[i][1],dataValue[i][2],dataValue[i][3],dataValue[i][4],
//						dataValue[i][5],dataValue[i][6],dataValue[i][7]},updateSql);
//			}
			
			//
			if (!isSave) {
//				SavePfmea savePfmea = new SavePfmea(session, meprocess);
//				savePfmea.insertData();
				getData();
				getCombineMap();
				//System.out.println(excelDataList);
				String name = ((TCComponentItemRevision)this.comp).getStringProperty("item_id")+
//						this.meprocess.getStringProperty("item_revision_id")+
						((TCComponentItemRevision)this.comp).getStringProperty("object_name");
				System.out.println(this.excelDataList.toString());
				outPutExcel(pfmeaBean, this.excelDataList, null,name);
			}
			rootPanel.setBackground(Color.GREEN);
			new Thread() {
				@Override
				public void run() {
					try {
						this.sleep(1000);
						rootPanel.setBackground(Color.WHITE);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}.start();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			rootPanel.setBackground(Color.RED);
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
	}


	
	
	//++ձ
	private void clearDatas(){
		for(int i=0;i<table.getSelectedRows().length;i++) {
			for(int j=1;j<table.getColumnCount();j++) {
				table.setValueAt("",table.getSelectedRows()[i],j);
			}
		}
		table.revalidate();
		table.repaint();
	}
	//++

	
	/**
	 * ȡݿе
	 */
	private void getData() {
		// TODO Auto-generated method stub
		ResultSet rs = null;
		InputStream input = null;
		excelDataList.clear();
		itemList.clear();
		try {
			// ȡݿ
			//SqlUtilT.getTCConnection();
			input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			if (meprocess != null) {
				SqlUtilT.getTCConnection();
				String sql = String.format(pro.getProperty("SETPFMEASELECT"), meprocess.getUid(),comp.getUid());
				rs = SqlUtilT.read(sql);
				while (rs.next()) {
					List<Object> rowList = new ArrayList<Object>();
					rowList.add(rs.getString("PLMEID"));
					rowList.add(rs.getString("GYBH"));
					String string = rs.getString("GCMC");
					rowList.add(rs.getString("GCMC"));
					itemList.add(string);
					rowList.add(rs.getString("STATION"));
					rowList.add(rs.getString("REQUIREMENT"));
					rowList.add(rs.getString("QZSXMS"));
					rowList.add(rs.getString("QZSXHG"));
					rowList.add(rs.getString("YZD"));
					rowList.add(rs.getString("JB"));
					rowList.add(rs.getString("QZSXQY"));
					rowList.add(rs.getString("XXGCKZYF"));
					rowList.add(rs.getString("PDS"));
					rowList.add(rs.getString("XXGCKZTC"));
					rowList.add(rs.getString("TCD"));
					rowList.add(rs.getString("RPN"));
					rowList.add(rs.getString("JYCS"));
					rowList.add(rs.getString("ZZR"));
					rowList.add(rs.getString("JHWCRQ"));
					rowList.add(rs.getString("CQDCS"));
					rowList.add(rs.getString("NEW_SEV"));
					rowList.add(rs.getString("NEW_OCC"));
					rowList.add(rs.getString("NEW_DET"));
					rowList.add(rs.getString("NEW_RPN"));
					rowList.add(rs.getString("IDEAL_STATE"));
					rowList.add(rs.getString("SPECIAL"));
					rowList.add(rs.getInt("HH"));
					rowList.add(rs.getString("HBDYG"));
					rowList.add(rs.getInt("HHC"));

					rowList.add(rs.getString("OCCURRRENCE"));
					rowList.add(rs.getString("DETECTION"));
					rowList.add(rs.getString("PRIORITY"));//PRIORITY
					rowList.add(rs.getString("P1"));
					rowList.add(rs.getString("P2"));
					rowList.add(rs.getString("P3"));
					rowList.add(rs.getString("P4"));
					rowList.add(rs.getString("P5"));
					rowList.add(rs.getString("NO"));
					excelDataList.add(rowList);
				}
//				for (int i = 0; i < excelDataList.size(); i++) {
//					// кŲ
//					excelDataList.get(i).set(27, i - Integer.parseInt(excelDataList.get(i).get(25).toString()));
//				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}
	}

	/**
	 * ȡϲԪ
	 */
	public void getCombineMap() {
		try {
			if (excelDataList != null && excelDataList.size() > 0) {
				for (int i = 0; i < excelDataList.size(); i++) {
					if (excelDataList.get(i).get(26) != null && !excelDataList.get(i).get(26).equals("")) {
						String sombine = excelDataList.get(i).get(26).toString();
						int rowDif = Integer.parseInt(excelDataList.get(i).get(27).toString());
						String[] sombines;
						if (sombine.indexOf("-") >= 0) {
							sombines = sombine.split("-");
						} else {
							sombines = new String[] { sombine };
						}
						for (int j = 0; j < sombines.length; j++) {
							if (sombines[j].indexOf("/") >= 0) {
								int[] row;
								int[] cloumn;
								String[] cells = sombines[j].split("/");
								if (cells[0].indexOf(",") >= 0) {
									String[] rows = cells[0].split(",");
									row = new int[rows.length];
									for (int k = 0; k < rows.length; k++) {
										row[k] = Integer.parseInt(rows[k]) + rowDif;
									}
								} else {
									row = new int[] { Integer.parseInt(cells[0]) + rowDif };
								}
								if (cells[1].indexOf(",") >= 0) {
									String[] cloumns = cells[1].split(",");
									cloumn = new int[cloumns.length];
									for (int k = 0; k < cloumns.length; k++) {
										cloumn[k] = Integer.parseInt(cloumns[k]);
									}
								} else {
									cloumn = new int[] { Integer.parseInt(cells[1]) };
								}
								this.excelCombineMap.put(row, cloumn);
							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void picture2(XSSFSheet sheet,XSSFWorkbook wb ,int col,int row,String fileUrl) { //, double scaleX, double scaleY
		try {

			int row2=row;
			ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
	    	BufferedImage bufferImg = ImageIO.read(new File(fileUrl));
	    	ImageIO.write(bufferImg, "png", byteArrayOut);
	    	Drawing drawing = sheet.createDrawingPatriarch();
	    	XSSFClientAnchor anchor = new XSSFClientAnchor();
	    	int picHeight = 500;
	    	int picWidth = 1050;
	    	int rowHeight = 0;
	    	for(int i =row;i<=row2;i++) {
	    		rowHeight += sheet.getRow(i).getHeight();
	    	}
	    	int strLength = sheet.getRow(row).getCell(col).getStringCellValue().length();
	    	int colWidth = sheet.getColumnWidth(col);
	    	row2 +=1;
	    	System.out.println("ǰУ"+row);
	        System.out.println("ǰβУ"+row2);
	    	System.out.println("ǰУ"+col);
	    	System.out.println("иߣ"+rowHeight);
	    	System.out.println("ǰп"+colWidth);

	    	colWidth = sheet.getColumnWidth(col);
	    	
	    	int t3 = (int)(picHeight/15);//ͼƬռԪ߶
	    	int t4 = (int)(picWidth/32);//ͼƬռԪ

//	    	int t6 = (int)(strLength%t5!=0?strLength/t5+1:strLength/t5);//Ԫ
//	    	int t7 = (int)(t6*417/15);//ռԪ߶
	    	int t8 = t3*2;//赥Ԫ߶
//	    	System.out.println(""+t6);
//	    	System.out.println("ָ߶ȣ"+t7);
	    	System.out.println("ǰԪ߶="+(int)(rowHeight/15));
	    	System.out.println("赥Ԫ߶="+t8);
	    	if((int)(rowHeight/15)<t8) {
	    		System.out.println("Ԫ߶Ȳ");
//	    		sheet.getRow(row).setHeight((short) ( t8*15));
	    	}
	    	int tempcolwid = colWidth - picWidth;
	    	if(tempcolwid>0) {
	    		tempcolwid /= 2;
	    		int t = (int)(rowHeight/15);
	    		int t2 = (int)(tempcolwid/32);
	    		System.out.println("t="+t);
	    		System.out.println("t2="+t2);
	    		anchor.setCol1(col);
	    		anchor.setCol2(col);
	    		anchor.setRow1(row);
	    		anchor.setRow2(row2);
	    		System.out.println("tw"+XSSFShape.EMU_PER_PIXEL);
	    		System.out.println("tw"+t);
	    		anchor.setDx1(XSSFShape.EMU_PER_PIXEL * t2); 
	    		anchor.setDx2(XSSFShape.EMU_PER_PIXEL * (t2+t4)); 
	    		if(row+1==row2) {//
	    			System.out.println("");
//	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * 100);
	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t/5)); //-XSSFShape.EMU_PER_PIXEL*(t/3)
//	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * 1);
	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (t3-4*t/5-2)); //-XSSFShape.EMU_PER_PIXEL*(t/3)
	    		}else {//кϲ
	    			System.out.println("");
	    			int tempRow = row;
	    			int row1Height = 0;
	    	    	row1Height = sheet.getRow(tempRow).getHeight();
	    	    	int t9 = (int)(row1Height/15);
	    	    	do {
	    	    		if(t9>(t/2)||tempRow==row2)break;
	    	    		tempRow++;
	    	    		row1Height = sheet.getRow(tempRow).getHeight();
	    	    		t9 +=(int)(row1Height/15);
	    	    	}while(true);
	    	    	if(tempRow == row2)System.out.println(""+row+"У"+col+"δҵʵУ");
	    	    	anchor.setRow1(tempRow);
	    	    	anchor.setRow2(tempRow+1);
	    	    	System.out.println("ʱУ"+tempRow);
	    	    	System.out.println("ʱи߶ȣ"+row1Height/15);
//	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * 150);
//	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * 500);
	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t9-t/2));
	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (t3+t9-t/2-row1Height/15));
	    		}
//	    		anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t - t2/2)); 
//	    		anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (-1*t + t2/2)); 
	    	}
	        System.out.println("y1="+anchor.getDy1());
	        System.out.println("y2="+anchor.getDy2());
	    	
	    	anchor.setAnchorType(ClientAnchor.MOVE_AND_RESIZE);
	    	Picture picture = drawing.createPicture(anchor, wb.addPicture(byteArrayOut.toByteArray(), HSSFWorkbook.PICTURE_TYPE_JPEG));
//	    	picture.resize(1d);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }

	/**
	 * PFMEA
	 * 
	 * @param pfmeaBean
	 * @param dataValeList
	 */
	private void outPutExcel(PFMEABean pfmeaBean, List<List<Object>> dataValeList, String[][] dataValue,String name) {
		// TODO Auto-generated method stub
		InputStream input = null;
		try {
			File pfmeaFile = TMomMethodUtil.getFile(session, "PFMEA", "MSExcel");
			if (pfmeaFile != null) {
				System.out.println("pfmeaFile length ==> "+pfmeaFile.length());
				input = new FileInputStream(pfmeaFile);
			} else {
				MessageBox.post("δҵPFMEAģ壡", "", MessageBox.ERROR);
				return;
			}
			String outFilePath = System.getenv("TEMP") + "\\" + "PFMEA.xlsx";
			FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//			HSSFWorkbook wb = new HSSFWorkbook(input);// (
//			outPutSheet1(wb, dataValue);
//			HSSFSheet sheet = wb.getSheetAt(1);
			XSSFWorkbook wb = new XSSFWorkbook(input);
			XSSFSheet sheet = wb.getSheetAt(0);
//			XSSFSheet sheet2 = wb.getSheetAt(2);
			
			
			//һҳ++++
			int startRow = 8;
			XSSFRow row4 = sheet.getRow(2);
			if(row4==null) {
				row4=sheet.createRow(2);
			}
			setCellValue(row4,2,pfmeaBean.getCompanyName());
			//setCellValue(row,,pfmeaBean);
			setCellValue(row4,9,pfmeaBean.getProject());
//			setCellValue(row4,15,pfmeaBean.getSecurityClassification());
//			15  2
//			XSSFRow row1 = sheet.getRow(1);
//			setCellValue(row1,15,pfmeaBean.getPfmeaNumber());
			XSSFRow row5 = sheet.getRow(3);
			if(row5==null) {
				row5=sheet.createRow(3);
			}
			setCellValue(row5,2,pfmeaBean.getAddress());
			setCellValue(row5,9,pfmeaBean.getPfmeaStartDate());  //汾
			setCellValue(row5,26,pfmeaBean.getPfmeaNumber());  //汾
//			setCellValue(row5,15,pfmeaBean.getPfmeaStartDate());
			XSSFRow row6 = sheet.getRow(4);
			if(row6==null) {
				row6=sheet.createRow(4);
			}
			setCellValue(row6,2,pfmeaBean.getCustomerName());
			setCellValue(row6,9,pfmeaBean.getPfmeaUpdateDate());   //processDutyField
			setCellValue(row6,26,pfmeaBean.getProcessDuty());  //ؼ
			XSSFRow row7 = sheet.getRow(5);
			if(row7==null) {
				row5=sheet.createRow(5);
			}
			setCellValue(row7,2,pfmeaBean.getModelPlatform());
			setCellValue(row7,9,pfmeaBean.getFunctionalTeams());
			setCellValue(row7,26,pfmeaBean.getSecurityClassification());
			for (int i = 0; i < dataValeList.size(); i++) {
				XSSFRow row = null;
				Boolean isCreat = false;
				row = sheet.getRow(i + startRow);
				if(row==null) {
					row = sheet.createRow(i+ startRow);
					isCreat = true;
				}
//				if(i<17) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}else{
//				row = sheet.createRow(i+ startRow);
//				isCreat = true;
//				}
				if (isCreat) {
					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
					
					if(oldRow==null) {
						oldRow = sheet.createRow(i + startRow - 1);
					}
					for (int j = 0; j < 32; j++) {
						XSSFCell oldCell = oldRow.getCell(j);
						if(oldCell==null) {
							oldCell=oldRow.createCell(j);
						}
						XSSFCell newCell = row.createCell(j);
						newCell.setCellStyle(oldCell.getCellStyle());
						newCell.setCellType(oldCell.getCellType());
					}
				}
				//ѭ
				for(int j=1;j<31;j++) {
					if(j==16||j==29) {
						String picMeString;
						if(j>25) {
							picMeString = (String)dataValeList.get(i).get(j+3);
						}else {
							picMeString = (String)dataValeList.get(i).get(j);
						}
						
						System.out.println("picMeString ====> "+picMeString);
						if(picMeString!=null&&!picMeString.equals("")) {
							int indexOf = tstxList.indexOf(picMeString);
							if(indexOf>=1) {
								File file = dsUidList.get(indexOf-1);
								String path = file.getPath();
								System.out.println("path==>"+path);
								picture2(sheet, wb, j-1, i+ startRow, path);
							}
							
						}
						
					}else {
						XSSFCell cell = row.getCell(j-1);
						if(cell==null) {
							cell=row.createCell(j-1);
						}
						
						if(j<25) {
							cell.setCellValue((String)dataValeList.get(i).get(j));
						}else {
							cell.setCellValue((String)dataValeList.get(i).get(j+3));
						}
					}
				}
			}
			//+++++++++++++
			
//			//ڶҳ++++++
//			int startRow2 = 3;
////			XSSFRow row21 = sheet2.getRow(2);
////			if(row21==null) {
////				row21=sheet2.createRow(2);
////			}
////			setCellValue(row21,0,"Ŀ:"+pfmeaBean.getProject());
////			setCellValue(row21,3,"ְ:"+pfmeaBean.getProcessDuty());
////			setCellValue(row21,7,"FMEA:"+pfmeaBean.getPfmeaNumber());
//			XSSFRow row22 = sheet2.getRow(3);
//			if(row22==null) {
//				row22=sheet2.createRow(3);
//			}
////			setCellValue(row22,0,"FMEA(ԭʼ):"+pfmeaBean.getPfmeaStartDate());
//			
//			for (int i = 0; i < dataValue.length; i++) {
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				
//				row = sheet2.getRow(i + startRow2);
//				if(row ==null) {
//					row = sheet2.createRow(i+ startRow2);
//					isCreat = true;
//				}else {
//					isCreat = false;
//				}
//				
////				if(i<15) {
////					row = sheet2.getRow(i + startRow2);
////					isCreat = false;
////				}else{
////				row = sheet2.createRow(i+ startRow2);
////				isCreat = true;
////				}
//				if (isCreat) {
//					XSSFRow oldRow = sheet2.getRow(i + startRow2 - 1);
//					if(oldRow==null) {
//						oldRow = sheet2.createRow(i + startRow2 - 1);
//					}
//					for (int j = 0; j < 9; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						if(oldCell==null) {
//							oldCell=oldRow.createCell(j);
//						}
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					combine(sheet2, new int[] { i + startRow2 }, new int[] { 3, 5 });
//				}
//				//ѭ
////				XSSFCell cell0 = row.getCell(0);
//				setCellValue(row,0,String.valueOf(i+1));  //ؼ
//				setCellValue(row,1,dataValue[i][1]);
//				setCellValue(row,2,itemRevision.getStringProperty("item_revision_id"));
//				setCellValue(row,3,dataValue[i][3]);
//				setCellValue(row,4,dataValue[i][4]);
//				setCellValue(row,5,dataValue[i][5]);
//				setCellValue(row,6,dataValue[i][6]);
////				for(int j=1;j<8;j++) {
////					
////					if(j<5) {
////					XSSFCell cell = row.getCell(j-1);
////					
////					if(cell==null) {
////						cell=row.createCell(j-1);
////					}
////					cell.setCellValue(dataValue[i][j]);
////					}else {
////						XSSFCell cell = row.getCell(j+1);
////						if(cell==null) {
////							cell=row.createCell(j+1);
////						}
////						cell.setCellValue(dataValue[i][j]);
////					}
////				}
//			}
			
//			}
			// ϲԪ
			if (excelCombineMap != null && excelCombineMap.size() > 0) {
				Iterator<Map.Entry<int[], int[]>> it = excelCombineMap.entrySet().iterator();
				while (it.hasNext()) {
					Map.Entry<int[], int[]> entry = it.next();
					int[] row = new int[entry.getKey().length];
					int[] column = new int[entry.getValue().length];
					for (int k = 0; k < entry.getKey().length; k++) {
						//row[k] = entry.getKey()[k] + 17;
						row[k] = entry.getKey()[k]+8 ;
					}
					for (int k = 0; k < entry.getValue().length; k++) {
						if (entry.getValue()[k] == 1) {
							//column[k] = entry.getValue()[k] + 1;
							column[k] = entry.getValue()[k] -1;
						} else {
							//column[k] = entry.getValue()[k]
							column[k] = entry.getValue()[k]-1;
						}
					}
					ExcelUtil.combine_XSSF(sheet, row, column);
				}
			}
			wb.write(output);
			output.close();
			input.close();
			//ExcelUtil.setExcelToItem(session, itemRevision, outFilePath, "PFMEA", true);
			if (ExcelUtil07.getExcelToItem(session, itemRevision,
					"IMAN_specification", "MSExcelX") != null) {
				ExcelUtil07.changeDataSet(
						ExcelUtil07.getExcelToDataset(session, itemRevision, "IMAN_specification", "MSExcelX"),
						"excel", "MSExcelX", outFilePath);
				new File(outFilePath).delete();
			} else {
				ExcelUtil07.setExcelToItem(session, itemRevision, outFilePath, name, "IMAN_specification",
						"MSExcelX", true);
			}
			System.out.println("-------WRITE EXCEL OVER-------");
		} catch (Exception e) {
			// TODO: handle exception
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		} finally {
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private void outPutSheet1(HSSFWorkbook wb, String[][] dataValue) {
		// TODO Auto-generated method stub
		HSSFSheet sheet = wb.getSheetAt(0);
		for (int i = 0; i < dataValue[0].length; i++) {
			HSSFRow row = null;
			Boolean isCreat = false;
			if ((i + 1) > sheet.getLastRowNum()) {
				row = sheet.createRow(i + 1);
				isCreat = true;
			} else {
				row = sheet.getRow(i + 1);
				isCreat = false;
			}
			for (int j = 0; j < dataValue.length; j++) {
				HSSFCell cell = null;
				if (isCreat) {
					cell = row.createCell(j);
				} else {
					cell = row.getCell(j);
				}

				if (cell == null) {
					cell = row.createCell(j);
				}
				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
				cell.setCellValue(dataValue[j][i]);
			}
		}

	}

	private List<List<String>> getTableValue() {
		// TODO Auto-generated method stub
		List<List<String>> dataValeList = new ArrayList<List<String>>();

		for (int j = 0; j < processRows.size(); j++) {
			List<String> rowValue = new ArrayList<String>();
			int a = this.map.getColumnCount();
			for (int j2 = 0; j2 < this.map.getColumnCount()-1; j2++) {
//				if (j2 == 1) {
//					//table.getValueAt(j, j2) != null && isStr2Num(table.getValueAt(j, j2).toString())
//					if (table.getValueAt(j, j2) != null ) {
//						rowValue.add(table.getValueAt(j, j2).toString());
//					} else {
//						rowValue.add("");
//					}
//				}
//
//				else {
					if (j2 < 25) {
						rowValue.add(table.getValueAt(j, j2) == null ? "" : table.getValueAt(j, j2).toString());
					}
//				}
//				// rowValue.add(getCellValue(processRows.get(j), j2));
			}
			rowValue.add(processRows.get(j).toString());//25к
			// rowValue.add("1");
			if (combineMap.size() > 0) {
				rowValue.add(TMomMethodUtil.getCombineCell(combineMap, processRows.get(j)));//26ϲԪ
			} else {
				rowValue.add("");
			}
//			if (rowValue.size() == 26) {
//				rowValue.add("");
//			}
//			if (isComplete) {
//				rowValue.add("1");
//			} else {
			rowValue.add("");//27кŲ
//			}
			rowValue.add("");//28
			rowValue.add("");//29

			for (int j2 = 25; j2 < this.map.getColumnCount()-1; j2++) {
				rowValue.add(table.getValueAt(j, j2) == null ? "" : table.getValueAt(j, j2).toString());
			}
			
			String cellValue = getCellValue(processRows.get(j),this.map.getColumnCount()-1 );
			System.out.println("processRows.get(j)==>"+processRows.get(j)+"map.getColumnCount()"+map.getColumnCount());
			System.out.println("cellValue==>"+cellValue);
			rowValue.add(cellValue);
			dataValeList.add(rowValue);
		}
		// for (int i = 0; i < processRowList.size(); i++) {
		// List<Integer> rows = processRowList.get(i);
		// }
		return dataValeList;
	}

	private String getCellValue(int row, int cloumn) {
		// TODO Auto-generated method stub
		String resultValue = "";
		if (this.map.getValueAt(row, cloumn) != null) {
			resultValue = this.map.getValueAt(row, cloumn).toString();
		}
		if (combineMap != null && combineMap.size() > 0) {
			Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry<int[], int[]> entry = it.next();
				List keysList = new ArrayList<>();
				List valuesList = new ArrayList<>();
				for (int k = 0; k < entry.getKey().length; k++) {
					keysList.add(entry.getKey()[k]);
				}
				for (int k = 0; k < entry.getValue().length; k++) {
					valuesList.add(entry.getValue()[k]);
				}
				if (keysList.contains(row) && valuesList.contains(cloumn)) {
					return (String) this.map.getValueAt(Integer.parseInt(keysList.get(0).toString()),
							Integer.parseInt(valuesList.get(0).toString()));
				}
			}
		} else {
			if (this.map.getValueAt(row, cloumn) != null) {
				return this.map.getValueAt(row, cloumn).toString();
			}

		}
		return resultValue;
	}

	//޸ϢرȨ
	private void closePermission() {
		if(isOwning) {
			//رȨ޸
			if(((TCComponent) comp).isCheckedOut()) {
				ReservationService service=ReservationService.getService((TCSession)app.getSession());
				service.checkin(new TCComponent[] {(TCComponent) this.comp});//ǩ
			}
		}
	}
	
	private String[] setCombineMap() {
		String[] combines = new String[combineMap.size()];
		Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
		int index = 0;
		while (it.hasNext()) {
			Map.Entry<int[], int[]> entry = it.next();
			StringBuffer rowSb = new StringBuffer();
			StringBuffer columnSb = new StringBuffer();
			for (int i = 0; i < entry.getKey().length; i++) {
				rowSb.append(entry.getKey()[i]);
				rowSb.append(",");
			}
			for (int i = 0; i < entry.getValue().length; i++) {
				columnSb.append(entry.getValue()[i]);
				columnSb.append(",");
			}
			combines[index] = rowSb.substring(0, rowSb.length() - 1) + "/"
					+ columnSb.substring(0, columnSb.length() - 1);
			index++;
		}
		return combines;
	}

	private int[] Union(int[] a1, int[] a2) {
		List<Integer> list1 = new ArrayList<Integer>();
		List<Integer> list2 = new ArrayList<Integer>();
		for (int i : a1) {
			list1.add(i);
		}
		for (int i : a2) {
			list2.add(i);
		}
		list1.removeAll(list2);
		list2.addAll(list1);
		int[] result = new int[list2.size()];
		for (int i = 0; i < list2.size(); i++) {
			result[i] = list2.get(i);
		}
		return result;
	}

	/**
	 * 
	 */
	private void addRow() {
		// TODO Auto-generated method stub
		if (this.tabbedPane.getSelectedIndex() == 1) {
			CTMap2 map = ((CTMap2) this.table2.getModel());
			map.insertRow(this.table2.getSelectedRow() + 1);
		} else {
			int row = table.getSelectedRow();
			if (this.processRows != null && this.processRows.size() == 0 && !(this.processRows.contains(row))) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			Map<int[], int[]> cellMap = new HashMap<int[], int[]>();
			Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry<int[], int[]> entry = it.next();
				List keysList = new ArrayList<>();
				for (int j = 0; j < entry.getKey().length; j++) {
					keysList.add(entry.getKey()[j]);
				}
				if (keysList.contains(row)) {
					int[] newKey = new int[entry.getKey().length];
					for (int i = 0; i < entry.getKey().length; i++) {
						for (int j = 0; j < entry.getValue().length; j++) {
							map.split(entry.getKey()[i], entry.getValue()[j]);
						}
						newKey[i] = entry.getKey()[i];
					}
					it.remove();
					// newKey[entry.getKey().length] = newKey[entry.getKey().length - 1] + 1;
					cellMap.put(newKey, entry.getValue());
				} else if (!keysList.contains(row) && Integer.parseInt(keysList.get(0).toString()) > row) {
					int[] newKey = new int[entry.getKey().length];
					for (int i = 0; i < entry.getKey().length; i++) {
						newKey[i] = entry.getKey()[i] + 1;
					}
					it.remove();
					cellMap.put(newKey, entry.getValue());
				}
			}
			map.insertRow(table.getSelectedRow() + 1);
			table.setValueAt(UUID.randomUUID().toString().replace("-", ""), table.getSelectedRow() + 1, 0);
			table.setValueAt(table.getValueAt(table.getSelectedRow(), 2), table.getSelectedRow() + 1, 2);
			table.setValueAt(table.getValueAt(table.getSelectedRow(), table.getColumnCount() - 1), table.getSelectedRow() + 1, table.getColumnCount() - 1);
			 //this.processRows = map.getProcessRowList();
			Iterator<Map.Entry<int[], int[]>> cellIt = cellMap.entrySet().iterator();
			while (cellIt.hasNext()) {
				Map.Entry<int[], int[]> entry = cellIt.next();
				map.combine(entry.getKey(), entry.getValue());
				combineMap.put(entry.getKey(), entry.getValue());
			}
			table.revalidate();
			table.repaint();
		}
	}

	/**
	 * Ӻϲ
	 */
	private void addCombineRow() {
		// TODO Auto-generated method stub
		if (this.tabbedPane.getSelectedIndex() == 1) {
			CTMap2 map = ((CTMap2) this.table2.getModel());
			map.insertRow(this.table2.getSelectedRow() + 1);
		} else {
			int row = table.getSelectedRow();
			if (this.processRows != null && this.processRows.size() == 0 && !(this.processRows.contains(row))) {
				MessageBox.post("ȨУ", "", MessageBox.ERROR);
				return;
			}
			Map<int[], int[]> cellMap = new HashMap<int[], int[]>();
			Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry<int[], int[]> entry = it.next();
				List keysList = new ArrayList<>();
				for (int j = 0; j < entry.getKey().length; j++) {
					keysList.add(entry.getKey()[j]);
				}
				if (keysList.contains(row)) {
					int[] newKey = new int[entry.getKey().length + 1];
					for (int i = 0; i < entry.getKey().length; i++) {
						for (int j = 0; j < entry.getValue().length; j++) {
							map.split(entry.getKey()[i], entry.getValue()[j]);
						}
						newKey[i] = entry.getKey()[i];
					}
					it.remove();
					newKey[entry.getKey().length] = newKey[entry.getKey().length - 1] + 1;
					cellMap.put(newKey, entry.getValue());
				} else if (!keysList.contains(row) && Integer.parseInt(keysList.get(0).toString()) > row) {
					int[] newKey = new int[entry.getKey().length];
					for (int i = 0; i < entry.getKey().length; i++) {
						newKey[i] = entry.getKey()[i] + 1;
					}
					it.remove();
					cellMap.put(newKey, entry.getValue());
				}
			}
			map.insertRow(table.getSelectedRow() + 1);
			table.setValueAt(UUID.randomUUID().toString().replace("-", ""), table.getSelectedRow() + 1, 0);
			table.setValueAt(table.getValueAt(table.getSelectedRow(), 4), table.getSelectedRow() + 1, 4);
			table.setValueAt(table.getValueAt(table.getSelectedRow(), table.getColumnCount() - 1), table.getSelectedRow() + 1, table.getColumnCount() - 1);
			// this.processRows = map.getProcessRowList();
			Iterator<Map.Entry<int[], int[]>> cellIt = cellMap.entrySet().iterator();
			while (cellIt.hasNext()) {
				Map.Entry<int[], int[]> entry = cellIt.next();
				map.combine(entry.getKey(), entry.getValue());
				combineMap.put(entry.getKey(), entry.getValue());
			}
			table.revalidate();
			table.repaint();
		}
	}

	/**
	 * Ƴ
	 */
	private void remRow() {
		// TODO Auto-generated method stub
		if (this.tabbedPane.getSelectedIndex() == 1) {
			if (table2.getSelectedRow() > 0 && table2.getSelectedColumn() > 0) {
				(table2.getCellEditor(table2.getSelectedRow(), table2.getSelectedColumn())).stopCellEditing();
			}
			int[] rows = table2.getSelectedRows();
			CTMap map = ((CTMap) this.table2.getModel());
			for (int i = 0; i < rows.length; i++) {
				map.removeRow(table2.getSelectedRow());
			}
		} else {
			if (table.getSelectedRow() > 0 && table.getSelectedColumn() > 0) {
				(table.getCellEditor(table.getSelectedRow(), table.getSelectedColumn())).stopCellEditing();
			}
			int[] rows = table.getSelectedRows();
			for (int i1 = 0; i1 < rows.length; i1++) {
				if (this.processRows != null && this.processRows.size() > 0
						&& !(this.processRows.contains(table.getSelectedRow()))) {
					MessageBox.post("ȨɾУ", "", MessageBox.ERROR);
					return;
				}
				Map<int[], int[]> cellMap = new HashMap<int[], int[]>();
				Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
				while (it.hasNext()) {
					Map.Entry<int[], int[]> entry = it.next();
					List keysList = new ArrayList<>();
					for (int j = 0; j < entry.getKey().length; j++) {
						keysList.add(entry.getKey()[j]);
					}
					if (keysList.contains(table.getSelectedRow())) {
						int[] newKey = new int[entry.getKey().length - 1];
						for (int i = 0; i < entry.getKey().length; i++) {
							for (int j = 0; j < entry.getValue().length; j++) {
								map.split(entry.getKey()[i], entry.getValue()[j]);
							}
							if (i < newKey.length) {
								newKey[i] = entry.getKey()[i];
							}
						}
						it.remove();
						cellMap.put(newKey, entry.getValue());
					} else if (!keysList.contains(table.getSelectedRow())
							&& Integer.parseInt(keysList.get(0).toString()) > table.getSelectedRow()) {
						int[] newKey = new int[entry.getKey().length];
						for (int i = 0; i < entry.getKey().length; i++) {
							for (int j = 0; j < entry.getValue().length; j++) {
								map.split(entry.getKey()[i], entry.getValue()[j]);
							}
							newKey[i] = entry.getKey()[i] - 1;
						}
						it.remove();
						cellMap.put(newKey, entry.getValue());
					}
				}
				if (map.getValueAt(table.getSelectedRow(), 0) != null
						&& plmeidList.contains(map.getValueAt(table.getSelectedRow(), 0))) {
					deleteRows.add(map.getValueAt(table.getSelectedRow(), 0).toString());
				}
				map.removeRow(table.getSelectedRow());
				// this.processRows = map.getProcessRowList();
				Iterator<Map.Entry<int[], int[]>> cellIt = cellMap.entrySet().iterator();
				while (cellIt.hasNext()) {
					Map.Entry<int[], int[]> entry = cellIt.next();
					if (entry.getKey().length > 0 && entry.getValue().length > 0) {
						map.combine(entry.getKey(), entry.getValue());
						combineMap.put(entry.getKey(), entry.getValue());
					}
				}
				table.revalidate();
				table.repaint();
			}
		}
	}
	
//	/**
//	 * ϲԪ
//	 */
//	private void comBineCell2() {
//		// TODO Auto-generated method stub
//		// table.setRowHeight(2, 50);
//		int[] rows = table2.getSelectedRows();
//		int[] columns = table2.getSelectedColumns();
//		if (rows.length <= 0) {
//			MessageBox.post("ѡҪϲĵԪ", "", MessageBox.ERROR);
//			return;
//		}
////		for (int i = 0; i < rows.length; i++) {
////			if (this.processRows != null && this.processRows.size() > 0 && !(this.processRows.contains(rows[i]))) {
////				MessageBox.post("Ȩ޺ϲԪ", "", MessageBox.ERROR);
////				return;
////			}
////		}
//		if (combineMap2 != null && combineMap2.size() != 0) {
//			for (int i = 0; i < rows.length; i++) {
//				Iterator<Map.Entry<int[], int[]>> it = combineMap2.entrySet().iterator();
//				while (it.hasNext()) {
//					Map.Entry<int[], int[]> entry = it.next();
//					List keysList = new ArrayList<>();
//					for (int j = 0; j < entry.getKey().length; j++) {
//						keysList.add(entry.getKey()[j]);
//					}
//					if (keysList.contains(rows[i])) {
//						for (int j = 0; j < columns.length; j++) {
//							List valueList = new ArrayList<>();
//							for (int k = 0; k < entry.getValue().length; k++) {
//								valueList.add(entry.getValue()[k]);
//							}
//							if (valueList.contains(columns[j])) {
//								columns = Union(columns, entry.getValue());
//								rows = Union(rows, entry.getKey());
//								if (combineMap2.get(entry.getKey()) != null) {
//									it.remove();
//								}
//							}
//						}
//					}
//				}
//			}
//			combineMap2.put(rows, columns);
//		} else {
//			combineMap2.put(rows, columns);
//		}
//		for (int i = 0; i < rows.length; i++) {
//			for (int j = 0; j < columns.length; j++) {
//				map2.split(rows[i], columns[j]);
//			}
//		}
//		Arrays.sort(rows);
//		Arrays.sort(columns);
//		map2.combine(rows, columns);
//		// map.removeRow(table.getSelectedRow());
//		table2.revalidate();
//		table2.repaint();
//	}

	/**
	 * ϲԪ
	 */
	private void comBineCell() {
		// TODO Auto-generated method stub
		// table.setRowHeight(2, 50);
		int[] rows = table.getSelectedRows();
		int[] columns = table.getSelectedColumns();
//		if(rows.length<=1&&columns.length<=1) {
//			return;
//		}
		if (rows.length <= 0) {
			MessageBox.post("ѡҪϲĵԪ", "", MessageBox.ERROR);
			return;
		}
		for (int i = 0; i < rows.length; i++) {
			if (this.processRows != null && this.processRows.size() > 0 && !(this.processRows.contains(rows[i]))) {
				MessageBox.post("Ȩ޺ϲԪ", "", MessageBox.ERROR);
				return;
			}
		}
		if (combineMap != null && combineMap.size() != 0) {
			for (int i = 0; i < rows.length; i++) {
				Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
				while (it.hasNext()) {
					Map.Entry<int[], int[]> entry = it.next();
					List keysList = new ArrayList<>();
					for (int j = 0; j < entry.getKey().length; j++) {
						keysList.add(entry.getKey()[j]);
					}
					if (keysList.contains(rows[i])) {
						for (int j = 0; j < columns.length; j++) {
							List valueList = new ArrayList<>();
							for (int k = 0; k < entry.getValue().length; k++) {
								valueList.add(entry.getValue()[k]);
							}
							if (valueList.contains(columns[j])) {
								columns = Union(columns, entry.getValue());
								rows = Union(rows, entry.getKey());
								if (combineMap.get(entry.getKey()) != null) {
									it.remove();
								}
							}
						}
					}
				}
			}
//			combineMap
			combineMap.put(rows, columns);
		} else {
			combineMap.put(rows, columns);
		}
		for (int i = 0; i < rows.length; i++) {
			for (int j = 0; j < columns.length; j++) {
				map.split(rows[i], columns[j]);
			}
		}
		Arrays.sort(rows);
		Arrays.sort(columns);
		System.out.println("rows"+rows.length+"columns"+columns.length);
		map.combine(rows, columns);
		// map.removeRow(table.getSelectedRow());
		table.invalidate();
		table.revalidate();
		table.repaint();
	}

	/**
	 * ֵԪ
	 */
	private void splitCell() {
		// TODO Auto-generated method stub
		int row = table.getSelectedRow();
		int colmn = table.getSelectedColumn();
		if (row < 0) {
			MessageBox.post("ѡҪֵĵԪ", "", MessageBox.ERROR);
			return;
		}
//		if (this.processRows != null && this.processRows.size() > 0
//				&& !(this.processRows.contains(row))) {
//			MessageBox.post("Ȩ޲ֵԪ", "", MessageBox.ERROR);
//			return;
//		}
		Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry<int[], int[]> entry = it.next();
			List keysList = new ArrayList<>();
			List valuesList = new ArrayList<>();
			for (int j = 0; j < entry.getKey().length; j++) {
				keysList.add(entry.getKey()[j]);
			}
			for (int j = 0; j < entry.getValue().length; j++) {
				valuesList.add(entry.getValue()[j]);
			}
			if (keysList.contains(row) && valuesList.contains(colmn)) {
				for (int i = 0; i < entry.getKey().length; i++) {
					for (int j = 0; j < entry.getValue().length; j++) {
						map.split(entry.getKey()[i], entry.getValue()[j]);
					}
				}
				it.remove();
			}
		}

		table.revalidate();
		table.repaint();
	}
	
	/**
	 * 鿴һַǷתΪ
	 * 
	 * @param str ַ
	 * @return true ; false 
	 */
	public boolean isStr2Num(String str) {
		try {
			Integer.parseInt(str);
			return true;
		} catch (NumberFormatException e) {
			return false;
		}
	}

	/**
	 * ʱ
	 */
	public void runTask() {
		timer = new Timer();
		timer.schedule(new TimerTask() {

			@Override
			public void run() {
				// TODO Auto-generated method stub
				 System.out.println(".....");
//				if(isOwning) {
//				okEvent(true, false);
//				}
			}
		}, 300 * 1000, 300 * 1000);

//		 final long timeInterval = 120000;// һ
//		 Runnable runnable = new Runnable() {
//			 public void run() {
//				while (true) {
//					// ------- code for task to run
//					okEvent(true);
//					// ------- ends here
//					//System.out.println(123);
//					try {
//						Thread.sleep(timeInterval);
//					} catch (InterruptedException e) {
//						e.printStackTrace();
//					}
//				}
//			}
//		};
//		Thread thread = new Thread(runnable);
//		thread.start();
	}

	private class selectExportPath extends AbstractAIFDialog implements ActionListener {
		// ؼ
		private JPanel mainPanel;
		private JFileChooser jfc;
		private JButton okButton;
		private JButton celButton;
		private JButton fileButton;
		private JTextField pathText;
		private JTextField fleName;
		private PFMEABean pfmeaBean;
		private List<List<Object>> dataValeList;
		private String[][] dataValue;
		private String name;
		public selectExportPath(PFMEABean pfmeaBean, List<List<Object>> dataValeList, String[][] dataValue,String name) {
			this.pfmeaBean=pfmeaBean;
			this.dataValeList=dataValeList;
			this.dataValue=dataValue;
			this.name = name;
			init();
		}

		private void init() {
			//ȡʻ
			Locale defaultLocale=Locale.getDefault();
			ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
			// TODO Auto-generated method stub
			this.setTitle(rb.getString("xzdclj31_display.TITLE"));
			this.setPreferredSize(new Dimension(480, 200));
			jfc = new JFileChooser();
			jfc.setCurrentDirectory(new File("c:\\"));// ļѡĳʼĿ¼Ϊd
			this.okButton = new JButton(rb.getString("dc_display.TITLE"));
			this.celButton = new JButton(rb.getString("qx_display.TITLE"));
			this.fileButton = new JButton("...");
			this.okButton.addActionListener(this);
			this.celButton.addActionListener(this);
			this.fileButton.addActionListener(this);
			this.fileButton.setPreferredSize(new Dimension(50, 30));
			this.pathText = new JTextField();
			pathText.setText("C:");
			this.pathText.setPreferredSize(new Dimension(300, 30));
			fleName = new JTextField();
			fleName.setText("PFMEA");
			this.fleName.setPreferredSize(new Dimension(300, 30));

			JLabel label = new JLabel(rb.getString("wjmc31_display.TITLE"));
			label.setPreferredSize(new Dimension(100, 30));
			JLabel label2 = new JLabel(rb.getString("xzwjj_display.TITLE"));
			label2.setPreferredSize(new Dimension(100, 30));

			JPanel panel1 = new JPanel(new FlowLayout());
			panel1.add(label);
			panel1.add(fleName);
			JPanel panel2 = new JPanel(new FlowLayout());
			panel2.add(label2);
			panel2.add(pathText);
			panel2.add(fileButton);

			this.mainPanel = new JPanel(new PropertyLayout());

			this.mainPanel.add("1.1.left.top", panel1);
			this.mainPanel.add("2.1.left.top", panel2);

			JPanel rootPanel = new JPanel(new FlowLayout());
			rootPanel.add(new JLabel("     "));
			rootPanel.add(new JLabel("     "));
			rootPanel.add(this.okButton);
			rootPanel.add(new JLabel("     "));
			rootPanel.add(this.celButton);
			

			this.setLayout(new BorderLayout());
			this.add(mainPanel, BorderLayout.CENTER);
			this.add(rootPanel, BorderLayout.SOUTH);
			this.pack();
			// this.centerToScreen();
			this.showDialog();
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			// TODO Auto-generated method stub
			Object source = e.getSource();
			if (source.equals(this.fileButton)) {
				selectFileButtonEvent(e);
			} else if (source.equals(this.okButton)) {
				// ȡģ
				String outFilePath = this.pathText.getText() + "\\"+this.name.replace("/", "-")+".xlsx";
//+++++++
		
				InputStream input = null;
				try {
					File pfmeaFile = TMomMethodUtil.getFile(session, "PFMEA", "MSExcel");
					if (pfmeaFile != null) {
						input = new FileInputStream(pfmeaFile);
					} else {
						MessageBox.post("δҵPFMEAģ壡", "", MessageBox.ERROR);
						return;
					}
					FileOutputStream output = new FileOutputStream(new File(outFilePath)); 
					XSSFWorkbook wb = new XSSFWorkbook(input);
					XSSFSheet sheet = wb.getSheetAt(1);
					XSSFSheet sheet2 = wb.getSheetAt(2);
					//һҳ++++
					int startRow = 10;
					XSSFRow row4 = sheet.getRow(3);
					setCellValue(row4,4,pfmeaBean.getCompanyName());
					//setCellValue(row,,pfmeaBean);
					setCellValue(row4,7,pfmeaBean.getProject());
					setCellValue(row4,9,pfmeaBean.getPfmeaNumber());
					XSSFRow row5 = sheet.getRow(4);
					setCellValue(row5,4,pfmeaBean.getAddress());
					setCellValue(row5,7,pfmeaBean.getPfmeaStartDate());
					setCellValue(row5,9,pfmeaBean.getProcessDuty());
					XSSFRow row6 = sheet.getRow(5);
					setCellValue(row6,4,pfmeaBean.getCustomerName());
					setCellValue(row6,7,pfmeaBean.getPfmeaUpdateDate());
					setCellValue(row6,9,pfmeaBean.getSecurityClassification());
					XSSFRow row7 = sheet.getRow(6);
					setCellValue(row7,4,pfmeaBean.getModelPlatform());
					setCellValue(row7,7,pfmeaBean.getFunctionalTeams());
					
					for (int i = 0; i < dataValeList.size(); i++) {
						XSSFRow row = null;
						Boolean isCreat = false;
						row = sheet.getRow(i + startRow);
						if(row==null) {
							row = sheet.createRow(i+ startRow);
							isCreat = true;
						}
						
//						if(i<17) {
//							row = sheet.getRow(i + startRow);
//							isCreat = false;
//						}else{
//						row = sheet.createRow(i+ startRow);
//						isCreat = true;
//						}
						if (isCreat) {
							XSSFRow oldRow = sheet.getRow(i + startRow - 1);
							if(oldRow==null) {
								oldRow = sheet.createRow(i + startRow - 1);
							}
							for (int j = 0; j < 32; j++) {
								XSSFCell oldCell = oldRow.getCell(j);
								XSSFCell newCell = row.createCell(j);
								if(oldCell==null) {
									oldCell=oldRow.createCell(j);
								}
								newCell.setCellStyle(oldCell.getCellStyle());
								newCell.setCellType(oldCell.getCellType());
							}
						}
						//ѭ
						for(int j=1;j<31;j++) {
							XSSFCell cell = row.getCell(j-1);
							if(j<25) {
								cell.setCellValue((String)dataValeList.get(i).get(j));
							}else {
								cell.setCellValue((String)dataValeList.get(i).get(j+3));
							}
						}
					}
					//+++++++++++++
					
					//ڶҳ++++++
					int startRow2 = 6;
					XSSFRow row21 = sheet2.getRow(2);
					setCellValue(row21,0,"Ŀ:"+pfmeaBean.getProject());
					setCellValue(row21,3,"ְ:"+pfmeaBean.getProcessDuty());
					setCellValue(row21,7,"FMEA:"+pfmeaBean.getPfmeaNumber());
					XSSFRow row22 = sheet2.getRow(3);
					setCellValue(row22,0,"FMEA(ԭʼ):"+pfmeaBean.getPfmeaStartDate());
					
					for (int i = 0; i < dataValue.length; i++) {
						XSSFRow row = null;
						Boolean isCreat = false;
						
						if(row==null) {
							row = sheet2.createRow(i+ startRow2);
							isCreat = true;
						}
//						if(i<15) {
//							row = sheet2.getRow(i + startRow2);
//							isCreat = false;
//						}else{
//						row = sheet2.createRow(i+ startRow2);
//						isCreat = true;
//						}
						if (isCreat) {
							XSSFRow oldRow = sheet2.getRow(i + startRow2 - 1);
							if(oldRow==null) {
								oldRow = sheet2.createRow(i + startRow2 - 1);
							}
							for (int j = 0; j < 9; j++) {
								XSSFCell oldCell = oldRow.getCell(j);
								if(oldCell==null) {
									oldCell=oldRow.createCell(j);
								}
								XSSFCell newCell = row.createCell(j);
								newCell.setCellStyle(oldCell.getCellStyle());
								newCell.setCellType(oldCell.getCellType());
							}
							combine(sheet2, new int[] { i + startRow2 }, new int[] { 3, 5 });
						}
						//ѭ
						for(int j=1;j<8;j++) {
							if(j<5) {
							XSSFCell cell = row.getCell(j-1);
							cell.setCellValue(dataValue[i][j]);
							}else {
								XSSFCell cell = row.getCell(j+1);
								cell.setCellValue(dataValue[i][j]);
							}
						}
					}

					// ϲԪ
					if (excelCombineMap != null && excelCombineMap.size() > 0) {
						Iterator<Map.Entry<int[], int[]>> it = excelCombineMap.entrySet().iterator();
						while (it.hasNext()) {
							Map.Entry<int[], int[]> entry = it.next();
							int[] row = new int[entry.getKey().length];
							int[] column = new int[entry.getValue().length];
							for (int k = 0; k < entry.getKey().length; k++) {
								//row[k] = entry.getKey()[k] + 17;
								row[k] = entry.getKey()[k]+10 ;
							}
							for (int k = 0; k < entry.getValue().length; k++) {
								if (entry.getValue()[k] == 1) {
									//column[k] = entry.getValue()[k] + 1;
									column[k] = entry.getValue()[k] -1;
								} else {
									//column[k] = entry.getValue()[k]
									column[k] = entry.getValue()[k]-1;
								}
							}
							ExcelUtil.combine_XSSF(sheet, row, column);
						}
					}
					wb.write(output);
					output.close();
					input.close();
				} catch (Exception e1) {
					// TODO: handle exception
					MessageBox.post(e1.toString(), "", MessageBox.ERROR);
					e1.printStackTrace();
				} finally {
					if (input != null) {
						try {
							input.close();
						} catch (IOException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
				}
//+++++++
				MessageBox.post("Excelɹ", "ɹ", MessageBox.INFORMATION);
				this.dispose();
			} else if (source.equals(this.celButton)) {
				this.dispose();
			}
		}
		
		/**
		 * ļѡť¼
		 * 
		 * @param e
		 */
		public void selectFileButtonEvent(ActionEvent e) {
			jfc.setFileSelectionMode(1);// 趨ֻѡļ
			int state = jfc.showOpenDialog(null);// ˾ǴļѡĴ
			if (state == 1) {
				return;
			} else {
				File f = jfc.getSelectedFile();// fΪѡ񵽵Ŀ¼
				pathText.setText(f.getAbsolutePath());
			}
		}
	}
	
	
	
	
	private class SpecialDialog extends JFrame implements ActionListener {
		private JPanel tablePanel;// ؼ
		private JTable table;

		private JPanel rootPanel;// ť
		private JButton okButton;// ȷ
		private JButton celButton;// ȡ

		public SpecialDialog() {
			// TODO Auto-generated constructor stub
			super();
			init();
		}

		private void init() {
			//ȡʻ
			Locale defaultLocale=Locale.getDefault();
			ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
			// TODO Auto-generated method stub
			this.setTitle(rb.getString("xztsfh10_display.TITLE"));
			this.table = getjTable(this.table, null, new Object[] { 1, 2, 3, 4, 5, 6, 7, 8 },
					new Object[][] { { 1, 2, 3, 4, 5, 6, 7, 8 }, { 9, 0, "q", "w", "e", "r", "t", "y" } });
			this.setLocationRelativeTo(this);
			this.table.setRowHeight(30);
			this.table.getTableHeader().setVisible(false);
			this.table.setFont(new Font("Y14.5M", 0, 15));
			this.tablePanel = new JPanel(new BorderLayout());
			this.tablePanel.add(this.table);

			this.okButton = new JButton(rb.getString("qd_display.TITLE"));
			this.okButton.addActionListener(this);
			this.celButton = new JButton(rb.getString("qx_display.TITLE"));
			this.celButton.addActionListener(this);
			this.rootPanel = new JPanel(new FlowLayout());
			this.rootPanel.add(this.okButton);
			this.rootPanel.add(this.celButton);

			this.add(this.tablePanel, BorderLayout.CENTER);
			this.add(this.rootPanel, BorderLayout.SOUTH);
			this.pack();
			this.show();
		}

		// Jtableͨ÷
		public JTable getjTable(JTable partsTable, DefaultTableModel dtm, Object[] titleNames, Object[][] values) {
			int simpleLen = 100;
			int totleLen = 1000;
			if (partsTable == null) {
				partsTable = new JTable(this.getTableModel(dtm, titleNames, values));
				partsTable.setCellSelectionEnabled(true);
				if (simpleLen * titleNames.length >= totleLen) {
					for (int i = 0; i < titleNames.length; i++) {
						partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
					}
					partsTable.setAutoResizeMode(0);
				} else {
					partsTable.setAutoResizeMode(1);
				}
			}
			return partsTable;
		}

		public DefaultTableModel getTableModel(DefaultTableModel dtm, Object[] titleNames, Object[][] values) {
			MyTableModel tableModel = null;
			if (dtm == null) {
				tableModel = new MyTableModel(values, titleNames);
			}
			return tableModel;
		}

		@Override
		public void actionPerformed(ActionEvent actionevent) {
			// TODO Auto-generated method stub
			Object source = actionevent.getSource();
			if (source.equals(this.okButton)) {
				int row = DesignPFMEADialog.table.getSelectedRow();
				int column = DesignPFMEADialog.table.getSelectedColumn();
				// λ
				String columnName = DesignPFMEADialog.table
						.getColumnName(DesignPFMEADialog.table.getSelectedColumn());

				int cursorIndex = ((TextAreaCellEditor) (DesignPFMEADialog.table.getCellEditor(row, column)))
						.getIndex();
				System.out.println("index+" + cursorIndex);
				(DesignPFMEADialog.table.getCellEditor(row, column)).stopCellEditing();
				// DesignPFMEADialog.table.getDefaultEditor(Object.class).stopCellEditing();
				StringBuilder sb = new StringBuilder(DesignPFMEADialog.table.getValueAt(row, column).toString());

				// ѭ,indexλò-1,һֱ
				Integer index = 0;
				while ((index = sb.toString().indexOf("\n", index)) != -1) {

					// ÿѭһξҪȷһβҵλ
					index = index + "\n".length();
					// ÿһμ
					cursorIndex++;
				}
				// 
				Object special = DesignPFMEADialog.table.getValueAt(row,
						DesignPFMEADialog.table.getColumnCount() - 1);
				if (special == null || special.toString() == "") {
					DesignPFMEADialog.table.setValueAt(columnName + "-" + cursorIndex, row,
							DesignPFMEADialog.table.getColumnCount() - 1);
				} else {
					DesignPFMEADialog.table.setValueAt(special + "|" + columnName + "-" + cursorIndex, row,
							DesignPFMEADialog.table.getColumnCount() - 1);
				}
				System.out.println(sb.length());
				String s = sb
						.insert(cursorIndex, this.table
								.getValueAt(this.table.getSelectedRow(), this.table.getSelectedColumn()).toString())
						.toString();
				DesignPFMEADialog.table.setValueAt(s, DesignPFMEADialog.table.getSelectedRow(),
						DesignPFMEADialog.table.getSelectedColumn());
				System.out.println(DesignPFMEADialog.table.getValueAt(row, column).toString());
			} else {
				this.dispose();
			}
		}
	}

	private class LibraryDialog extends JFrame {
		private List<TreeBean> beans = new ArrayList<TreeBean>();
		private int index = -1;
		private List<Integer> dontMove = new ArrayList<Integer>();
		private TableRowSorter mainSorter;
		// ѯ
		private JTextField findLeftField;
		private JButton findLeftButton;
		// ѯ
		private JTextField findMainField;
		private JTextField findColumnField;
		private JButton findMainButton;
		
		private JTextField heightField;
		private JButton heightButton;
		private JButton saveBtnSize;
		private JButton findColumnButton;
		// ؼ
		private JTextPane selectCellValuePane;
		private JPanel titlePanel;// 
		private JLabel titleLabel;
		// 
		private CTable leftTable;
		private JTable mainTable;
		private int setRowHeight = 0;
		private int selectMainRow = -1;
		private int selectMainCol = -1;
		private Map<int[], int[]> combineMap=new HashMap<int[], int[]>();// źϲԪ
		
//		private Map<int[], int[]> combineMap2=new HashMap<int[], int[]>();// źϲԪ
		private CTMap2 map;

		// Ҽ˵
		private JPopupMenu libraryMenu;
		// Ҽ˵
		private JMenuItem copyRowItem;// ƶ
		
		private String gcbz;
		// ǩؼ
		// private JTabbedPane tabbedPane;
		public LibraryDialog(String string) {
			// TODO Auto-generated constructor stub
			super();
			// getData();
			this.gcbz=string;
			getPFMEAData();
			init();
		}
		public LibraryDialog() {
			// TODO Auto-generated constructor stub
			super();
			// getData();
			getPFMEAData();
			init();
		}
		public void HiddenCell(int column,JTable table) {
			TableColumn tc = table.getTableHeader().getColumnModel().getColumn(column);
			tc.setMaxWidth(0);
			tc.setPreferredWidth(0);
			tc.setWidth(0);
			tc.setMinWidth(0);
			table.getTableHeader().getColumnModel().getColumn(column).setMaxWidth(0);
			table.getTableHeader().getColumnModel().getColumn(column).setMinWidth(0);
		}
		public void HiddenRow(int row,JTable table) {
//			TableColumn tc = table.getTableHeader().getColumnModel().getColumn(column);
//			table.getRow
			table.setRowHeight(row, 1);
//			table.getModel()
//			tc.setMaxWidth(0);
//			tc.setPreferredWidth(0);
//			tc.setWidth(0);
//			tc.setMinWidth(0);
//			table.getTableHeader().getColumnModel().getColumn(column).setMaxWidth(0);
//			table.getTableHeader().getColumnModel().getColumn(column).setMinWidth(0);
		}
		public void analyticSize2(List<String> rowList) {
			if(rowList.get(0).indexOf("/")>-1) {//ȡСλ
				String[] data=rowList.get(0).split("/");
				for(int i=0;i<4;i++) {
					SizeLoca2[i]=Integer.parseInt(data[i]);
				}
			}
			if(rowList.get(1).indexOf("/")>-1) {
				String[] data=rowList.get(1).split("/");
				for(int i=0;i<3;i++) {
					table1Size2[i]=Integer.parseInt(data[i]);
				}
			}
			if(rowList.get(2).indexOf("/")>-1) {
				String[] data=rowList.get(2).split("/");
				for(int i=0;i<29;i++) {
					table2Size2[i]=Integer.parseInt(data[i]);
				}
			}
			
			if(!rowList.get(3).equals("")) {
				initRowHeight2 = Integer.valueOf(rowList.get(3));
			}
			
			
		}
		private boolean isFirstOpen2=false;
		public void getFrameSize2() {
			// ȡݿ
			SqlUtilT.getTCConnection();
			ResultSet rs = null;
			ResultSet rs0 = null;
			InputStream input = null;
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			try {
				pro.load(input);
				String sql = String.format("select * from AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'",userName,"PFMEAlibraryDialog");
				rs = SqlUtilT.read(sql);
				List<String> rowList = new ArrayList<String>();
				while (rs.next()) {
					rowList.add(rs.getString("FRAMESIZE"));//Сλ
					rowList.add(rs.getString("TABLE1SIZE"));//һп
					rowList.add(rs.getString("TABLE2SIZE"));//ڶп
					rowList.add(rs.getString("ROWHEIGHT"));//1и
					break;
				}
				if(rowList.size()==4) {//Сλãп
					analyticSize2(rowList);
				}else {
					String sql0 = String.format("select * from AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'","iniUser","PFMEAlibraryDialog");
					rs0 = SqlUtilT.read(sql0);
					while (rs0.next()) {
						rowList.add(rs0.getString("FRAMESIZE"));//Сλ
						rowList.add(rs0.getString("TABLE1SIZE"));//һп
						rowList.add(rs0.getString("TABLE2SIZE"));//ڶп
						
						rowList.add(rs0.getString("ROWHEIGHT"));//1и
						break;
					}
					if(rowList.size()<=0) {
						MessageBox.post("(ݿ)δýߴ磬ã", "", MessageBox.ERROR);
						return;
					}else {
						isFirstOpen=true;
						analyticSize2(rowList);
					}
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}finally {
				if (rs != null) {
					SqlUtilT.free(rs);
				}
				if(rs0 != null) {
					SqlUtilT.free(rs0);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
			}
	}
		private int[] SizeLoca2=new int[4];
		private int[] table1Size2=new int[3];
		private int[] table2Size2=new int[29];
		private int initRowHeight2 = 50;
		private TableRowSorter sorter;
		private void init() {
			getFrameSize2();
			//ȡʻ
			Locale defaultLocale=Locale.getDefault();
			ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
			// TODO Auto-generated method stub
			this.setTitle(rb.getString("PFMEAc10_display.TITLE"));
//			this.setPreferredSize(new Dimension(850, 600));
			this.setPreferredSize(new Dimension(SizeLoca2[0], SizeLoca2[1]));
			System.out.println(SizeLoca2[0]+"sizes"+ SizeLoca2[1]);
			this.setLocation(SizeLoca2[2], SizeLoca2[3]);
			// ʼⲿֿؼ
			this.titlePanel = new JPanel();
			this.titleLabel = new JLabel(rb.getString("qzsxmsjhgfx10_display.TITLE"));
			this.titleLabel.setFont(new Font("", 1, 18));
			this.titlePanel.add(this.titleLabel);

			JPanel centerPanel = new JPanel(new BorderLayout());
			centerPanel.add(titlePanel, BorderLayout.NORTH);

			JPanel findLeftPanel = new JPanel(new PropertyLayout());
			this.findLeftField = new JTextField();
			this.findLeftField.setPreferredSize(new Dimension(100, 20));
			this.findLeftButton = new JButton(rb.getString("cz10_display.TITLE"));
			findLeftPanel.add("1.1.left.top", this.findLeftField);
			findLeftPanel.add("1.2.left.top", this.findLeftButton);

			this.leftTable = getNewjTable(null, null, leftHeader, beans.size(), false);
			// 
			leftTable.HiddenCell(0);
			leftTable.HiddenCell(3);
			leftTable.setRowHeight(30);
			int ind = -1;
			for (int i = 0; i < beans.size(); i++) {
//				this.leftTable.setValueAt(beans.get(i).getPlmeid(), i, 0);
				this.leftTable.setValueAt(beans.get(i).getId(), i, 1);
				if(gcbz!=null) {
					System.out.println("beans.get(i).getName() " + beans.get(i).getName() + " gcbz"+gcbz);
					if(gcbz.contains(beans.get(i).getName())) {
						ind = i;
					}
				}
				
				this.leftTable.setValueAt(beans.get(i).getName(), i, 2);
//				this.leftTable.setValueAt(beans.get(i).getParentId(), i, 3);
			}
			CTMap2 cmodel = (CTMap2) this.leftTable.getModel();
			sorter = new TableRowSorter(cmodel);
			this.leftTable.setRowSorter(sorter); // ΪJTable
			for(int i=1;i<=2;i++) {
				leftTable.getColumnModel().getColumn(i).setPreferredWidth(table1Size[i-1]);;
			}
			this.findLeftButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (findLeftField.getText().length() == 0) {
						sorter.setRowFilter(null);
					} else {
						sorter.setRowFilter(RowFilter.regexFilter(findLeftField.getText()));// ΪJTableûʽĹ
					}
				}
			});
			leftTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
				@Override
				public void valueChanged(ListSelectionEvent arg0) {
					// TODO Auto-generated method stub
					if (index == -1) {
						refreshPFMEATable();
						index = leftTable.getSelectedRow();
					} else if (index != -1 && index != leftTable.getSelectedRow()) {
						refreshPFMEATable();
						index = leftTable.getSelectedRow();
					}
				}
			});
			JPanel findMainPanel = new JPanel(new PropertyLayout());
			this.findMainField = new JTextField();
			this.findMainField.setPreferredSize(new Dimension(100, 20));
			this.findMainButton = new JButton(rb.getString("cz10_display.TITLE"));
			
			this.findColumnField = new JTextField();
			this.findColumnField.setPreferredSize(new Dimension(100, 20));
			this.findColumnButton = new JButton("вѯ");
			
			this.heightField = new JTextField();
			this.heightField.setPreferredSize(new Dimension(100, 20));
			this.heightButton = new JButton("иߵ");
			
			this.saveBtnSize = new JButton("汣");
			
			findMainPanel.add("1.1.left.top", this.findMainField);
			findMainPanel.add("1.2.left.top", this.findMainButton);
			
			findMainPanel.add("1.3.left.top", this.findColumnField);
			findMainPanel.add("1.4.left.top", this.findColumnButton);
			
			findMainPanel.add("1.5.left.top", this.heightField);
			findMainPanel.add("1.6.left.top", this.heightButton);
			findMainPanel.add("1.7.left.top", this.saveBtnSize);
			
			this.mainTable = getNewjTable(null, null, pfmeaKuHeader, 0, false);
			// 
			HiddenCell(0,mainTable);
			HiddenCell(1,mainTable);
//			mainTable.HiddenCell(pfmeaKuHeader.length - 1);
			HiddenCell(pfmeaKuHeader.length - 1,mainTable);
			HiddenCell(pfmeaKuHeader.length - 2,mainTable);
			if(initRowHeight2==0) {
				mainTable.setRowHeight(40);
			}else {
				mainTable.setRowHeight(initRowHeight2);
			}
			
			for(int i=2;i<=table2Size2.length+1;i++) {
				this.mainTable.getColumnModel().getColumn(i).setPreferredWidth(table2Size2[i-2]);;
			}
//			mainSorter = new TableRowSorter(this.mainTable.getModel());
//			this.mainTable.setRowSorter(mainSorter); // ΪJTable
			this.saveBtnSize.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						try {
							String list1=String.valueOf(((int)getSize().getWidth()))+"/"+String.valueOf((int)getSize().getHeight())
							+"/"+String.valueOf(((int)getLocation().getX()))+"/"+String.valueOf((((int)getLocation().getY())));

//							String list2="";
//							for(int i=1;i<leftTable.getColumnModel().getColumnCount()-1;i++) {
//								if(i==leftTable.getColumnModel().getColumnCount()-2) {
//									list2+=String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()));
//								}else {
//									list2+=(String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()))+"/");
//								}
//							}
							String list3="";
							for(int i=2;i<mainTable.getColumnModel().getColumnCount();i++) {
								if(i==mainTable.getColumnModel().getColumnCount()-1) {
									list3+=String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()));
								}else {
									list3+=(String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()))+"/");
								}
							}
							SqlUtilT.getTCConnection();
							InputStream input = null;
							input = new BufferedInputStream(getClass().getResourceAsStream(
									"/sql.properties"));
							Properties pro = new Properties();
							try {
								pro.load(input);
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							System.out.println("this.userName====>"+userName);
							System.out.println("this.type====>"+"DesignToLib");
							System.out.println("list1====>"+list1.toString());
//							System.out.println("list2====>"+list2.toString());
							System.out.println("list3====>"+list3.toString());
							if(isFirstOpen) {
//								String insertSQL = "INSERT INTO AHMC_PFMEAFRAME_SIZE VALUES(?,?,?,?,?,?,?)";
//								SqlUtilT.write(new String[] {
//										UUID.randomUUID().toString().replace("-", ""),
//										userName,"PFMEAlibraryDialog",list1,list2,list3,String.valueOf(mainTable.getRowHeight())}, insertSQL);
//								System.out.println("insertSQL====>"+insertSQL);
//								isFirstOpen=false;
								System.out.println("first?");
							}else {
								String updateSQL = String.format(
										"update AHMC_PFMEAFRAME_SIZE set FRAMESIZE = ?, TABLE2SIZE = ?,ROWHEIGHT = ? WHERE USERNAME ='%s' AND TYPE = '%s'",userName,"PFMEAlibraryDialog");
								SqlUtilT.update(
										new String[] {list1,list3,String.valueOf(mainTable.getRowHeight())},updateSQL);
							}
							SqlUtilT.freeAll();
							///++++++
						} catch (Exception e3) {
							// TODO: handle exception
						}
//						
//						mainTable.invalidate();
					} catch (Exception e2) {
						// TODO: handle exception
						e2.printStackTrace();
//						System.out.println("");
					}
				}
			});
			this.heightButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String selectedText = heightField.getText();
					try {
//						Double valueOf = Double.valueOf(selectedText);
						int rowCount = mainTable.getRowCount();
						int rowHeight = 40;
						Integer valueOf = Integer.valueOf(selectedText);
						if(valueOf>10 || valueOf<1) {
							MessageBox.post("и߽1-10֮","ʾ",2);
						}
						System.out.println("valueOf"+valueOf+"rowHeight"+rowHeight);
						rowHeight = (int) (rowHeight*valueOf);
						System.out.println("new rowHeight"+rowHeight);
						setRowHeight = rowHeight;
						mainTable.setRowHeight(rowHeight);
//						mainTable.invalidate();
					} catch (Exception e2) {
						// TODO: handle exception
						e2.printStackTrace();
//						System.out.println("");
					}
					
					
				}
			});
			this.findColumnButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {

//					leftTable.setRowSelectionInterval(lastSelectedRow,lastSelectedRow);
					try {
						
						dontMove.clear();
						System.out.println(lastSelectedRow+"lastSelectedRow");
						refreshPFMEATable((String)leftTable.getValueAt(lastSelectedRow, 1));
						JTable jTable = mainTable; 
						CTMap2 model = (CTMap2) jTable.getModel();
						System.out.println(jTable.getRowCount());
//						int columnSelect = jTable.getSelectedColumnCount();
//						int rowSelect = jTable.getSelectedRow();
						System.out.println("jTable"+selectMainRow+"columnSelect"+selectMainCol);
						if(selectMainRow ==-1 || selectMainCol==-1) {
							System.out.println("δѡĳһ");
						}else {
							List<Integer> removeRows = new ArrayList<Integer>();
//							combineMap.get(0);
//							int index
							String text = findColumnField.getText();
							System.out.println("ѯ"+text);
							int rowCount = jTable.getRowCount();
							if(!text.trim().equals("")) {
								int removes = 0;
//								int 
								combineMap.clear();
								for(int t=0;t<rowCount;t++) {
									List<Object> list = rememberRow.get(t);
									String object = (String) list.get(35);
//									System.out.println(rememberRow.get(index));
									String valueAt =(String)rememberRow.get(t).get(selectMainCol); //(String) jTable.getValueAt(t, selectMainCol);
									System.out.println("valueAt  =====> "+valueAt);
//									index = index + 1;
									if(valueAt ==null || !valueAt.contains(text)) {
										System.out.println( "remove ======> "+t);
										removeRows.add(t);
										removes = removes + 1;
									}else {
										comBine(object,removes);
									}
								}
								System.out.println(dontMove.toString()+"---------");
								for(int t = removeRows.size()-1;t>=0;t--) {
//									ta
									if(!dontMove.contains(removeRows.get(t))) {
										model.removeRow(removeRows.get(t));
									}
								}
//								map.in
//								map = new CTMap2(model.getRowCount(),pfmeaKuHeader.length);
								map.setNumRows(model.getRowCount());
								map.setSize(new Dimension(pfmeaKuHeader.length, model.getRowCount()));
								System.out.println("combineMap2"+combineMap.size());
								if (combineMap != null && combineMap.size() != 0) {
									Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
									while (it.hasNext()) {
										Map.Entry<int[], int[]> entry = it.next();
//										for()
										int[] key = entry.getKey();
										for(int xx=0;xx<key.length;xx++) {
											System.out.println("xx"+xx);
										}
										map.combine(entry.getKey(), entry.getValue(),model.getRowCount());
									}
								}
							}
							
							
							
							
						}
						jTable.invalidate();
					} catch (Exception e2) {
						// TODO: handle exception
						e2.printStackTrace();
					}
					
				}
			});
			this.findMainButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (findMainField.getText().length() == 0) {
						mainSorter.setRowFilter(null);
					} else {
						mainSorter.setRowFilter(RowFilter.regexFilter(findMainField.getText()));// ΪJTableûʽĹ
					}
				}
			});
			// 
			mainTable.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent mouseevent) {
					// TODO Auto-generated method stub
					try {
						selectMainCol = mainTable.getSelectedColumn();
						selectMainRow = mainTable.getSelectedRow();
						if (mouseevent.getClickCount() == 2) {
							if (DesignPFMEADialog.table.getSelectedRow() >= 0) {
								if(mainTable.getSelectedColumn()==2) {
									DesignPFMEADialog.table.getCellEditor(DesignPFMEADialog.table.getSelectedRow(),
											DesignPFMEADialog.table.getSelectedColumn()).stopCellEditing();
									for (int i = 2; i < mainTable.getColumnCount(); i++) {
										if (i == mainTable.getColumnCount() - 1 || i== 3) {//һڵ㲻ܸ
											continue;
										} 
										else {
										DesignPFMEADialog.table.setValueAt(
													mainTable.getValueAt(mainTable.getSelectedRow(), i),
													DesignPFMEADialog.table.getSelectedRow(), i-1);
										}
									}
//									for (int j = 2; j < mainTable.getColumnCount(); j++) {
//										//+++
//										if(j == mainTable.getColumnCount() - 1 || j== 5) {//һڵ㲻ܸ
//											continue;
//										}else {
//											if((DesignPFMEADialog.table.getSelectedRow())<DesignPFMEADialog.table.getRowCount()) {//ֹѡиƵг
//												DesignPFMEADialog.table.setValueAt(
//															jtable.getValueAt(selectRowAll.get(i), j),
//															DesignPFMEADialog.table.getSelectedRow() + i, j-1 );
//												}
//										}
//									}
								}else {
									DesignPFMEADialog.table.setValueAt(
											mainTable.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()),
											DesignPFMEADialog.table.getSelectedRow(), DesignPFMEADialog.table.getSelectedColumn());
								}
								
							}
						}
						if (mouseevent.getClickCount() == 1) {
							if (mainTable.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()) != null) {
								selectCellValuePane.setText(mainTable
										.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()).toString());
							} else {
								selectCellValuePane.setText("");
							}
						}
						if (mouseevent.getButton() == MouseEvent.BUTTON3) {
							libraryMenu.show(mainTable, mouseevent.getX(), mouseevent.getY());
						}
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
					
				}
			});
			Adapter adapter = new Adapter(mainTable);
			JScrollPane scrollPane = new JScrollPane(mainTable);
			scrollPane.getVerticalScrollBar().setUnitIncrement(2);
			JScrollPane scrollPane2 = new JScrollPane(leftTable);
			scrollPane2.setPreferredSize(new Dimension(150, 600));
			scrollPane2.getVerticalScrollBar().setUnitIncrement(2);

			JSplitPane splitPane2 = new JSplitPane();
			splitPane2.setOneTouchExpandable(true);// ÷ָʾͷ
			splitPane2.setContinuousLayout(true);// ͷػͼ
			splitPane2.setLeftComponent(scrollPane2);
			splitPane2.setRightComponent(scrollPane);

			// Ҽ˵
			libraryMenu = new JPopupMenu();
			// 
			copyRowItem = new JMenuItem(rb.getString("fzdh10_display.TITLE"));
			copyRowItem.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent actionevent) {
					// TODO Auto-generated method stub
					try {
						Component component = tabbedPane.getSelectedComponent();
//						if (component instanceof JScrollPane) {
//							JScrollPane scrollPane = (JScrollPane) component;
//							Component tableComponent = scrollPane.getViewport().getView();
//							if (tableComponent instanceof CTable) {
						
						JTable jtable = mainTable;
						int firstRow = -1;
						List<Integer> selectRowAll = new ArrayList<Integer>();
//						for(int t=0;t<mainTable.getRowCount();t++) {
//							Boolean valueAt = (Boolean) mainTable.getValueAt(t, 1);
//							if(firstRow ==-1 && valueAt) {
//								firstRow = t;
//							}
//							if(valueAt) {
//								
//								selectRowAll.add(t);
//							}
//						}
						int[] selectedRows = mainTable.getSelectedRows();
						for(int selectedRow:selectedRows) {
							if(firstRow ==-1) {
								firstRow = selectedRow;
							}
							selectRowAll.add(selectedRow);
						}
						
						if(firstRow==-1) {
							System.out.println("ûѡ");
						}
						//ڻԭPFMEAѡ
						int PFMEADialogSelectrow=DesignPFMEADialog.table.getSelectedRow();//PFMEAѡе
						int PFMEADialogSelectrows=DesignPFMEADialog.table.getSelectedRowCount();//PFMEAѡе
						int PFMEADialogSelectColumn=DesignPFMEADialog.table.getSelectedColumn();//PFMEAѡе
						int PFMEADialogSelectColumns=DesignPFMEADialog.table.getSelectedColumnCount();//PFMEAѡе
						
						//λѡеһԱԶ
						DesignPFMEADialog.table.setRowSelectionInterval(PFMEADialogSelectrow+PFMEADialogSelectrows-1, PFMEADialogSelectrow+PFMEADialogSelectrows-1);//λѡеһ
						if(PFMEADialogSelectrows<selectRowAll.size()) {
							for(int i=0;i<selectRowAll.size()-PFMEADialogSelectrows;i++) {
								addRow();	
							}
						}
						//ԶкҪ¶λѡеĵһУ
						DesignPFMEADialog.table.setRowSelectionInterval(PFMEADialogSelectrow, PFMEADialogSelectrow);
						int low = 0;
						//jtableѡи飬ڼѡǷϲ
						int[] selectRows= new int[selectRowAll.size()];
						for(int k=0;k<selectRowAll.size();k++) {
							selectRows[k]=selectRowAll.get(k);
							if(k>0) {
								int z = selectRowAll.get(k) - selectRows[k-1];
								if(z>1) {
									low = low + z -1;
								}
							}
						}
						DesignPFMEADialog.table.revalidate();
						DesignPFMEADialog.table.repaint();
						
						//ͨPFMEAежλPFMEAе
						int Dvalue=DesignPFMEADialog.table.getSelectedRow()-firstRow;
						
						Set<int[]> combinRows=combineMap.keySet();
						//ѡеǷϲ
						for(int[] combinRow:combinRows) {
							if(iscontain(selectRows, combinRow)!=null) {
								System.out.println("------ҵҪϲĵԪ");
								int[] hbh=iscontain(selectRows, combinRow);
								System.out.println("------ϲ"+hbh[hbh.length-1]+Dvalue);
								int[] hbl=combineMap.get(combinRow);
								int start = hbh[0] - firstRow;
								System.out.println("------ϲ"+start+"xxxxx" +Dvalue +"hbl[0]"+hbl[0] +"hbl[hbl.length-1]"+hbl[hbl.length-1]);
								//System.out.println("ϲк====>:"+Arrays.toString(hbh));
								//ͨDvalueתϲPFMEAPFMEAѡеĵλ
								
								DesignPFMEADialog.table.setRowSelectionInterval(  hbh[0] + Dvalue - low, hbh[hbh.length-1]+Dvalue - low);
								//ΪPFMEAǰУ012û洢ݶPFMEAֻУ01ʴʱҪ1
								DesignPFMEADialog.table.setColumnSelectionInterval(hbl[0]-1, hbl[hbl.length-1]-1);
								comBineCell();
							}
						}
						//ϲнҪѡлصʼλãڲ
						DesignPFMEADialog.table.setRowSelectionInterval(PFMEADialogSelectrow, PFMEADialogSelectrow+PFMEADialogSelectrows-1);
						DesignPFMEADialog.table.setColumnSelectionInterval(PFMEADialogSelectColumn, PFMEADialogSelectColumn+PFMEADialogSelectColumns-1);
						
						
						
						for (int i = 0; i < selectRowAll.size() ; i++) {
							if (DesignPFMEADialog.table.getSelectedRow() >= 0) {
								DesignPFMEADialog.table.getCellEditor(DesignPFMEADialog.table.getSelectedRow(),
										DesignPFMEADialog.table.getSelectedColumn()).stopCellEditing();
								for (int j = 2; j < jtable.getColumnCount(); j++) {
									//+++
									if(j == mainTable.getColumnCount() - 1 || j== 3) {//һڵ㲻ܸ
										continue;
									}else {
										if((DesignPFMEADialog.table.getSelectedRow() + i)<DesignPFMEADialog.table.getRowCount()) {//ֹѡиƵг
											DesignPFMEADialog.table.setValueAt(
														jtable.getValueAt(selectRowAll.get(i), j),
														DesignPFMEADialog.table.getSelectedRow() + i, j-1 );
											}
									}


								}
							}
						}
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
				}
//					}
//				}
			});
			libraryMenu.add(copyRowItem);

			selectCellValuePane = new JTextPane();
			selectCellValuePane.setPreferredSize(new Dimension(500, 40));

			JPanel southPanel = new JPanel(new PropertyLayout());
			southPanel.add("1.1.left.top", findLeftPanel);
			southPanel.add("1.2.left.top", new JScrollPane(selectCellValuePane));
			southPanel.add("1.3.left.top", findMainPanel);

			this.setLayout(new BorderLayout());
			this.add(centerPanel, BorderLayout.NORTH);
			this.add(splitPane2, BorderLayout.CENTER);
			// dialog.add(tablePanel, BorderLayout.CENTER);
			this.add(southPanel, BorderLayout.SOUTH);
			this.pack();
			this.show();
			
			if(ind>-1) {
				lastSelectedRow = ind;
				System.out.println("ind"+ind);
				leftTable.setRowSelectionInterval(ind,ind);
				leftTable.invalidate();
				refreshPFMEATable((String)leftTable.getValueAt(ind, 1));
				
			}
		}

		/**
		 * ȡݿе
		 */
		private void getPFMEAData() {
			// TODO Auto-generated method stub
			ResultSet rs = null;
			InputStream input = null;
			try {
				// ȡݿ
				SqlUtilT.getTCConnection();
				input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
				pro.load(input);
				String sql = String.format(pro.getProperty("TM2PFMEATREESELECT"));
				rs = SqlUtilT.read(sql);
				while (rs.next()) {
					TreeBean bean = new TreeBean();
					bean.setPlmeid(rs.getString("PLMEID"));
					bean.setId(rs.getString("ID"));
					bean.setName(rs.getString("NAME"));
					bean.setParentId(rs.getString("PARENT_ID"));
					beans.add(bean);
				}
				// createTabbedPane(beans);
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				if (rs != null) {
					SqlUtilT.free(rs);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
			}

		}
		private List<List<Object>> rememberRow;
		private int lastSelectedRow;
		private void refreshPFMEATable(String valueAt) {
			// TODO Auto-generated method stub
			
			
			try {
				String list1=String.valueOf(((int)this.getSize().getWidth()))+"/"+String.valueOf((int)this.getSize().getHeight())
				+"/"+String.valueOf(((int)this.getLocation().getX()))+"/"+String.valueOf((((int)this.getLocation().getY())));

//				String list2="";
//				for(int i=1;i<leftTable.getColumnModel().getColumnCount()-1;i++) {
//					if(i==leftTable.getColumnModel().getColumnCount()-2) {
//						list2+=String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()));
//					}else {
//						list2+=(String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()))+"/");
//					}
//				}
				String list3="";
				for(int i=2;i<mainTable.getColumnModel().getColumnCount();i++) {
					if(i==mainTable.getColumnModel().getColumnCount()-1) {
						list3+=String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()));
					}else {
						list3+=(String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()))+"/");
					}
				}
				SqlUtilT.getTCConnection();
				InputStream input = null;
				input = new BufferedInputStream(getClass().getResourceAsStream(
						"/sql.properties"));
				Properties pro = new Properties();
				try {
					pro.load(input);
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				System.out.println("this.userName====>"+userName);
				System.out.println("this.type====>"+"DesignToLib");
				System.out.println("list1====>"+list1.toString());
//				System.out.println("list2====>"+list2.toString());
				System.out.println("list3====>"+list3.toString());
				if(isFirstOpen) {
//					String insertSQL = "INSERT INTO AHMC_PFMEAFRAME_SIZE VALUES(?,?,?,?,?,?,?)";
//					SqlUtilT.write(new String[] {
//							UUID.randomUUID().toString().replace("-", ""),
//							userName,"PFMEAlibraryDialog",list1,list2,list3,String.valueOf(mainTable.getRowHeight())}, insertSQL);
//					System.out.println("insertSQL====>"+insertSQL);
//					isFirstOpen=false;
					System.out.println("first?");
				}else {
					String updateSQL = String.format(
							"update AHMC_PFMEAFRAME_SIZE set FRAMESIZE = ?, TABLE2SIZE = ?,ROWHEIGHT = ? WHERE USERNAME ='%s' AND TYPE = '%s'",userName,"PFMEAlibraryDialog");
					SqlUtilT.update(
							new String[] {list1,list3,String.valueOf(mainTable.getRowHeight())},updateSQL);
				}
				SqlUtilT.freeAll();
				///++++++
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
			}
			
			
			ResultSet rs = null;
			InputStream input = null;
			try {

				SqlUtilT.getTCConnection();
				// ȡSQL
				input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
				Properties pro = new Properties();
				pro.load(input);
//				lastSelectedRow = leftTable.getSelectedRow();
				String sql = String.format(pro.getProperty("PFMEALIBRARYSELECT"),
						valueAt);
				rs = SqlUtilT.read(sql);
				List<List<String>> rowList = new ArrayList<List<String>>();
				List<List<Object>> rowList2 = new ArrayList<List<Object>>();
				while (rs.next()) {
					List<String> list = new ArrayList<String>();
					List<Object> list2 = new ArrayList<Object>();
					
					list2.add(rs.getString("PLMEID"));
					list2.add(false);
					list2.add(rs.getString("ID"));
					list2.add(rs.getString("LSBG"));
					list2.add(rs.getString("STATION"));
					list2.add(rs.getString("REQUIREMENT"));
					list2.add(rs.getString("QZSXMS"));
					list2.add(rs.getString("QZSXHG"));
					list2.add(rs.getString("YZD"));
					list2.add(rs.getString("JB"));
					list2.add(rs.getString("QZSXQY"));
					list2.add(rs.getString("XXGCKZYF"));
					list2.add(rs.getString("PDS"));
					list2.add(rs.getString("XXGCKZTC"));
					list2.add(rs.getString("TCD"));
					list2.add(rs.getString("RPN"));
					list2.add(rs.getString("JYCS"));
					list2.add(rs.getString("ZZR"));
					list2.add(rs.getString("JHWCRQ"));
					list2.add(rs.getString("CQDCS"));
					list2.add(rs.getString("NEW_SEV"));
					list2.add(rs.getString("NEW_OCC"));
					list2.add(rs.getString("NEW_DET"));
					list2.add(rs.getString("NEW_RPN"));
					list2.add(rs.getString("IDEAL_STATE"));
					list2.add(rs.getString("SPECIAL"));
					list2.add(rs.getString("P1"));
					list2.add(rs.getString("P2"));
					list2.add(rs.getString("P3"));
					list2.add(rs.getString("P4"));
					list2.add(rs.getString("P5"));
					list2.add(rs.getString("P6"));
					list2.add(rs.getString("P7"));
					list2.add(rs.getString("P8"));
					list2.add(rs.getString("PARENT_ID"));
					list2.add(rs.getString("HBDYG"));
					rowList2.add(list2);
					//
					list.add(rs.getString("PLMEID"));
					list.add(rs.getString("ID"));
					list.add(rs.getString("LSBG"));
					list.add(rs.getString("STATION"));
					list.add(rs.getString("REQUIREMENT"));
					list.add(rs.getString("QZSXMS"));
					list.add(rs.getString("QZSXHG"));
					list.add(rs.getString("YZD"));
					list.add(rs.getString("JB"));
					list.add(rs.getString("QZSXQY"));
					list.add(rs.getString("XXGCKZYF"));
					list.add(rs.getString("PDS"));
					list.add(rs.getString("XXGCKZTC"));
					list.add(rs.getString("TCD"));
					list.add(rs.getString("RPN"));
					list.add(rs.getString("JYCS"));
					list.add(rs.getString("ZZR"));
					list.add(rs.getString("JHWCRQ"));
					list.add(rs.getString("CQDCS"));
					list.add(rs.getString("NEW_SEV"));
					list.add(rs.getString("NEW_OCC"));
					list.add(rs.getString("NEW_DET"));
					list.add(rs.getString("NEW_RPN"));
					list.add(rs.getString("IDEAL_STATE"));
					list.add(rs.getString("SPECIAL"));
					list.add(rs.getString("P1"));
					list.add(rs.getString("P2"));
					list.add(rs.getString("P3"));
					list.add(rs.getString("P4"));
					list.add(rs.getString("P5"));
					list.add(rs.getString("P6"));
					list.add(rs.getString("P7"));
					list.add(rs.getString("P8"));
					list.add(rs.getString("PARENT_ID"));
					list.add(rs.getString("HBDYG"));
					rowList.add(list);
				}
				if (rowList.size() > 0) {
					rememberRow = rowList2;
					map = new CTMap2(rowList.size(), pfmeaKuHeader.length);
					System.out.println(map.getColumnClass(1)+"---------");
					map.setColumnIdentifiers(pfmeaKuHeader);
					map.setEditable(true);
					mainTable.setModel(map);
					try {
						map.setRowCount(0);
						mainTable.removeAll();
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
					
					
					mainSorter = new TableRowSorter(map);
					this.mainTable.setRowSorter(mainSorter); // ΪJTable
//					map.getCo
//					TableColumn tcm1 = mainTable.getColumnModel().getColumn(1);
//			        tcm1.setCellEditor(mainTable.getDefaultEditor(Boolean.class));
//			        tcm1.setCellRenderer(mainTable.getDefaultRenderer(Boolean.class));
			        for (int j = 0; j < rowList.size(); j++) {
			        	map.addRow(rowList.get(j).toArray());
					}
					comBine(rowList2);
					
				} else {
					map = new CTMap2(1, pfmeaHeader.length);
					map.setColumnIdentifiers(pfmeaHeader);
					mainTable.setModel(map);
					mainSorter = new TableRowSorter(map);
					this.mainTable.setRowSorter(mainSorter); // ΪJTable
					map.setValueAt(leftTable.getValueAt(leftTable.getSelectedRow(), 1), 0,
							mainTable.getColumnCount() - 1);
				}
				getFrameSize2();
				for(int i=1;i<30;i++) {
					mainTable.getColumnModel().getColumn(i+1).setPreferredWidth(table2Size2[i-1]);;
				}
				for(int i=1;i<=2;i++) {
					leftTable.getColumnModel().getColumn(i).setPreferredWidth(table1Size2[i-1]);;
				}
				if(initRowHeight2!=0) {
					mainTable.setRowHeight(initRowHeight2);
				}
				if(setRowHeight!=0) {
					mainTable.setRowHeight(setRowHeight);
				}
				leftTable.setRowHeight(30);
				
				mainTable.invalidate();
			} catch (Exception e) {
				// TODO: handle exception
				
				e.printStackTrace();
				
			} finally {
				if (rs != null) {
					SqlUtilT.free(rs);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
				HiddenCell(0,mainTable);
				HiddenCell(1,mainTable);
//				mainTable.HiddenCell(pfmeaKuHeader.length - 1);
				HiddenCell(pfmeaKuHeader.length - 1,mainTable);
				HiddenCell(pfmeaKuHeader.length - 2,mainTable);
			}
		}
		private void refreshPFMEATable() {
			// TODO Auto-generated method stub
			// ˢҲ
			try {
				String list1=String.valueOf(((int)this.getSize().getWidth()))+"/"+String.valueOf((int)this.getSize().getHeight())
				+"/"+String.valueOf(((int)this.getLocation().getX()))+"/"+String.valueOf((((int)this.getLocation().getY())));

//				String list2="";
//				for(int i=1;i<leftTable.getColumnModel().getColumnCount()-1;i++) {
//					if(i==leftTable.getColumnModel().getColumnCount()-2) {
//						list2+=String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()));
//					}else {
//						list2+=(String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()))+"/");
//					}
//				}
				String list3="";
				for(int i=2;i<mainTable.getColumnModel().getColumnCount();i++) {
					if(i==mainTable.getColumnModel().getColumnCount()-1) {
						list3+=String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()));
					}else {
						list3+=(String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()))+"/");
					}
				}
				SqlUtilT.getTCConnection();
				InputStream input = null;
				input = new BufferedInputStream(getClass().getResourceAsStream(
						"/sql.properties"));
				Properties pro = new Properties();
				try {
					pro.load(input);
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				System.out.println("this.userName====>"+userName);
				System.out.println("this.type====>"+"DesignToLib");
				System.out.println("list1====>"+list1.toString());
//				System.out.println("list2====>"+list2.toString());
				System.out.println("list3====>"+list3.toString());
				if(isFirstOpen) {
//					String insertSQL = "INSERT INTO AHMC_PFMEAFRAME_SIZE VALUES(?,?,?,?,?,?,?)";
//					SqlUtilT.write(new String[] {
//							UUID.randomUUID().toString().replace("-", ""),
//							userName,"PFMEAlibraryDialog",list1,list2,list3,String.valueOf(mainTable.getRowHeight())}, insertSQL);
//					System.out.println("insertSQL====>"+insertSQL);
//					isFirstOpen=false;
					System.out.println("?");
				}else {
					String updateSQL = String.format(
							"update AHMC_PFMEAFRAME_SIZE set FRAMESIZE = ?, TABLE2SIZE = ?,ROWHEIGHT = ? WHERE USERNAME ='%s' AND TYPE = '%s'",userName,"PFMEAlibraryDialog");
					SqlUtilT.update(
							new String[] {list1,list3,String.valueOf(mainTable.getRowHeight())},updateSQL);
				}
				SqlUtilT.freeAll();
				///++++++
			} catch (Exception e) {
				// TODO: handle exception
			}
			ResultSet rs = null;
			InputStream input = null;
			try {

				SqlUtilT.getTCConnection();
				// ȡSQL
				input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
				Properties pro = new Properties();
				pro.load(input);
				lastSelectedRow = leftTable.getSelectedRow();
				String sql = String.format(pro.getProperty("PFMEALIBRARYSELECT"),
						leftTable.getValueAt(leftTable.getSelectedRow(), 1));
				rs = SqlUtilT.read(sql);
				List<List<String>> rowList = new ArrayList<List<String>>();
				List<List<Object>> rowList2 = new ArrayList<List<Object>>();
				while (rs.next()) {
					List<String> list = new ArrayList<String>();
					List<Object> list2 = new ArrayList<Object>();
					
					list2.add(rs.getString("PLMEID"));
					list2.add(false);
					list2.add(rs.getString("ID"));
					list2.add(rs.getString("LSBG"));
					list2.add(rs.getString("STATION"));
					list2.add(rs.getString("REQUIREMENT"));
					list2.add(rs.getString("QZSXMS"));
					list2.add(rs.getString("QZSXHG"));
					list2.add(rs.getString("YZD"));
					list2.add(rs.getString("JB"));
					list2.add(rs.getString("QZSXQY"));
					list2.add(rs.getString("XXGCKZYF"));
					list2.add(rs.getString("PDS"));
					list2.add(rs.getString("XXGCKZTC"));
					list2.add(rs.getString("TCD"));
					list2.add(rs.getString("RPN"));
					list2.add(rs.getString("JYCS"));
					list2.add(rs.getString("ZZR"));
					list2.add(rs.getString("JHWCRQ"));
					list2.add(rs.getString("CQDCS"));
					list2.add(rs.getString("NEW_SEV"));
					list2.add(rs.getString("NEW_OCC"));
					list2.add(rs.getString("NEW_DET"));
					list2.add(rs.getString("NEW_RPN"));
					list2.add(rs.getString("IDEAL_STATE"));
					list2.add(rs.getString("SPECIAL"));
					list2.add(rs.getString("P1"));
					list2.add(rs.getString("P2"));
					list2.add(rs.getString("P3"));
					list2.add(rs.getString("P4"));
					list2.add(rs.getString("P5"));
					list2.add(rs.getString("P6"));
					list2.add(rs.getString("P7"));
					list2.add(rs.getString("P8"));
					list2.add(rs.getString("PARENT_ID"));
					list2.add(rs.getString("HBDYG"));
					rowList2.add(list2);
					//
					list.add(rs.getString("PLMEID"));
					list.add(rs.getString("ID"));
					list.add(rs.getString("LSBG"));
					list.add(rs.getString("STATION"));
					list.add(rs.getString("REQUIREMENT"));
					list.add(rs.getString("QZSXMS"));
					list.add(rs.getString("QZSXHG"));
					list.add(rs.getString("YZD"));
					list.add(rs.getString("JB"));
					list.add(rs.getString("QZSXQY"));
					list.add(rs.getString("XXGCKZYF"));
					list.add(rs.getString("PDS"));
					list.add(rs.getString("XXGCKZTC"));
					list.add(rs.getString("TCD"));
					list.add(rs.getString("RPN"));
					list.add(rs.getString("JYCS"));
					list.add(rs.getString("ZZR"));
					list.add(rs.getString("JHWCRQ"));
					list.add(rs.getString("CQDCS"));
					list.add(rs.getString("NEW_SEV"));
					list.add(rs.getString("NEW_OCC"));
					list.add(rs.getString("NEW_DET"));
					list.add(rs.getString("NEW_RPN"));
					list.add(rs.getString("IDEAL_STATE"));
					list.add(rs.getString("SPECIAL"));
					list.add(rs.getString("P1"));
					list.add(rs.getString("P2"));
					list.add(rs.getString("P3"));
					list.add(rs.getString("P4"));
					list.add(rs.getString("P5"));
					list.add(rs.getString("P6"));
					list.add(rs.getString("P7"));
					list.add(rs.getString("P8"));
					list.add(rs.getString("PARENT_ID"));
					list.add(rs.getString("HBDYG"));
					rowList.add(list);
				}
				if (rowList.size() > 0) {
					map = new CTMap2(rowList.size(), pfmeaKuHeader.length);
					System.out.println(map.getColumnClass(1)+"---------");
					map.setColumnIdentifiers(pfmeaKuHeader);
					map.setEditable(true);
					mainTable.setModel(map);
					try {
						map.setRowCount(0);
						mainTable.removeAll();
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
					
					
					mainSorter = new TableRowSorter(map);
					this.mainTable.setRowSorter(mainSorter); // ΪJTable
//					map.getCo
//					TableColumn tcm1 = mainTable.getColumnModel().getColumn(1);
//			        tcm1.setCellEditor(mainTable.getDefaultEditor(Boolean.class));
//			        tcm1.setCellRenderer(mainTable.getDefaultRenderer(Boolean.class));
			        for (int j = 0; j < rowList.size(); j++) {
			        	map.addRow(rowList.get(j).toArray());
					}
					comBine(rowList2);
					
				} else {
					map = new CTMap2(1, pfmeaHeader.length);
					map.setColumnIdentifiers(pfmeaHeader);
					mainTable.setModel(map);
					mainSorter = new TableRowSorter(map);
					this.mainTable.setRowSorter(mainSorter); // ΪJTable
					map.setValueAt(leftTable.getValueAt(leftTable.getSelectedRow(), 1), 0,
							mainTable.getColumnCount() - 1);
				}
				getFrameSize2();
				for(int i=1;i<29;i++) {
					mainTable.getColumnModel().getColumn(i+1).setPreferredWidth(table2Size2[i-1]);;
				}
				for(int i=1;i<=2;i++) {
					leftTable.getColumnModel().getColumn(i).setPreferredWidth(table1Size2[i-1]);;
				}
				if(initRowHeight2!=0) {
					mainTable.setRowHeight(initRowHeight2);
				}
//				if(rowHeightAll!=0) {
//					mainTable.setRowHeight(rowHeightAll);
//				}
				if(setRowHeight!=0) {
					mainTable.setRowHeight(setRowHeight);
				}
				leftTable.setRowHeight(30);
				HiddenCell(0,mainTable);
				HiddenCell(1,mainTable);
//				mainTable.HiddenCell(pfmeaKuHeader.length - 1);
				HiddenCell(pfmeaKuHeader.length - 1,mainTable);
				HiddenCell(pfmeaKuHeader.length - 2,mainTable);
				mainTable.invalidate();
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
			} finally {
				if (rs != null) {
					SqlUtilT.free(rs);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
			}
		}
		
		
		//aǷb
				public  int[] iscontain( int[] a, int[] b){
			        
			        for (int i = 0; i < a.length; i++) {
			            for (int j = 0; j < b.length&&j<(a.length-i); j++) {
			                if(a[i+j]==b[j]){
			                    if(j==b.length-1){
			                        return b;
			                    }else if(j==a.length-1-i) {
			                    	return Arrays.copyOfRange(a,i,a.length);//ȡai
			                    }
			                    continue;
			                }else{
			                    break;
			                }
			            }
			        }
			        return null;
			    }
		
		
		public void comBine(String combs,int moved) {
			System.out.println("String.valueOf(selectMainCol-1)"+String.valueOf(selectMainCol-1));
		
			if (combs!= null && !combs.equals("")) {
				System.out.println(moved);
				System.out.println(combs);
				String sombine = combs;
				String[] sombines;
				if (sombine.indexOf("-") >= 0) {
					sombines = sombine.split("-");
				} else {
					sombines = new String[] { sombine };
				}
				for (int j = 0; j < sombines.length; j++) {
					if (sombines[j].indexOf("/") >= 0) {
						int[] row;
						int[] cloumn;
						String[] cells = sombines[j].split("/");
						if (cells[0].indexOf(",") >= 0) {
							String[] rows = cells[0].split(",");
							row = new int[rows.length];
							for (int k = 0; k < rows.length; k++) {
								row[k] = Integer.parseInt(rows[k]) - moved;
								if(cells[1].contains(String.valueOf(selectMainCol-1))) {
									dontMove.add(Integer.parseInt(rows[k]));
								}
							}
						} else {
							row = new int[] { Integer
									.parseInt(cells[0]) - moved};
							if(cells[1].contains(String.valueOf(selectMainCol-1))) {
								dontMove.add(Integer.parseInt(cells[0]));
							}
							
						}
						if (cells[1].indexOf(",") >= 0) {
							String[] cloumns = cells[1].split(",");
							cloumn = new int[cloumns.length];
							for (int k = 0; k < cloumns.length; k++) {
								cloumn[k] = Integer
										.parseInt(cloumns[k])+1;
							}
						} else {
							cloumn = new int[1]; //cells[1]+1
							cloumn[0] =  Integer.parseInt(cells[1])+1;
						}
						this.combineMap.put(row, cloumn);
					}
				}
			}
		}
		//غϲԪ
		public void comBine(List<List<Object>> rowList) {
			
			
				combineMap.clear();
					if (rowList != null && rowList.size() > 0) {
						for (int i = 0; i < rowList.size(); i++) {
							if (rowList.get(i).get(35)!= null
									&& !rowList.get(i).get(35).equals("")) {
								String sombine = rowList.get(i).get(35).toString();
//								int rowDif = 0;
								String[] sombines;
								if (sombine.indexOf("-") >= 0) {
									sombines = sombine.split("-");
								} else {
									sombines = new String[] { sombine };
								}
								for (int j = 0; j < sombines.length; j++) {
									if (sombines[j].indexOf("/") >= 0) {
										int[] row;
										int[] cloumn;
										String[] cells = sombines[j].split("/");
										if (cells[0].indexOf(",") >= 0) {
											String[] rows = cells[0].split(",");
											row = new int[rows.length];
											for (int k = 0; k < rows.length; k++) {
												row[k] = Integer.parseInt(rows[k]);
											}
										} else {
											row = new int[] { Integer.parseInt(cells[0])};
										}
										if (cells[1].indexOf(",") >= 0) {
											String[] cloumns = cells[1].split(",");
											cloumn = new int[cloumns.length];
											for (int k = 0; k < cloumns.length; k++) {
												cloumn[k] = Integer
														.parseInt(cloumns[k])+1;
											}
										} else {
											cloumn = new int[1]; //cells[1]+1
											cloumn[0] =  Integer.parseInt(cells[1])+1;
										}
										this.combineMap.put(row, cloumn);
									}
								}
							}
						}
					}
					
					try {
						if (combineMap != null && combineMap.size() != 0) {
							Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
							while (it.hasNext()) {
								Map.Entry<int[], int[]> entry = it.next();
								map.combine(entry.getKey(), entry.getValue());
							}
						}
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
			// TODO Auto-generated method stub
		
		}
		
		
	}

	public class AddRowsDialog extends AbstractAIFDialog implements ActionListener {

		private JPanel panel;
		private JLabel label;
		private JTextField textField;
		private JButton button;

		private Object source;

		public AddRowsDialog(Object source) {
			// TODO Auto-generated constructor stub
			super();
			this.source = source;
			init();
		}

		private void init() {
			//ȡʻ
			Locale defaultLocale=Locale.getDefault();
			ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
			// TODO Auto-generated method stub
			this.panel = new JPanel(new PropertyLayout());
			this.label = new JLabel(rb.getString("crhs10_display.TITLE"));
			this.textField = new JTextField(20);
			this.textField.addKeyListener(new KeyAdapter() {
				@Override
				public void keyPressed(KeyEvent arg0) {
					if (arg0.getKeyCode() == KeyEvent.VK_ENTER) {
						okEvent();
					} else {
						super.keyPressed(arg0);
					}
				}
			});
			this.button = new JButton(rb.getString("qd_display.TITLE"));
			this.button.addActionListener(this);
			this.panel.add("1.1.left.top", label);
			this.panel.add("1.2.left.top", textField);
			this.panel.add("1.3.left.top", button);

			this.add(this.panel, BorderLayout.CENTER);
			this.pack();
			this.showDialog();
		}

		@Override
		public void actionPerformed(ActionEvent actionevent) {
			// TODO Auto-generated method stub
			Object source = actionevent.getSource();
			if (source.equals(this.button)) {
				okEvent();
			}
		}

		private void okEvent() {
			// TODO Auto-generated method stub
			if (this.source.equals(addRowsItem)) {
				if (!isStr2Num(textField.getText())) {
					MessageBox.post("ȷ!", "!", MessageBox.ERROR);
					return;
				}
				for (int i1 = 0; i1 < Integer.parseInt(textField.getText()); i1++) {
					addRow();
				}
				this.disposeDialog();
				this.dispose();
			} else if (this.source.equals(addCombineRowsItem)) {
				if (!isStr2Num(textField.getText())) {
					MessageBox.post("ȷ!", "!", MessageBox.ERROR);
					return;
				}
				for (int i1 = 0; i1 < Integer.parseInt(textField.getText()); i1++) {
					addCombineRow();
				}
				this.disposeDialog();
				this.dispose();
			}
		}
	}
	/**
	 * õԪ
	 * 
	 * @param row1
	 * @param index
	 * @param str
	 */
	public static void setCellValue(XSSFRow row1, int index, String str) {
		XSSFCell cell = row1.getCell(index);
		if(cell==null) {
			cell=row1.createCell(index);
		}
		cell.setCellType(XSSFCell.CELL_TYPE_STRING);
		cell.setCellValue(str);
	}

	/**
	 * õԪ
	 * 
	 * @param row1
	 * @param index
	 * @param str
	 */
	public static void setCellValue(Row row1, int index, String str) {
		Cell cell = row1.getCell(index);
		cell.setCellType(XSSFCell.CELL_TYPE_STRING);
		cell.setCellValue(str);
	}
	public static boolean combine(XSSFSheet sheet, int[] rows, int[] columns) {
		boolean isOK = false;
		if (rows.length <=1 && columns.length <=1) {//ԵԪϲ
		}else {
			sheet.addMergedRegion(new CellRangeAddress(rows[0],
					rows[rows.length - 1], columns[0],
					columns[columns.length - 1]));
			isOK = true;
		}
		return isOK;
	}
}

//++++
	class MultiLineHeaderRenderer extends JList implements TableCellRenderer {
    public MultiLineHeaderRenderer() {
        setOpaque(true);
        setForeground(UIManager.getColor("TableHeader.foreground"));
        setBackground(UIManager.getColor("TableHeader.background"));
        setBorder(UIManager.getBorder("TableHeader.cellBorder"));
        ListCellRenderer renderer = getCellRenderer();
        ((JLabel) renderer).setHorizontalAlignment(JLabel.CENTER);
        setCellRenderer(renderer);
    }

	

    public Component getTableCellRendererComponent(JTable table, Object value,
                                                   boolean isSelected, boolean hasFocus, int row, int column) {
        setFont(table.getFont());
        String str = (value == null) ? "" : value.toString();
        BufferedReader br = new BufferedReader(new StringReader(str));
        String line;
        Vector v = new Vector();
        try {
            while ((line = br.readLine()) != null) {
                v.addElement(line);
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        setListData(v);
        return this;
    }

	}
	
	//++++
