package com.connor.hs2.plm.PFMEA.design;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;

import javax.imageio.ImageIO;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.ClientAnchor;
import org.apache.poi.ss.usermodel.Drawing;
import org.apache.poi.ss.usermodel.Picture;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFClientAnchor;
import org.apache.poi.xssf.usermodel.XSSFShape;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;



public class InsertPictureToExcelTest {

	public static void main(String[] args) {
		String oldFile = "D:\\ֲ\\\\׷PFMEAģ(1).xlsx";
//		String newFile = "C:\\Users\\blue\\Desktop\\ԭexcel.xlsx";
		String pictureUrl = "D:\\ֲ\\\\.png";
		InputStream inputStream = null;
        FileOutputStream fileOut = null;
        int [] columns = {6,7,17,29};
        int col = 15;
        int currentRow = 18;
        int row1 = currentRow;
        int row2 = currentRow;
        int startrow = 10;
		try {
			System.out.println("ڲͼƬ");
			inputStream = new FileInputStream(oldFile);
			XSSFWorkbook workbook = new XSSFWorkbook(inputStream);
			if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
			XSSFSheet sheet = workbook.getSheetAt(0);
//			reSetRowHeight(workbook,sheet,startrow,sheet.getLastRowNum(),columns);
//			Result result = isMergedRegion(sheet,currentRow,col);
//			if(result.isBool()) {
//				row1 = result.getRow1();
//				row2 = result.getRow2();
//			}
			
			insertTitlePicture2(workbook,sheet, pictureUrl,"png", col, row1,row2);
			fileOut = new FileOutputStream(new File(oldFile));
			workbook.write(fileOut);
			System.out.println("");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            if (fileOut != null) {
            	try {
            		fileOut.close();
            	} catch (Exception e) {
            		e.printStackTrace();
            	}
            }
        }
	}
	
	public static void reSetRowHeight(Workbook wb,Sheet sheet,int startRow,int endRow,int[] columnNum) {
		int picWidth = 1856 * 2;//ͼƬ
		int picHeight = 710;
		int t3 = (int)(picHeight/15);//ͼƬռԪ߶
		
		for(int i = startRow;i<endRow;i++) {
			System.out.println("i="+i);
			Row row = sheet.getRow(i);
			if(row == null)row = sheet.createRow(i);
			for(int j = 0;j<columnNum.length;j++) {
				int row1 = i;
				int row2 = i;
				int col = columnNum[j];
				Result result = isMergedRegion(sheet,i,col);
				if(result.isBool()) {
					row1 = result.getRow1();
					row2 = result.getRow2();
				}
				Cell cell = row.getCell(col);
				if(cell == null)cell = row.createCell(col);
				int strLength = cell.getStringCellValue()!=null?cell.getStringCellValue().length():0;
		    	int colWidth = sheet.getColumnWidth(col);
		    	System.out.println(""+col+"пΪ"+colWidth);
		    	if(colWidth<picWidth) {
		    		System.out.println("õ"+col+"пΪ"+picWidth);
		    		sheet.setColumnWidth(col, picWidth);
		    	}
		    	colWidth = sheet.getColumnWidth(col);
		    	int t5 = (int)(colWidth/837);//Ԫп
		    	int t6 = (int)(strLength%t5!=0?strLength/t5+1:strLength/t5);//Ԫ
		    	int t7 = (int)(t6*417/15);//ռԪ߶
		    	int t8 = t3*2+t7;//赥Ԫ߶
		    	int rowHeight = 0;
		    	for(int ii =row1;ii<=row2;ii++) {
		    		rowHeight += sheet.getRow(ii).getHeight();
		    	}
		    	System.out.println("ǰиߣ"+rowHeight);
		    	if((rowHeight/15)<t8) {
		    		int temp = sheet.getRow(row1).getHeight()+t8*15-rowHeight;
	    			System.out.println("õ"+row1+"иΪ"+temp);
	    			sheet.getRow(row1).setHeight((short)(temp));
		    	}
			}
//			if(row1!=row2)i = row2;
		}
		
	}
    public static void insertTitlePicture2(Workbook wb,Sheet sheet, String fileUrl,String type, int col, int row, int row2) throws Exception {
    	ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
    	BufferedImage bufferImg = ImageIO.read(new File(fileUrl));
    	ImageIO.write(bufferImg, type, byteArrayOut);
    	Drawing drawing = sheet.createDrawingPatriarch();
    	XSSFClientAnchor anchor = new XSSFClientAnchor();
    	int picHeight = 500;
    	int picWidth = 1050;
    	int rowHeight = 0;
    	for(int i =row;i<=row2;i++) {
    		rowHeight += sheet.getRow(i).getHeight();
    	}
    	int strLength = sheet.getRow(row).getCell(col).getStringCellValue().length();
    	int colWidth = sheet.getColumnWidth(col);
    	row2 +=1;
    	System.out.println("ǰУ"+row);
        System.out.println("ǰβУ"+row2);
    	System.out.println("ǰУ"+col);
    	System.out.println("иߣ"+rowHeight);
    	System.out.println("ǰп"+colWidth);

    	colWidth = sheet.getColumnWidth(col);
    	
    	int t3 = (int)(picHeight/15);//ͼƬռԪ߶
    	int t4 = (int)(picWidth/32);//ͼƬռԪ

//    	int t6 = (int)(strLength%t5!=0?strLength/t5+1:strLength/t5);//Ԫ
//    	int t7 = (int)(t6*417/15);//ռԪ߶
    	int t8 = t3*2;//赥Ԫ߶
//    	System.out.println(""+t6);
//    	System.out.println("ָ߶ȣ"+t7);
    	System.out.println("ǰԪ߶="+(int)(rowHeight/15));
    	System.out.println("赥Ԫ߶="+t8);
    	if((int)(rowHeight/15)<t8) {
    		System.out.println("Ԫ߶Ȳ");
//    		sheet.getRow(row).setHeight((short) ( t8*15));
    	}
    	int tempcolwid = colWidth - picWidth;
    	if(tempcolwid>0) {
    		tempcolwid /= 2;
    		int t = (int)(rowHeight/15);
    		int t2 = (int)(tempcolwid/32);
    		System.out.println("t="+t);
    		System.out.println("t2="+t2);
    		anchor.setCol1(col);
    		anchor.setCol2(col);
    		anchor.setRow1(row);
    		anchor.setRow2(row2);
    		System.out.println("tw"+XSSFShape.EMU_PER_PIXEL);
    		System.out.println("tw"+t);
    		anchor.setDx1(XSSFShape.EMU_PER_PIXEL * t2); 
    		anchor.setDx2(XSSFShape.EMU_PER_PIXEL * (t2+t4)); 
    		if(row+1==row2) {//
    			System.out.println("");
//    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * 100);
    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t/5)); //-XSSFShape.EMU_PER_PIXEL*(t/3)
//    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * 1);
    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (t3-4*t/5-2)); //-XSSFShape.EMU_PER_PIXEL*(t/3)
    		}else {//кϲ
    			System.out.println("");
    			int tempRow = row;
    			int row1Height = 0;
    	    	row1Height = sheet.getRow(tempRow).getHeight();
    	    	int t9 = (int)(row1Height/15);
    	    	do {
    	    		if(t9>(t/2)||tempRow==row2)break;
    	    		tempRow++;
    	    		row1Height = sheet.getRow(tempRow).getHeight();
    	    		t9 +=(int)(row1Height/15);
    	    	}while(true);
    	    	if(tempRow == row2)System.out.println(""+row+"У"+col+"δҵʵУ");
    	    	anchor.setRow1(tempRow);
    	    	anchor.setRow2(tempRow+1);
    	    	System.out.println("ʱУ"+tempRow);
    	    	System.out.println("ʱи߶ȣ"+row1Height/15);
//    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * 150);
//    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * 500);
    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t9-t/2));
    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (t3+t9-t/2-row1Height/15));
    		}
//    		anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t - t2/2)); 
//    		anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (-1*t + t2/2)); 
    	}
        System.out.println("y1="+anchor.getDy1());
        System.out.println("y2="+anchor.getDy2());
    	
    	anchor.setAnchorType(ClientAnchor.MOVE_AND_RESIZE);
    	Picture picture = drawing.createPicture(anchor, wb.addPicture(byteArrayOut.toByteArray(), HSSFWorkbook.PICTURE_TYPE_JPEG));
//    	picture.resize(1d);
    }
    public static Result isMergedRegion(Sheet sheet,int row,int column){
    	int sheetMergeCount=sheet.getNumMergedRegions(); 
    	for(int i=0;i<sheetMergeCount;i++){
	    	CellRangeAddress range=sheet.getMergedRegion(i);
			int firstColumn=range.getFirstColumn(); 
			int lastColumn=range.getLastColumn(); 
			int firstRow=range.getFirstRow(); 
			int lastRow=range.getLastRow();
	    	if(row>=firstRow&&row<=lastRow){
	    		if(column>=firstColumn&&column<=lastColumn){
	    				return new Result(true, firstRow, firstColumn, lastRow, lastColumn);
	    		}
	    	}
    	}
    	return new Result(false, 0, 0, 0, 0);

    }
}
