package com.connor.hs2.plm.PFMEA.design;

import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentContextList;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentMEProcess;
import com.teamcenter.rac.kernel.TCComponentProcess;
import com.teamcenter.rac.kernel.TCComponentQuery;
import com.teamcenter.rac.kernel.TCComponentQueryType;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCQueryClause;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.TCTextService;
import com.teamcenter.rac.kernel.TCUserService;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.util.FileUtility;
import com.teamcenter.rac.util.MessageBox;

public class TMomMethodUtil {
	
	private static List<List<String>> bomPropertyList = new ArrayList<List<String>>();

	public static void main(String[] args) {
		String str = "123|1234|123124";
		System.out.println(str.split("\\|").length);
	}

	/**
	 * жϻȡĶǷȫΪITEM
	 * 
	 * @param comps
	 *            ҪжϵĿ
	 * @param isNotIgor
	 *            ǷҪԣTRUE ܺԣFALSE Ժ
	 * 
	 * @param isSameType
	 *            ǷҪͬ,TRUE Ҫͬ
	 * @return
	 */
	public static List<TCComponentItem> getItemList(
			InterfaceAIFComponent[] comps, Boolean isNotIgor, Boolean isSameType) {
		if (comps == null) {

			return null;
		}
		List<TCComponentItem> itemList = new ArrayList<TCComponentItem>();
		String type = null;
		for (int i = 0; i < comps.length; i++) {
			if (comps[i] instanceof TCComponentItem) {
				if (isSameType) {
					if (type == null) {
						type = comps[i].getType();
					} else if (!type.equals(comps[i].getType())) {
						return null;
					}
				}
				itemList.add((TCComponentItem) comps[i]);
			} else if (isNotIgor) {
				return null;
			}
		}
		return itemList;
	}

//	/**
//	 * ȡģļ
//	 * @param session session
//	 * @param fileName ļ
//	 * @param Filetype ļ
//	 * @return
//	 */
	public static File getFile(TCSession session,String fileName,String Filetype) {
		// TODO Auto-generated method stub
		try {
			TCPreferenceService service = session.getPreferenceService();
		      String[] modelFiles = service.getStringValues("ZF6-GYGL-Template");
		      if (modelFiles == null)
		      {
		        System.out.println("δҵѡ");
		        return null;
		      }
		      String puid = "";
		      for (int i = 0; i < modelFiles.length; i++) {
				if(modelFiles[i].split(":")[0].equals(fileName))
				{
					puid = modelFiles[i].split(":")[1];
				}
			  }
		      TCComponentDataset dat = (TCComponentDataset)session
				        .stringToComponent(puid);
		      TCComponentTcFile[] tcFile = dat.getTcFiles();
		      if(tcFile != null && tcFile.length == 0)
		      {
		    	  System.out.println("δҵļ");
		      }
		      else
		      {
		    	  return tcFile[0].getFmsFile();
		      }
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return null;
	}
	/**
	 * ȡµѷİ汾
	 * @param item
	 * @return
	 */
//	public static TCComponentItemRevision getLastItemRevision(TCComponentItem item) {
//		// TODO Auto-generated method stub
//		try {
//			TCComponentItemRevision[] items = item.getReleasedItemRevisions();
//			int revId = 0;
//			TCComponentItemRevision itemRevision = null;
//			for (int i = 0; i < items.length; i++) {
//				String revisionId = items[i].getStringProperty("item_revision_id");
//				if(letterToNumber(revisionId) >= revId )
//				{
//					itemRevision = items[i];
//					revId = letterToNumber(revisionId);
//				}
//			}
//			return itemRevision;
//		} catch (TCException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		return null;
//	}
	
	public static int letterToNumber(String letter) {
	    int length = letter.length();
	    int num = 0;
	    int number = 0;
	    for(int i = 0; i < length; i++) {
	        char ch = letter.charAt(length - i - 1);
	        num = (int)(ch - 'A' + 1) ;
	        num *= Math.pow(26, i);
	        number += num;
	    }
	    return number;
	}

	/**
	 * ȡ汾
	 * 
	 * @param comps
	 *            ҪжϵĿ
	 * @param isNotIgor
	 *            ǷҪԣTRUE ܺԣFALSE Ժ
	 * 
	 * @param isSameType
	 *            ǷҪͬͣTRUE Ҫͬ
	 * @return
	 */
	public static List<TCComponentItemRevision> getItemRevList(
			InterfaceAIFComponent[] comps, Boolean isNotIgor, Boolean isSameType) {
		if (comps == null) {

			return null;
		}
		List<TCComponentItemRevision> itemList = new ArrayList<TCComponentItemRevision>();

		String type = null;
		for (int i = 0; i < comps.length; i++) {
			if (comps[i] instanceof TCComponentItemRevision) {

				if (isSameType) {
					if (type == null) {
						type = comps[i].getType();
					} else if (!type.equals(comps[i].getType())) {
						return null;
					}
				}
				itemList.add((TCComponentItemRevision) comps[i]);
			} else if (isNotIgor) {
				return null;
			}
		}
		return itemList;
	}

	/**
	 * ȡŵļ
	 * 
	 * @param item
	 * @param name
	 * @return
	 */
	public static TCComponentFolder getParentFolder(TCComponentItem item,
			String name) {
		TCComponentFolder folder = null;
		try {
			AIFComponentContext[] comtexts = item.whereReferenced();
			if (comtexts != null) {
				for (int i = 0; i < comtexts.length; i++) {
					if (comtexts[i].getComponent() instanceof TCComponentFolder) {
						String nameT = ((TCComponentFolder) comtexts[i]
								.getComponent())
								.getStringProperty("object_name");
						if (name.equals("ͼֽ") && nameT.equals("ͼֽ")) {
							folder = (TCComponentFolder) comtexts[i]
									.getComponent();
						}
						else if(nameT.equals(name))
						{
							folder = (TCComponentFolder) comtexts[i]
									.getComponent();
						}
					}
				}
			}
		} catch (TCException e) {
			e.printStackTrace();
		}
		return folder;
	}

	/**
	 * ȡڵITEMĸ
	 * 
	 * @param session
	 *            Ự
	 * @param oldItemID
	 *            ɱ
	 * @return
	 */
	public static Integer getItemCount(TCSession session, String oldItemID) {
		Integer count = 0;
		InterfaceAIFComponent[] comps = searchComponentsCollection(session,
				"Connor_TMom_Query_Item", new String[] { "item_id" },
				new String[] { oldItemID });
		if (comps == null) {
			return null;
		}
		count = comps.length;
		return count;
	}

	/**
	  * µID
	  * 
	  * @param oldItemID
	  * @return
	  */
	 public static String getGyRuleID(TCSession session, String oldItemID) {
	  DecimalFormat df = new DecimalFormat("000");
	  String newID = oldItemID + "_P001";
	  Integer count = 0;
	  // String idTemp =
	  TCComponentItemType tccomponentitemtype;
	  try {
	   tccomponentitemtype = (TCComponentItemType) (session
	     .getTypeComponent("Item"));
	   
	   tccomponentitemtype.getNewID();
	   int i = 1;
	   //setByPass(session,true);
	   while (tccomponentitemtype.find(newID) != null) {
	    i++;
	    newID = oldItemID + "_P" + df.format(i);
	   }
	  // setByPass(session,false);
	  } catch (TCException e) {
	   // TODO Auto-generated catch block
	   e.printStackTrace();
	  }
	  return newID;
	 }


	 /**
	  * ID
	  * 
	  * @param oldItemID
	  * @return
	  */
	 public static String getGxRuleID(TCSession session, String oldItemID) {
	  TCComponentItemType tccomponentitemtype;
	  try {
	   tccomponentitemtype = (TCComponentItemType) (session
	     .getTypeComponent("MEOP"));

	   return tccomponentitemtype.getNewID();
	  } catch (TCException e) {
	   // TODO Auto-generated catch block
	   e.printStackTrace();
	  }
	  return "";
	 }

	/**
	 * ͨѯ,ҷİ汾
	 * 
	 * @param session
	 *            Ự
	 * @param searchName
	 *            ѯ
	 * @param keys
	 *            ѯؼ
	 * @param values
	 *            ѯֵ
	 * @return
	 */
	public static InterfaceAIFComponent[] searchComponentsCollection(
			TCSession session, String searchName, String[] keys, String[] values) {
		// Ϣ
		InterfaceAIFComponent[] result = new InterfaceAIFComponent[0];

		try {
			TCTextService textService = session.getTextService();
			TCComponentQueryType querytype = (TCComponentQueryType) session
					.getTypeComponent("ImanQuery");
			TCComponentQuery query = (TCComponentQuery) querytype
					.find(searchName);
			if (query == null) {
				MessageBox.post("ͨѯ" + searchName + "", "", 1);
				return null;
			}
			querytype.clearCache();
			String[] as = new String[keys.length];
			for (int i = 0; i < keys.length; i++) {
				as[i] = textService.getTextValue(keys[i]);
			}

			String[] as1 = new String[values.length];
			for (int i = 0; i < values.length; i++) {
				as1[i] = textService.getTextValue(values[i]);

			}

			query.clearCache();
			TCQueryClause[] clauses = query.describe();
			TCComponentContextList list = query.getExecuteResultsList(as, as1);
		
			if (list != null) {
				int count = list.getListCount();
				result = new InterfaceAIFComponent[count];

				for (int i = 0; i < count; i++) {
					result[i] = list.get(i).getComponent();
				}
			}
		} catch (TCException e) {
			e.printStackTrace();
			MessageBox.post("ͨѯ" + searchName + "ѯ.", "", 1);
		}

		return result;
	}
	/**
	 * Զļļ
	 * 
	 * @param comps
	 * @return
	 * @throws TCException
	 * @throws IOException
	 */
	
	public static String downLoadFiles(TCComponent comp,String Titles,String URL,Boolean flag) {
		if (comp == null) {
			return "";
		}
		String value = "";
		String tempPath = System.getenv("TEMP");
		// MessageBox.post(" tempPath =
		// "+tempPath,"INFO",MessageBox.INFORMATION);
		if (tempPath == null) {
			tempPath = "";
		} else if (!tempPath.endsWith("\\")) {
			tempPath = tempPath + "\\";
		}
		
		// MessageBox.post(" tempPath = "+tempPath,"INFO",MessageBox.INFORMATION);
		// MessageBox.post(" URL = "+URL,"INFO",MessageBox.INFORMATION);
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
		// for(TCComponent comp : comps){
		try {
			if (comp instanceof TCComponentDataset) {
				TCComponentTcFile[] tcFiles = ((TCComponentDataset) comp)
						.getTcFiles();
				File file = null;
				if (tcFiles != null && tcFiles.length != 0) {
					file = tcFiles[0].getFmsFile();
					String fileName = file.getName();
					String fileDix = fileName.substring(
							fileName.lastIndexOf("."), fileName.length());
					if (flag == true)
					{
						if ((URL != "")&&(URL != " ")&&(URL != null))
						{
							fileName = URL + Titles + fileDix;
						}
						else
						{
							fileName = tempPath + Titles + fileDix;
						}
					}
					else
					{
						fileName = tempPath + sdf.format(new Date()) + fileDix;
					}
					File dirFile = new File(fileName);
					FileUtility.copyFile(file, dirFile);

					return fileName;
				}
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// }
		return value;
	}

	
	
	

	/**
	 * ļ
	 * 
	 * @param comps
	 * @return
	 * @throws TCException
	 * @throws IOException
	 */
	public static String downLoadFile(TCComponent comp) {
		if (comp == null) {
			return "";
		}
		String value = "";
		String tempPath = System.getenv("TEMP");
		// MessageBox.post(" tempPath =
		// "+tempPath,"INFO",MessageBox.INFORMATION);
		if (tempPath == null) {
			tempPath = "";
		} else if (!tempPath.endsWith("\\")) {
			tempPath = tempPath + "\\";
		}
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
		// for(TCComponent comp : comps){
		try {
			if (comp instanceof TCComponentDataset) {
				TCComponentTcFile[] tcFiles = ((TCComponentDataset) comp)
						.getTcFiles();
				File file = null;
				if (tcFiles != null && tcFiles.length != 0) {
					file = tcFiles[0].getFmsFile();
					String fileName = file.getName();
					String fileDix = fileName.substring(
							fileName.lastIndexOf("."), fileName.length());
					fileName = tempPath + sdf.format(new Date()) + fileDix;
					File dirFile = new File(fileName);
					FileUtility.copyFile(file, dirFile);

					return fileName;
				}
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// }
		return value;
	}

	/***
	 * ȡѡ
	 * 
	 * @param session
	 *            Ự
	 * @param preferenceName
	 *            ѡ
	 * @return
	 */
	public static String[] getPreferenceValues(String preferenceName) {
		AbstractAIFApplication app = AIFUtility.getCurrentApplication();
		TCSession session = (TCSession) app.getSession();
		if (preferenceName == null || session == null) {
			System.out.println("");
			return null;
		}
		String[] values = null;
		TCPreferenceService service = session.getPreferenceService();
		values = service.getStringArray(TCPreferenceService.TC_preference_site,
				preferenceName);
		String[] resultValues = new String[values.length];
		for (int i = 0; i < values.length; i++) {
			if(values[i].indexOf("\\n") >= 0)
			{
				resultValues[i] = values[i].replace("\\n", "\n");
			}
			else
			{
				resultValues[i] = values[i];
			}
		}
		return resultValues;
	}

	/**
	 * ɾļ
	 * 
	 * @param filePathList
	 *            ļַ
	 */
	public static void deleteFile(List<String> filePathList) {
		for (int i = 0; i < filePathList.size(); i++) {
			File file = new File(filePathList.get(i));
			if (file.exists() && file.isFile()) {
				if (file.delete()) {
					System.out.println("ļ" + filePathList.get(i) + "ɾ");
				}
			}
		}
	}

	/**
	 * ·
	 * 
	 * @param session
	 * @param val
	 * @throws TCException
	 */
	public static void setByPass(TCSession session, boolean val)
			throws TCException {

		TCUserService userservice = session.getUserService();

		Object[] obj = new Object[1];
		obj[0] = "";
		if (val) {
			userservice.call("Connor_set_bypass", obj);
		} else {
			userservice.call("Connor_close_bypass", obj);
		}
	}
	/**
	 * תϲԪ
	 * @param regionCell
	 * @param row
	 * @return
	 */
	public static String getCombineCell(Map<int[],int[]> regionCell, int row) {
		Iterator<Map.Entry<int[], int[]>> it = regionCell.entrySet().iterator();
		StringBuffer sb = new StringBuffer();
		while (it.hasNext()) {
			Map.Entry<int[], int[]> entry = it.next();
			StringBuffer rowSb = new StringBuffer();
			StringBuffer columnSb = new StringBuffer();
			for (int k = 0; k < entry.getKey().length; k++) {
				rowSb.append(entry.getKey()[k]);
				rowSb.append(",");
			}
			for (int k = 0; k < entry.getValue().length; k++) {
				columnSb.append(entry.getValue()[k]);
				columnSb.append(",");
			}
			if (entry.getKey()[0] == row) {
				sb.append(rowSb.substring(0, rowSb.length() - 1)+ "/"+ columnSb.substring(0,columnSb.length() - 1)+"-");
			}
		}
		if(sb.length() > 0)
		{
			return sb.toString().substring(0, sb.length()-1);
		}
		else
		{
			return "";
		}
	}

	/**
	 * ֪ͨ
	 * 
	 * @param session
	 * @param val
	 * @throws TCException
	 */
	public static void setProcess(TCSession session,
			TCComponentProcess process, TCComponentUser user)
			throws TCException {

		TCUserService userservice = session.getUserService();

		Object[] obj = new Object[2];
		obj[0] = process;
		obj[1] = user;
		userservice.call("TMOM_meop_tongzhi", obj);
	}
	
	/**
	 * ȡPFMEA BOM
	 */
	public static List<List<String>> getPFMEABomPropertys(TCSession session, TCComponentItem item) {
		// TODO Auto-generated method stub
		//ȡBOM 
		TCComponentBOMWindow bomWindow = null;
		bomPropertyList.clear();
		try {
			TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
					.getTypeComponent("BOMWindow");
			bomWindow = bomWindowType.create(null);
			TCComponentBOMLine topBomLine = bomWindow.setWindowTopLine(item,
					item.getLatestItemRevision(), null, null);
			//ȡµĿƼƻ
//			TCComponent[] kzjh = item.getRelatedComponents("IMAN_reference");
//			List<TCComponentItem> itme = new ArrayList<TCComponentItem>();
//			for (int i = 0; i < kzjh.length; i++) {
//				if(kzjh[i].getType().toUpperCase().indexOf("KZJH") >= 0)
//				{
//					itme.add((TCComponentItem)kzjh[i]);
//				}
//			}
			getBomPropertys(topBomLine, true);
			return bomPropertyList;
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return null;
	}
//	public static List<List<String>> getPFMEABomPropertys(TCSession session, TCComponentItem item) {
//		// TODO Auto-generated method stub
//		//ȡBOM 
//		TCComponentBOMWindow bomWindow = null;
//		try {
//			TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
//					.getTypeComponent("BOMWindow");
//			bomWindow = bomWindowType.create(null);
//			TCComponentBOMLine topBomLine = bomWindow.setWindowTopLine(item,
//					item.getLatestItemRevision(), null, null);
//			//ȡµĿƼƻ
//			TCComponent[] kzjh = item.getRelatedComponents("IMAN_reference");
//			List<TCComponentItem> itme = new ArrayList<TCComponentItem>();
//			for (int i = 0; i < kzjh.length; i++) {
//				if(kzjh[i].getType().toUpperCase().indexOf("KZJH") >= 0)
//				{
//					itme.add((TCComponentItem)kzjh[i]);
//				}
//			}
//			// ȡ
//			AIFComponentContext aif[] = topBomLine.getChildren();
//			List<List<String>> properties = new ArrayList<List<String>>();
//			for (int i = 0; i < aif.length; i++) {
//				TCComponentBOMLine subline = (TCComponentBOMLine) aif[i]
//						.getComponent();
//				if(subline.getStringProperty("RB3_is_hide") != null && subline.getStringProperty("RB3_is_hide").equals("true"))
//				{
//					continue;
//				}
//				List<String> propertie = new ArrayList<String>();
//				propertie
//						.add(subline.getStringProperty("bl_indented_title")
//								.split("/")[0]);
//				propertie.add(subline.getStringProperty("bl_sequence_no"));
//				propertie
//						.add(subline
//								.getStringProperty("bl_item_object_name") == null ? ""
//								: subline
//										.getStringProperty("bl_item_object_name"));
//				//ȡµBOM
//				List<String> equipmentNameList = new ArrayList<String>();
//				if(subline.getChildren().length>0)
//				{
//					for (int j = 0; j < subline.getChildren().length; j++) {
//						TCComponentBOMLine subChildrenline = (TCComponentBOMLine) subline.getChildren()[j]
//								.getComponent();
//						System.out.println(subChildrenline.getType());
//						if(subChildrenline.getType().indexOf("Equipment") >= 0)
//						{
//							TCComponentICO[] icos = subChildrenline.getItem().getLatestItemRevision()
//									.getClassificationObjects();
//							if (icos.length > 0) {
//								ICSProperty[] descriptions = icos[0]
//										.getICSProperties(true);
//								for (int k = 0; k < descriptions.length; k++) {
//									if (descriptions[k].getId() == 1004 && descriptions[k].getValue() != null
//											&& !descriptions[k].getValue().equals("")) {
//										System.out.println(equipmentNameList.toString());
//										if(!equipmentNameList.contains(descriptions[k].getValue()))
//										{
//											equipmentNameList.add(descriptions[k].getValue());
//										}
//										System.out.println(equipmentNameList.toString());
//										//sb.append(descriptions[k].getValue()+",");
//										
//									}
//								}
//							}
//						}
//					}
//				}
//				if(equipmentNameList.size() > 0)
//				{
//					propertie.add(equipmentNameList.toString().substring(1, equipmentNameList.toString().length()-1));
//				}
//				else
//				{
//					propertie.add("");
//				}
//				properties.add(propertie);
//			}
//			return properties;
//		} catch (Exception e) {
//			// TODO: handle exception
//			e.printStackTrace();
//		}
//		return null;
//	}
	
	/**
	 * ȡBOM
	 */
	public static List<List<String>> getBomPropertys(TCSession session, TCComponentItem item) {
		// TODO Auto-generated method stub
		bomPropertyList.clear();
		//ȡBOM 
		TCComponentBOMWindow bomWindow = null;
		try {
			TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
					.getTypeComponent("BOMWindow");
			bomWindow = bomWindowType.create(null);
			TCComponentBOMLine topBomLine = bomWindow.setWindowTopLine(item,
					item.getLatestItemRevision(), null, null);
			//ȡµĿƼƻ
			TCComponent[] kzjh = item.getRelatedComponents("IMAN_reference");
			List<TCComponentItem> itme = new ArrayList<TCComponentItem>();
			for (int i = 0; i < kzjh.length; i++) {
				if(kzjh[i].getType().toUpperCase().indexOf("KZJH") >= 0)
				{
					itme.add((TCComponentItem)kzjh[i]);
				}
			}
			getBomPropertys(topBomLine, false);
			return bomPropertyList;
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return null;
	}
//	public static List<List<String>> getBomPropertys(TCSession session, TCComponentItem item) {
//		// TODO Auto-generated method stub
//		//ȡBOM 
//		TCComponentBOMWindow bomWindow = null;
//		try {
//			TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
//					.getTypeComponent("BOMWindow");
//			bomWindow = bomWindowType.create(null);
//			TCComponentBOMLine topBomLine = bomWindow.setWindowTopLine(item,
//					item.getLatestItemRevision(), null, null);
//			//ȡµĿƼƻ
//			TCComponent[] kzjh = item.getRelatedComponents("IMAN_reference");
//			List<TCComponentItem> itme = new ArrayList<TCComponentItem>();
//			for (int i = 0; i < kzjh.length; i++) {
//				if(kzjh[i].getType().toUpperCase().indexOf("KZJH") >= 0)
//				{
//					itme.add((TCComponentItem)kzjh[i]);
//				}
//			}
//			// ȡ
//			AIFComponentContext aif[] = topBomLine.getChildren();
//			List<List<String>> properties = new ArrayList<List<String>>();
//			for (int i = 0; i < aif.length; i++) {
//				TCComponentBOMLine subline = (TCComponentBOMLine) aif[i]
//						.getComponent();
//				List<String> propertie = new ArrayList<String>();
//				propertie
//						.add(subline.getStringProperty("bl_indented_title")
//								.split("/")[0]);
//				propertie.add(subline.getStringProperty("bl_sequence_no"));
//				propertie
//						.add(subline
//								.getStringProperty("bl_item_object_name") == null ? ""
//								: subline
//										.getStringProperty("bl_item_object_name"));
//				//ȡµBOM
//				List<String> equipmentNameList = new ArrayList<String>();
//				if(subline.getChildren().length>0)
//				{
//					for (int j = 0; j < subline.getChildren().length; j++) {
//						TCComponentBOMLine subChildrenline = (TCComponentBOMLine) subline.getChildren()[j]
//								.getComponent();
//						System.out.println(subChildrenline.getType());
//						if(subChildrenline.getType().indexOf("Equipment") >= 0)
//						{
//							TCComponentICO[] icos = subChildrenline.getItem().getLatestItemRevision()
//									.getClassificationObjects();
//							if (icos.length > 0) {
//								ICSProperty[] descriptions = icos[0]
//										.getICSProperties(true);
//								for (int k = 0; k < descriptions.length; k++) {
//									if (descriptions[k].getId() == 1004 && descriptions[k].getValue() != null
//											&& !descriptions[k].getValue().equals("")) {
//										System.out.println(equipmentNameList.toString());
//										if(!equipmentNameList.contains(descriptions[k].getValue()))
//										{
//											equipmentNameList.add(descriptions[k].getValue());
//										}
//										System.out.println(equipmentNameList.toString());
//										//sb.append(descriptions[k].getValue()+",");
//										
//									}
//								}
//							}
//						}
//					}
//				}
//				if(equipmentNameList.size() > 0)
//				{
//					propertie.add(equipmentNameList.toString().substring(1, equipmentNameList.toString().length()-1));
//				}
//				else
//				{
//					propertie.add("");
//				}
//				properties.add(propertie);
//			}
//			return properties;
//		} catch (Exception e) {
//			// TODO: handle exception
//			e.printStackTrace();
//		}
//		return null;
//	}
	/**
	 * ȡ뵽ȨޱBOM
	 * @param session
	 * @param item
	 * @return
	 */
	public static List<List<String>> getPermissionsBomPropertys(TCSession session, TCComponentItem item) {
		// TODO Auto-generated method stub
		//ȡBOM 
		TCComponentBOMWindow bomWindow = null;
		
		try {
			TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
					.getTypeComponent("BOMWindow");
			bomWindow = bomWindowType.create(null);
			TCComponentBOMLine topBomLine = bomWindow.setWindowTopLine(item,
					item.getLatestItemRevision(), null, null);
			//ȡµĿƼƻ
			TCComponent[] kzjh = item.getRelatedComponents("IMAN_reference");
			List<TCComponentItem> itme = new ArrayList<TCComponentItem>();
			for (int i = 0; i < kzjh.length; i++) {
				if(kzjh[i].getType().toUpperCase().indexOf("KZJH") >= 0)
				{
					itme.add((TCComponentItem)kzjh[i]);
				}
			}
			// ȡ
			AIFComponentContext aif[] = topBomLine.getChildren();
			List<List<String>> properties = new ArrayList<List<String>>();
			for (int i = 0; i < aif.length; i++) {
				if(((TCComponentBOMLine)aif[i].getComponent()).getItem().getType().equals("MEProcess"))
				{
					continue;
				}
				TCComponentBOMLine subline = (TCComponentBOMLine) aif[i]
						.getComponent();
				List<String> propertie = new ArrayList<String>();
				propertie
						.add(subline.getStringProperty("bl_indented_title")
								.split("/")[0]);
				propertie.add(subline.getStringProperty("bl_sequence_no"));
				
				String objectName = subline.getStringProperty("bl_item_object_name") == null ? ""
						: subline.getStringProperty("bl_item_object_name");
				if(objectName.indexOf("/") >= 0)
				{
					propertie.add(objectName.split("/")[0]);
				}
				else
				{
					propertie.add(objectName);
				}
				//+++ȡ
				propertie.add(subline.getStringProperty("RB3_GXH"));
				//+++
				//ȡµBOM
				List<String> equipmentNameList = new ArrayList<String>();
				if(subline.getChildren().length>0)
				{
					for (int j = 0; j < subline.getChildren().length; j++) {
						TCComponentBOMLine subChildrenline = (TCComponentBOMLine) subline.getChildren()[j]
								.getComponent();
						System.out.println(subChildrenline.getType());
						//if(subChildrenline.getType().indexOf("Equipment") >= 0)
						//{
						equipmentNameList.add(subChildrenline.getItem().getStringProperty("item_id"));
//							TCComponentICO[] icos = subChildrenline.getItem().getLatestItemRevision()
//									.getClassificationObjects();
//							
//							if (icos.length > 0) {
//								ICSProperty[] descriptions = icos[0]
//										.getICSProperties(true);
//								for (int k = 0; k < descriptions.length; k++) {
//									if (descriptions[k].getId() == 1004 && descriptions[k].getValue() != null
//											&& !descriptions[k].getValue().equals("")) {
//										System.out.println(equipmentNameList.toString());
//										if(!equipmentNameList.contains(descriptions[k].getValue()))
//										{
//											equipmentNameList.add(descriptions[k].getValue());
//										}
//										System.out.println(equipmentNameList.toString());
//										//sb.append(descriptions[k].getValue()+",");
//										
//									}
//								}
//							}
						//}
					}
				}
				if(equipmentNameList.size() > 0)
				{
					propertie.add(equipmentNameList.toString().substring(1, equipmentNameList.toString().length()-1));
				}
				else
				{
					propertie.add("");
				}
				properties.add(propertie);
			}
			return properties;
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * ȡBOMϢ
	 * @param meprocess BOMLINE
	 * @param isMeop ǷPFEMA
	 * 
	 */
	public static void getBomPropertys(TCComponentBOMLine meprocessBomLine, boolean isPFEMA)
	{
		try {
			//ȡµBOM
			AIFComponentContext aif[] = meprocessBomLine.getChildren();
			for (int i = 0; i < aif.length; i++) {
				if(aif[i]==null) {//ֹ
					continue;
				}
				TCComponentBOMLine subline = (TCComponentBOMLine) aif[i]
						.getComponent();
				if(subline==null) {
					continue;
				}
				
				TCComponentItem item = subline.getItem();
				
				System.out.println("type ==> "+item.getType());
				
				//жǷǹ
				if(item.getType().equals("ZF6_GYLXRevision"))   //.getType().equals("MEProcess")
				{
					getBomPropertys(subline, isPFEMA);
				}
				else // if(item.getType().equals("HS2_MEOP"))
				{
					List<String> propertie = new ArrayList<String>();
					//String ss = subline.getStringProperty("bl_indented_title");
					propertie.add(subline.getStringProperty("bl_indented_title")
									.split("/")[0]);
					//Ƽƻе/ձŸΪ
					//propertie.add(subline.getStringProperty("bl_sequence_no"));
					propertie.add(subline.getStringProperty("bl_sequence_no")==null ? "":
						subline.getStringProperty("bl_sequence_no"));
					String bzString = subline.getStringProperty("bl_item_object_name") == null ? "": subline.getStringProperty("bl_item_object_name");
					String processNo = subline.getItemRevision().getStringProperty("zf6_ywfy") == null ? "": subline.getItemRevision().getStringProperty("zf6_ywfy");
					propertie.add(bzString+processNo);
					
					//ȡµBOMԴ豸PFMEA
					if(isPFEMA)
					{
						propertie.add("");
					}else {
					List<String> equipmentNameList = new ArrayList<String>();
					if(subline.getChildren().length>0)
					{
						for (int j = 0; j < subline.getChildren().length; j++) {
							TCComponentBOMLine subChildrenline = (TCComponentBOMLine) subline.getChildren()[j]
									.getComponent();
							if(subChildrenline.toString().equals("<<޷ȡ>>")&&subChildrenline!=null) {//ֹԴȨ޶ȡ
								continue;
							}
							System.out.println(subChildrenline.getType());
							String ClassID=subChildrenline.getItemRevision().getClassificationClass();
							if(ClassID!=null&&!ClassID.equals("")&&ClassID.length()>2) {
								if(ClassID.substring(0,2).equals("15")) {
									equipmentNameList.add(subChildrenline.getItem().getStringProperty("object_name"));
									}
							}

						}
					}
					if(equipmentNameList.size() > 0)
					{
						propertie.add(equipmentNameList.toString().substring(1, equipmentNameList.toString().length()-1));
					}
					else
					{
						propertie.add("");
					}
					}
					propertie.add(subline.getItemRevision().getUid());
					propertie.add(String.valueOf(bomPropertyList.size()+1));
					bomPropertyList.add(propertie);
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	/***
	 * ʽȡе
	 * @param value
	 * @return
	 */
	public static List<String> getListByRegular(String value)
	{
		List<String> resultList = new ArrayList<String>();
		Pattern p = Pattern.compile("(\\[[^\\]]*\\])");
		Matcher m = p.matcher(value);
		while(m.find())
		{
			resultList.add(m.group().substring(1, m.group().length() - 1));
		}
		return resultList;
	}
	
	public static int getDays(String dateStr1, String dateStr2, String dateFormat) {
		SimpleDateFormat simpleDateFormat = new SimpleDateFormat(dateFormat);
		Date date1 = null;
		Date date2 = null;
		try {
			date1 = simpleDateFormat.parse(dateStr1);
			date2 = simpleDateFormat.parse(dateStr2);
		} catch (ParseException e) {
			e.printStackTrace();
		}

		String year1 = String.format("%tY", date1);
		String mon1 = String.format("%tm", date1);
		String day1 = String.format("%td", date1);
		int y1 = Integer.valueOf(year1);
		int m1 = Integer.valueOf(mon1);
		int d1 = Integer.valueOf(day1);
		int days1 = getRecentYearDays(y1, m1, d1);
		System.out.println(days1);

		String year2 = String.format("%tY", date2);
		String mon2 = String.format("%tm", date2);
		String day2 = String.format("%td", date2);
		int y2 = Integer.valueOf(year2);
		int m2 = Integer.valueOf(mon2);
		int d2 = Integer.valueOf(day2);
		int days2 = getRecentYearDays(y2, m2, d2);
		System.out.println(days2);

		int count = 0;
		for (int i = y1; i < y2; i++) {
			if ((i % 4 == 0 && i % 100 != 0) || i % 400 == 0) {
				count += 366;
			} else {
				count += 365;
			}
		}
		count = count + days2 - days1;

		return count;
	}

	public static int getRecentYearDays(int y, int m, int d) {

		int count = 0;

		switch (m - 1) {
		case 1:
			count += 31;
			break;
		case 2:
			count += 31 + 28;
			break;
		case 3:
			count += 31 + 28 + 31;
			break;
		case 4:
			count += 31 + 28 + 31 + 30;
			break;
		case 5:
			count += 31 + 28 + 31 + 30 + 31;
			break;
		case 6:
			count += 31 + 28 + 31 + 30 + 31 + 30;
			break;
		case 7:
			count += 31 + 28 + 31 + 30 + 31 + 30 + 31;
			break;
		case 8:
			count += 31 + 28 + 31 + 30 + 31 + 30 + 31 + 31;
			break;
		case 9:
			count += 31 + 28 + 31 + 30 + 31 + 30 + 31 + 31 + 30;
			break;
		case 10:
			count += 31 + 28 + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31;
			break;
		case 11:
			count += 31 + 28 + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31 + 30;
			break;
		}
		if (((y % 4 == 0 && y % 100 != 0) || y % 400 == 0) && m > 2)
			count++;
		return count + d;
	}

//	public static ControlPlanComboBoxBean[] getComboxItem(TCSession session,String pernaem)
//	{
//		ControlPlanComboBoxBean[] comboBoxBeans = null;
//		TCPreferenceService pref = session.getPreferenceService();
//		String[] items = pref.getStringValues(pernaem);// ѡpuid
//		comboBoxBeans = new ControlPlanComboBoxBean[items.length];
//		for (int i = 0; i < items.length; i++) {
//			if(items[i].indexOf("-")>0)
//			{
//				ControlPlanComboBoxBean bean = new ControlPlanComboBoxBean();
//				bean.setItemId(items[i].split("-")[0]);
//				bean.setItemName(items[i].split("-")[1]);
//				comboBoxBeans[i] = bean;
//			}
//		}
//		return comboBoxBeans;
//	}
	
}
