package com.connor.hs2.plm.PFMEA.library;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Properties;

import javax.swing.table.DefaultTableModel;

import com.connor.hs2.plm.PFMEA.design.SqlUtilT;
import com.connor.hs2.plm.PFMEA.design.TreeBean;
import com.connor.renben.process.plm.util.CTMap;
import com.connor.renben.process.plm.util.CTable;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFCommand;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCSession;
public class LibraryCommand extends AbstractAIFCommand {

	private TCSession session;
	private AbstractAIFApplication app;
	private String commandId;
	private String titleName = "PFMEA";
	private String titleLabel = "ǱʧЧģʽ";
	private InterfaceAIFComponent comp;
	private TCComponent form;
	private boolean isOwning = false;
	// private List<List<Integer>> processRowList = new
	// ArrayList<List<Integer>>();
	private TCComponentUser user;// ǰ¼û
	private List<List<Object>> dataList = new ArrayList<List<Object>>();// е
	private List<TreeBean> beans = new ArrayList<TreeBean>();
	private TreeBean bean;
	private Properties pro = new Properties();
//	private String[] header = new String[] {"PLMEID","",
//			"1. "
//			+ "ϵͳϵͳҪػ",
//			"2. ̲"
//			+ "λź͹עҪ", 
//			"3. ̹Ҫ 4M", 
//			"1.Ĺ"
//			+ "ϵͳϵͳҪػ̵Ĺ", 
//			"2.̲ĹܺͲƷ"
//			+ "ֵΪѡ", 
//			"3.̹ҪصĹܺ͹", 
//			"1.һϸ߼Ҫ/նûʧЧӰ죨FE", 
//			"ʧЧӰضȣS",
//			"2.עҪصʧЧģʽ(FM)", 
//			"3.ҪصʧЧFC", 
//			"ʧЧĵǰԤƣPC",
//			"ʧЧƵȣO", 
//			"ʧЧʧЧģʽĵǰ̽ƣDC",
//			"ʧЧ/ʧЧģʽĿ̽ȣD", 
//			"PFMEAʩȼ",
//			"Ʒ",
//			"ɸѡ루ѡ", 
//			"Ԥʩ", 
//			"̽ʩ", 
//			"", 
//			"Ŀ",
//			"״̬",
//			"ȡ֤ݵĴʩ" ,
//			"",
//			"ضȣSSeverity(S)",
//			"ƵȣOOccurrence(O)",
//			"̽ȣDDetection(D)",
//			"Ʒ",
//			"PFMEA AP ",
//			"ע", "ڵID"};
	private String[] header = new String[] {"PLMEID",""
			, "", "̲(λź͹עҪ)", "̹Ҫ4",
			"ƵĹ", "̲蹦ܺͲƷ", "̹ҪصĹܺ͹", "һϵͳʧ\nЧӰ\nӰ(FE)",
			"ضs", "עҪʧЧģʽFM", "ҪʧЧFC", "ǰĶʧЧԤ\nʩ", "ʧЧģʽƵo",
			"ǰʧЧģ/ʧЧģʽ̽ʩ", "̽ȣ", "PFMEAʩȼ", "", "ɸѡ", "Ԥʩ",
			"̽ʩ", "", "Ŀ\n", "״̬", "ȡ֤\nĴʩ", "\nʱ", "ض",
			"Ƶ", "̽","PFMEAʩŻAP", "","ע","p","ڵID"};

	public LibraryCommand() {
		super();
	}

	public LibraryCommand(AbstractAIFApplication app,
			TCSession session, String commandId) {
		this.session = session;
		this.app = app;
		this.commandId = commandId;
		this.comp = app.getTargetComponent();
		this.user = session.getUser();
	}

	/**
	 * ȡݿе
	 */
	private void getData() {
		// TODO Auto-generated method stub
		ResultSet rs = null;
		try {
			// ȡݿ
			SqlUtilT.getTCConnection();
			String sql = String.format(pro
					.getProperty("TM2PFMEATREESELECT"));
			rs = SqlUtilT.read(sql);
			while (rs.next()) {
				TreeBean bean = new TreeBean();
				bean.setPlmeid(rs.getString("PLMEID"));
				bean.setId(rs.getString("ID"));
				bean.setName(rs.getString("NAME"));
				bean.setParentId(rs.getString("PARENT_ID"));
				beans.add(bean);
			}
			
			Collections.sort(beans, new NaturalOrderComparator<>(true));
			beans.forEach(item -> System.out.println(item));
			//createTabbedPane(beans);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
		}

	}
	
	class NaturalOrderComparator<T> implements Comparator<T> {

		private final boolean caseInsensitive;

		public NaturalOrderComparator(boolean caseInsensitive) {
			this.caseInsensitive = caseInsensitive;
		}

		private int compareRight(String a, String b) {
			int bias = 0;
			int ia = 0;
			int ib = 0;
			for (; ; ia++, ib++) {
				char ca = charAt(a, ia);
				char cb = charAt(b, ib);

				if (!Character.isDigit(ca) && !Character.isDigit(cb)) {
					return bias;
				} else if (!Character.isDigit(ca)) {
					return -1;
				} else if (!Character.isDigit(cb)) {
					return +1;
				} else if (ca < cb) {
					if (bias == 0) {
						bias = -1;
					}
				} else if (ca > cb) {
					if (bias == 0) {
						bias = +1;
					}
				} else if (ca == 0 && cb == 0) {
					return bias;
				}
			}
		}

		@Override
		public int compare(T o1, T o2) {
			
			TreeBean bean1 = (TreeBean)o1;
			TreeBean bean2 = (TreeBean)o2;
			
			String a = bean1.getId();
			String b = bean2.getId();
			int ia = 0, ib = 0;
			int nza = 0, nzb = 0;
			char ca, cb;
			int result;
			while (true) {
				nza = nzb = 0;
				ca = charAt(a, ia);
				cb = charAt(b, ib);

				while (ca == '0') {
					nza++;
					if (!Character.isDigit(charAt(a, ia + 1))) {
						break;
					}
					ca = charAt(a, ++ia);
				}
				while (cb == '0') {
					nzb++;
					if (!Character.isDigit(charAt(b, ib + 1))) {
						break;
					}
					cb = charAt(b, ++ib);
				}

				if (Character.isDigit(ca) && Character.isDigit(cb)) {
					if ((result = compareRight(a.substring(ia), b.substring(ib))) != 0) {
						return result;
					}
				}
				if (ca == 0 && cb == 0) {
					return nza - nzb;
				}
				if (ca < cb) {
					return -1;
				} else if (ca > cb) {
					return +1;
				}
				++ia;
				++ib;
			}
		}

		private char charAt(String s, int i) {
			if (i >= s.length()) {
				return 0;
			} else {
				return caseInsensitive ? Character.toUpperCase(s.charAt(i)) : s.charAt(i);
			}
		}
	}

//	// Jtableͨ÷
//	public CTable getNewjTable(CTable partsTable, DefaultTableModel dtm,
//			Object[] titleNames, int rows) {
//		int simpleLen = 100;
//		int totleLen = 1000;
//		if (partsTable == null) {
//			CTMap map = new CTMap(rows, titleNames.length);
//			map.setColumnIdentifiers(titleNames);
//			map.setEditable(true);
//			partsTable = new CTable(map);
//			partsTable.setRowHeight(50);
//			partsTable.HiddenCell(0);
//			// 
//			partsTable.HiddenCell(titleNames.length - 1);
//			partsTable.HiddenCell(titleNames.length - 2);
//			// ʾȾ
//			// TableCellTextAreaRenderer renderer = new
//			// TableCellTextAreaRenderer();
//			// partsTable.setDefaultRenderer(Object.class, renderer);
//			// partsTable.setRowHeight(1, 50);
//			if (simpleLen * titleNames.length >= totleLen) {
//				for (int i = 0; i < titleNames.length; i++) {
//					partsTable.getColumnModel().getColumn(i)
//							.setPreferredWidth(simpleLen);
//				}
//				partsTable.setAutoResizeMode(0);
//			} else {
//				partsTable.setAutoResizeMode(1);
//			}
//		}
//		return partsTable;
//	}

	@Override
	public void executeModal() throws Exception {
		// ȡ汾
		InputStream input = null;
		try {
			// ȡSQL
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			pro.load(input);
			// ȡνṹڵ
			getData();
			new Thread() {
				@Override
				public void run() {
					LibraryDialog dialog = new LibraryDialog(
							app, session, commandId, form, beans, header,
							isOwning, titleName, titleLabel);
				}
			}.start();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}  finally {
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		super.executeModal();
	}

}
