package com.connor.hs2.plm.PFMEA.library;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.UUID;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.ListSelectionModel;
import javax.swing.RowSorter;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;


import com.connor.hs2.plm.PFMEA.design.SqlUtilT;
import com.connor.hs2.plm.PFMEA.design.TableCellTextAreaRenderer2;
import com.connor.hs2.plm.PFMEA.design.TreeBean;
import com.connor.hs2.plm.PFMEA.library.LibraryCommand.NaturalOrderComparator;
import com.connor.hs2.plm.PFMEA.library.LibraryDialog.AddRowsDialog;
import com.connor.renben.process.plm.util.CTable;
import com.connor.renben.process.plm.util.Adapter;
import com.connor.renben.process.plm.util.CTMap;
import com.connor.renben.process.plm.util.MyTableModel;
import com.connor.hs2.plm.PFMEA.design.TMomMethodUtil;
import com.connor.renben.process.plm.util.TextAreaCellEditor;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;

public class LibraryDialog extends JFrame implements ActionListener {

private AbstractAIFApplication app;
private TCSession session;
private String titleName;
private String title;
private String commandId;
private String[] header2 = new String[]{"PLMEID","ID","",""};
private String[] header;
private List<String> deleteRows = new ArrayList<String>();
private List<TreeBean> beans;
private int index = -1;
private boolean isMeopSave = false;
private SpecialDialog specialDialog;
private String nodeName;// ڵ
private String nodeID;// ڵ
private int selectRow = -1;
private int selectColumn = -1;
//жϵԪʾǷȡ
private boolean isFocusOwner = false;
// ؼ
private JPanel titlePanel;// 
private JLabel titleLabel;
private JTextPane selectCellValuePane;
//
private CTable leftTable;
private CTable mainTable;

private int rowHeightAll = 0;

//frameSize
private int[] SizeLoca=new int[4];
private int[] table1Size=new int[3];
private int[] table2Size=new int[30];
private int initRowHeight = 0;
private String userName="";
private String type="";
private boolean isFirstOpen=false;//жǷǵһδ򿪣ͬʱǵһδ򿪣һαݿisFirstOpenfalseٱʱֻ£ظ	
private boolean isReSet=false;
private JScrollPane scrollPane2 ;
private JButton reSetSize;// ýС
private JButton setRowHeightBtn;// и
private JTextField setRowHeightTxt;// и

//Ҽ˵
private static JPopupMenu mainMenu;
private JMenuItem addItem;
private JMenuItem addItems;
private JMenuItem remItem;
private JMenuItem comBineItem;
private JMenuItem splitItem;
private static JPopupMenu leftMenu;
private JMenuItem addNodeItem;
private JMenuItem remNodeItem;
private JMenuItem updateNodItem;
private JMenuItem shrinkColumnItem;
private JMenuItem celShrinkColumnItem;
private CTMap map;
private Map<int[], int[]> combineMap=new HashMap<int[], int[]>();// źϲԪ



private JPanel rootPanel;// ť
private JButton saveButton;// 
//private JButton addSpecialButton;// 

List<String> tstxList = new ArrayList<String>();
List<String> dsUidList = new ArrayList<String>();
public LibraryDialog(AbstractAIFApplication app,
	TCSession session, String commandId, TCComponent form,
	List<TreeBean> beans, String[] header, boolean isOwning,
	String titleName, String title) {
	super();
	this.beans = beans;
	this.app = app;
	this.session = session;
	this.userName=this.session.getUser().toString();
	this.type="PFMEAlibraryDialog";
	this.commandId = commandId;
	this.titleName = titleName;
	this.title = title;
	this.header = header;
	TCPreferenceService service = session.getPreferenceService();
	String[] strs = service.getStringValues("ZF6_PFMEA_TSTX"); 
	
	for(String str:strs) {
		
		if(str.contains(":")) {
			String[] split = str.split(":");
			tstxList.add(split[0]);
			dsUidList.add(split[1]);
		}
		
	}
	init();
}

public void getFrameSize() {
	// ȡݿ
	SqlUtilT.getTCConnection();
	ResultSet rs = null;
	ResultSet rs0 = null;
	InputStream input = null;
	input = new BufferedInputStream(getClass().getResourceAsStream(
			"/sql.properties"));
	Properties pro = new Properties();
	try {
		pro.load(input);
		String sql = String.format("select * from AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'",userName,type);
		rs = SqlUtilT.read(sql);
		List<String> rowList = new ArrayList<String>();
		while (rs.next()) {
			rowList.add(rs.getString("FRAMESIZE"));//Сλ
			rowList.add(rs.getString("TABLE1SIZE"));//һп
			rowList.add(rs.getString("TABLE2SIZE"));//ڶп
			rowList.add(rs.getString("ROWHEIGHT"));//1и
			break;
		}
		if(rowList.size()==4) {//Сλãп
			analyticSize(rowList);
		}else {
			String sql0 = String.format("select * from AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'","iniUser",type);
			rs0 = SqlUtilT.read(sql0);
			while (rs0.next()) {
				rowList.add(rs0.getString("FRAMESIZE"));//Сλ
				rowList.add(rs0.getString("TABLE1SIZE"));//һп
				rowList.add(rs0.getString("TABLE2SIZE"));//ڶп
				
				rowList.add(rs0.getString("ROWHEIGHT"));//1и
				break;
			}
			if(rowList.size()<=0) {
				MessageBox.post("(ݿ)δýߴ磬ã", "", MessageBox.ERROR);
				return;
			}else {
				isFirstOpen=true;
				analyticSize(rowList);
			}
		}
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}finally {
		if (rs != null) {
			SqlUtilT.free(rs);
		}
		if(rs0 != null) {
			SqlUtilT.free(rs0);
		}
		if (input != null) {
			try {
				input.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		SqlUtilT.freeAll();
	}
}

//
public void analyticSize(List<String> rowList) {
	if(rowList.get(0).indexOf("/")>-1) {//ȡСλ
		String[] data=rowList.get(0).split("/");
		for(int i=0;i<4;i++) {
			SizeLoca[i]=Integer.parseInt(data[i]);
		}
	}
	if(rowList.get(1).indexOf("/")>-1) {
		String[] data=rowList.get(1).split("/");
		for(int i=0;i<3;i++) {
			table1Size[i]=Integer.parseInt(data[i]);
		}
	}
	if(rowList.get(2).indexOf("/")>-1) {
		String[] data=rowList.get(2).split("/");
		for(int i=0;i<30;i++) {
			table2Size[i]=Integer.parseInt(data[i]);
		}
	}
	
	if(!rowList.get(3).equals("")) {
		initRowHeight = Integer.valueOf(rowList.get(3));
	}
	
}


public class AddRowsDialog extends AbstractAIFDialog implements ActionListener {

	private JPanel panel;
	private JLabel label;
	private JTextField textField;
	private JButton button;

	private Object source;

	public AddRowsDialog(Object source) {
		// TODO Auto-generated constructor stub
		super();
		this.source = source;
		init();
	}

	private void init() {
		//ȡʻ
		Locale defaultLocale=Locale.getDefault();
		ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
		// TODO Auto-generated method stub
		this.panel = new JPanel(new PropertyLayout());
		this.label = new JLabel(rb.getString("crhs10_display.TITLE"));
		this.textField = new JTextField(20);
		this.textField.addKeyListener(new KeyAdapter() {
			@Override
			public void keyPressed(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ENTER) {
					okEvent();
				} else {
					super.keyPressed(arg0);
				}
			}
		});
		this.button = new JButton(rb.getString("qd_display.TITLE"));
		this.button.addActionListener(this);
		this.panel.add("1.1.left.top", label);
		this.panel.add("1.2.left.top", textField);
		this.panel.add("1.3.left.top", button);

		this.add(this.panel, BorderLayout.CENTER);
		this.pack();
		this.showDialog();
	}

	@Override
	public void actionPerformed(ActionEvent actionevent) {
		// TODO Auto-generated method stub
		Object source = actionevent.getSource();
		if (source.equals(this.button)) {
			okEvent();
		}
	}

	private void okEvent() {
		// TODO Auto-generated method stub
		if (this.source.equals(addItems)) {
			if (!isStr2Num(textField.getText())) {
				MessageBox.post("ȷ!", "!", MessageBox.ERROR);
				return;
			}
			for (int i1 = 0; i1 < Integer.parseInt(textField.getText()); i1++) {
//				addRow();
				CTable table = mainTable;
				if (table.getSelectedRow() > -1) {
//					((CTMap) table.getModel()).insertRow(table
//							.getSelectedRow() + 1);
					int selectedRow = table.getSelectedRow();
					Object valueAt = table.getValueAt(table.getSelectedRow(),
							table.getColumnCount() - 1);
					int selectedColumn = table.getSelectedColumn();
					if(selectedColumn>-1)
					if (combineMap != null && combineMap.size() != 0) {
						Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
						while (it.hasNext()) {
							Map.Entry<int[], int[]> entry = it.next();
							int[] key = entry.getKey();
							int[] value = entry.getValue();
							if(value[0]==selectedColumn && key[0]==selectedRow) {
								selectedRow = key[key.length-1];
							}
//							combine(entry.getKey(), entry.getValue());
						}
					}
					
					combineMap = map.insertRowComb(selectedRow + 1,combineMap);

					
					System.out.println("valueAt=======>"+valueAt);
//						
					table.setValueAt(
							valueAt,
							selectedRow + 1,
							table.getColumnCount() - 1);
					table.revalidate();
					table.repaint();
					//this.tabbedPane.updateUI();
				}
				
			}
			this.disposeDialog();
			this.dispose();
		}
	}
}

private void init() {
	getFrameSize();
	this.setTitle(this.titleName);
	this.setPreferredSize(new Dimension(SizeLoca[0], SizeLoca[1]));
	this.setLocation(SizeLoca[2], SizeLoca[3]);
	//ȡʻ
	Locale defaultLocale=Locale.getDefault();
	ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
	// ʼⲿֿؼ
	this.titlePanel = new JPanel();
	this.titleLabel = new JLabel(this.title);
	this.titleLabel.setFont(new Font("", 1, 18));
	this.titlePanel.add(titleLabel);
	
	this.leftTable = getNewjTable(null, null, header2, beans.size());
	
	// 
	leftTable.HiddenCell(0);
	leftTable.HiddenCell(3);
	leftTable.setRowHeight(30);
	//п
	leftTable.getColumnModel().getColumn(2)
			.setPreferredWidth(200);
	// 
	leftTable.addMouseListener(new MouseAdapter() {
		@Override
		public void mouseClicked(MouseEvent mouseevent) {
			// TODO Auto-generated method stub
			if(mouseevent.getButton() == MouseEvent.BUTTON3)
			{
				leftMenu.show(leftTable, mouseevent.getX(), mouseevent.getY());
			}
		}
	});
	for (int i = 0; i < beans.size(); i++) {
		this.leftTable.setValueAt(beans.get(i).getPlmeid(), i, 0);
		this.leftTable.setValueAt(beans.get(i).getId(), i, 1);
		this.leftTable.setValueAt(beans.get(i).getName(), i, 2);
		this.leftTable.setValueAt(beans.get(i).getParentId(), i, 3);
	}
	leftTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
		@Override
		public void valueChanged(ListSelectionEvent arg0) {
			// TODO Auto-generated method stub
			System.out.println("======"+addSelected+"isMeopSave"+isMeopSave);
			if(index == -1)
			{
				if(addSelected != -1 && isMeopSave) {
					System.out.println("okEvent");
					
					okEvent(true);
					
					addSelected = -1;
				}else if(!isMeopSave){
					String list1=String.valueOf(((int)getSize().getWidth()))+"/"+String.valueOf((int)getSize().getHeight())
					+"/"+String.valueOf(((int)getLocation().getX()))+"/"+String.valueOf((((int)getLocation().getY())));
	
					String list2="";
					for(int i=1;i<4;i++) {
						if(i==3) {
							list2+=String.valueOf(((int)scrollPane2.getWidth()));
						}else {
							list2+=(String.valueOf(((int)leftTable.getColumnModel().getColumn(i).getWidth()))+"/");
						}
					}
					String list3="";
					for(int i=1;i<31;i++) {
						if(i==30) {
							list3+=String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()));
						}else {
							list3+=(String.valueOf(((int)mainTable.getColumnModel().getColumn(i).getWidth()))+"/");
						}
					}
					SqlUtilT.getTCConnection();
					InputStream input = null;
					input = new BufferedInputStream(getClass().getResourceAsStream(
							"/sql.properties"));
					Properties pro = new Properties();
					try {
						pro.load(input);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					System.out.println(type+"tyye=====>");
					if(isFirstOpen) {
						String insertSQL = "INSERT INTO AHMC_PFMEAFRAME_SIZE VALUES(?,?,?,?,?,?,?)";
						SqlUtilT.write(new String[] {
								UUID.randomUUID().toString().replace("-", ""),
								userName,type,list1,list2,list3,String.valueOf(mainTable.getRowHeight())}, insertSQL);
						isFirstOpen=false;
					}else if(!isReSet){
						String updateSQL = String.format(
								"update AHMC_PFMEAFRAME_SIZE set FRAMESIZE = ?, TABLE1SIZE = ?, TABLE2SIZE = ?,ROWHEIGHT = ?  WHERE USERNAME ='%s' AND TYPE = '%s'",userName,type);
						SqlUtilT.update(
								new String[] {list1,list2,list3,String.valueOf(mainTable.getRowHeight())},updateSQL);
					}
					SqlUtilT.freeAll();
				}
				refreshPFMEATable();
				index = leftTable.getSelectedRow();
				
			}
			else if(index != -1 && index != leftTable.getSelectedRow())
			{
				if (mainTable.getSelectedRow() >= 0
						&& mainTable.getSelectedColumn() >= 0) {
					(mainTable.getCellEditor(mainTable.getSelectedRow(),
							mainTable.getSelectedColumn())).stopCellEditing();
				}
				if(isMeopSave)
				{
					okEvent(true);
				}
				refreshPFMEATable();
				index = leftTable.getSelectedRow();
			}
		}
	});
	this.mainTable = getNewjTable(null, null, header, 0);
// 
//switch (commandId) {
//case "com.connor.renben.process.plm.commands.ControlPlanLibrary":
//	mainTable.HiddenCell(0);
//	mainTable.HiddenCell(header.length - 1);
//	mainTable.HiddenCell(header.length - 2);
//	break;
//case "com.connor.renben.process.plm.commands.PFMEALibrary":
	mainTable.HiddenCell(0);
	mainTable.HiddenCell(1);
	mainTable.HiddenCell(header.length - 1);
	mainTable.HiddenCell(header.length - 2);
//	break;
//case "com.connor.renben.process.plm.commands.Thesaurus":
//	mainTable.HiddenCell(0);
//	mainTable.HiddenCell(header.length - 1);
//	//п
//	mainTable.getColumnModel().getColumn(2)
//			.setPreferredWidth(300);
//	break;
//default:
//	break;
//}
// 
mainTable.addMouseListener(new MouseAdapter() {
	@Override
	public void mouseClicked(MouseEvent mouseevent) {
		// TODO Auto-generated method stub
		if (mouseevent.getClickCount() ==1) {
			((CTMap)mainTable.getModel()).setRow(mainTable.getSelectedRow());
			((CTMap)mainTable.getModel()).setColumn(mainTable.getSelectedColumn());
			
			if(isFocusOwner && selectRow != -1 && selectColumn != -1)
			{
				mainTable.setValueAt(selectCellValuePane.getText(), selectRow, selectColumn);
			}
			
			if(mainTable.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()) != null)
			{
				selectCellValuePane.setText("");
				selectCellValuePane.setText(mainTable.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()).toString());
			}
			else
			{
				selectCellValuePane.setText("");
			}
		}
		selectRow = mainTable.getSelectedRow();
		selectColumn = mainTable.getSelectedColumn();
		isFocusOwner = false;
		if(mouseevent.getButton() == MouseEvent.BUTTON3)
		{
			mainMenu.show(mainTable, mouseevent.getX(), mouseevent.getY());
		}
	}
});

//Ӽ̼
this.mainTable.addKeyListener(new KeyAdapter() {
	@Override
	public void keyPressed(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
		if (arg0.getKeyCode()==16) {//shift16Ӽ
			comBineCell();
	}
	if (arg0.getKeyCode()==20) {//caps_lock20Ӽ
		splitCell();
	}
	if (arg0.getKeyCode() == KeyEvent.VK_V) { // Copy              
        System.out.println("here");
        Clipboard localAIFClipboard =  Toolkit.getDefaultToolkit().getSystemClipboard();
		      Transferable localTransferable = localAIFClipboard.getContents(null);
		//          localTransferable.
		      String transferData;
		  try {
			transferData = (String)localTransferable.getTransferData(DataFlavor.stringFlavor);
			 int selectRow=mainTable.getSelectedRow();//ѡе
			 int selectRows=mainTable.getSelectedRowCount();//ѡе
			 int selectColumn=mainTable.getSelectedColumn();//ѡе
			 int selectColumns=mainTable.getSelectedColumnCount();//ѡе
			 
			 
			 //+++ݸԶ
			 mainTable.setRowSelectionInterval(selectRow+selectRows-1, selectRow+selectRows-1);//λѡеһ
			  if(transferData.indexOf("$")>-1) {
				  if(selectRows<transferData.split("\\$").length) {
					   for (int i1 = 0; i1 < transferData.split("\\$").length-selectRows; i1++) {
						   map.insertRow(mainTable.getSelectedRow() + 1);
						   mainTable.setValueAt(
								   //Ʋһеĵֵĸڵ㣩
								   mainTable.getValueAt(mainTable.getSelectedRow(),
										   mainTable.getColumnCount() - 1),
								   mainTable.getSelectedRow() + 1,
								   mainTable.getColumnCount() - 1);
					   }
					 };
			  }else {
				  //excelƵת£ÿ$
				 // System.out.println("fuzhidao:"+transferData);
				  String[] values = transferData.split("\"");
		             StringBuffer sb = new StringBuffer();
		             //滻ExcelеĻз
		             for (int i = 0; i < values.length; i++) {
		            	 System.out.println(i+values[i]);
		            	 if(i % 2 ==0 && values[i].indexOf("\n") >= 0)
		            	 {
		            		 sb.append(values[i].replace("\n", " $")); 
		            	 }
		            	 else
		            	 {
		            		 sb.append(values[i]); 
		            	 }
					}
		             //System.out.println("sb++++++++"+sb.toString());
		             
		             if(sb.indexOf("$")>-1) {
						  if(selectRows<sb.toString().split("\\$").length) {
							   for (int i1 = 0; i1 < sb.toString().split("\\$").length-selectRows; i1++) {
								   map.insertRow(mainTable.getSelectedRow() + 1);
								   mainTable.setValueAt(
										   mainTable.getValueAt(mainTable.getSelectedRow(),
												   mainTable.getColumnCount() - 1),
										   mainTable.getSelectedRow() + 1,
										   mainTable.getColumnCount() - 1);
							   }
							 };
					  }
			  }
			  mainTable.revalidate();
			  mainTable.repaint();
			  mainTable.setRowSelectionInterval(selectRow, selectRow);//λѡеĵһ
			  
		  //+++excelԶϲԪ
			  if(localTransferable.isDataFlavorSupported(DataFlavor.fragmentHtmlFlavor)) {//жǷexcelĸݣǵĻԴӡxmlݹϲϢ
				  String transferData1 = (String)localTransferable.getTransferData(DataFlavor.fragmentHtmlFlavor);
					 //System.out.println("ӡexcelԣ"+transferData1);
				  Map<String, Integer> widMap = new HashMap< String,Integer>();
				  	String[] widString = transferData1.split("<col width=");
				  	for(int t = 0; t<widString.length ;t++) {
				  		String wid = widString[t];
				  		if(wid.contains(" style='mso-width")) {
				  			String string = wid.split(" style='mso-width")[0];
				  			widMap.put(string,t);
				  		}
//				  		
				  	}
				  	try {
						
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
					 String[] s=transferData1.split("<tr");
					 try {
						 for (int i = 0; i < s.length; i++) {
					            //System.out.println("====>"+s[i]);
					            if(s[i].indexOf("rowspan")>0||s[i].indexOf("colspan")>0){
					                //System.out.println("===>"+i+"У");
					                String[] ss=s[i].split("<td");
					                boolean as = false;
					                for (int j = 0; j < ss.length; j++) {
					                    if(ss[j].indexOf("rowspan")>0||ss[j].indexOf("colspan")>0){
					                    	int combineRow=1;
					                    	int combineColumn=1;
					                        if(getIndex(ss[j],"rowspan")>0){//кϲֵ򷵻غϲ,ϲоͷgetIndexΪ2
					                        	combineRow=getIndex(ss[j],"rowspan");
					                           // System.out.println(""+j+"У");
					                            //System.out.println("ϲ"+getIndex(ss[j],"rowspan"));
					                        }
					                        if(getIndex(ss[j],"colspan")>0){
					                        	combineColumn=getIndex(ss[j],"colspan");
					                            //System.out.println("ϲ"+getIndex(ss[j],"colspan"));
					                        }
					                      //combineRowҪ1.Ϊ統ϲʱ2ʱcombineRowΪ2ֻҪѡУҪcombineRow-1
					                        //ûкϲлʱ1-1Ϊ0൱ھֻѡһлһ
					                        String[] split = ss[j].split(" width=");
					                        if(split.length==2) {
					                        	String[] split2 = split[1].split(" style=");
//						                        if(spl)
						                        Integer integer = 0;
						                        if(widMap.containsKey(split2[0])) {
						                        	integer = widMap.get(split2[0]);
						                        }
						                        
						                        mainTable.setRowSelectionInterval(selectRow+i-1, selectRow+i-1+combineRow-1);
						                        mainTable.setColumnSelectionInterval(selectColumn-1+integer, selectColumn-1+integer+combineColumn-1);
					                        	System.out.println("rowselecttion"+(selectRow+i-1)+"end"+(selectRow+i-1+combineRow-1));
					                        	System.out.println(integer +"column select"+(selectColumn+integer-1)+"end"+(selectColumn-1+integer+combineColumn-1));
					                        	if(combineRow > 2) {
					                        		as = true;
						                        }
					                        	comBineCell();
					                        }
					                        
					                    }
					                }
//					                if(as) {
//					                	index = index+1;
//					                }
					            }
					        }
					} catch (Exception e) {
						// TODO: handle exception
						e.printStackTrace();
					}
				        
				        //Ҫѡеклعʼ״̬Ա
				        mainTable.setRowSelectionInterval(selectRow, selectRow+selectRows-1);
				        mainTable.setColumnSelectionInterval(selectColumn, selectColumn+selectColumns-1);
			  }
//		  if(localTransferable.isDataFlavorSupported(DataFlavor.fragmentHtmlFlavor)) {//жǷexcelĸݣǵĻԴӡxmlݹϲϢ
//			  String transferData1 = (String)localTransferable.getTransferData(DataFlavor.fragmentHtmlFlavor);
//				 //System.out.println("ӡexcelԣ"+transferData1);
//				 String[] s=transferData1.split("<tr");
//			        for (int i = 0; i < s.length; i++) {
//			            //System.out.println("====>"+s[i]);
//			            if(s[i].indexOf("rowspan")>0||s[i].indexOf("colspan")>0){
//			                //System.out.println("===>"+i+"У");
//			                String[] ss=s[i].split("<td");
//			                for (int j = 0; j < ss.length; j++) {
//			                    if(ss[j].indexOf("rowspan")>0||ss[j].indexOf("colspan")>0){
//			                    	int combineRow=1;
//			                    	int combineColumn=1;
//			                        if(getIndex(ss[j],"rowspan")>0){//кϲֵ򷵻غϲ,ϲоͷgetIndexΪ2
//			                        	combineRow=getIndex(ss[j],"rowspan");
//			                           // System.out.println(""+j+"У");
//			                            //System.out.println("ϲ"+getIndex(ss[j],"rowspan"));
//			                        }
//			                        if(getIndex(ss[j],"colspan")>0){
//			                        	combineColumn=getIndex(ss[j],"colspan");
//			                            //System.out.println("ϲ"+getIndex(ss[j],"colspan"));
//			                        }
//			                      //combineRowҪ1.Ϊ統ϲʱ2ʱcombineRowΪ2ֻҪѡУҪcombineRow-1
//			                        //ûкϲлʱ1-1Ϊ0൱ھֻѡһлһ
//			                        mainTable.setRowSelectionInterval(selectRow+i-1, selectRow+i-1+combineRow-1);
//			                        mainTable.setColumnSelectionInterval(selectColumn+j-1, selectColumn+j-1+combineColumn-1);
//		                        	
//			                        comBineCell();
//			                    }
//			                }
//			            }
//			        }
//			        //Ҫѡеклعʼ״̬Ա
//			        mainTable.setRowSelectionInterval(selectRow, selectRow+selectRows-1);
//			        mainTable.setColumnSelectionInterval(selectColumn, selectColumn+selectColumns-1);
//		  }
			//+++
			 // System.out.println(transferData);
		} catch (UnsupportedFlavorException | IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
		super.keyPressed(arg0);
	}
});



mainTable.getModel().addTableModelListener(new TableModelListener() {
	
	@Override
	public void tableChanged(TableModelEvent tablemodelevent) {
		// TODO Auto-generated method stub
		if(tablemodelevent.getType() == TableModelEvent.UPDATE){
			isMeopSave = true;
		}
	}
});

this.selectCellValuePane = new JTextPane();
this.selectCellValuePane.addFocusListener(new FocusListener() {
	//private int row;
	//private int column;
	@Override
	public void focusLost(FocusEvent focusevent) {
		// TODO Auto-generated method stub
//		if(selectRow != -1 && selectColumn != -1)
//		{
//			mainTable.setValueAt(selectCellValuePane.getText(), selectRow, selectColumn);
//		}
	}
	
	@Override
	public void focusGained(FocusEvent focusevent) {
		// TODO Auto-generated method stub
		isFocusOwner = true;
		//this.row = mainTable.getSelectedRow();
		//this.column = mainTable.getSelectedColumn();
	}
});
selectCellValuePane.setPreferredSize(new Dimension(700, 40));

Adapter adapter = new Adapter(mainTable);
JScrollPane scrollPane = new JScrollPane(mainTable);
scrollPane.getVerticalScrollBar().setUnitIncrement(2);
scrollPane2 = new JScrollPane(leftTable);
scrollPane2.setPreferredSize(new Dimension(table1Size[2], 600));
scrollPane2.getVerticalScrollBar().setUnitIncrement(2);

//JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
//splitPane.setOneTouchExpandable(true);// ÷ָʾͷ
//splitPane.setContinuousLayout(true);// ͷػͼ
//splitPane.setTopComponent(new JScrollPane(selectCellValuePane));
//splitPane.setBottomComponent(scrollPane);

JSplitPane splitPane2 = new JSplitPane();
splitPane2.setOneTouchExpandable(true);// ÷ָʾͷ
splitPane2.setContinuousLayout(true);// ͷػͼ
splitPane2.setLeftComponent(scrollPane2);
splitPane2.setRightComponent(scrollPane);

this.mainMenu = new JPopupMenu();
this.addItem = new JMenuItem(rb.getString("tjh_display.TITLE"));
this.addItems = new JMenuItem(rb.getString("tjdh_display.TITLE"));
this.remItem = new JMenuItem(rb.getString("ych12_display.TITLE"));
this.shrinkColumnItem = new JMenuItem(rb.getString("sxxzl_display.TITLE"));
this.celShrinkColumnItem = new JMenuItem(rb.getString("qxsxxzl_display.TITLE"));
this.comBineItem = new JMenuItem("ϲԪ");
this.splitItem = new JMenuItem("ֵԪ");
this.mainMenu.add(this.addItem);
this.mainMenu.add(this.addItems);
this.mainMenu.add(this.remItem);
this.mainMenu.add(this.shrinkColumnItem);
this.mainMenu.add(this.celShrinkColumnItem);
this.mainMenu.add(this.comBineItem);
this.mainMenu.add(this.splitItem);

this.leftMenu = new JPopupMenu();
this.addNodeItem = new JMenuItem(rb.getString("tjjd12_display.TITLE"));
this.remNodeItem = new JMenuItem(rb.getString("ycjd12_display.TITLE"));
this.updateNodItem = new JMenuItem(rb.getString("gxjd12_display.TITLE"));
this.leftMenu.add(this.addNodeItem);
this.leftMenu.add(this.remNodeItem);
this.leftMenu.add(this.updateNodItem);

this.rootPanel = new JPanel(new FlowLayout());
//this.addNodeButton = new JButton("ӽڵ");
//this.addButton = new JButton("");
//this.remButton = new JButton("Ƴ");
//this.remNodeButton = new JButton("Ƴڵ");
this.saveButton = new JButton(rb.getString("bc_display.TITLE"));
this.reSetSize = new JButton("ýС");
this.setRowHeightBtn = new JButton("и");
this.setRowHeightTxt = new JTextField(); 
this.setRowHeightTxt.setPreferredSize(new Dimension(160, 20));
//this.addSpecialButton = new JButton("");
//this.rootPanel.add(addNodeButton);
//this.rootPanel.add(addButton);
//this.rootPanel.add(remButton);
//this.rootPanel.add(remNodeButton);
this.rootPanel.add(new JScrollPane(selectCellValuePane));
this.rootPanel.add(saveButton);
this.rootPanel.add(this.reSetSize);
this.rootPanel.add(this.setRowHeightTxt);
this.rootPanel.add(this.setRowHeightBtn);
//this.rootPanel.add(addSpecialButton);

JPanel centerPanel = new JPanel(new BorderLayout());
centerPanel.add(titlePanel, BorderLayout.NORTH);

// 
this.createActionEvent();
this.setLayout(new BorderLayout());
this.add(centerPanel, BorderLayout.NORTH);
this.add(splitPane2, BorderLayout.CENTER);
this.add(rootPanel, BorderLayout.SOUTH);
this.pack();
this.show();

}


//excelʱǷкϲкС"rowspan"ǺϲУ"colspan"ǺϲСȻ󷵻rowspan(colspan)=ֵ
		public static int getIndex(String tag1,String tag2){
	        int loca=0;
	        if(tag1.indexOf(tag2)>0){
	            int l=tag1.indexOf(tag2);
	            while(!tag1.substring(l,l+1).equals("=")){
	                l++;
	            }
	            int start=++l;
	            while(!tag1.substring(l,l+1).equals(" ")){
	                    l++;
	            }
	            loca=Integer.valueOf(tag1.substring(start,l));
	        }
	        return loca;
	    }



//private void refreshTable() {
//// TODO Auto-generated method stub
////ˢҲ
//ResultSet rs = null;
//InputStream input = null;
//try {
//	
//	SqlUtilT.getTCConnection();
//	// ȡSQL
//	input = new BufferedInputStream(getClass().getResourceAsStream(
//			"/sql.properties"));
//	Properties pro = new Properties();
//	pro.load(input);
//	String sql = String.format(pro.getProperty("CONTROLPLANLIBRARYSELECT"), leftTable.getValueAt(leftTable.getSelectedRow(), 1));
//	rs = SqlUtilT.read(sql);
//	List<List<String>> rowList = new ArrayList<List<String>>();
//	while (rs.next()) {
//		List<String> list = new ArrayList<String>();
//		list.add(rs.getString("PLMEID"));
//		list.add(rs.getString("ID"));
//		list.add(rs.getString("JQSB"));
//		list.add(rs.getString("SMJY"));
//		list.add(rs.getString("QPTBH"));
//		//list.add(rs.getString("CC"));
//		//list.add(rs.getString("NO"));
//		list.add(rs.getString("CP"));
//		list.add(rs.getString("GC"));
//		list.add(rs.getString("TSTX"));
//		list.add(rs.getString("CPGC"));
//		list.add(rs.getString("CLFF"));
//		list.add(rs.getString("RL"));
//		list.add(rs.getString("PL"));
//		//list.add(rs.getString("FZR"));
//		list.add(rs.getString("KZFF"));
//		//list.add(rs.getString("CZGF"));
//		list.add(rs.getString("FYJH"));
//		//list.add(rs.getString("SJSJ"));
//		//list.add(rs.getString("GCSJ"));
//		//list.add(rs.getString("MJSJ"));
//		list.add(rs.getString("PARENT_ID"));
//		list.add(rs.getString("SPECIAL"));
//		rowList.add(list);
//	}
//	if (rowList.size() > 0) {
//		CTMap map = new CTMap(rowList.size(),header.length);
//		map.setColumnIdentifiers(header);
//		map.setEditable(true);
//		mainTable.setModel(map);
//		mainTable.getColumnModel().getColumn(2)
//		.setPreferredWidth(300);
//		for (int j = 0; j < rowList.size(); j++) {
//			for (int k = 0; k < rowList.get(j).size(); k++) {
//				mainTable.setValueAt(rowList.get(j).get(k), j, k);
//			}
//		}
//		map.addTableModelListener(new TableModelListener() {
//			
//			@Override
//			public void tableChanged(TableModelEvent tablemodelevent) {
//				// TODO Auto-generated method stub
//				if(tablemodelevent.getType() == TableModelEvent.UPDATE){
//					isMeopSave = true;
//				}
//			}
//		});
//	} else {
//		CTMap map = new CTMap(1,header.length);
//		map.setColumnIdentifiers(header);
//		map.setEditable(true);
//		mainTable.setModel(map);
//		mainTable.getColumnModel().getColumn(2)
//		.setPreferredWidth(300);
//		map.setValueAt(leftTable.getValueAt(leftTable.getSelectedRow(), 1), 0,
//				mainTable.getColumnCount() - 2);
//		map.addTableModelListener(new TableModelListener() {
//			
//			@Override
//			public void tableChanged(TableModelEvent tablemodelevent) {
//				// TODO Auto-generated method stub
//				if(tablemodelevent.getType() == TableModelEvent.UPDATE){
//					isMeopSave = true;
//				}
//			}
//		});
//	}
//	mainTable.HiddenCell(0);
//	mainTable.HiddenCell(header.length - 1);
//	mainTable.HiddenCell(header.length - 2);
//	mainTable.invalidate();
//} catch (Exception e) {
//	// TODO: handle exception
//	e.printStackTrace();
//} finally {
//	if (rs != null) {
//		SqlUtilT.free(rs);
//	}
//	if (input != null) {
//		try {
//			input.close();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//	}
//	 SqlUtilT.freeAll();
//}
//}
private int addSelected = -1;
private void refreshPFMEATable(String valueAt) {
	// TODO Auto-generated method stub
	//ˢҲ
		ResultSet rs = null;
		InputStream input = null;
		try {
			
			System.out.println("refresh22");
			SqlUtilT.getTCConnection();
			// ȡSQL
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			String sql = String.format(pro.getProperty("PFMEALIBRARYSELECT"), valueAt); //leftTable.getValueAt(leftTable.getSelectedRow(), 1)
			rs = SqlUtilT.read(sql);
			List<List<String>> rowList = new ArrayList<List<String>>();
			while (rs.next()) {
				List<String> list = new ArrayList<String>();
				list.add(rs.getString("PLMEID"));
				list.add(rs.getString("ID"));
				list.add(rs.getString("LSBG"));
				list.add(rs.getString("STATION"));
				list.add(rs.getString("REQUIREMENT"));
				list.add(rs.getString("QZSXMS"));
				list.add(rs.getString("QZSXHG"));
				list.add(rs.getString("YZD"));
				list.add(rs.getString("JB"));
				list.add(rs.getString("QZSXQY"));
				list.add(rs.getString("XXGCKZYF"));
				list.add(rs.getString("PDS"));
				list.add(rs.getString("XXGCKZTC"));
				list.add(rs.getString("TCD"));
				list.add(rs.getString("RPN"));
				list.add(rs.getString("JYCS"));
				list.add(rs.getString("ZZR"));
				list.add(rs.getString("JHWCRQ"));
				list.add(rs.getString("CQDCS"));
				list.add(rs.getString("NEW_SEV"));
				list.add(rs.getString("NEW_OCC"));
				list.add(rs.getString("NEW_DET"));
				list.add(rs.getString("NEW_RPN"));
				list.add(rs.getString("IDEAL_STATE"));
				list.add(rs.getString("SPECIAL"));
				list.add(rs.getString("P1"));
				list.add(rs.getString("P2"));
				list.add(rs.getString("P3"));
				list.add(rs.getString("P4"));
				list.add(rs.getString("P5"));
				list.add(rs.getString("P6"));
				list.add(rs.getString("P7"));
				list.add(rs.getString("P8"));
				list.add(rs.getString("PARENT_ID"));
				list.add(rs.getString("HBDYG"));
				rowList.add(list);
			}
			if (rowList.size() > 0) {
				map = new CTMap(rowList.size(),header.length);
				map.setColumnIdentifiers(header);
				map.setEditable(true);
				mainTable.setModel(map);
		//		mainTable.getColumnModel().getColumn(2)
		//		.setPreferredWidth(300);
				for (int j = 0; j < rowList.size(); j++) {
					for (int k = 0; k < rowList.get(j).size()-1; k++) {
						mainTable.setValueAt(rowList.get(j).get(k), j, k);
					}
				}
				map.addTableModelListener(new TableModelListener() {
					
					@Override
					public void tableChanged(TableModelEvent tablemodelevent) {
						// TODO Auto-generated method stub
						if(tablemodelevent.getType() == TableModelEvent.UPDATE){
							isMeopSave = true;
						}
					}
				});
				comBine(rowList);
			} else {
				map = new CTMap(1,header.length);
				map.setColumnIdentifiers(header);
				map.setEditable(true);
				mainTable.setModel(map);
				mainTable.getColumnModel().getColumn(2)
				.setPreferredWidth(300);
				map.setValueAt(valueAt, 0 , mainTable.getColumnCount() - 1);
				map.addTableModelListener(new TableModelListener() {
					
					@Override
					public void tableChanged(TableModelEvent tablemodelevent) {
						// TODO Auto-generated method stub
						if(tablemodelevent.getType() == TableModelEvent.UPDATE){
							isMeopSave = true;
						}
					}
				});
			}
			getFrameSize();
			for(int i=1;i<=30;i++) {
				mainTable.getColumnModel().getColumn(i).setPreferredWidth(table2Size[i-1]);
			}
			for(int i=1;i<=2;i++) {
				leftTable.getColumnModel().getColumn(i).setPreferredWidth(table1Size[i-1]);
			}
			if(rowHeightAll!=0) {
				mainTable.setRowHeight(rowHeightAll);
			}
			mainTable.HiddenCell(0);
			mainTable.HiddenCell(1);
			mainTable.HiddenCell(header.length - 1);
			mainTable.HiddenCell(header.length - 2);
			leftTable.setRowHeight(30);
			mainTable.invalidate();
			mainTable.revalidate();
			mainTable.repaint();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			 SqlUtilT.freeAll();
		}
	}

private void refreshPFMEATable() {
// TODO Auto-generated method stub
//ˢҲ
	ResultSet rs = null;
	InputStream input = null;
	try {
		
		System.out.println("refresh11");
		SqlUtilT.getTCConnection();
		// ȡSQL
		input = new BufferedInputStream(getClass().getResourceAsStream(
				"/sql.properties"));
		Properties pro = new Properties();
		pro.load(input);
		String sql = String.format(pro.getProperty("PFMEALIBRARYSELECT"), leftTable.getValueAt(leftTable.getSelectedRow(), 1));
		rs = SqlUtilT.read(sql);
		List<List<String>> rowList = new ArrayList<List<String>>();
		while (rs.next()) {
			List<String> list = new ArrayList<String>();
			list.add(rs.getString("PLMEID"));
			list.add(rs.getString("ID"));
			list.add(rs.getString("LSBG"));
			list.add(rs.getString("STATION"));
			list.add(rs.getString("REQUIREMENT"));
			list.add(rs.getString("QZSXMS"));
			list.add(rs.getString("QZSXHG"));
			list.add(rs.getString("YZD"));
			list.add(rs.getString("JB"));
			list.add(rs.getString("QZSXQY"));
			list.add(rs.getString("XXGCKZYF"));
			list.add(rs.getString("PDS"));
			list.add(rs.getString("XXGCKZTC"));
			list.add(rs.getString("TCD"));
			list.add(rs.getString("RPN"));
			list.add(rs.getString("JYCS"));
			list.add(rs.getString("ZZR"));
			list.add(rs.getString("JHWCRQ"));
			list.add(rs.getString("CQDCS"));
			list.add(rs.getString("NEW_SEV"));
			list.add(rs.getString("NEW_OCC"));
			list.add(rs.getString("NEW_DET"));
			list.add(rs.getString("NEW_RPN"));
			list.add(rs.getString("IDEAL_STATE"));
			list.add(rs.getString("SPECIAL"));
			list.add(rs.getString("P1"));
			list.add(rs.getString("P2"));
			list.add(rs.getString("P3"));
			list.add(rs.getString("P4"));
			list.add(rs.getString("P5"));
			list.add(rs.getString("P6"));
			list.add(rs.getString("P7"));
			list.add(rs.getString("P8"));
			list.add(rs.getString("PARENT_ID"));
			list.add(rs.getString("HBDYG"));
			rowList.add(list);
		}
		System.out.println(rowList.toString());
		if (rowList.size() > 0) {
			map = new CTMap(rowList.size(),header.length);
			map.setColumnIdentifiers(header);
			map.setEditable(true);
			mainTable.setModel(map);
	//		mainTable.getColumnModel().getColumn(2)
	//		.setPreferredWidth(300);
			for (int j = 0; j < rowList.size(); j++) {
				for (int k = 0; k < rowList.get(j).size()-1; k++) {
					mainTable.setValueAt(rowList.get(j).get(k), j, k);
				}
			}
			map.addTableModelListener(new TableModelListener() {
				
				@Override
				public void tableChanged(TableModelEvent tablemodelevent) {
					// TODO Auto-generated method stub
					if(tablemodelevent.getType() == TableModelEvent.UPDATE){
						isMeopSave = true;
					}
				}
			});
			comBine(rowList);
		} else {
			map = new CTMap(1,header.length);
			map.setColumnIdentifiers(header);
			map.setEditable(true);
			mainTable.setModel(map);
			mainTable.getColumnModel().getColumn(2)
			.setPreferredWidth(300);
			map.setValueAt(leftTable.getValueAt(leftTable.getSelectedRow(), 1), 0,
					mainTable.getColumnCount() - 1);
			map.addTableModelListener(new TableModelListener() {
				
				@Override
				public void tableChanged(TableModelEvent tablemodelevent) {
					// TODO Auto-generated method stub
					if(tablemodelevent.getType() == TableModelEvent.UPDATE){
						System.out.println("isMeopSave"+isMeopSave);
						isMeopSave = true;
					}
				}
			});
		}
		getFrameSize();
		for(int i=1;i<=30;i++) {
			mainTable.getColumnModel().getColumn(i).setPreferredWidth(table2Size[i-1]);;
		}
		for(int i=1;i<=2;i++) {
			leftTable.getColumnModel().getColumn(i).setPreferredWidth(table1Size[i-1]);;
		}
		if(rowHeightAll!=0) {
			mainTable.setRowHeight(rowHeightAll);
		}
		mainTable.HiddenCell(0);
		mainTable.HiddenCell(1);
		mainTable.HiddenCell(header.length - 1);
		mainTable.HiddenCell(header.length - 2);
//		leftTable.setRowHeight(30);
		mainTable.invalidate();
		mainTable.revalidate();
		mainTable.repaint();
	} catch (Exception e) {
		// TODO: handle exception
		e.printStackTrace();
	} finally {
		if (rs != null) {
			SqlUtilT.free(rs);
		}
		if (input != null) {
			try {
				input.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		 SqlUtilT.freeAll();
	}
}

/**
* 
*/
private void refreshLeftTable() {
// TODO Auto-generated method stub
//ˢҲ
ResultSet rs = null;
InputStream input = null;
try {
	
	SqlUtilT.getTCConnection();
	// ȡSQL
	input = new BufferedInputStream(getClass().getResourceAsStream(
			"/sql.properties"));
	Properties pro = new Properties();
	pro.load(input);
	String sql = String.format(pro
				.getProperty("TM2CONTROLPLANTREESELECT"));
	rs = SqlUtilT.read(sql);
	List<TreeBean> bneanList = new ArrayList<TreeBean>();
	while (rs.next()) {
		TreeBean bean = new TreeBean();
		bean.setPlmeid(rs.getString("PLMEID"));
		bean.setId(rs.getString("ID"));
		bean.setName(rs.getString("NAME"));
		bean.setParentId(rs.getString("PARENT_ID"));
		bneanList.add(bean);
	}
	if (bneanList.size() > 0) {
		CTMap map = new CTMap(bneanList.size(),header2.length);
		map.setColumnIdentifiers(header2);
		//map.setEditable(true);
		leftTable.setModel(map);
		leftTable.getColumnModel().getColumn(2)
		.setPreferredWidth(200);
		for (int i = 0; i < bneanList.size(); i++) {
			this.leftTable.setValueAt(bneanList.get(i).getPlmeid(), i, 0);
			this.leftTable.setValueAt(bneanList.get(i).getId(), i, 1);
			this.leftTable.setValueAt(bneanList.get(i).getName(), i, 2);
			this.leftTable.setValueAt(bneanList.get(i).getParentId(), i, 3);
		}
	}
	leftTable.HiddenCell(0);
	leftTable.HiddenCell(3);
	leftTable.invalidate();
} catch (Exception e) {
	// TODO: handle exception
	e.printStackTrace();
} finally {
	if (rs != null) {
		SqlUtilT.free(rs);
	}
	if (input != null) {
		try {
			input.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	 SqlUtilT.freeAll();
}
}

/**
* 
*/
private void refreshPFMEALeftTable() {
// TODO Auto-generated method stub
//ˢҲ
ResultSet rs = null;
InputStream input = null;
try {
	
	SqlUtilT.getTCConnection();
	// ȡSQL
	input = new BufferedInputStream(getClass().getResourceAsStream(
			"/sql.properties"));
	Properties pro = new Properties();
	pro.load(input);
	String sql = String.format(pro
				.getProperty("TM2PFMEATREESELECT"));
	rs = SqlUtilT.read(sql);
	List<TreeBean> bneanList = new ArrayList<TreeBean>();
	while (rs.next()) {
		TreeBean bean = new TreeBean();
		bean.setPlmeid(rs.getString("PLMEID"));
		bean.setId(rs.getString("ID"));
		bean.setName(rs.getString("NAME"));
		bean.setParentId(rs.getString("PARENT_ID"));
		bneanList.add(bean);
	}
	
	
	Collections.sort(bneanList, new NaturalOrderComparator<>(true));
	bneanList.forEach(item -> System.out.println(item));
	if (bneanList.size() > 0) {
		CTMap map = new CTMap(bneanList.size(),header2.length);
		map.setColumnIdentifiers(header2);
		//map.setEditable(true);
		leftTable.setModel(map);
		leftTable.getColumnModel().getColumn(2)
		.setPreferredWidth(200);
		for (int i = 0; i < bneanList.size(); i++) {
			this.leftTable.setValueAt(bneanList.get(i).getPlmeid(), i, 0);
			this.leftTable.setValueAt(bneanList.get(i).getId(), i, 1);
			this.leftTable.setValueAt(bneanList.get(i).getName(), i, 2);
			this.leftTable.setValueAt(bneanList.get(i).getParentId(), i, 3);
		}
	}
	leftTable.HiddenCell(0);
	leftTable.HiddenCell(3);
	leftTable.invalidate();
	leftTable.revalidate();
} catch (Exception e) {
	// TODO: handle exception
	e.printStackTrace();
} finally {
	if (rs != null) {
		SqlUtilT.free(rs);
	}
	if (input != null) {
		try {
			input.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	 SqlUtilT.freeAll();
}
}

class NaturalOrderComparator<T> implements Comparator<T> {

	private final boolean caseInsensitive;

	public NaturalOrderComparator(boolean caseInsensitive) {
		this.caseInsensitive = caseInsensitive;
	}

	private int compareRight(String a, String b) {
		int bias = 0;
		int ia = 0;
		int ib = 0;
		for (; ; ia++, ib++) {
			char ca = charAt(a, ia);
			char cb = charAt(b, ib);

			if (!Character.isDigit(ca) && !Character.isDigit(cb)) {
				return bias;
			} else if (!Character.isDigit(ca)) {
				return -1;
			} else if (!Character.isDigit(cb)) {
				return +1;
			} else if (ca < cb) {
				if (bias == 0) {
					bias = -1;
				}
			} else if (ca > cb) {
				if (bias == 0) {
					bias = +1;
				}
			} else if (ca == 0 && cb == 0) {
				return bias;
			}
		}
	}

	@Override
	public int compare(T o1, T o2) {
		
		TreeBean bean1 = (TreeBean)o1;
		TreeBean bean2 = (TreeBean)o2;
		
		String a = bean1.getId();
		String b = bean2.getId();
		int ia = 0, ib = 0;
		int nza = 0, nzb = 0;
		char ca, cb;
		int result;
		while (true) {
			nza = nzb = 0;
			ca = charAt(a, ia);
			cb = charAt(b, ib);

			while (ca == '0') {
				nza++;
				if (!Character.isDigit(charAt(a, ia + 1))) {
					break;
				}
				ca = charAt(a, ++ia);
			}
			while (cb == '0') {
				nzb++;
				if (!Character.isDigit(charAt(b, ib + 1))) {
					break;
				}
				cb = charAt(b, ++ib);
			}

			if (Character.isDigit(ca) && Character.isDigit(cb)) {
				if ((result = compareRight(a.substring(ia), b.substring(ib))) != 0) {
					return result;
				}
			}
			if (ca == 0 && cb == 0) {
				return nza - nzb;
			}
			if (ca < cb) {
				return -1;
			} else if (ca > cb) {
				return +1;
			}
			++ia;
			++ib;
		}
	}

	private char charAt(String s, int i) {
		if (i >= s.length()) {
			return 0;
		} else {
			return caseInsensitive ? Character.toUpperCase(s.charAt(i)) : s.charAt(i);
		}
	}
}


private void refreshThesaurusLeftTable() {
// TODO Auto-generated method stub
//ˢҲ
ResultSet rs = null;
InputStream input = null;
try {
	
	SqlUtilT.getTCConnection();
	// ȡSQL
	input = new BufferedInputStream(getClass().getResourceAsStream(
			"/sql.properties"));
	Properties pro = new Properties();
	pro.load(input);
	String sql = String.format(pro
				.getProperty("TM2THESAURUSTREESELECT"));
	rs = SqlUtilT.read(sql);
	List<TreeBean> bneanList = new ArrayList<TreeBean>();
	while (rs.next()) {
		TreeBean bean = new TreeBean();
		bean.setPlmeid(rs.getString("PLMEID"));
		bean.setId(rs.getString("ID"));
		bean.setName(rs.getString("NAME"));
		bean.setParentId(rs.getString("PARENT_ID"));
		bneanList.add(bean);
	}
	if (bneanList.size() > 0) {
		CTMap map = new CTMap(bneanList.size(),header2.length);
		map.setColumnIdentifiers(header2);
		//map.setEditable(true);
		leftTable.setModel(map);
		leftTable.getColumnModel().getColumn(2)
		.setPreferredWidth(200);
		for (int i = 0; i < bneanList.size(); i++) {
			this.leftTable.setValueAt(bneanList.get(i).getPlmeid(), i, 0);
			this.leftTable.setValueAt(bneanList.get(i).getId(), i, 1);
			this.leftTable.setValueAt(bneanList.get(i).getName(), i, 2);
			this.leftTable.setValueAt(bneanList.get(i).getParentId(), i, 3);
		}
	}
	leftTable.HiddenCell(0);
	leftTable.HiddenCell(3);
	leftTable.invalidate();
} catch (Exception e) {
	// TODO: handle exception
	e.printStackTrace();
} finally {
	if (rs != null) {
		SqlUtilT.free(rs);
	}
	if (input != null) {
		try {
			input.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	 SqlUtilT.freeAll();
}
}

private void refreshThesaurusTable() {
// TODO Auto-generated method stub
//ˢҲ
ResultSet rs = null;
InputStream input = null;
try {
	
	SqlUtilT.getTCConnection();
	// ȡSQL
	input = new BufferedInputStream(getClass().getResourceAsStream(
			"/sql.properties"));
	Properties pro = new Properties();
	pro.load(input);
	String sql = String.format(pro.getProperty("TM2THESAURUSNODESELECT"), leftTable.getValueAt(leftTable.getSelectedRow(), 1));
	rs = SqlUtilT.read(sql);
	List<List<String>> rowList = new ArrayList<List<String>>();
	while (rs.next()) {
		List<String> list = new ArrayList<String>();
		list.add(rs.getString("PLMEID"));
		list.add(rs.getString("ID"));
		list.add(rs.getString("VALUE"));
		//list.add(rs.getString("VALUE2"));
		//list.add(rs.getString("EXAMPLE"));
		list.add(rs.getString("PARENT_ID"));
		rowList.add(list);
	}
	if (rowList.size() > 0) {
		CTMap map = new CTMap(rowList.size(),header.length);
		map.setColumnIdentifiers(header);
		map.setEditable(true);
		mainTable.setModel(map);
		mainTable.getColumnModel().getColumn(2)
		.setPreferredWidth(300);
		for (int j = 0; j < rowList.size(); j++) {
			for (int k = 0; k < rowList.get(j).size(); k++) {
				if(k == rowList.get(j).size()-2){
					mainTable.setValueAt(rowList.get(j).get(k+1), j, k+1);
				}
				else if(k == rowList.get(j).size()-1){
					mainTable.setValueAt(rowList.get(j).get(k-1), j, k-1);
				}
				else{
					mainTable.setValueAt(rowList.get(j).get(k), j, k);
				}
			}
		}
		map.addTableModelListener(new TableModelListener() {
			@Override
			public void tableChanged(TableModelEvent tablemodelevent) {
				// TODO Auto-generated method stub
				if(tablemodelevent.getType() == TableModelEvent.UPDATE){
					isMeopSave = true;
				}
			}
		});
	} else {
		CTMap map = new CTMap(20,header.length);
		map.setColumnIdentifiers(header);
		map.setEditable(true);
		mainTable.setModel(map);
		mainTable.getColumnModel().getColumn(2)
		.setPreferredWidth(300);
		map.setValueAt(leftTable.getValueAt(leftTable.getSelectedRow(), 1), 0,
				mainTable.getColumnCount() - 1);
		map.addTableModelListener(new TableModelListener() {
			
			@Override
			public void tableChanged(TableModelEvent tablemodelevent) {
				// TODO Auto-generated method stub
				if(tablemodelevent.getType() == TableModelEvent.UPDATE){
					isMeopSave = true;
				}
			}
		});
	}
	mainTable.HiddenCell(0);
	mainTable.HiddenCell(header.length - 1);
	leftTable.setRowHeight(30);
	mainTable.invalidate();
} catch (Exception e) {
	// TODO: handle exception
	e.printStackTrace();
} finally {
	if (rs != null) {
		SqlUtilT.free(rs);
	}
	if (input != null) {
		try {
			input.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	 SqlUtilT.freeAll();
}
}
// Ӽ
public void createActionEvent() {
this.addItem.addActionListener(this);
this.addItems.addActionListener(this);
this.addNodeItem.addActionListener(this);
this.updateNodItem.addActionListener(this);
this.shrinkColumnItem.addActionListener(this);
this.celShrinkColumnItem.addActionListener(this);
this.remItem.addActionListener(this);
this.remNodeItem.addActionListener(this);
this.saveButton.addActionListener(this);
this.comBineItem.addActionListener(this);
this.splitItem.addActionListener(this);
this.reSetSize.addActionListener(this);
this.setRowHeightBtn.addActionListener(this);
//this.addSpecialButton.addActionListener(this);
}


//غϲԪ
public void comBine(List<List<String>> rowList) {
	combineMap.clear();
			if (rowList != null && rowList.size() > 0) {
				for (int i = 0; i < rowList.size(); i++) {
					if (rowList.get(i).get(34)!= null
							&& !rowList.get(i).get(34).equals("")) {
						String sombine = rowList.get(i).get(34).toString();
						int rowDif = 0;
						String[] sombines;
						if (sombine.indexOf("-") >= 0) {
							sombines = sombine.split("-");
						} else {
							sombines = new String[] { sombine };
						}
						for (int j = 0; j < sombines.length; j++) {
							if (sombines[j].indexOf("/") >= 0) {
								int[] row;
								int[] cloumn;
								String[] cells = sombines[j].split("/");
								if (cells[0].indexOf(",") >= 0) {
									String[] rows = cells[0].split(",");
									row = new int[rows.length];
									for (int k = 0; k < rows.length; k++) {
										row[k] = Integer.parseInt(rows[k])
												+ rowDif;
									}
								} else {
									row = new int[] { Integer
											.parseInt(cells[0]) + rowDif };
								}
								if (cells[1].indexOf(",") >= 0) {
									String[] cloumns = cells[1].split(",");
									cloumn = new int[cloumns.length];
									for (int k = 0; k < cloumns.length; k++) {
										cloumn[k] = Integer
												.parseInt(cloumns[k]);
									}
								} else {
									cloumn = new int[] { Integer
											.parseInt(cells[1]) };
								}
								this.combineMap.put(row, cloumn);
							}
						}
					}
				}
			}
	// TODO Auto-generated method stub
	if (combineMap != null && combineMap.size() != 0) {
		Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry<int[], int[]> entry = it.next();
			try {
				map.combine(entry.getKey(), entry.getValue());
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
			}
			
		}
	}
}

String selectId;
/**
 * ϲԪ
 */
private void comBineCell() {
	isMeopSave=true;
	// TODO Auto-generated method stub
	// table.setRowHeight(2, 50);
	int[] rows = mainTable.getSelectedRows();
	int[] columns = mainTable.getSelectedColumns();
	if (rows.length <= 0) {
		MessageBox.post("ѡҪϲĵԪ", "", MessageBox.ERROR);
		return;
	}
//	for (int i = 0; i < rows.length; i++) {
//		if (this.processRows != null && this.processRows.size() > 0 && !(this.processRows.contains(rows[i]))) {
//			MessageBox.post("Ȩ޺ϲԪ", "", MessageBox.ERROR);
//			return;
//		}
//	}
	if (combineMap != null && combineMap.size() != 0) {
		for (int i = 0; i < rows.length; i++) {
			Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry<int[], int[]> entry = it.next();
				List keysList = new ArrayList<>();
				for (int j = 0; j < entry.getKey().length; j++) {
					keysList.add(entry.getKey()[j]);
				}
				if (keysList.contains(rows[i])) {
					for (int j = 0; j < columns.length; j++) {
						List valueList = new ArrayList<>();
						for (int k = 0; k < entry.getValue().length; k++) {
							valueList.add(entry.getValue()[k]);
						}
						if (valueList.contains(columns[j])) {
							columns = Union(columns, entry.getValue());
							rows = Union(rows, entry.getKey());
							if (combineMap.get(entry.getKey()) != null) {
								it.remove();
							}
						}
					}
				}
			}
		}
		combineMap.put(rows, columns);
	} else {
		combineMap.put(rows, columns);
	}
	for (int i = 0; i < rows.length; i++) {
		for (int j = 0; j < columns.length; j++) {
			map.split(rows[i], columns[j]);
		}
	}
	Arrays.sort(rows);
	Arrays.sort(columns);
	map.combine(rows, columns);
	// map.removeRow(table.getSelectedRow());
	mainTable.revalidate();
	mainTable.repaint();
}


/**
 * ֵԪ
 */
private void splitCell() {
	isMeopSave=true;
	// TODO Auto-generated method stub
	int row = mainTable.getSelectedRow();
	int colmn = mainTable.getSelectedColumn();
	if (row < 0) {
		MessageBox.post("ѡҪֵĵԪ", "", MessageBox.ERROR);
		return;
	}
//	if (this.processRows != null && this.processRows.size() > 0
//			&& !(this.processRows.contains(row))) {
//		MessageBox.post("Ȩ޲ֵԪ", "", MessageBox.ERROR);
//		return;
//	}
	Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
	while (it.hasNext()) {
		Map.Entry<int[], int[]> entry = it.next();
		List keysList = new ArrayList<>();
		List valuesList = new ArrayList<>();
		for (int j = 0; j < entry.getKey().length; j++) {
			keysList.add(entry.getKey()[j]);
		}
		for (int j = 0; j < entry.getValue().length; j++) {
			valuesList.add(entry.getValue()[j]);
		}
		if (keysList.contains(row) && valuesList.contains(colmn)) {
			for (int i = 0; i < entry.getKey().length; i++) {
				for (int j = 0; j < entry.getValue().length; j++) {
					map.split(entry.getKey()[i], entry.getValue()[j]);
				}
			}
			it.remove();
		}
	}

	mainTable.revalidate();
	mainTable.repaint();
}






// Jtableͨ÷
public CTable getNewjTable(CTable partsTable, DefaultTableModel dtm,
	Object[] titleNames, int rows) {
int simpleLen = 100;
int totleLen = 100;
if (partsTable == null) {
	
	if(rows==0) {
		map = new CTMap(rows+1, titleNames.length);
	}else {
		map = new CTMap(rows, titleNames.length);
	}
	
	//CTMap map = new CTMap(rows, titleNames.length);
	map.setColumnIdentifiers(titleNames);
	map.setEditable(false);
	partsTable = new CTable(map,true,tstxList);
	
	if(initRowHeight==0) {
		partsTable.setRowHeight(50);
	}else {
		partsTable.setRowHeight(initRowHeight);
	}
	
	//partsTable.HiddenCell(0);
	// 
	//partsTable.HiddenCell(titleNames.length - 1);
	// partsTable.HiddenCell(titleNames.length-2);
	// partsTable.setRowHeight(1, 50);
	TableCellTextAreaRenderer2 renderer = new TableCellTextAreaRenderer2();
	partsTable.setDefaultRenderer(Object.class, renderer);
	if (simpleLen * titleNames.length >= totleLen) {
		for (int i = 0; i < titleNames.length; i++) {
			partsTable.getColumnModel().getColumn(i)
					.setPreferredWidth(simpleLen);
		}
		partsTable.setAutoResizeMode(0);
	} else {
		partsTable.setAutoResizeMode(1);
	}
}
return partsTable;
}

@Override
public void actionPerformed(ActionEvent arg0) {
Object source = arg0.getSource();
if (source.equals(this.addItem)) {
//	Component component = tabbedPane.getSelectedComponent();
//	if (component instanceof JScrollPane) {
//		JScrollPane scrollPane = (JScrollPane) component;
//		Component tableComponent = scrollPane.getViewport().getView();
//		if (tableComponent instanceof CTable) {
			CTable table = this.mainTable;
			if (table.getSelectedRow() > -1) {
//				((CTMap) table.getModel()).insertRow(table
//						.getSelectedRow() + 1);
				int selectedRow = table.getSelectedRow();
				Object valueAt = table.getValueAt(table.getSelectedRow(),
						table.getColumnCount() - 1);
				int selectedColumn = table.getSelectedColumn();
				if(selectedColumn>-1)
				if (combineMap != null && combineMap.size() != 0) {
					Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
					while (it.hasNext()) {
						Map.Entry<int[], int[]> entry = it.next();
						int[] key = entry.getKey();
						int[] value = entry.getValue();
						if(value[0]==selectedColumn && key[0]==selectedRow) {
							selectedRow = key[key.length-1];
						}
//						combine(entry.getKey(), entry.getValue());
					}
				}
				
				combineMap = map.insertRowComb(selectedRow + 1,combineMap);

				
				System.out.println("valueAt=======>"+valueAt);
//					
				table.setValueAt(
						valueAt,
						selectedRow + 1,
						table.getColumnCount() - 1);
				table.revalidate();
				table.repaint();
				//this.tabbedPane.updateUI();
			}
//		}
//	}
}else if (source.equals(this.addItems)) {
//	Component component = tabbedPane.getSelectedComponent();
//	if (component instanceof JScrollPane) {
//		JScrollPane scrollPane = (JScrollPane) component;
//		Component tableComponent = scrollPane.getViewport().getView();
//		if (tableComponent instanceof CTable) {
	
	AddRowsDialog dialog = new AddRowsDialog(source);
	
//		}
//	}
}  
else if (source.equals(this.addNodeItem)) {
	//ȡʻ
	Locale defaultLocale=Locale.getDefault();
	ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
	
	final JFrame frame = new JFrame();
	frame.setLocationRelativeTo(this);
	frame.setSize(new Dimension(400, 200));
	JLabel label = new JLabel(rb.getString("jdmc12_display.TITLE"));
	final JTextField field = new JTextField(20);
	JLabel idlabel = new JLabel(rb.getString("jdID12_display.TITLE"));
	final JTextField idfield = new JTextField(20);
	JButton okButton = new JButton(rb.getString("qd_display.TITLE"));
	okButton.addActionListener(new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			// TODO Auto-generated method stub
			nodeName = field.getText();
			nodeID = idfield.getText();
			// node.add(new DefaultMutableTreeNode("ս"));
			String selectSql = "";
			String insterSql = "";
				insterSql = "insert into AHMC_PFMEA_TREE values(?,?,?,?)";
//			}
			//String id = "";
			try {
				UUID uid = UUID.randomUUID();
				TreeBean bean = new TreeBean();
				bean.setPlmeid(uid.toString().replace("-", ""));
				bean.setId(nodeID);
				bean.setName(nodeName);
				bean.setParentId("");
			//	tabbedPane.add(nodeName, new JScrollPane(table));
				// ȡݿ
				SqlUtilT.getTCConnection();
				SqlUtilT.write(
						new String[] { uid.toString().replace("-", ""),
								nodeID, nodeName, "" },
						insterSql);
					refreshPFMEALeftTable();
				frame.dispose();
				int rowCount = leftTable.getRowCount();
				for(int t=0;t<rowCount;t++) {
					String uid111 = (String) leftTable.getValueAt(t, 0);
					if(uid111.equals(bean.getPlmeid())) {
						leftTable.setRowSelectionInterval(t,t);
						System.out.println("-----------------"+t);
						addSelected = t;
						selectId = bean.getId();
						refreshPFMEATable(bean.getId());
						isMeopSave = true;
						combineMap.clear();
					}
				}
				
				//tabbedPane.updateUI();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {
				SqlUtilT.freeAll();
			}
		}
	});
	JButton celButton = new JButton("ȡ");
	celButton.addActionListener(new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			frame.dispose();
		}
	});
	JPanel jPanel = new JPanel(new PropertyLayout());
	jPanel.add("1.1.left.top", idlabel);
	jPanel.add("1.2.left.top", idfield);
	jPanel.add("2.1.left.top", label);
	jPanel.add("2.2.left.top", field);
	
	JPanel rootJPanel = new JPanel(new FlowLayout());
	rootJPanel.add(okButton);
	rootJPanel.add(celButton);
	JPanel panel = new JPanel(new BorderLayout());
	panel.add(new JScrollPane(jPanel), BorderLayout.CENTER);
	panel.add(rootJPanel, BorderLayout.SOUTH);
	frame.add(panel);
	frame.show();
}else if (source.equals(this.updateNodItem)) {
	CTable table = this.leftTable;
	final JFrame frame = new JFrame();
	frame.setLocationRelativeTo(this);
	frame.setSize(new Dimension(400, 200));
	JLabel label = new JLabel("ڵ");
	final JTextField field = new JTextField(20);
	field.setText(table.getValueAt(table.getSelectedRow(), 2) == null ? "": table.getValueAt(table.getSelectedRow(), 2).toString());
	JLabel idlabel = new JLabel("ڵID");
	final JTextField idfield = new JTextField(20);
	idfield.setText(table.getValueAt(table.getSelectedRow(),1 ) == null ? "" : table.getValueAt(table.getSelectedRow(),1 ).toString());
	JButton okButton = new JButton("ȷ");
	okButton.addActionListener(new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			// TODO Auto-generated method stub
			nodeName = field.getText() == null ? "" : field.getText();
			nodeID = idfield.getText() == null ? "" : idfield.getText();
//PARENT_ID
			String updateSql = String
						.format("update AHMC_PFMEA_TREE set NAME = ?,ID = ? where PLMEID = \'%s\'",
								leftTable.getValueAt(leftTable.getSelectedRow(), 0).toString());
//				break;
//			case "com.connor.renben.process.plm.commands.Thesaurus":
//				updateSql = String
//						.format("update RB3_THESAURUS_TREE set NAME = ?,PARENT_ID = ? where PLMEID = \'%s\'",
//								leftTable.getValueAt(leftTable.getSelectedRow(), 0).toString());
//				break;
//			default:
//				break;
//			}
				System.out.println(updateSql);
			try {
				SqlUtilT.getTCConnection();
				SqlUtilT.write(
						new String[] { nodeName, nodeID },
								updateSql);
				
					refreshPFMEALeftTable();

				frame.dispose();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {
				SqlUtilT.freeAll();
			}
		}
	});
	//ȡʻ
	Locale defaultLocale=Locale.getDefault();
	ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
	
	JButton celButton = new JButton(rb.getString("qx_display.TITLE"));
	celButton.addActionListener(new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			frame.dispose();
		}
	});
	JPanel jPanel = new JPanel(new PropertyLayout());
	
	jPanel.add("1.1.left.top", idlabel);
	jPanel.add("1.2.left.top", idfield);
	jPanel.add("2.1.left.top", label);
	jPanel.add("2.2.left.top", field);
	JPanel rootJPanel = new JPanel(new FlowLayout());
	rootJPanel.add(okButton);
	rootJPanel.add(celButton);
	JPanel panel = new JPanel(new BorderLayout());
	panel.add(new JScrollPane(jPanel), BorderLayout.CENTER);
	panel.add(rootJPanel, BorderLayout.SOUTH);
	frame.add(panel);
	frame.show();
} else if (source.equals(this.remItem)) {
//	Component component = tabbedPane.getSelectedComponent();
//	if (component instanceof JScrollPane) {
//		JScrollPane scrollPane = (JScrollPane) component;
//		Component tableComponent = scrollPane.getViewport().getView();
//		if (tableComponent instanceof CTable) {
	int i=JOptionPane.showConfirmDialog(null, "ǷɾѡУ", "ɾ", JOptionPane.YES_NO_OPTION);
    if(i!=JOptionPane.YES_OPTION){
    	return;
    }
			CTable table = this.mainTable;
			
			remRow(table);
			
//			if (table.getSelectedRow() >= 0
//					&& table.getSelectedColumn() > 0) {
//				(table.getCellEditor(table.getSelectedRow(),
//						table.getSelectedColumn())).stopCellEditing();
//				if (((CTMap) table.getModel()).getValueAt(
//						table.getSelectedRow(), 0) != null) {
//					deleteRows.add(((CTMap) table.getModel())
//							.getValueAt(table.getSelectedRow(), 0)
//							.toString());
//				}
////				((CTMap) table.getModel()).removeRow(table
////						.getSelectedRow());
//				map.removeRow(table.getSelectedRow());
//				table.revalidate();
//				table.repaint();
//			}
//		}
//	}
} else if (source.equals(this.remNodeItem)) {
//	Component component = tabbedPane.getSelectedComponent();
//	if (component instanceof JScrollPane) {
//		JScrollPane scrollPane = (JScrollPane) component;
//		Component tableComponent = scrollPane.getViewport().getView();
//		if (tableComponent instanceof CTable) {
			CTable table = this.mainTable;
			String deleteNodeSql = "";
			String deleteTreeSql = "";
//			switch (commandId) {
//			case "com.connor.renben.process.plm.commands.ControlPlanLibrary":
//				deleteTreeSql = String
//						.format("delete from RB3_CONTROLPLAN_TREE where PLMEID = \'%s\'",
//								leftTable.getValueAt(leftTable.getSelectedRow(), 0).toString());
//				deleteNodeSql = String
//						.format("delete from RB3_CONTROLPLAN_NODE where PARENT_ID = \'%s\'",
//								leftTable.getValueAt(leftTable.getSelectedRow(), 1).toString());
//				break;
//			case "com.connor.renben.process.plm.commands.PFMEALibrary":
			 Object nameVal = leftTable.getValueAt(leftTable.getSelectedRow(), 0);
			 String nameString = "";
			 if(nameVal!=null) {
			 	nameString = nameVal.toString();
			 }
			
				deleteTreeSql = String
						.format("delete from AHMC_PFMEA_TREE where PLMEID = \'%s\'",
								nameString==null?"":nameString);
				Object valueAt = leftTable.getValueAt(leftTable.getSelectedRow(), 1);
				String idString = "";
				if(valueAt!=null) {
					idString = valueAt.toString();
				}
				
				deleteNodeSql = String
						.format("delete from AHMC_PFMEA_NODE where PARENT_ID = \'%s\'",
								idString==null?"":idString);
//				break;
//			case "com.connor.renben.process.plm.commands.Thesaurus":
//				deleteTreeSql = String
//						.format("delete from RB3_THESAURUS_TREE where PLMEID = \'%s\'",
//								leftTable.getValueAt(leftTable.getSelectedRow(), 0).toString());
//				deleteNodeSql = String
//						.format("delete from RB3_THESAURUS_NODE where PARENT_ID = \'%s\'",
//								leftTable.getValueAt(leftTable.getSelectedRow(), 1).toString());
//				break;
//			default:
//				break;
//			}
			SqlUtilT.getTCConnection();
			SqlUtilT.delete(deleteTreeSql);
			SqlUtilT.freeAll();
			SqlUtilT.getTCConnection();
			SqlUtilT.delete(deleteNodeSql);
			SqlUtilT.freeAll();
//			switch (commandId) {
//			case "com.connor.renben.process.plm.commands.ControlPlanLibrary":
//				refreshLeftTable();
//				break;
//			case "com.connor.renben.process.plm.commands.PFMEALibrary":
				refreshPFMEALeftTable();
//				break;
//			case "com.connor.renben.process.plm.commands.Thesaurus":
//				refreshThesaurusLeftTable();
//				break;
//			default:
//				break;
//			}
			//this.tabbedPane.remove(scrollPane);
			//this.tabbedPane.updateUI();
//		}
//	}
} else if (source.equals(this.saveButton)) {
	okEvent(true);
	//this.disposeDialog();
	
//	this.dispose();
}
else if (source.equals(shrinkColumnItem)) {
	for (int i = 0; i < mainTable.getSelectedColumns().length; i++) {
		mainTable.getColumnModel().getColumn(mainTable.getSelectedColumns()[i]).setPreferredWidth(5);
	}
	mainTable.revalidate();
	mainTable.repaint();
}
else if (source.equals(celShrinkColumnItem)) {
	for (int i = 0; i < mainTable.getSelectedColumns().length; i++) {
		mainTable.getColumnModel().getColumn(mainTable.getSelectedColumns()[i]).setPreferredWidth(100);
	}
	mainTable.revalidate();
	mainTable.repaint();
}else if(source.equals(splitItem)) {
	splitCell();
}else if(source.equals(comBineItem) ){
	comBineCell();
}
else if(source.equals(this.reSetSize)){
	int i=JOptionPane.showConfirmDialog(null, "ǷýСǡ´δ򿪽ʱЧ", "", JOptionPane.YES_NO_OPTION);
    if(i==JOptionPane.YES_OPTION){
			SqlUtilT.getTCConnection();
			InputStream input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			try {
				pro.load(input);
				String deleteSQL = String.format(
						"DELETE FROM AHMC_PFMEAFRAME_SIZE WHERE USERNAME = '%s' AND TYPE = '%s'",userName,type);
				SqlUtilT.delete(deleteSQL);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			isReSet=true;
			SqlUtilT.freeAll();
    }
}
else if (source.equals(setRowHeightBtn)) {
	if (!this.setRowHeightTxt.getText().equals("")) {
		String text = setRowHeightTxt.getText();
		
		Integer valueOf = Integer.valueOf(text);
		if(valueOf>10 || valueOf<1) {
			MessageBox.post("и߽1-10֮","ʾ",2);
		}
		
		mainTable.setRowHeight(valueOf*40);
		rowHeightAll = valueOf*40;
	} else {
		
	}
}
else {
	//this.disposeDialog();
	this.dispose();
	// this.setVisible(false);
}
}


private void remRow(CTable table) {
	// TODO Auto-generated method stub
//	if (this.tabbedPane.getSelectedIndex() == 1) {
//		if (table2.getSelectedRow() > 0 && table2.getSelectedColumn() > 0) {
//			(table2.getCellEditor(table2.getSelectedRow(), table2.getSelectedColumn())).stopCellEditing();
//		}
//		int[] rows = table2.getSelectedRows();
//		CTMap map = ((CTMap) this.table2.getModel());
//		for (int i = 0; i < rows.length; i++) {
//			map.removeRow(table2.getSelectedRow());
//		}
//	} else {
	if (table.getSelectedRow() > 0 && table.getSelectedColumn() > 0) {
		(table.getCellEditor(table.getSelectedRow(), table.getSelectedColumn())).stopCellEditing();
	}
	int[] rows = table.getSelectedRows();
	for (int i1 = 0; i1 < rows.length; i1++) {
//		if (this.processRows != null && this.processRows.size() > 0
//				&& !(this.processRows.contains(table.getSelectedRow()))) {
//			MessageBox.post("ȨɾУ", "", MessageBox.ERROR);
//			return;
//		}
		Map<int[], int[]> cellMap = new HashMap<int[], int[]>();
		Iterator<Map.Entry<int[], int[]>> it = combineMap.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry<int[], int[]> entry = it.next();
			List keysList = new ArrayList<>();
			for (int j = 0; j < entry.getKey().length; j++) {
				keysList.add(entry.getKey()[j]);
			}
			if (keysList.contains(table.getSelectedRow())) {
				int[] newKey = new int[entry.getKey().length - 1];
				for (int i = 0; i < entry.getKey().length; i++) {
					for (int j = 0; j < entry.getValue().length; j++) {
						map.split(entry.getKey()[i], entry.getValue()[j]);
					}
					if (i < newKey.length) {
						newKey[i] = entry.getKey()[i];
					}
				}
				it.remove();
				cellMap.put(newKey, entry.getValue());
			} else if (!keysList.contains(table.getSelectedRow())
					&& Integer.parseInt(keysList.get(0).toString()) > table.getSelectedRow()) {
				int[] newKey = new int[entry.getKey().length];
				for (int i = 0; i < entry.getKey().length; i++) {
					for (int j = 0; j < entry.getValue().length; j++) {
						map.split(entry.getKey()[i], entry.getValue()[j]);
					}
					newKey[i] = entry.getKey()[i] - 1;
				}
				it.remove();
				cellMap.put(newKey, entry.getValue());
			}
		}
		if (map.getValueAt(table.getSelectedRow(), 0) != null) {
			deleteRows.add(map.getValueAt(table.getSelectedRow(), 0).toString());
		}
		map.removeRow(table.getSelectedRow());
		// this.processRows = map.getProcessRowList();
		Iterator<Map.Entry<int[], int[]>> cellIt = cellMap.entrySet().iterator();
		while (cellIt.hasNext()) {
			Map.Entry<int[], int[]> entry = cellIt.next();
			if (entry.getKey().length > 0 && entry.getValue().length > 0) {
				map.combine(entry.getKey(), entry.getValue());
				combineMap.put(entry.getKey(), entry.getValue());
			}
		}
		table.revalidate();
		table.repaint();
	}
//	}
}

private void okEvent(boolean isSave) {
	//ȡĻߴλ+++++
			String list1=String.valueOf(((int)this.getSize().getWidth()))+"/"+String.valueOf((int)this.getSize().getHeight())
							+"/"+String.valueOf(((int)this.getLocation().getX()))+"/"+String.valueOf((((int)this.getLocation().getY())));
			
			String list2="";
			for(int i=1;i<4;i++) {
				if(i==3) {
					list2+=String.valueOf(((int)scrollPane2.getWidth()));
				}else {
					list2+=(String.valueOf(((int)this.leftTable.getColumnModel().getColumn(i).getWidth()))+"/");
				}
			}
			String list3="";
			for(int i=1;i<31;i++) {
				if(i==30) {
					list3+=String.valueOf(((int)this.mainTable.getColumnModel().getColumn(i).getWidth()));
				}else {
					list3+=(String.valueOf(((int)this.mainTable.getColumnModel().getColumn(i).getWidth()))+"/");
				}
			}
			SqlUtilT.getTCConnection();
			InputStream input = null;
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			try {
				pro.load(input);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			if(isFirstOpen) {
				String insertSQL = "INSERT INTO AHMC_PFMEAFRAME_SIZE VALUES(?,?,?,?,?,?,?)";
				SqlUtilT.write(new String[] {
						UUID.randomUUID().toString().replace("-", ""),
						this.userName,this.type,list1,list2,list3,String.valueOf(mainTable.getRowHeight())}, insertSQL);
				isFirstOpen=false;
			}else if(!isReSet){
				String updateSQL = String.format(
						"update AHMC_PFMEAFRAME_SIZE set FRAMESIZE = ?, TABLE1SIZE = ?, TABLE2SIZE = ?,ROWHEIGHT = ?  WHERE USERNAME ='%s' AND TYPE = '%s'",userName,type);
				SqlUtilT.update(
						new String[] {list1,list2,list3,String.valueOf(mainTable.getRowHeight())},updateSQL);
			}
			SqlUtilT.freeAll();
			///++++++
	
	
	
		isMeopSave = false;
		// TODO Auto-generated method stub
		// ݱ浽
		try {
			// ȡJTableе
			List<List<String>> dataValeList = getTableValue();
			System.out.println(dataValeList.size()+"dataValeList    ======>");
			this.rootPanel.setBackground(Color.GREEN);
			new Thread() {
				@Override
				public void run() {
					try {
						
						ResultSet rs = null;
						InputStream input = null;
						try {
							// ȡSQL
							input = new BufferedInputStream(getClass().getResourceAsStream(
									"/sql.properties"));
							Properties pro = new Properties();
							pro.load(input);
							// ɾ
							for (int i = 0; i < deleteRows.size(); i++) {
								// ȡݿ
								SqlUtilT.getTCConnection();
								String deleteSQL = String.format(
										pro.getProperty("PFMEALIBRARYDELETE"),
										deleteRows.get(i));
								SqlUtilT.delete(deleteSQL);
								SqlUtilT.freeAll();
							}
							// ѯźID
							// ݿд
							
							for (int i = 0; i < dataValeList.size(); i++) {
								// ȡݿ
								SqlUtilT.getTCConnection();
								List<String> rowList = dataValeList.get(i);
								if (rowList.get(0) != null && !rowList.get(0).equals("")) {
									// ȡݿ
									String updateSQL = String.format(
											pro.getProperty("PFMEALIBRARYUPDATE"),
											rowList.get(0));
									SqlUtilT.update(
											new String[] { 
													rowList.get(1),rowList.get(2),rowList.get(3),
													rowList.get(4),rowList.get(5), rowList.get(6),
													rowList.get(7),rowList.get(8),rowList.get(9),
													rowList.get(10),rowList.get(11), rowList.get(12),
													rowList.get(13),rowList.get(14),rowList.get(15),
													rowList.get(16),rowList.get(17), rowList.get(18),
													rowList.get(19),rowList.get(20),rowList.get(21),
													rowList.get(22),rowList.get(23),rowList.get(24),
													rowList.get(25),rowList.get(26),rowList.get(27),
													rowList.get(28),rowList.get(29),rowList.get(30),
													rowList.get(31),rowList.get(32),rowList.get(34),rowList.get(35)},
											updateSQL);
								} else {
									
									String insertSQL = pro.getProperty("PFMEALIBRARYINSERT");
									SqlUtilT.write(new String[] {
											UUID.randomUUID().toString().replace("-", ""),
											rowList.get(3),rowList.get(4),
											rowList.get(5), rowList.get(6),rowList.get(7),
											rowList.get(8), rowList.get(9),rowList.get(10),
											rowList.get(11), rowList.get(12),rowList.get(13),
											rowList.get(14), rowList.get(15),rowList.get(16),
											rowList.get(17), rowList.get(18),rowList.get(19),
											rowList.get(20), rowList.get(21),rowList.get(22),
											rowList.get(23) ,rowList.get(33) ,rowList.get(24),rowList.get(1),
											rowList.get(25),rowList.get(26),rowList.get(27),rowList.get(28),rowList.get(29),
											rowList.get(30),rowList.get(31),rowList.get(32),rowList.get(34), rowList.get(2),rowList.get(35)}, 
											insertSQL);
								}
								SqlUtilT.freeAll();
							}
							if(leftTable.getSelectedRow()>-1) {
								System.out.println(leftTable.getSelectedRow()+"leftTable.getSelectedRow()");
								refreshPFMEATable();
							}else if(selectId!=null &&  !selectId.equals("")){
								System.out.println("selectId == >"+selectId);
								refreshPFMEATable(selectId);
							}
							//MessageBox.post("ɹ", "ɹ", MessageBox.WARNING);
						} catch (Exception e) {
							MessageBox.post(e.toString(), "", MessageBox.ERROR);
							e.printStackTrace();
//							throw e;
						} finally {
							if (rs != null) {
								SqlUtilT.free(rs);
							}
							if (input != null) {
								try {
									input.close();
								} catch (IOException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
							SqlUtilT.freeAll();
						}
						
						
						this.sleep(1000);
						rootPanel.setBackground(Color.WHITE);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}.start();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			this.rootPanel.setBackground(Color.RED);
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
}

private List<List<String>> getTableValue() {
// TODO Auto-generated method stub
List<List<String>> dataList = new ArrayList<List<String>>();
//Component[] components = tabbedPane.getComponents();
//for (int i = 0; i < components.length; i++) {
//	if (components[i] instanceof JScrollPane) {
//		JScrollPane scrollPane = (JScrollPane) components[i];
//		Component tableComponent = scrollPane.getViewport().getView();
//		if (tableComponent instanceof CTable) {
			CTable table = this.mainTable;
			//Ƴ
			if (table.getSelectedRow() >= 0 && table.getSelectedColumn() >= 0) {
				(table.getCellEditor(table.getSelectedRow(),
						table.getSelectedColumn())).stopCellEditing();
			}
			System.out.println("table.getRowCount() ====>"+table.getRowCount());
			for (int j = 0; j < table.getRowCount(); j++) {
				List<String> rowValue = new ArrayList<String>();
				for (int j2 = 0; j2 < table.getColumnCount(); j2++) {
					if(j2 == 1)
					{
						if(table.getValueAt(j, j2) != null )//isStr2Num(table.getValueAt(j, j2).toString())
						{
							rowValue.add(table.getValueAt(j, j2).toString());
							
						}
						else
						{
							rowValue.add("");
						}
						
						
					} 
					else
					{
						rowValue.add(table.getValueAt(j, j2) == null ? ""
								: table.getValueAt(j, j2).toString());
					}
				}
				rowValue.add(TMomMethodUtil.getCombineCell(combineMap,j) );
				System.out.println("j======>"+j+"rowValue"+rowValue.toString());
				
				rowValue.add(String.valueOf(j+2));
				dataList.add(rowValue);
			}
				return dataList;
}

private int[] Union(int[] a1, int[] a2) {
List<Integer> list1 = new ArrayList<Integer>();
List<Integer> list2 = new ArrayList<Integer>();
for (int i : a1) {
	list1.add(i);
}
for (int i : a2) {
	list2.add(i);
}
list1.removeAll(list2);
list2.addAll(list1);
int[] result = new int[list2.size()];
for (int i = 0; i < list2.size(); i++) {
	result[i] = list2.get(i);
}
return result;
}

/** 
* 鿴һַǷתΪ 
* @param str ַ 
* @return true ; false  
*/  
public boolean isStr2Num(String str) {   
try {  
    Integer.parseInt(str);  
    return true;  
} catch (NumberFormatException e) {  
    return false;  
}  
}

private class SpecialDialog extends AbstractAIFDialog implements
	ActionListener {
private JPanel tablePanel;// ؼ
private JTable table;

private JPanel rootPanel;// ť
private JButton okButton;// ȷ
private JButton celButton;// ȡ

public SpecialDialog() {
	// TODO Auto-generated constructor stub
	super();
	init();
}

private void init() {
	//ȡʻ
	Locale defaultLocale=Locale.getDefault();
	ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
	// TODO Auto-generated method stub
	this.setTitle(rb.getString("xztsfh12_display.TITLE"));
	this.table = getjTable(this.table, null, new Object[] { 1, 2, 3, 4,
			5, 6, 7, 8 }, new Object[][] { { 1, 2, 3, 4, 5, 6, 7, 8 },
			{ 9, 0, "q", "w", "e", "r", "t", "y" } });
	this.setLocationRelativeTo(this);
	this.table.setRowHeight(30);
	this.table.getTableHeader().setVisible(false);
	this.table.setFont(new Font("Y14.5M", 0, 15));
	this.tablePanel = new JPanel(new BorderLayout());
	this.tablePanel.add(this.table);

	this.okButton = new JButton(rb.getString("qd_display.TITLE"));
	this.okButton.addActionListener(this);
	this.celButton = new JButton(rb.getString("qx_display.TITLE"));
	this.celButton.addActionListener(this);
	this.rootPanel = new JPanel(new FlowLayout());
	this.rootPanel.add(this.okButton);
	this.rootPanel.add(this.celButton);

	this.add(this.tablePanel, BorderLayout.CENTER);
	this.add(this.rootPanel, BorderLayout.SOUTH);
	this.pack();
	this.show();
}

// Jtableͨ÷
public JTable getjTable(JTable partsTable, DefaultTableModel dtm,
		Object[] titleNames, Object[][] values) {
	int simpleLen = 100;
	int totleLen = 1000;
	if (partsTable == null) {
		partsTable = new JTable(this.getTableModel(dtm, titleNames,
				values));
		partsTable.setCellSelectionEnabled(true);
		if (simpleLen * titleNames.length >= totleLen) {
			for (int i = 0; i < titleNames.length; i++) {
				partsTable.getColumnModel().getColumn(i)
						.setPreferredWidth(simpleLen);
			}
			partsTable.setAutoResizeMode(0);
		} else {
			partsTable.setAutoResizeMode(1);
		}
	}
	return partsTable;
}

public DefaultTableModel getTableModel(DefaultTableModel dtm,
		Object[] titleNames, Object[][] values) {
	MyTableModel tableModel = null;
	if (dtm == null) {
		tableModel = new MyTableModel(values, titleNames);
	}
	return tableModel;
}

@Override
public void actionPerformed(ActionEvent actionevent) {
	// TODO Auto-generated method stub
	Object source = actionevent.getSource();
	if (source.equals(this.okButton)) {
		// DefaultMutableTreeNode node = (DefaultMutableTreeNode)
		// TMom012ControlPlanLibraryDialog.tree.getSelectionPath().getLastPathComponent();
		// node.add(new DefaultMutableTreeNode("ս"));
//		Component component = tabbedPane.getSelectedComponent();
//		if (component instanceof JScrollPane) {
//			JScrollPane scrollPane = (JScrollPane) component;
//			Component tableComponent = scrollPane.getViewport()
//					.getView();
//			if (tableComponent instanceof CTable) {
				CTable table = mainTable;
				int row = table.getSelectedRow();
				int column = table.getSelectedColumn();
				// λ
				String columnName = table.getColumnName(table
						.getSelectedColumn());

				int cursorIndex = ((TextAreaCellEditor) (table
						.getCellEditor(row, column))).getIndex();
				System.out.println("index+" + cursorIndex);
				(table.getCellEditor(row, column)).stopCellEditing();
				// TMom010SetPFMEADialog.table.getDefaultEditor(Object.class).stopCellEditing();
				StringBuilder sb = new StringBuilder(table.getValueAt(
						row, column).toString());

				// ѭ,indexλò-1,һֱ
				Integer index = 0;
				while ((index = sb.toString().indexOf("\n", index)) != -1) {

					// ÿѭһξҪȷһβҵλ
					index = index + "\n".length();
					// ÿһμ
					cursorIndex++;
				}
				// 
				Object special = table.getValueAt(row,
						table.getColumnCount() - 1);
				if (special == null || special.toString() == "") {
					table.setValueAt(columnName + "-" + cursorIndex,
							row, table.getColumnCount() - 1);
				} else {
					table.setValueAt(special + "|" + columnName + "-"
							+ cursorIndex, row,
							table.getColumnCount() - 1);
				}
				System.out.println(sb.length());
				String s = sb.insert(
						cursorIndex,
						this.table.getValueAt(
								this.table.getSelectedRow(),
								this.table.getSelectedColumn())
								.toString()).toString();
				table.setValueAt(s, table.getSelectedRow(),
						table.getSelectedColumn());
				System.out.println(table.getValueAt(row, column)
						.toString());
//			}
//		}
	} else {
		this.dispose();
	}
}
}
}
