package com.connor.renben.process.plm.util;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.imageio.ImageIO;


import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFClientAnchor;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFFormulaEvaluator;
import org.apache.poi.hssf.usermodel.HSSFName;
import org.apache.poi.hssf.usermodel.HSSFPatriarch;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.SpreadsheetVersion;
import org.apache.poi.ss.usermodel.BorderStyle;
//import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.CellValue;
//import org.apache.poi.ss.usermodel.ClientAnchor.AnchorType;
import org.apache.poi.ss.usermodel.IndexedColors;
import org.apache.poi.ss.util.AreaReference;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.ss.util.CellReference;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFFont;
import org.apache.poi.xssf.usermodel.XSSFFormulaEvaluator;
import org.apache.poi.xssf.usermodel.XSSFName;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCSession;

/**
 * Excel ǩ
 * 
 * @author hub 2015-09-06
 */
public class ExcelUtil {
	// private static Registry reg = Registry.getRegistry(this);
	// private static HSSFSheet sheet;
	// private static final int MY_ROWS = 46;
	private SimpleDateFormat dateFormat = new SimpleDateFormat(
			"yyyy-M-dd HH:mm");

	/**
	 * ȡEXCEL
	 * 
	 * @param File
	 *            excel_file
	 * @return List<List<String>> صϢ
	 * @throws IOException
	 * @throws FileNotFoundException
	 */
//	public static List<List<String>> readExcel(File excel_file)
//			throws FileNotFoundException, IOException {
//		if (excel_file == null || !excel_file.exists()) {
//			return null;
//		}
//		// صееϢ
//		List<List<String>> lines_msg = new ArrayList<List<String>>();
//		HSSFWorkbook workBook = new HSSFWorkbook(
//				new FileInputStream(excel_file));
//		HSSFFormulaEvaluator evaluator = new HSSFFormulaEvaluator(workBook);
//		HSSFSheet sheet = workBook.getSheetAt(0);
//		HSSFRow title_row = sheet.getRow(0);
//		// õеĿ
//		int col_count = title_row.getPhysicalNumberOfCells();
//		System.out.println(" SHEET COL COUNT " + col_count);
//		// õеĿ
//		int row_count = sheet.getLastRowNum();
//
//		System.out.println(" SHEET ROW COUNT " + row_count);
//		for (int j = 0; j < row_count + 1; j++) {
//			// صеϢ
//			HSSFRow row = sheet.getRow(j);
//			List<String> line_msg = new ArrayList<String>();
//			for (int i = 0; i < col_count; i++) {
//				String value = getStringCellValue(evaluator,
//						row.getCell((short) i));
//				line_msg.add(value);
//			}
//			lines_msg.add(line_msg);
//		}
//		// insertRow(sheet,4,1);
//		return lines_msg;
//	}
//
//	public void writeSignName(String intExcelFilePath, String outExcelFilePath,
//			String signName, String msgValue, int sheetIndex, int rowIndex,
//			int cellIndex) throws IOException {
//		// ļ·
//		FileOutputStream outPut = new FileOutputStream(new File(
//				outExcelFilePath));
//		// ļ·
//		FileInputStream inPut = new FileInputStream(new File(intExcelFilePath));
//		HSSFWorkbook wb = new HSSFWorkbook(inPut);
//		wb.getName("");
//		
////		AreaReference.generateContiguous(null, msgValue)
//		AreaReference[] areaR2 = AreaReference.generateContiguous( SpreadsheetVersion.EXCEL2007,wb
//				.getName("").getRefersToFormula());
//		AreaReference areaR = null;
//		CellReference[] cellR = areaR.getAllReferencedCells();
//		cellR[0].getSheetName();// s
//		cellR[0].getCol();//
//		cellR[0].getRow();//
//		HSSFFormulaEvaluator evaluator = new HSSFFormulaEvaluator(wb);
//		HSSFSheet sheet = wb.getSheetAt(sheetIndex);
//		HSSFRow row = sheet.getRow(rowIndex);
//
//		HSSFCell cell = row.getCell(cellIndex);
//		String value = getStringCellValue(evaluator, cell);
//		if (value.startsWith(signName)) {
//			value = value.substring(0, signName.length());
//		}
//
//		cell.setCellValue(value + msgValue);
//		wb.write(outPut);
//		inPut.close();
//		outPut.close();
//	}

	/**
	 * õԪָʽ
	 * 
	 * @param wb
	 * @param s
	 *            
	 * @param firstIndex
	 *            ʼλ
	 * @param lastIndex
	 *            λ
	 * @param fontSize
	 *            С
	 * @param FontName
	 *            ʽ
	 * @return
	 */
	public static HSSFRichTextString setCellFont(HSSFWorkbook wb, String s,
			int firstIndex, int lastIndex, int fontSize, String FontName) {
		HSSFRichTextString ts = new HSSFRichTextString(s);
		HSSFFont font1 = (HSSFFont) wb.createFont();
		font1.setFontHeightInPoints((short) 8); // ߶
		font1.setFontName(""); // 
		// font1.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD); // 
		HSSFFont font = (HSSFFont) wb.createFont();
		font.setFontHeightInPoints((short) fontSize); // ߶
		font.setFontName(FontName); // 
		// font.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD); // 
		ts.applyFont(firstIndex, lastIndex, font);
		ts.applyFont(lastIndex, ts.length(), font1);
		return ts;
	}
	/**
	 * õԪָʽ
	 * 
	 * @param wb
	 * @param s
	 *            
	 * @param firstIndex
	 *            ʼλ
	 * @param lastIndex
	 *            λ
	 * @param fontSize
	 *            С
	 * @param FontName
	 *            ʽ
	 * @return
	 */
	public static HSSFRichTextString setCellFont_XSSF(XSSFWorkbook wb, String s,
			int firstIndex, int lastIndex, int fontSize, String FontName) {
		HSSFRichTextString ts = new HSSFRichTextString(s);
		XSSFFont font1 = (XSSFFont) wb.createFont();
		font1.setFontHeightInPoints((short) 8); // ߶
		font1.setFontName(""); // 
		// font1.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD); // 
		XSSFFont font = (XSSFFont) wb.createFont();
		font.setFontHeightInPoints((short) fontSize); // ߶
		font.setFontName(FontName); // 
		// font.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD); // 
		ts.applyFont(firstIndex, lastIndex, font);
		ts.applyFont(lastIndex, ts.length(), font1);
		return ts;
	}

	/**
	 * ϲԪsheet.addMergedRegion(new CellRangeAddress(check_index-1,
	 * check_index+12+check_rows, 0, 0));
	 * 
	 * @param startRow
	 * @param endRow
	 * @return
	 */
	public static boolean combine(HSSFSheet sheet, int[] rows, int[] columns) {
		boolean isOK = false;
		if (rows.length > 0 && columns.length > 0) {
			sheet.addMergedRegion(new CellRangeAddress(rows[0],
					rows[rows.length - 1], columns[0],
					columns[columns.length - 1]));
			isOK = true;
		}
		return isOK;
	}
	/**
	 * ϲԪsheet.addMergedRegion(new CellRangeAddress(check_index-1,
	 * check_index+12+check_rows, 0, 0));
	 * 
	 * @param startRow
	 * @param endRow
	 * @return
	 */
	public static boolean combine_XSSF(XSSFSheet sheet, int[] rows, int[] columns) {
		boolean isOK = false;
		
		try {
			
			for(int t=0;t<rows.length;t++) {
				System.out.println("rows ==> "+rows[t]);
			}
			
			if ((rows.length > 0 && columns.length > 0 )  && (rows.length > 1 || columns.length > 1 )) {
				sheet.addMergedRegion(new CellRangeAddress(rows[0],
						rows[rows.length - 1], columns[0],
						columns[columns.length - 1]));
				isOK = true;
			}
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
		}
		
		
		return isOK;
	}

	/**
	 * ȡԪ
	 * 
	 * @param wb
	 * @param cellName
	 * @return
	 * @throws IOException
	 */
//	public static int getNamedColumnIndex(HSSFWorkbook wb, String cellName)
//			throws IOException {
//		int index = -1;
//		HSSFFormulaEvaluator evaluator = new HSSFFormulaEvaluator(wb);
//		HSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return -1;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007,name
//				.getRefersToFormula());
//		if (areaRs != null)
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						HSSFSheet sheet = wb.getSheet(sheetName);
//						HSSFRow row = sheet.getRow(rowIndex);
//						return colIndex;
//					}
//				}
//			}
//		return index;
//	}
//	/**
//	 * ȡԪ
//	 * 
//	 * @param wb
//	 * @param cellName
//	 * @return
//	 * @throws IOException
//	 */
//	public static int getNamedColumnIndex_XSSF(XSSFWorkbook wb, String cellName)
//			throws IOException {
//		int index = -1;
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(wb);
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return -1;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007,name
//				.getRefersToFormula());
//		if (areaRs != null)
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						XSSFSheet sheet = wb.getSheet(sheetName);
//						XSSFRow row = sheet.getRow(rowIndex);
//						return colIndex;
//					}
//				}
//			}
//		return index;
//	}

	/**
	 * 
	 * 
	 * @param session
	 * @param item
	 *            İ汾
	 * @param tcResource
	 *            ļ·
	 * @param relationName
	 *            ϵ
	 */
	public static void setExcelToItem(TCSession session,
			TCComponentItemRevision item, String tcResource, String fileName,
			boolean isDelete) {
		try {
			String as1[] = { tcResource };// ļ·
			String as2[] = { "excel" };
			String as3[] = { "MSExcel" };
			String as4[] = { "Plain" };
			TCComponentDatasetType tccomponentDatasetType = (TCComponentDatasetType) session
					.getTypeComponent("Dataset");
			TCComponentDataset tccomponentDataset = tccomponentDatasetType
					.create(fileName, "excel", "MSExcel");
			tccomponentDataset.setFiles(as1, as3, as4, as2);
			AIFComponentContext[] zyzdsChildrens = item.getChildren();
			TCComponentItemRevision zyzdsRev = item;
			for (AIFComponentContext zyzdsChildren : zyzdsChildrens) {
				if ("MSExcel".equals(zyzdsChildren.getComponent().getType())) {
					TCComponentDataset dateSet = (TCComponentDataset) zyzdsChildren
							.getComponent();
					zyzdsRev.remove("TC_Attaches", dateSet);
					dateSet.delete();
				}
			}
			item.add("TC_Attaches", tccomponentDataset);
			if (isDelete) {
				new File(tcResource).delete();
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * ȡԪ
	 * 
	 * @param wb
	 * @param cellName
	 * @return
	 * @throws IOException
	 */
//	public static String getNamedCellValue(HSSFWorkbook wb, String cellName)
//			throws IOException {
//		String value = null;
//		HSSFFormulaEvaluator evaluator = new HSSFFormulaEvaluator(wb);
//		HSSFName name = wb.getName(cellName);
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007,name
//				.getRefersToFormula());
//		if (areaRs != null)
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						HSSFSheet sheet = wb.getSheet(sheetName);
//						HSSFRow row = sheet.getRow(rowIndex);
//						HSSFCell cell = row.getCell(colIndex);
//						value = getStringCellValue(evaluator, cell);
//					}
//				}
//			}
//		return value;
//	}

	// Excel
	public void writeExcel(String xls_write_Address, InputStream stream,
			Vector<Vector<Object>> ls, String[] sheetnames) {
		FileOutputStream outStream;
		try {
			outStream = new FileOutputStream(new File(xls_write_Address));
			/*
			 * HSSFWorkbook workbook=new HSSFWorkbook(); HSSFSheet
			 * sheet=workbook.getSheetAt(0); for (int i = 0; i <
			 * this.resuList.size(); i++) { HSSFRow row = sheet.createRow(i);
			 * String[] s=this.resuList.get(i); for (int j = 0; j < s.length;
			 * j++) { HSSFCell cell=row.createCell(i);
			 * cell.setCellType(XSSFCell.CELL_TYPE_STRING);
			 * cell.setCellValue(s[i]); } }
			 */
			XSSFWorkbook workbook = new XSSFWorkbook(stream);
			XSSFCellStyle style = workbook.createCellStyle();
			style.setBorderBottom(BorderStyle.THIN);
			style.setBorderTop(BorderStyle.THIN);
			style.setBorderRight(BorderStyle.THIN);
			style.setBorderLeft(BorderStyle.THIN);
			for (int sn = 0; sn < sheetnames.length; sn++) {
				XSSFSheet sheet = workbook.getSheetAt(0);
				for (int i = 0; i < ls.size(); i++) {
					XSSFRow row = sheet.createRow(i + 1);
					Vector<Object> ls2 = ls.get(i);
					for (int cols = 0; cols < ls2.size(); cols++) {
						XSSFCell cell = row.createCell(cols);
						cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
						cell.setCellStyle(style);// ӱ߿
						if (ls2.get(cols) instanceof Date) {
							String date = ls2.get(cols) == null ? ""
									: dateFormat.format(ls2.get(cols));
							cell.setCellValue(date);// д
						} else {
							cell.setCellValue(ls2.get(cols) == null ? "" : ls2
									.get(cols).toString());// д
						}
					}
				}
			}
			workbook.write(outStream);
			outStream.close();
			System.out.println("ɹ");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void writeExcel(String xls_write_Address, InputStream stream,
			ArrayList<ArrayList<String>> ls, String[] sheetnames) {
		FileOutputStream outStream;
		try {
			outStream = new FileOutputStream(new File(xls_write_Address));
			/*
			 * HSSFWorkbook workbook=new HSSFWorkbook(); HSSFSheet
			 * sheet=workbook.getSheetAt(0); for (int i = 0; i <
			 * this.resuList.size(); i++) { HSSFRow row = sheet.createRow(i);
			 * String[] s=this.resuList.get(i); for (int j = 0; j < s.length;
			 * j++) { HSSFCell cell=row.createCell(i);
			 * cell.setCellType(XSSFCell.CELL_TYPE_STRING);
			 * cell.setCellValue(s[i]); } }
			 */
			XSSFWorkbook workbook = new XSSFWorkbook(stream);
			XSSFCellStyle style = workbook.createCellStyle();
			style.setBorderBottom(BorderStyle.THIN);
			style.setBorderTop(BorderStyle.THIN);
			style.setBorderRight(BorderStyle.THIN);
			style.setBorderLeft(BorderStyle.THIN);
			for (int sn = 0; sn < sheetnames.length; sn++) {
				XSSFSheet sheet = workbook.getSheetAt(0);
				for (int i = 0; i < ls.size(); i++) {
					XSSFRow row = sheet.createRow(i + 1);
					ArrayList<String> ls2 = ls.get(i);
					for (int cols = 0; cols < ls2.size(); cols++) {
						XSSFCell cell = row.createCell(cols);
						cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
						cell.setCellStyle(style);// ӱ߿
						cell.setCellValue(ls2.get(cols));// д
					}
				}
			}
			workbook.write(outStream);
			outStream.close();
			System.out.println("ɹ");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

//	/***
//	 * д뵽EXCEL д뵥ݣ
//	 * 
//	 * @param xls_write_Address
//	 * @param ls
//	 * @param sheetnames
//	 * @throws IOException
//	 */
//	public void writeExcel5(String xls_write_Address, InputStream stream,
//			ArrayList<ArrayList<String>> ls, String[] sheetnames)
//			throws IOException {
//		FileOutputStream output = new FileOutputStream(new File(
//				xls_write_Address)); // ȡļ·
//		HSSFWorkbook wb = new HSSFWorkbook(stream);// (new
//													// BufferedInputStream(output));
//		HSSFCellStyle style = wb.createCellStyle();
//		style.setBorderBottom(BorderStyle.THIN);
//		style.setBorderTop(BorderStyle.THIN);
//		style.setBorderRight(BorderStyle.THIN);
//		style.setBorderLeft(BorderStyle.THIN);
//		for (int sn = 0; sn < sheetnames.length; sn++) {
//			HSSFSheet sheet = wb.getSheetAt(0);
//			for (int i = 0; i < ls.size(); i++) {
//				HSSFRow row = sheet.createRow(i + 1);
//				ArrayList<String> ls2 = ls.get(i);
//				for (int cols = 0; cols < ls2.size(); cols++) {
//					HSSFCell cell = row.createCell(cols);
//					cell.setCellType(CellType.STRING);// ıʽ
//					cell.setCellStyle(style);// ӱ߿
//					cell.setCellValue(ls2.get(cols));// д
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//	}

	/***
	 * д뵽EXCEL д뵥ݣ
	 * 
	 * @param xls_write_Address
	 * @param ls
	 * @param sheetnames
	 * @throws IOException
	 */
	public void writeExcel(String xls_write_Address, ArrayList<ArrayList> ls,
			String[] sheetnames) throws IOException {
		FileOutputStream output = new FileOutputStream(new File(
				xls_write_Address)); // ȡļ·
		HSSFWorkbook wb = new HSSFWorkbook();// (new
												// BufferedInputStream(output));
		for (int sn = 0; sn < ls.size(); sn++) {
			HSSFSheet sheet = wb.createSheet(String.valueOf(sn));
			wb.setSheetName(sn, sheetnames[sn]);
			ArrayList<String[]> ls2 = ls.get(sn);
			for (int i = 0; i < ls2.size(); i++) {
				HSSFRow row = sheet.createRow(i);
				String[] s = ls2.get(i);
				for (int cols = 0; cols < s.length; cols++) {
					HSSFCell cell = row.createCell(cols);
					cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
					cell.setCellValue(s[cols]);// д
				}
			}
		}
		wb.write(output);
		output.close();
		System.out.println("-------WRITE EXCEL OVER-------");
	}

//	/**
//	 * ݵԪҵԪ
//	 * 
//	 * @param inputFilePath
//	 * @param cellName
//	 * @return
//	 */
//	public static List<String> getExcelNamedCellValue(String inputFilePath,
//			String[] cellNames) {
//		List<String> valueList = new ArrayList<String>();
//		try {
//			FileInputStream is = new FileInputStream(new File(inputFilePath));
//			HSSFWorkbook wb = new HSSFWorkbook(is);
//			for (String name : cellNames)
//				valueList.add(getNamedCellValue(wb, name));
//			is.close();
//		} catch (FileNotFoundException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		return valueList;
//	}

	/**
	 * Թ̱Ϣд
	 * 
	 * @param xls_write_Address
	 * @param ls
	 * @throws IOException
	 */
	/*
	 * public static void writeExcel(String outPath, InputStream input,
	 * List<JFomProjectChangeBean> beanListAll) throws IOException { int
	 * rowsCount = 5;
	 * 
	 * // insertRow();
	 * 
	 * FileOutputStream output = new FileOutputStream(new File(outPath)); //
	 * ȡļ· // FileInputStream input= new FileInputStream(); HSSFWorkbook wb
	 * = new HSSFWorkbook(input);// (new HSSFSheet sheet = wb.getSheetAt(0); for
	 * (int i = 0; i < (beanListAll.size() - rowsCount); i++) insertRow(sheet,
	 * 4, 1); int startRow = 2; for (int i = 0; i < beanListAll.size(); i++) {
	 * JFomProjectChangeBean bean = beanListAll.get(i); HSSFRow row = null;
	 * Boolean isCreat = false; if ((i + startRow) > sheet.getLastRowNum()) {
	 * row = sheet.createRow(i + startRow); isCreat = true; } else { row =
	 * sheet.getRow(i + startRow); isCreat = false; }
	 * 
	 * for (int cols = 0; cols < 12; cols++) { HSSFCell cell = null; if
	 * (isCreat) { cell = row.createCell(cols); } else { cell =
	 * row.getCell(cols); } if (cell == null) cell = row.createCell(cols);
	 * cell.setCellType(HSSFCell.CELL_TYPE_STRING);// ıʽ switch (cols) {
	 * 
	 * case 0: cell.setCellValue(bean.getIndexStr());// д break; case 1:
	 * cell.setCellValue(bean.getECRCode());// д break; case 2:
	 * cell.setCellValue(bean.getInternalCode());// д break; case 3:
	 * cell.setCellValue(bean.getDrawingNo());// д break; case 4:
	 * cell.setCellValue(bean.getPartStatus());// д break; case 5:
	 * cell.setCellValue(bean.getInitiator());// д break; case 6:
	 * cell.setCellValue(bean.getSureDate());// д break; case 7:
	 * cell.setCellValue(bean.getChangeMsgBef());// д break; case 8:
	 * cell.setCellValue(bean.getChangeMsg());// д break; case 9:
	 * cell.setCellValue(bean.getChargePerson());// д break; case 10:
	 * cell.setCellValue("");// д break; case 11: cell.setCellValue("");//
	 * д break; } } }
	 * 
	 * // } wb.write(output); output.close(); input.close();
	 * System.out.println("-------WRITE EXCEL OVER-------"); }
	 */
//	public void insertPicture(HSSFWorkbook wb, HSSFSheet sheet1,
//			String picPath, short colIndex, int rowIndex) {
//
//		// FileOutputStream fileOut = null;
//		BufferedImage bufferImg = null;
//		// ȰѶͼƬŵһByteArrayOutputStreamУԱByteArray
//		try {
//			if (!new File(picPath).exists()) {
//				return;
//			}
//			String dexStr = picPath.substring(picPath.lastIndexOf(".") + 1,
//					picPath.length());
//
//			ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
//			System.out.println(picPath);
//			bufferImg = ImageIO.read(new File(picPath));
//			ImageIO.write(bufferImg, dexStr, byteArrayOut);
//			// HSSFWorkbook wb = new HSSFWorkbook();
//			// HSSFSheet sheet1 = wb.createSheet("test picture");
//			// ͼĶһsheetֻܻȡһһҪע㣩
//			HSSFPatriarch patriarch = sheet1.createDrawingPatriarch();
//			// anchorҪͼƬ
//			HSSFClientAnchor anchor = new HSSFClientAnchor(13, 13, 0, 0,
//					(short) colIndex, rowIndex, (short) (colIndex + 1),
//					rowIndex + 1);
//			anchor.setAnchorType(AnchorType.DONT_MOVE_AND_RESIZE);
//			// ͼƬ
//			patriarch
//					.createPicture(anchor, wb.addPicture(
//							byteArrayOut.toByteArray(),
//							HSSFWorkbook.PICTURE_TYPE_JPEG));
//
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//
//	}
//	
	/**
	 * õԪ
	 * 
	 * @param wb
	 * @param cellName
	 * @return
	 * @throws IOException
	 */
//	public static void setNamedCellValue(HSSFWorkbook wb, String cellName,
//			String cellValue) throws IOException {
//		String value = null;
//		HSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007 ,name
//				.getRefersToFormula());
//		if (areaRs != null) {
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						HSSFSheet sheet = wb.getSheet(sheetName);
//						HSSFRow row = sheet.getRow(rowIndex);
//						HSSFCell cell = row.getCell(colIndex);
//						cell.setCellValue(cellValue);
//					}
//				}
//			}
//		}
//	}
	/**
	 * õԪ
	 * 
	 * @param wb
	 * @param cellName
	 * @return
	 * @throws IOException
	 */
//	public static void setNamedCellValue_XSSF(XSSFWorkbook wb, String cellName,
//			String cellValue) throws IOException {
//		String value = null;
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007 ,name
//				.getRefersToFormula());
//		if (areaRs != null) {
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						XSSFSheet sheet = wb.getSheet(sheetName);
//						XSSFRow row = sheet.getRow(rowIndex);
//						XSSFCell cell = row.getCell(colIndex);
//						cell.setCellValue(cellValue);
//					}
//				}
//			}
//		}
//	}

	/**
	 * ƳϲĵԪ
	 * 
	 * @param startRow
	 * @param endRow
	 * @return
	 */
	public static boolean removeMergen(HSSFSheet sheet, int startRow, int endRow) {
		boolean isOK = false;
		int count = sheet.getNumMergedRegions();
		for (int i = 0; i < count; i++) {
			CellRangeAddress address = sheet.getMergedRegion(i);
			System.out.println(address.getFirstRow() + "|"
					+ address.getLastRow());
			if (address.getFirstRow() == startRow
					&& address.getLastRow() == endRow) {
				sheet.removeMergedRegion(i);
				isOK = true;
				break;
			}
		}
		return isOK;
	}

	//ͼƬ;isProportionfalseǽͼƬǶ뵽ȫԪtrueǽԭͼ
	//sheetexcelpicturePathͼƬ·RowsͼƬУ1ʼcolunmsͼƬУ1ʼ
	//RowHeightCMƵиߣColumnWidthCMƵп
//	public static void InsertTitlePicture(File file,String outFilePath,String picturePath,int[] Rows,int[] colunms,boolean isProportion,
//			double RowHeightCM,double ColumnWidthCM,int ii,int jj) throws IOException {
////		//ȡϵͳֱ
////		int screenWidth=((int)java.awt.Toolkit.getDefaultToolkit().getScreenSize().width);
////		int screenHeight = ((int)java.awt.Toolkit.getDefaultToolkit().getScreenSize().height);
//		Workbook wb = new Workbook();
//		wb.loadFromHtml(new FileInputStream(file));
//		Worksheet sheet = wb.getWorksheets().get(0);
//		
//		double ColumnWidth=0.0;//пԪ
//		double RowHeight=0.0;//и
////		double ColumnWidthCM=0.0;//пԪCM
////		double RowHeightCM=0.0;//иCM
//		
//		for(int i=0;i<colunms.length;i++) {
//			ColumnWidth=ColumnWidth+sheet.getColumnWidthPixels(colunms[i]);
//			//ColumnWidthCM=ColumnWidthCM+sheet.getColumnWidth(colunms[i]);//ColumnWidthCMȡexcelпƣ
//		}
//		for(int i=0;i<Rows.length;i++) {
//			RowHeight=RowHeight+sheet.getRowHeightPixels(Rows[i]);
//			//RowHeightCM=RowHeightCM+sheet.getRowHeight(Rows[i]);;//RowHeightCMȡexcelиߣƣ
//		}
////		//ȡипתΪ
////		RowHeightCM=RowHeightCM*(0.031);//*0.031=3.25/105иߣףgetRowHeightõexcelʾĵλ
////		ColumnWidthCM=ColumnWidthCM*(0.22862);//*0.211=5.46/25.9пףgetColumnWidthõexcelʾĵλ
//		
//		//ȡͼƬ
//		FileInputStream input = new FileInputStream(picturePath);
//		BufferedImage sourceImg = ImageIO.read(input);
//		ExcelPicture pic1 = sheet.getPictures().add(ii, jj,sourceImg);
//		//ȡͼƬر
//		double W=sourceImg.getWidth();
//		double H=sourceImg.getHeight();
////		//ͼֱʱ
////		double WH=W/H;
//		//и
//		double w1=ColumnWidthCM/ColumnWidth;
//		double h1=RowHeightCM/RowHeight;
//		double CW=W/ColumnWidth;
//		double RH=H/RowHeight;
//		
//		if(isProportion) {
//			//
//			double h=0.0;
//			double w=0.0;
//			if(CW*h1/w1>RH) {
//				w=W/CW;
//				h=(H/CW)*w1/h1;//w1ǷͼƬпռ(0.18)h1иߵռ(0.23)
//			}else {
//				h=H/RH;
//				w=(W/RH)*h1/w1;
//			}
//			pic1.setWidth((int) (w));
//			pic1.setHeight((int) (h));
//		}else {
//			pic1.setWidth((int) ColumnWidth);
//			pic1.setHeight((int) RowHeight);
//		}
//		
//		wb.saveToFile(outFilePath);
//	    input.close();
//	    pic1.dispose();
//	    sourceImg.flush();
//	    new File(picturePath).delete();
//	    
////    //ˮӡ
////    File file1=new File(outFilePath);
////    FileInputStream input1 = new FileInputStream(file1);
////    XSSFWorkbook wb1 = new XSSFWorkbook(input1);
////    wb1.removeSheetAt(wb1.getActiveSheetIndex());
////    FileOutputStream output = new FileOutputStream(new File(outFilePath));
////    wb1.write(output);
////    input.close();
////    output.close();
//	}
//	

	
//	//ͼƬWorkBook
//	public static void InsertPicture(File file,int row,int colunm,String outFilePath,String outFilePathp) throws IOException {
//		//FileInputStream file = new FileInputStream(new File(outFilePath));
//		Workbook wb = new Workbook();
//		wb.loadFromHtml(new FileInputStream(file));
//		Worksheet sheet = wb.getWorksheets().get(0);
//		//ȡͼƬ
//		InputStream input = new FileInputStream(outFilePathp);
//		BufferedImage sourceImg = ImageIO.read(input);
//		ExcelPicture pic1 = sheet.getPictures().add(row, colunm,sourceImg);
//		
//		double ColumnWidth=sheet.getColumnWidthPixels(colunm)+sheet.getColumnWidthPixels(colunm+1)+sheet.getColumnWidthPixels(colunm+2)
//						+sheet.getColumnWidthPixels(colunm+3)+sheet.getColumnWidthPixels(colunm+4)+sheet.getColumnWidthPixels(colunm+5)
//						+sheet.getColumnWidthPixels(colunm+6)+sheet.getColumnWidthPixels(colunm+7);
//		double RowHeight=sheet.getRowHeightPixels(row)+sheet.getRowHeightPixels(row+1)+sheet.getRowHeightPixels(row+2)+sheet.getRowHeightPixels(row+3)
//							+sheet.getRowHeightPixels(row+4)+sheet.getRowHeightPixels(row+5)+sheet.getRowHeightPixels(row+6)
//							+sheet.getRowHeightPixels(row+7)+sheet.getRowHeightPixels(row+8)+sheet.getRowHeightPixels(row+9);
//		System.out.println("ͼƬԪ"+ColumnWidth);
//		System.out.println("ͼƬԪ"+RowHeight);
//		//ȡ߱
//		double aaa=sourceImg.getWidth();
//		double bbbb=sourceImg.getHeight();
//		double WidthProportion=ColumnWidth/aaa;
//		double HeightProportion=RowHeight/bbbb;
//		if(WidthProportion>HeightProportion) {
//			WidthProportion=HeightProportion;
//		}
//		//System.out.println("ͼƬԪߣ"+sheet.getCellRange("K6:K6").getp.getRowHeight());
//		pic1.setWidth((int) (sourceImg.getWidth()*WidthProportion));
//	    pic1.setHeight((int) (sourceImg.getHeight()*WidthProportion));
//	    
//	    wb.saveToFile(outFilePath);
//	    wb.dispose();
//	    input.close();
//	    pic1.dispose();
//	    sourceImg.flush();
//	    new File(outFilePathp).delete();
//	    
//	    
////	    //ˮӡ
////	    File file1=new File(outFilePath);
////        FileInputStream input = new FileInputStream(file1);
////        XSSFWorkbook wb1 = new XSSFWorkbook(input);
////        wb1.removeSheetAt(1);
////        FileOutputStream output = new FileOutputStream(new File(outFilePath));
////        wb1.write(output);
////        input.close();
////        output.close();
//	   
//	}
//	
	
	/**
	 * ȡַ
	 * 
	 * @param inStr
	 * @return
	 */
	public static String changeStringToInt(String inStr) {
		int index = inStr.indexOf(".");
		System.out.println(index);
		String outStr = null;
		if (index != -1) {

			outStr = inStr.substring(0, index);
		} else {
			outStr = inStr;

		}
		// System.out.println(outStr);
		return outStr;
	}

	/**
	 * ȡһȵַ
	 * 
	 * @param inStr
	 * @param inLen
	 * @return
	 */
	public static String changeStringToInt(String inStr, int inLen) {
		int index = inStr.indexOf(".");
		inLen++;
		System.out.println(index);
		String outStr = null;
		if (index != -1 && (inStr.length() - index) >= inLen) {

			outStr = inStr.substring(0, index + inLen);
		} else {
			outStr = inStr;

		}
		// System.out.println(outStr);
		return outStr;
	}

	/**
	 * floatתɱλַ
	 * 
	 * @param f
	 *            Ҫתfloat
	 * @return
	 */
	public static String changeFloatToStr(float f) {
		DecimalFormat decimalFormat = new DecimalFormat(".0");// 췽ַʽС2λ,0.
		String str = decimalFormat.format(f);// format صַ
		return str;
	}

	/**
	 * ַתint
	 * 
	 * @param str
	 * @return
	 */
	public static float changeStrToFloat(String str) {
		float temp_int = 0;
		try {
			temp_int = Float.parseFloat(str.trim());
			return temp_int;
		} catch (NumberFormatException e) {
			System.out.println(e.getMessage());
			return -1;
		}
	}

	/**
	 * formualʱ滻ԭеĵԪŵµĵԪ
	 * 
	 * @param originStr
	 * @param subStr
	 * @param index
	 * @param index2
	 * @return
	 */
	public static String replaceSubString(String originStr, String subStr,
			int index, int index2) {
		StringBuffer sbO = new StringBuffer();
		sbO.append(subStr);
		sbO.append(index);
		StringBuffer sbR = new StringBuffer();
		sbR.append(subStr);
		sbR.append(index2);
		String resultStr = originStr.replace(sbO.toString(), sbR.toString());
		return resultStr;
	}

	/**
	 * ȡEXCELϢ
	 * 
	 * @param String
	 *            excel_file
	 * @return List<List<String>> Ϣ
	 * @throws IOException
	 * @throws FileNotFoundException
	 */
//	public static List<List<String>> readExcel(String excel_file)
//			throws FileNotFoundException, IOException {
//		if (excel_file == null) {
//			return null;
//		}
//		File file = new File(excel_file);
//		return readExcel(file);
//	}

	/**
	 * ȡԪΪַ͵
	 * 
	 * @param cell
	 *            ExcelԪ
	 * @return String Ԫ
	 */
//	private static String getStringCellValue(HSSFFormulaEvaluator evaluator,
//			HSSFCell cell) {
//		if (cell == null) {
//			return "";
//		}
//		String strCell = "";
//		
//		switch (cell.getCellType()) {
//		case STRING:
//			strCell = cell.getStringCellValue();
//			break;
//		case NUMERIC:
//			strCell = "" + cell.getNumericCellValue();
//			if (strCell.endsWith(".0")) {
//				strCell = strCell.substring(0, strCell.indexOf(".0"));
//			}
//			break;
//		case BOOLEAN:
//			strCell = String.valueOf(cell.getBooleanCellValue());
//			break;
//		case BLANK:
//			strCell = "";
//			break;
//		case ERROR:
//			strCell = String.valueOf(cell.getErrorCellValue());
//			break;
//		case FORMULA:
//			CellValue value = evaluator.evaluate(cell);
//			try {
//				strCell = value.getStringValue();
//				if (strCell == null) {
//					strCell = "" + value.getNumberValue();
//					if (strCell.endsWith(".0")) {
//						strCell = strCell.substring(0, strCell.indexOf(".0"));
//					}
//				}
//			} catch (Exception e) {
//
//				strCell = "" + value.getNumberValue();
//				if (strCell.endsWith(".0")) {
//					strCell = strCell.substring(0, strCell.indexOf(".0"));
//				}
//			}
//			break;
//		default:
//			strCell = "";
//			break;
//		}
//		if (strCell.equals("") || strCell == null) {
//			return "";
//		}
//		return strCell;
//	}

	// public static void insertRow(HSSFSheet sheet, int starRow, int rows) {
	// HSSFRow sourceRow = sheet.getRow(starRow);
	// sheet.shiftRows(starRow + 1, sheet.getLastRowNum(), rows, true, false);
	// // starRow = starRow -1;
	// for (int i = 0; i < rows; i++) {
	// // sheet.shiftRows(starRow + i, sheet.getLastRowNum(), 1, true,
	// // false);
	// HSSFRow targetRow = null;
	// HSSFCell sourceCell = null;
	// HSSFCell targetCell = null;
	// short m;
	// targetRow = sheet.createRow(starRow + 1);
	// targetRow.setHeight(sourceRow.getHeight());
	// System.out.println(sourceRow.getLastCellNum());
	// for (m = sourceRow.getFirstCellNum(); m < sourceRow
	// .getLastCellNum(); m++) {
	// System.out.println(m);
	// sourceCell = sourceRow.getCell(m);
	// targetCell = targetRow.createCell(m);
	// // System.out.println(" ===== " + sourceCell + "  " +
	// // targetCell);
	// // targetCell.setEncoding(sourceCell.get);
	// targetCell.setCellStyle(sourceCell.getCellStyle());
	// targetCell.setCellType(sourceCell.getCellType());
	// // targetCell.setCellValue("11111");
	// }
	// }
	// }

	/**
	 * 
	 * 
	 * @param starRow
	 * @param rows
	 */
	public static void insertRow(HSSFSheet sheet, int starRow, int rows) {
		HSSFRow sourceRow = sheet.getRow(starRow);
		sheet.shiftRows(starRow + 1, sheet.getLastRowNum(), rows, true, false);
		for (int i = 0; i < rows; i++) {
			HSSFRow targetRow = null;
			HSSFCell sourceCell = null;
			HSSFCell targetCell = null;
			short m;
			targetRow = sheet.createRow(starRow + 1);
			targetRow.setHeight(sourceRow.getHeight());
			System.out.println(sourceRow.getLastCellNum());
			for (m = sourceRow.getFirstCellNum(); m < sourceRow
					.getLastCellNum(); m++) {
				System.out.println(m);
				sourceCell = sourceRow.getCell(m);
				targetCell = targetRow.createCell(m);
				targetCell.setCellStyle(sourceCell.getCellStyle());
				targetCell.setCellType(sourceCell.getCellType());
			}
		}
	}

	/***
	 * sheetвһ
	 * 
	 * @param sheet
	 * @param startRow
	 * @param rows
	 * @return
	 */
	public static HSSFSheet insertRows(HSSFSheet sheet, int startRow, int rows) {
		HSSFRow sourceRow = sheet.getRow(startRow);
		sheet.shiftRows(startRow + 1, sheet.getLastRowNum(), rows, true, false);
		for (int i = 0; i < rows; i++) {
			HSSFRow targetRow = null;
			HSSFCell sourceCell = null;
			HSSFCell targetCell = null;
			short m;
			targetRow = sheet.createRow(startRow + 1);
			targetRow.setHeight(sourceRow.getHeight());
			System.out.println(sourceRow.getLastCellNum());
			for (m = sourceRow.getFirstCellNum(); m < sourceRow
					.getLastCellNum(); m++) {
				System.out.println(m);
				sourceCell = sourceRow.getCell(m);
				targetCell = targetRow.createCell(m);
				targetCell.setCellStyle(sourceCell.getCellStyle());
				targetCell.setCellType(sourceCell.getCellType());
			}
		}
		return sheet;
	}

	/**
	 * 鵥ԪǷ
	 * 
	 * @param value
	 * @return
	 */
	public static boolean CheckCellValueIsNumber(String value) {
		boolean is_ok = false;
		if (value.equals("")) {
			return false;
		}
		try {
			Float.parseFloat(value);
		} catch (NumberFormatException e) {
			e.printStackTrace();
			System.out.println("===>" + value);
			is_ok = true;
		}
		return is_ok;
	}
	
//	public static void setFlowChart(Map<String, String> valueMap, File file) {
//		// TODO Auto-generated method stub
//		file.setWritable(true);
//		try {
//			InputStream is = new FileInputStream(file);
//			HSSFWorkbook wb = new HSSFWorkbook(is);// (
//			//HSSFSheet sheet = wb.getSheetAt(0);
//			
//			Iterator<Map.Entry<String, String>> it = valueMap.entrySet()
//					.iterator();
//			while (it.hasNext()) {
//				Map.Entry<String, String> entry = it.next();
//				setNamedCellValue(wb, entry.getKey(), entry.getValue());
//			}
//			FileOutputStream output = new FileOutputStream(file);
//			wb.write(output);
//			output.close();
//			is.close();
//		} catch (Exception e) {
//			// TODO: handle exception
//			e.printStackTrace();
//		}
//		//file.setReadOnly();
//		System.out.println("-------WRITE EXCEL OVER-------");
//	}
}
