//package com.connor.renben.process.plm.util;
//
//import java.awt.Color;
//import java.awt.Component;
//import java.awt.Container;
//import java.awt.Dimension;
//import java.awt.Graphics;
//import java.awt.Insets;
//import java.awt.LayoutManager;
//import java.awt.event.ActionEvent;
//import java.awt.event.ActionListener;
//import java.awt.event.KeyEvent;
//import java.awt.event.KeyListener;
//import java.awt.event.MouseEvent;
//import java.awt.event.MouseListener;
//import java.util.ArrayList;
//import java.util.Enumeration;
//import java.util.List;
//
//import javax.swing.JButton;
//import javax.swing.JComponent;
//import javax.swing.JPanel;
//import javax.swing.JScrollPane;
//import javax.swing.JTextArea;
//import javax.swing.JTextField;
//import javax.swing.UIManager;
//import javax.swing.plaf.basic.BasicArrowButton;
//import javax.swing.tree.DefaultMutableTreeNode;
//import javax.swing.tree.TreeNode;
//import javax.swing.tree.TreePath;
//
//import com.connor.renben.process.plm.bean.TMomUserBean;
//import com.teamcenter.rac.kernel.TCComponent;
//import com.teamcenter.rac.kernel.TCException;
//import com.teamcenter.rac.kernel.TCSession;
//import com.teamcenter.rac.util.MessageBox;
//import com.teamcenter.rac.util.PropertyLayout;
//
//public class TreeComboBox extends JComponent {
//
//	private Object[] values;
//
//	public Object[] defaultValues;
//
//	private List<ActionListener> listeners = new ArrayList<ActionListener>();
//
//	public TreeComboBoxPopup popup;
//
//	public JTextArea editor;
//
//	protected JButton arrowButton;
//
//	private String valueSperator;
//	
//	private TCSession session;
//	private String value;
//	private List<String> nameList = new ArrayList<String>();
//
//	private static final String DEFAULT_VALUE_SPERATOR = ",";
//
//	public TreeComboBox(Object[] value, Object[] defaultValue,TCSession session) {
//		this(value, defaultValue, DEFAULT_VALUE_SPERATOR,session);
//	}
//
//	public TreeComboBox(Object[] value, Object[] defaultValue, String valueSperator,TCSession session) {
//		values = value;
//		defaultValues = defaultValue;
//		this.valueSperator = valueSperator;
//		this.session = session;
//		initComponent();
//	}
//
//	private void initComponent() {
//		// ʱʹøò,Լд
//		this.setLayout(new PropertyLayout());
//		// this.set
//		popup = new TreeComboBoxPopup(values, defaultValues,session);
//		popup.addActionListener(new PopupAction());
//		
//		editor = new JTextArea();
//		editor.setBackground(Color.WHITE);
//		editor.setEditable(true);
////			editor.setBorder(getBorder());
//		editor.addKeyListener(new KeyListener() {
//			
//			@Override
//			public void keyTyped(KeyEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//			
//			@Override
//			public void keyReleased(KeyEvent e) {
//				// TODO Auto-generated method stub
//				char ch = e.getKeyChar();
//				// if (ch == KeyEvent.CHAR_UNDEFINED || Character.isISOControl(ch)
//				// || ch == KeyEvent.VK_DELETE)
//				// return;
//				if (e.getKeyCode() == KeyEvent.VK_ENTER) {
//					editor.setText(editor.getText().substring(0, editor.getText().length()-1));
//					int caretPosition = editor.getCaretPosition();
//					String str = editor.getText();
//					if (str.length() == 0)
//						return;
//					
//					if (value != null && !value.equals(str)) {
//						nameList.clear();
//						value = str;
//					} else {
//						value = str;
//					}
//					DefaultMutableTreeNode node = popup.searchNode(
//							str, nameList);
//					if (node != null) {
//						String user = ((String) node.getUserObject());
//						nameList.add(user);
//						TreeNode[] nodes = popup.m_model.getPathToRoot(node);
//						TreePath path = new TreePath(nodes);
//						popup.tree.scrollPathToVisible(path);
//						popup.tree.setSelectionPath(path);
//						
//						togglePopup();
//					} else {
//						MessageBox.post("δҵѡ", "", MessageBox.ERROR);
//						nameList.clear();
//					}
//					
//					
//					//autoComplete(str, caretPosition);
//				}
//			}
//			
//			@Override
//			public void keyPressed(KeyEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//		});
//		//editor.addMouseListener(new EditorHandler());
//		arrowButton = new JButton("");//createArrowButton();
//		arrowButton.setPreferredSize(new Dimension(50, 60));
//		arrowButton.addMouseListener(new EditorHandler());
//		JScrollPane scrollPane1 = new JScrollPane(); // jtaӹ
//		scrollPane1.setPreferredSize(new Dimension(335, 58));
//		scrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
//		scrollPane1.setViewportView(this.editor);
//		add("1.1.left.top", scrollPane1);
//		add("1.2.left.top", arrowButton);
//		// add(arrowButton);
//		setText();
//
//	}
//
//	public Object[] getSelectedValues() {
//		return popup.getSelectedValues();
//	}
//
//	public void addActionListener(ActionListener listener) {
//		if (!listeners.contains(listener))
//			listeners.add(listener);
//	}
//
//	public void removeActionListener(ActionListener listener) {
//		if (listeners.contains(listener))
//			listeners.remove(listener);
//	}
//
//	protected void fireActionPerformed(ActionEvent e) {
//		for (ActionListener l : listeners) {
//			l.actionPerformed(e);
//		}
//	}
//
//	private class PopupAction implements ActionListener {
//
//		public void actionPerformed(ActionEvent e) {
//
//			if (e.getActionCommand().equals(TreeComboBoxPopup.CANCEL_EVENT)) {
//				popup.setVisible(false);
//			} else if (e.getActionCommand().equals(TreeComboBoxPopup.COMMIT_EVENT)) {
//				defaultValues = popup.getSelectedValues();
//				if(defaultValues.length > 0)
//				{
//					setText();
//					// ¼ݳȥ
//					fireActionPerformed(e);
//					popup.setVisible(false);
//					//togglePopup();
//				}
//			}
//			else if (e.getActionCommand().equals(TreeComboBoxPopup.CANCEL_NEXT)) {
//				DefaultMutableTreeNode node = popup.searchNode(
//						editor.getText(), nameList);
//				if (node != null) {
//					String user = ((String) node.getUserObject());
//					nameList.add(user);
//					TreeNode[] nodes = popup.m_model.getPathToRoot(node);
//					TreePath path = new TreePath(nodes);
//					popup.tree.scrollPathToVisible(path);
//					popup.tree.setSelectionPath(path);
//				} else {
//					MessageBox.post("δҵѡ", "", MessageBox.ERROR);
//					nameList.clear();
//				}
//			}
//
//
//		}
//
//	}
//
//	private void togglePopup() {
//		if (popup.isVisible()) {
//			//popup.setVisible(false);
//		} else {
//			popup.setDefaultValue(defaultValues);
//			popup.show(this, 0, getHeight());
//		}
//	}
//
//	private void setText() {
//		StringBuilder builder = new StringBuilder();
//		for (Object dv : defaultValues) {
//			builder.append(dv);
//			builder.append(valueSperator);
//		}
//
//		editor.setText(builder.substring(0, builder.length() > 0 ? builder.length() - 1 : 0).toString());
//	}
//
//	private class EditorHandler implements MouseListener {
//
//		public void mouseClicked(MouseEvent e) {
//			togglePopup();
//		}
//
//		public void mousePressed(MouseEvent e) {
//
//		}
//
//		public void mouseReleased(MouseEvent e) {
//
//		}
//
//		public void mouseEntered(MouseEvent e) {
//
//		}
//
//		public void mouseExited(MouseEvent e) {
//
//		}
//
//	}
//
//	public void paintComponent(Graphics g) {
//		g.setColor(Color.white);
//		g.fillRect(0, 0, getWidth(), getHeight());
//	}
//
//	protected JButton createArrowButton() {
//		JButton button = new BasicArrowButton(BasicArrowButton.SOUTH, UIManager.getColor("ComboBox.buttonBackground"),
//				UIManager.getColor("ComboBox.buttonShadow"), UIManager.getColor("ComboBox.buttonDarkShadow"),
//				UIManager.getColor("ComboBox.buttonHighlight"));
//		button.setName("ComboBox.arrowButton");
//		return button;
//	}
//
//	private class MulitComboboxLayout implements LayoutManager {
//
//		public void addLayoutComponent(String name, Component comp) {
//			// TODO Auto-generated method stub
//
//		}
//
//		public void removeLayoutComponent(Component comp) {
//			// TODO Auto-generated method stub
//
//		}
//
//		public Dimension preferredLayoutSize(Container parent) {
//			return parent.getPreferredSize();
//		}
//
//		public Dimension minimumLayoutSize(Container parent) {
//			return parent.getMinimumSize();
//		}
//
//		public void layoutContainer(Container parent) {
//			int w = parent.getWidth();
//			int h = parent.getHeight();
//			Insets insets = parent.getInsets();
//			h = h - insets.top - insets.bottom;
//
//		}
//
//	}
//
//}
