package com.connor.renben.process.plm.util;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

public class TreeTableCellRenderer extends DefaultTreeCellRenderer {
	JTable table;

	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean selected, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
		Object ud = node.getUserObject();

		if (!(ud instanceof JTable) || !leaf) {
			return super.getTreeCellRendererComponent(tree, value, leaf,
					expanded, leaf, row, hasFocus);
		}
		return (JTable) ud;
	}
}
