package com.connor.zf.controlplan;

import java.awt.BorderLayout;
import java.awt.Color;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.UUID;

import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.plaf.metal.MetalProgressBarUI;

import org.apache.xmlbeans.impl.xb.xsdschema.Public;
//import org.junit.Test;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFCommand;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.commands.reserve.ReserveOperation;
import com.teamcenter.rac.kernel.TCAccessControlService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentGroup;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentRole;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCComponentUserType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.TCTypeService;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.services.rac.core.ReservationService;

public class TMom004SetControlPlanCommand extends AbstractAIFCommand {
	private TCSession session;
	private AbstractAIFApplication app;// ȡѡĿ
	private InterfaceAIFComponent comp;
	private TCComponentItem item;
	private TCComponentItemRevision itemRevision;
	private TCComponent form;
	private TCComponentItemRevision meprocess;
	private boolean isOwning = false;
	private TCTypeService service;
	private JFrame frame = new JFrame("ڼ...");//
	private JProgressBar progressBar = new JProgressBar();//
	//	private String[] properName = new String[] {
	//			"zf6_kzjhbh",//Ƽƻ
	//			"zf6_zylxdh", // Ҫϵ˵绰
	//			"zf6_bzrq",//
	//			"zf6_xdrq",//޶
	//			"zf6_sor", // SOR/
	//			"zf6_ljhzzbb",///հ汾
	//			"zf6_hxxz", // С
	//			"zf6_gkgcpz",// ˿͹׼/
	//			"zf6_khtzbh",//ͻͼֽ
	//			"zf6_ljmcms",///
	//			"zf6_gfgcpz", // /׼/
	//			"zf6_gkzlpz",// ˿׼/
	//			"zf6_gfgc",// /
	//			"zf6_gfdh",// 
	//			"zf6_gkpz",// ˿׼/
	//			"zf6_qtpzrq1", // ׼/1
	//			"zf6_qtpzrq2" }; // ׼/2;
	private Map<int[], int[]> combineMap = new HashMap<int[], int[]>();// źϲԪ
	//	private TCProperty[] properties;
	// private List<List<Integer>> processRowList = new
	// ArrayList<List<Integer>>();
	private List<Integer> processRows = new ArrayList<Integer>();
	//	private List<String> meopNameList;
	private Map<Integer,List<String>> labelRows  = new HashMap<Integer,List<String>>();//ע
	private TCComponentUser user;// ǰ¼û
	private List<List<Object>> dataList = new ArrayList<List<Object>>();// е
	private List<String> plmeidList = new ArrayList<String>();// plmeid
	private List<String> meopId = new ArrayList<String>();// ID
	private List<List<String>> completeDataList = new ArrayList<List<String>>();// ɵԱ
	private String UID;
	boolean isRelease=false;
	private Map<String,String> meopNameToID  = new HashMap<String,String>();//ID
	private Map<String,String> MEOPIDToNO  = new HashMap<String,String>();//ID
	private List<String> meoplist = new ArrayList<String>();// ݿеĹID
	private List<String> HeadList = new ArrayList<String>();
	private boolean isReimport =false;
	public TMom004SetControlPlanCommand() {
		super();
	}

	public TMom004SetControlPlanCommand(AbstractAIFApplication app,InterfaceAIFComponent comp,
			TCSession session,String UID,boolean isReimport) {
		this.session = session;
		this.app = app;
		this.comp = comp;
		this.user = session.getUser();
		this.UID=UID;
		this.isReimport=isReimport;
		this.service = session.getTypeService();
	}



	/**
	 * ȡݿе
	 */
	private void getData() {
		// TODO Auto-generated method stub
		ResultSet rs = null;
		InputStream input = null;
		try {
			// ȡݿ
			SqlUtilT.getTCConnection();
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			String sql = String.format(pro.getProperty("CONTROLPLANSELECT"),
					meprocess.getItem().getUid(),comp.getUid());
			rs = SqlUtilT.read(sql);
			System.out.println("sql===>"+sql);

			int num=rs.getFetchSize()/75;
			int num1=1;
			int num2=0;
			while (rs.next()) {
				//++++
				if(num2==num*num1) {
					progressBar.setValue(num1+20);
					num1++;
				}
				num2++;
				//+++
				List<Object> rowList = new ArrayList<Object>();
				rowList.add(rs.getString("PLMEID"));//0
				rowList.add(rs.getString("LJGCBH"));//1
				rowList.add(rs.getString("GCMC"));//2
				rowList.add(rs.getString("JQZHJJGZ"));//3
				rowList.add(rs.getString("BH"));//4
				rowList.add(rs.getString("CP"));//5
				rowList.add(rs.getString("GC"));//6
				rowList.add(rs.getString("TSTXFL"));//7
				rowList.add(rs.getString("CPGC"));//8
				rowList.add(rs.getString("JSCLJS"));//9
				rowList.add(rs.getString("XM"));//10
				rowList.add(rs.getString("RL"));//11
				rowList.add(rs.getString("PL"));//12
				rowList.add(rs.getString("ZRR"));//13
				rowList.add(rs.getString("KZFF"));//14
				rowList.add(rs.getString("FYJH"));//15
				rowList.add(rs.getString("NO"));//16
				rowList.add(rs.getString("ZF6_HH"));//17
				rowList.add(rs.getString("ZF6_HBDYG"));//18
				rowList.add(rs.getString("ZF6_HHC"));//19
				System.out.println("ȡݣ===="+rowList);
				dataList.add(rowList);
			}
			
			
		
//			// е,ȡǰû޸ĵк
//			String userName = form.getReferenceProperty("owning_user")
//					.getStringProperty("user_id");

			
//			TCPreferenceService service = session.getPreferenceService();
//			String[] strs = service.getStringValues("Cust_ControlPlanLibrary_Privilege");  
//			List Privilegelist = Arrays.asList(strs);
			
			
			//Ƿ񷢲ждȨжȨ
			for (int i = 0; i < dataList.size(); i++) {
				// кŲ
				dataList.get(i).set(19,i- Integer.parseInt(dataList.get(i).get(17).toString()));
				if(user.getGroups()[0].getGroupName().equals("dba"))//Ȩû
				{
					isOwning = true;
					processRows.add(i);
					plmeidList.add(dataList.get(i).get(0).toString());
					continue;
				}
				else if (isRelease && !user.getGroups()[0].getGroupName().equals("dba")) 
				{
					continue;
				}
				else {
					isOwning = true;
					processRows.add(i);
					if(dataList.get(i)==null) {
						MessageBox.post("dataList.get("+"):"+dataList.get(i).toString(), "", MessageBox.ERROR);
					}
					if(dataList.get(i).get(0)==null) {
						MessageBox.post(dataList.get(i).toString(), "", MessageBox.ERROR);
					}
					plmeidList.add(dataList.get(i).get(0).toString());
					
				}
			}
			input.close();
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}

	}

	/**
	 * ȡݿбͷ
	 */
	private void getHeadData() {
		// TODO Auto-generated method stub
		ResultSet rs = null;
		InputStream input = null;
		try {
			// ȡݿ
			SqlUtilT.getTCConnection();
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			String sql = String.format(pro.getProperty("CONTROLPLANHEADSELECT"),
					comp.getUid());
			System.out.println("sqlhead=====>"+sql);
			
			rs = SqlUtilT.read(sql);
			if(!rs.next()) {//ʼͷ
				String PLMEID=UUID.randomUUID().toString().replace("-", "");
				HeadList.add(PLMEID);
				HeadList.add(itemRevision.getUid());
				HeadList.add("");//
				HeadList.add(itemRevision.getStringProperty("item_id"));//Ƽƻ
				for(int i=0;i<12;i++) {
					HeadList.add("");
				}
				String[] data=HeadList.toArray(new String[]{});
				System.out.println("data===>"+Arrays.toString(data));
				String insertSQL = "insert into ZF6_CONTROLPLANHEAD values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
				SqlUtilT.write2(data, insertSQL);
				SqlUtilT.connection.commit();
			}else {
					HeadList.add(rs.getString("PLMEID"));//0
					HeadList.add(rs.getString("PUID"));//1
					HeadList.add(rs.getString("type"));//2
					HeadList.add(rs.getString("kzjhbh"));//3
					HeadList.add(rs.getString("zylxr"));//4
					HeadList.add(rs.getString("bzriq"));//5
					HeadList.add(rs.getString("xdrq"));//6
					HeadList.add(rs.getString("ljbh"));//7
					HeadList.add(rs.getString("hxxz"));//8
					HeadList.add(rs.getString("gkgcpz"));//9
					HeadList.add(rs.getString("ljmc"));//10
					HeadList.add(rs.getString("gfpzrq"));//11
					HeadList.add(rs.getString("gkzlpz"));//12
					HeadList.add(rs.getString("zzdm"));//13
					HeadList.add(rs.getString("qtpz"));//14
					HeadList.add(rs.getString("qtpzrq"));//15
					System.out.println("head===>"+HeadList);
			}
			
			input.close();
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}

	}
	
	
	private void getItem() {
		try {
			// ȡѡжİ汾
			//			if (comp instanceof TCComponentItem) {
			//				MessageBox.post("ѡƼƻ汾", "", MessageBox.ERROR);
			//				
			//				//throw new Exception("δҵ");
			//			} else 
			System.out.println("getitem");
			if (itemRevision.getType().toUpperCase().equals("ZF6_KZJHREVISION")) {
				AIFComponentContext[] context = itemRevision.whereReferenced();
				
				for (int i = 0; i < context.length; i++) {
					if (context[i].getComponent().getType().equals("ZF6_GYLXRevision")) {
						
						meprocess = (TCComponentItemRevision) context[i].getComponent();
						System.out.println("--------------ҵն--------------------"+meprocess.getStringProperty("object_name"));
						break;
					}
				}
				item = itemRevision.getItem();
				//				form = itemRevision.getRelatedComponent("IMAN_master_form_rev");
			}else {
				MessageBox.post("ѡƼƻ汾", "", MessageBox.ERROR);
				return;
			}
		} catch (Exception e) {
			// TODO: handle exception
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
	}
	//ǷDOڵ
	public boolean isDoTask(String meopId,String userId) {
		try {
			TCComponentItemType itemType = (TCComponentItemType) this.session
					.getTypeComponent("Item");
			TCComponentItem meopItem = itemType.find(meopId);
			if(meopItem != null)
			{
				TCComponent[] items = meopItem
						.getRelatedComponents("process_stage_list");
				for (int i = 0; i < items.length; i++) {
					if (items[i].getType().indexOf("DoTask") >= 0) {
						TCComponentUser user = (TCComponentUser) items[i].getRelatedComponent("owning_user");
						if(user.getUserId().equals(userId))
						{
							return true;
						}
					}

				}
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}

		return false;
	}
	//Ƿڵ
	public boolean isReviewTask(String meopId,String userId) {
		try {
			TCComponentItemType itemType = (TCComponentItemType) this.session
					.getTypeComponent("Item");
			TCComponentItem meopItem = itemType.find(meopId);
			if(meopItem != null)
			{
				TCComponent[] items = meopItem
						.getRelatedComponents("process_stage_list");
				for (int i = 0; i < items.length; i++) {
					if (items[i].getType().indexOf("ReviewTask") >= 0) {
						TCComponentUser user = (TCComponentUser) items[i].getRelatedComponent("owning_user");
						if(user.getUserId().equals(userId))
						{
							return true;
						}
					}

				}
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}

		return false;
	}

	public void getCombineMap() {
		try {
			if (dataList != null && dataList.size() > 0) {
				for (int i = 0; i < dataList.size(); i++) {
					if (dataList.get(i).get(18) != null
							&& !dataList.get(i).get(18).equals("")) {
						String sombine = dataList.get(i).get(18).toString();
						int rowDif = Integer.parseInt(dataList.get(i).get(19)
								.toString());
						String[] sombines;
						if (sombine.indexOf("-") >= 0) {
							sombines = sombine.split("-");
						} else {
							sombines = new String[] { sombine };
						}
						for (int j = 0; j < sombines.length; j++) {
							if (sombines[j].indexOf("/") >= 0) {
								int[] row;
								int[] cloumn;
								String[] cells = sombines[j].split("/");
								if (cells[0].indexOf(",") >= 0) {
									String[] rows = cells[0].split(",");
									row = new int[rows.length];
									for (int k = 0; k < rows.length; k++) {
										row[k] = Integer.parseInt(rows[k])
												+ rowDif;
									}
								} else {
									row = new int[] { Integer
											.parseInt(cells[0]) + rowDif };
								}
								if (cells[1].indexOf(",") >= 0) {
									String[] cloumns = cells[1].split(",");
									cloumn = new int[cloumns.length];
									for (int k = 0; k < cloumns.length; k++) {
										cloumn[k] = Integer
												.parseInt(cloumns[k]);
									}
								} else {
									cloumn = new int[] { Integer
											.parseInt(cells[1]) };
								}
								this.combineMap.put(row, cloumn);
							}
						}
					}
				}
			}
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
	}

	/**
	 * ȡмĹ
	 * @param name ѡ
	 * @return ûмĹ
	 */
	private List<String> getMeopNames(String name) {
		// TODO Auto-generated method stub
		String[] values = null;
		if(name != null)
		{
			TCPreferenceService service = this.session.getPreferenceService();
			String[] props = service.getStringArray(TCPreferenceService.TC_preference_site, name);
			if(props != null || props.length>0)
			{
				values = new String[props.length];
				for (int i = 0; i < props.length; i++) {
					if(props[i].indexOf("/") >= 0)
					{
						values[i] = props[i].split("/")[0];
					}
					else
					{
						values[i] = props[i];
					}
				}
			}
		}
		else
		{
			MessageBox.post("δѡ", "", MessageBox.ERROR);
		}
		return Arrays.asList(values);
	}

	
	@Override
	public void executeModal() throws Exception {
		System.out.println("򿪿Ƽƻ");
		//+++++++жǷ񷢲
		isRelease = comp.getProperty(
				"release_status_list") != "";
		//++++ûisReleaseΪfalseͿǷдȨ
		if(!isRelease) {
			try {
				TCComponentUser user = session.getUser();
				TCComponentGroup group = session.getCurrentGroup();
				TCComponentRole role = session.getCurrentRole();

				TCComponent coms[] = { user, group, role };
				TCAccessControlService service = session
						.getTCAccessControlService();
				boolean[] flags = service.checkAccessorsPrivileges(coms, (TCComponent) app.getTargetComponent(),
						new String[] { "WRITE" });
				for (boolean b : flags) {
					if (!b) {
						//ûдȨ޾isReleaseΪtrueͲ༭
						//MessageBox.post("ûдȨ", "", MessageBox.ERROR);
						isRelease = true;
						break;
					}
				}
			} catch (TCException e) {
				e.printStackTrace();
			}
		}
		if(!isRelease) {
			//жǷǩ
			if(((TCComponent) comp).isCheckedOut()) {
				MessageBox.post("Ƽƻڱ༭(ǩ)", "", MessageBox.ERROR);
				return;
			}
			//ûǩڴʱǩ
			new ReserveOperation(new AIFComponentContext(comp,
					comp, "context")).executeModeless();
		}
		if (comp instanceof TCComponentItemRevision) {
			itemRevision = (TCComponentItemRevision) comp;
		}
		System.out.println("======1");
		//+++
		getItem();

		//+++ӽ
		frame.setSize(300, 70);
		frame.setLocationRelativeTo(null);
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setLayout(new BorderLayout());
		progressBar.setOrientation(JProgressBar.HORIZONTAL);
		progressBar.setSize(300, 50);
		progressBar.setMinimum(0);
		progressBar.setMaximum(100);
		progressBar.setBorderPainted(true);
		progressBar.setUI(new MetalProgressBarUI());
		progressBar.setBackground(Color.white);
		progressBar.setForeground(Color.green);
		progressBar.setStringPainted(true);
		frame.setAlwaysOnTop(true);
		frame.add(progressBar);
		frame.setVisible(true);
		progressBar.setValue(1);
		//+++

		//		meopNameList = getMeopNames("ZF6_CONCEAL_MEOP_NAME");
		//		//ûİ汾Ҫͬbom
		//		if(comp.getProperty("release_status_list")==null||comp.getProperty("release_status_list").equals("")) {
		//			CollectControlPlan collectControlPlan = new CollectControlPlan(session, item.getType().toUpperCase(), meprocess);
		//			SaveControlPlan saveControlPlan = new SaveControlPlan(session, meprocess,comp);
		//			saveControlPlan.insertData();
		//		}

		
		//++++汾İ汾ǡ00ͻȡ汾ݸ޶İ汾
		// ȡݿ
		ResultSet rs0 = null;
		ResultSet rs = null;
		InputStream input = null;
		SqlUtilT.getTCConnection();
		input = new BufferedInputStream(getClass().getResourceAsStream(
				"/sql.properties"));
		System.out.println("ȡݿļ=====>"+input);
		Properties pro = new Properties();
		pro.load(input);

		String revisionID=itemRevision.getProperty("item_revision_id");
		TCComponent[] Revisions=itemRevision.getItem().getReferenceListProperty("revision_list");

		//鿴ѡĿǷǵһδ򿪣޶İ汾Ͱ°汾ݸƸ
		System.out.println("CONTROLPLANSELECT"+pro.getProperty("CONTROLPLANSELECT"));
//		System.out.println("meprocess.getUid():"+meprocess.getUid());
//		System.out.println("itemRevision.getUid():"+itemRevision.getUid());
		String sql0 = String.format(pro.getProperty("CONTROLPLANSELECT"),
				meprocess.getItem().getUid(),comp.getUid());
		System.out.println("sql0:"+sql0);
		rs0 = SqlUtilT.read(sql0);
		System.out.println("revisionID====>"+revisionID);
		System.out.println("Revisions====>"+Revisions);
		if(!revisionID.equals("A")&&!rs0.next()) {
			System.out.println("ǵһ汾");
			List<List<String>> addData=new ArrayList<List<String>>();
			
			char revID=revisionID.toCharArray()[0];
			String lastRevID=Character.toString(--revID);
			String lastRevUid="";
			for(TCComponent rev:Revisions) {
				if(rev.getProperty("item_revision_id").equals(lastRevID)) {
					lastRevUid=rev.getUid();
					break;
				}
			}
			
			System.out.println("lastRevID========>"+lastRevID);
			System.out.println("lastRevUid========>"+lastRevUid);
			try {
				String sql = String.format(pro.getProperty("CONTROLPLANSELECT"),
						meprocess.getItem().getUid(),lastRevUid);
				SqlUtilT.getTCConnection();
				rs = SqlUtilT.read(sql);
				System.out.println("ϸ汾===>"+sql);
				while (rs.next()) {
					System.out.println("===ѯϸ汾ݲ===");
					List<String> dataList=new ArrayList<String>();
					dataList.add(UUID.randomUUID().toString().replace("-", ""));
					dataList.add(rs.getString("PROCESSPUID"));
					dataList.add(rs.getString("PROCESSID"));
					dataList.add(comp.getUid());
					dataList.add(rs.getString("LJGCBH"));
					dataList.add(rs.getString("GCMC"));
					dataList.add(rs.getString("JQZHJJGZ"));
					dataList.add(rs.getString("BH"));//5
					dataList.add(rs.getString("CP"));
					dataList.add(rs.getString("GC"));
					dataList.add(rs.getString("TSTXFL"));
					dataList.add(rs.getString("CPGC"));
					dataList.add(rs.getString("JSCLJS"));//10
					dataList.add(rs.getString("XM"));
					dataList.add(rs.getString("RL"));
					dataList.add(rs.getString("PL"));
					dataList.add(rs.getString("ZRR"));
					dataList.add(rs.getString("KZFF"));//15
					dataList.add(rs.getString("FYJH"));//ұ
					dataList.add(rs.getString("NO"));//uid
					dataList.add(rs.getString("ZF6_HH"));//uid
					dataList.add(rs.getString("ZF6_HBDYG"));//uid
					dataList.add(rs.getString("ZF6_HHC"));//uid
					
					
					addData.add(dataList);
				}
			
			
			System.out.println("°汾ݣ"+addData);
			for(int i=0;i<addData.size();i++) {
				List<String> dataList=new ArrayList<String>();
				dataList=addData.get(i);
				String[] data=dataList.toArray(new String[]{});
				String insertSQL = pro.getProperty("INSERTSQL");
				SqlUtilT.getTCConnection();
				SqlUtilT.write2(data, insertSQL);
				
			}
			SqlUtilT.connection.commit();
			
			System.out.println("°汾ͷ");
			String sql1 = String.format(pro.getProperty("CONTROLPLANHEADSELECT"),
					lastRevUid);
			ResultSet rs2= SqlUtilT.read(sql1);
			System.out.println("°汾ʱѯϸͷsql======>"+sql1);
			if(rs2.next()) {//ʼͷ
				List<String> newHeadList = new ArrayList<String>();
				String PLMEID=UUID.randomUUID().toString().replace("-", "");
				newHeadList.add(PLMEID);
				newHeadList.add(comp.getUid());
				newHeadList.add(rs2.getString("type"));//
				newHeadList.add(rs2.getString("kzjhbh"));
				newHeadList.add(rs2.getString("zylxr"));
				newHeadList.add(rs2.getString("bzriq"));
				newHeadList.add(rs2.getString("xdrq"));
				newHeadList.add(rs2.getString("ljbh"));
				newHeadList.add(rs2.getString("hxxz"));
				newHeadList.add(rs2.getString("gkgcpz"));
				newHeadList.add(rs2.getString("ljmc"));
				newHeadList.add(rs2.getString("gfpzrq"));
				newHeadList.add(rs2.getString("gkzlpz"));
				newHeadList.add(rs2.getString("zzdm"));
				newHeadList.add(rs2.getString("qtpz"));
				newHeadList.add(rs2.getString("qtpzrq"));
				System.out.println("°汾ʱѯϸͷ======>"+newHeadList);
				String[] data=newHeadList.toArray(new String[]{});
				//System.out.println("data===>"+Arrays.toString(data));
				String insertSQL = "insert into ZF6_CONTROLPLANHEAD values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
				SqlUtilT.write2(data, insertSQL);
				SqlUtilT.connection.commit();
			}
			}catch (Exception e) {
				MessageBox.post(e.toString(), "", MessageBox.ERROR);
				e.printStackTrace();
			}finally {
				if (rs != null) {
					SqlUtilT.free(rs);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
			}
		}
		
		//µҪͬbom
		if(isReimport) {
			System.out.println("========µ=======");
			SqlUtilT.getTCConnection();
			ResultSet rsData = null;
			String sql13 = String.format(pro.getProperty("CONTROLPLAN_IDTONO"), comp.getUid());
			rsData = SqlUtilT.read(sql13);
			while (rsData.next()) {
				MEOPIDToNO.put(rsData.getString("PROCESSID"), rsData.getString("NO"));
				meoplist.add(rsData.getString("PROCESSID"));
				
			}
			SqlUtilT.free(rsData);
			
			TCComponentBOMWindowType winType = (TCComponentBOMWindowType) service.getTypeComponent("BOMWindow");
			TCComponentBOMWindow view = winType.create(null);
			TCComponentBOMLine line = view.setWindowTopLine(meprocess.getItem(), meprocess, null, null);
			AIFComponentContext[] childs = line.getChildren();
			Map<String, String> meopIDtoNO=new HashMap<String, String>();
			Map<String, String> meopIDtoName=new HashMap<String, String>();
			List<String> meops=new ArrayList<String>();
			for (int i = 0; i < childs.length; i++) {
				InterfaceAIFComponent comp = childs[i].getComponent();
				if(comp instanceof TCComponentBOMLine) {
					TCComponentBOMLine ziLine = (TCComponentBOMLine) comp;
					TCComponentItemRevision ziRev = ziLine.getItemRevision();//
					String id = ziRev.getStringProperty("item_id");//id
					String name = ziRev.getStringProperty("object_name")+ziRev.getStringProperty("zf6_ywfy");//
					String NO = ziLine.getStringProperty("bl_sequence_no");
					meopIDtoNO.put(id, NO);
					meopIDtoName.put(id, name);
					meops.add(id);
				}
			}
			
			//ɾ
			for(int i=0;i<meoplist.size();i++) {
				if(!meops.contains(meoplist.get(i))) {
					// ȡݿ
					String deleteSQL = String.format("delete from ZF6_CONTROLPLAN where PROCESSPUID = '%s' AND PROCESSID='%s' AND PUID='%s'",
							meprocess.getItem().getUid(),meoplist.get(i),comp.getUid());
					SqlUtilT.getTCConnection();
					SqlUtilT.delete(deleteSQL);
				}
			}
			
			//ºͲ
			for(int i=0;i<meops.size();i++) {
				if(meoplist.contains(meops.get(i))) {
					//²ұ
					if(MEOPIDToNO.get(meops.get(i))!=meopIDtoNO.get(meops.get(i))) {
						String updateSQL = String.format("update ZF6_CONTROLPLAN set NO = ? where PROCESSPUID = '%s' AND PROCESSID='%s' AND PUID='%s'"
								, meprocess.getItem().getUid(),meops.get(i),comp.getUid());
						SqlUtilT.getTCConnection();
						SqlUtilT.update(new String[] {meopIDtoNO.get(meops.get(i))},
								updateSQL);
					}
					
				}else {
					String insertSQL ="insert into ZF6_CONTROLPLAN values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
					SqlUtilT.getTCConnection();
					SqlUtilT.write2(new String[] { UUID.randomUUID().toString().replace("-", ""), meprocess.getItem().getUid(), meops.get(i),UID,
							"", meopIDtoName.get(meops.get(i)), "","1","","","","","","","","","","","",meopIDtoNO.get(meops.get(i)),
							"0","",""}, insertSQL);//кŲ0
				}
			}
			SqlUtilT.connection.commit();
			SqlUtilT.freeAll();
			
		}
		
		
		
		
		getData();
		if(dataList.size()==0){
			List<List<String>> addData=new ArrayList<List<String>>();
			System.out.println("=====ʼ==========");
			TCComponentBOMWindowType winType = (TCComponentBOMWindowType) service.getTypeComponent("BOMWindow");
			TCComponentBOMWindow view = winType.create(null);
			TCComponentBOMLine line = view.setWindowTopLine(meprocess.getItem(), meprocess, null, null);
			AIFComponentContext[] childs = line.getChildren();
			for (int i = 0; i < childs.length; i++) {
				List<String> dataList=new ArrayList<String>();
				InterfaceAIFComponent comp = childs[i].getComponent();
				if(comp instanceof TCComponentBOMLine) {
					TCComponentBOMLine ziLine = (TCComponentBOMLine) comp;
					TCComponentItemRevision ziRev = ziLine.getItemRevision();//
					String id = ziRev.getStringProperty("item_id");//id
					String name = ziRev.getStringProperty("object_name")+ziRev.getStringProperty("zf6_ywfy");
					meopNameToID.put(name, id);
					dataList.add(UUID.randomUUID().toString().replace("-", ""));//0plmeid
					dataList.add(meprocess.getItem().getUid());//1uid
					dataList.add(id);//2ID
//					dataList.add(id);
//					dataList.add(name);
					dataList.add(itemRevision.getUid());//3
					dataList.add("");//4
					dataList.add(name);//5
					dataList.add("");//6
					dataList.add("1");//7
					dataList.add("");//8
					dataList.add("");//9
					dataList.add("");//10
					dataList.add("");//11
					dataList.add("");//12
					dataList.add("");//13
					dataList.add("");//14
					dataList.add("");//15
					dataList.add("");//16
					dataList.add("");//17
					dataList.add("");//18
					dataList.add(ziLine.getStringProperty("bl_sequence_no"));//19ұ
					dataList.add(String.valueOf(i));//20
					dataList.add("");//21
					dataList.add("");//22
					//dataList.add(itemRevision.getUid());//ѡĶpuidݿREVISIONID
					
					addData.add(dataList);
				}
			}
			System.out.println("addDataaddData====>"+addData);
			
			for(int i=0;i<addData.size();i++) {
				
				List<String> dataList=new ArrayList<String>();
				dataList=addData.get(i);
				String[] data=dataList.toArray(new String[]{});
				String insertSQL = pro.getProperty("INSERTSQL");
				System.out.println(""+i+"ݣ"+insertSQL);
				SqlUtilT.getTCConnection();
				SqlUtilT.write2(data, insertSQL);
				SqlUtilT.connection.commit();
			}
			
			getData();
		}
		progressBar.setValue(15);
		//++++++++


		//ûİ汾Ҫͬbom
		//		if(!isRelease) {
		//			CollectControlPlan collectControlPlan = new CollectControlPlan(session, item.getType().toUpperCase(), meprocess);
		//			SaveControlPlan saveControlPlan = new SaveControlPlan(session, meprocess,comp);
		//			saveControlPlan.insertData();
		//		}
		//		progressBar.setValue(20);

//		getData();
		getHeadData();
		getCombineMap();
		//		getControlPlanCompleteUser();
		//ӡcombineMapϲ
//		for (int[] name : combineMap.keySet()) {
//			String key = Arrays.toString(name);
//			String value =  Arrays.toString(combineMap.get(name));
//			System.out.println("===>"+key + " " + value);
//		}
		//		if (properties == null) {
		//			return;
		//		}
		//properties[0].getPropertyValue()
		//жǷ
//		if(processRows.size() > 0 && dataList.get(processRows.get(0)).get(16).toString().equals("1"))
//		{
//			meopIsComplete = true;
//		}
		progressBar.setValue(100);
//		
		
		System.out.println("dataList++++>"+dataList);
		System.out.println("HeadList++++>"+HeadList);
		new Thread() {
			@Override
			public void run() {
				try {
					System.out.println("=====򿪴======");
					TMom004SetControlPlanDialog dislog = new TMom004SetControlPlanDialog(
							app, session, processRows,labelRows, item,itemRevision, meprocess.getItem(), 
							combineMap, dataList,meopId,plmeidList,HeadList, isOwning,UID,meopNameToID,comp);
					frame.dispose();
				} catch (Exception e2) {
					// TODO: handle exception
				}

			}
		}.start();
		super.executeModal();

	}

}
