package com.connor.zf.controlplan;


import java.awt.image.BufferedImage;
import java.io.*;
import java.util.*;

import javax.imageio.ImageIO;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.ClientAnchor;
import org.apache.poi.ss.usermodel.Drawing;
import org.apache.poi.ss.usermodel.Picture;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFClientAnchor;
import org.apache.poi.xssf.usermodel.XSSFDrawing;
import org.apache.poi.xssf.usermodel.XSSFPicture;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFShape;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
public class outPutExcel {
	
	
	private static Map<int[], int[]> excelCombineMap = new HashMap<int[], int[]>();// źϲԪ
	/**
	 * ƼƻEXCEL
	 * 
	 * @param controlPlanBean ƼƻϢ
	 * @param input           ģļ
	 * @param outputFilePath  Ҫȫ·
	 * @throws IOException
	 */
	public static int writeControlPlanToExcel(TCSession session,List<List<String>> tableValues, List<String> headValue,File file,String outPutPath) throws IOException {
		file.setWritable(true);
		InputStream input = new FileInputStream(file);
		XSSFWorkbook wb = new XSSFWorkbook(input);
		XSSFSheet sheet = wb.getSheetAt(0);
		excelCombineMap.clear();
		//ȡԵͼƬ
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringValues("ZF6_KZJH_TSTX"); 
		Map<String, String> NameToPicpath=new HashMap<String, String>();
		for(String str:strs) {
			System.out.println("NameToPicpath==="+str.split(":")[0]+"==="+getPic(session, str.split(":")[1]));
			NameToPicpath.put(str.split(":")[0], getPic(session, str.split(":")[1]));
		}
		
		
		XSSFRow row1 = sheet.getRow(1);
		if(row1==null) {
			row1=sheet.createRow(1);
		}
		setCellValue(row1, 7, "Ҫϵ/绰Key Contact:"+headValue.get(2));
		setCellValue(row1, 14, headValue.get(3).toString());
		
		XSSFRow row2 = sheet.getRow(2);
		if(row2==null) {
			row2=sheet.createRow(2);
		}
		setCellValue(row2, 5, headValue.get(1).toString());
		setCellValue(row2, 8, headValue.get(6).toString());
		setCellValue(row2, 14, headValue.get(4).toString());
		
		XSSFRow row3 = sheet.getRow(4);
		if(row3==null) {
			row3=sheet.createRow(4);
		}
		setCellValue(row3, 0, headValue.get(5).toString());
		setCellValue(row3, 12, headValue.get(7).toString());
		
		XSSFRow row4 = sheet.getRow(6);
		if(row4==null) {
			row4=sheet.createRow(6);
		}
		setCellValue(row4, 0, headValue.get(8).toString());
		setCellValue(row4, 7, headValue.get(9).toString());
		setCellValue(row4, 12, headValue.get(10).toString());
		
		XSSFRow row5 = sheet.getRow(8);
		if(row5==null) {
			row5=sheet.createRow(8);
		}
		setCellValue(row5, 5, headValue.get(11).toString());
		setCellValue(row5, 7, headValue.get(12).toString());
		setCellValue(row5, 12, headValue.get(13).toString());
		
		int startRow=12;
		short h1=  sheet.getRow(startRow).getHeight();
		if(tableValues.size()>34) {
			sheet.shiftRows(46,sheet.getLastRowNum(), tableValues.size()-34 );
		}
		
		for(int n=0;n<tableValues.size();n++) {
			List<String> dataValeList=tableValues.get(n);
			//for (int i = 0; i < dataValeList.size(); i++) {
				XSSFRow row = null;
				Boolean isCreat = false;
				row = sheet.getRow(n + startRow);
				if(n>=34) {
					//sheet.shiftRows(n + startRow,sheet.getLastRowNum(), 1 );
					//row = sheet.getRow(n + startRow);
					//row = sheet.createRow(n+ startRow);
					row = sheet.createRow(n + startRow);
					row.setHeight(h1);
					combine2(sheet, new int[] {n+startRow}, new int[] {0,1});
					combine2(sheet, new int[] {n+startRow}, new int[] {3,4});
					isCreat = true;
				}
				if (isCreat) {
					XSSFRow oldRow = sheet.getRow( startRow);
					
					if(oldRow==null) {
						oldRow = sheet.createRow(startRow);
					}
					for (int j = 0; j < 17; j++) {
						XSSFCell oldCell = oldRow.getCell(j);
						if(oldCell==null) {
							oldCell=oldRow.createCell(j);
						}
						XSSFCell newCell = row.createCell(j);
						newCell.setCellStyle(oldCell.getCellStyle());
						newCell.setCellType(oldCell.getCellType());
					}
				}
				
			//}
			//ѭ
			for(int j=0;j<17;j++) {
				XSSFCell cell = row.getCell(j);
				if(cell==null) {
					cell=row.createCell(j);
				}
				if(j>1) {
					if(j>4) {
						if(j==8) {//ԲͼƬ
							if(NameToPicpath.containsKey((String)dataValeList.get(j-2))) {
								System.out.println((String)dataValeList.get(j-2)+"ȡ·Ϊ"+NameToPicpath.get((String)dataValeList.get(j-2)));
								insertPicture(sheet, wb, n + startRow, 8, NameToPicpath.get((String)dataValeList.get(j-2)));
							}
						}else {
							cell.setCellValue((String)dataValeList.get(j-2));
						}
						
					}else if(j<4) {
						
						cell.setCellValue((String)dataValeList.get(j-1));
					}
				}else if(j==0) {
					cell.setCellValue((String)dataValeList.get(j));
				}
			}
		}
		
		//+++++++++++++
		
		
		
		//ȡϲԪϢ
		for(int i=0;i<tableValues.size();i++) {
			List<String> rowList = tableValues.get(i);
			if (rowList.get(15) != null && !rowList.get(15).equals("")) {
				String sombine = rowList.get(15);
				int rowDif = 0;
				String[] sombines;
				if (sombine.indexOf("-") >= 0) {
					sombines = sombine.split("-");
				} else {
					sombines = new String[] { sombine };
				}
				for (int j = 0; j < sombines.length; j++) {
					if (sombines[j].indexOf("/") >= 0) {
						int[] row;
						int[] cloumn;
						String[] cells = sombines[j].split("/");
						if (cells[0].indexOf(",") >= 0) {
							String[] rows = cells[0].split(",");
							row = new int[rows.length];
							for (int k = 0; k < rows.length; k++) {
								row[k] = Integer.parseInt(rows[k]) + rowDif;
							}
						} else {
							row = new int[] { Integer.parseInt(cells[0]) + rowDif };
						}
						if (cells[1].indexOf(",") >= 0) {
							String[] cloumns = cells[1].split(",");
							cloumn = new int[cloumns.length];
							for (int k = 0; k < cloumns.length; k++) {
								cloumn[k] = Integer.parseInt(cloumns[k]);
							}
						} else {
							cloumn = new int[] { Integer.parseInt(cells[1]) };
						}
						System.out.println("ӺϲϢ===>:"+Arrays.toString(row)+"----У"+Arrays.toString(cloumn));
						excelCombineMap.put(row, cloumn);
					}
				}
			}
			
		}
		System.out.println("ϲϢ==="+excelCombineMap.toString());
		
		
		if (excelCombineMap != null && excelCombineMap.size() != 0) {
			Iterator<Map.Entry<int[], int[]>> it = excelCombineMap.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry<int[], int[]> entry = it.next();
				List<Integer> columnIndex = new ArrayList<Integer>();
				for (int i = 0; i < entry.getValue().length; i++) {
						columnIndex.add(entry.getValue()[i]);
				}
				int[] column = new int[columnIndex.size()];
				for (int i = 0; i < columnIndex.size(); i++) {
					column[i] = columnIndex.get(i);
				}
				if (column.length > 0) {
					combine(sheet, entry.getKey(), column);
				}
			}
		}
		//combine(sheet, new int[] {12,13,14}, new int[] {6,7});
		//+++++++++++++++++++
		FileOutputStream output = new FileOutputStream(new File(outPutPath));
		wb.write(output);
		output.close();
		input.close();
		// file.setReadOnly();
		//
		System.out.println("-------WRITE EXCEL OVER-------");
		return 0;
	}
	
	/**
	 * տEXCEL,
	 * 
	 * @param controlPlanBean ƼƻϢ
	 * @param input           ģļ
	 * @param outputFilePath  Ҫȫ·
	 * @throws IOException
	 */
	public static int writeGYKToExcel(TCSession session,List<List<String>> productTableValue, List<List<String>> processTableValue,
			List<String> headValue,File file,String outPutPath,String ID,String revID,String type) throws IOException {
		file.setWritable(true);
		InputStream input = new FileInputStream(file);
		XSSFWorkbook wb = new XSSFWorkbook(input);
		XSSFSheet sheet = wb.getSheetAt(0);
		
		
		//ȡԵͼƬ
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringValues("ZF6_KZJH_TSTX"); 
		Map<String, String> NameToPicpath=new HashMap<String, String>();
		for(String str:strs) {
			System.out.println("NameToPicpath==="+str.split(":")[0]+"==="+getPic(session, str.split(":")[1]));
			NameToPicpath.put(str.split(":")[0], getPic(session, str.split(":")[1]));
		}
		
		
		//ݹտͷ
		XSSFRow row1 = sheet.getRow(0);
		setCellValue(row1, 20, ID);//
		XSSFRow row2 = sheet.getRow(1);
		setCellValue(row2, 20, revID);//
		XSSFRow row3 = sheet.getRow(4);
		setCellValue(row3, 3, headValue.get(3).toString());//Ʒͺ
		setCellValue(row3, 7, headValue.get(11).toString());//
		setCellValue(row3, 9, headValue.get(4).toString());//
		if(type.indexOf("ӹ")>=0) {
			setCellValue(row3, 13, headValue.get(7).toString());//豸ͺ
			setCellValue(row3, 17, headValue.get(10).toString());//ߵƬͺ
		}else if(type.indexOf("")>=0) {
			setCellValue(row3, 13, headValue.get(7).toString());//豸ͺ
			setCellValue(row3, 17, headValue.get(10).toString());//ߵƬͺ
		}else if(type.indexOf("ĥӹ")>=0) {
			setCellValue(row3, 13, headValue.get(7).toString());//豸ͺ
			setCellValue(row3, 17, headValue.get(5).toString());//ɰʯ
			setCellValue(row3, 21, headValue.get(6).toString());//ɰʯ
		}else if(type.indexOf("")>=0) {
			setCellValue(row3, 13, headValue.get(7).toString());//豸ͺ
			setCellValue(row3, 17, headValue.get(10).toString());//ߵƬͺ
		}else if(type.indexOf("ȴ")>=0) {
			setCellValue(row3, 13, headValue.get(8).toString());//豸ͺ
			setCellValue(row3, 19, headValue.get(9).toString());//ߵƬͺ
		}
		
	
		
		//
		int startRow1=33;
		int startRow2=36;
		XSSFRow oldRow1 = sheet.getRow( startRow1);
		XSSFRow oldRow2 = sheet.getRow( startRow2);
		short h1=  oldRow1.getHeight();
		short h2=  oldRow2.getHeight();
		//һ
		if(productTableValue.size()>1) {
			sheet.shiftRows(startRow1+1,sheet.getLastRowNum(), productTableValue.size()-1 );
			
		}
		 
		for(int i=1;i<productTableValue.size();i++) {//һв½
			XSSFRow row = sheet.createRow(i+ startRow1);
			row.setHeight(h1);
			//ƵԪʽ
			for (int j = 0; j < 24; j++) {
				XSSFCell oldCell = oldRow1.getCell(j);
//				if(oldCell==null) {
//					oldCell=oldRow1.createCell(j);
//				}
				XSSFCell newCell = row.createCell(j);
				newCell.setCellStyle(oldCell.getCellStyle());
				newCell.setCellType(oldCell.getCellType());
			}
			//ϲԪ
			combine2(sheet, new int[] {i+startRow1}, new int[] {2,3,4,5});
			combine2(sheet, new int[] {i+startRow1}, new int[] {7,8,9,10});
			combine2(sheet, new int[] {i+startRow1}, new int[] {11,12,13,14,15});
			combine2(sheet, new int[] {i+startRow1}, new int[] {17,18});
			combine2(sheet, new int[] {i+startRow1}, new int[] {20,21});
			combine2(sheet, new int[] {i+startRow1}, new int[] {22,23});
		}
		//һбкϲ
		combine2(sheet, new int[] {startRow1,startRow1+productTableValue.size()-1}, new int[] {0});
		
		//ڶ
		startRow2=startRow2+productTableValue.size()-1;
		if(processTableValue.size()>1) {
			 sheet.shiftRows(startRow2+1,sheet.getLastRowNum(), processTableValue.size()-1 );
		}
		
//		XSSFRow rowh2 = sheet.createRow(startRow2);
//		rowh2.setHeight(h2);
		for(int i=1;i<processTableValue.size();i++) {//һв½
			XSSFRow row = sheet.createRow(i+ startRow2);
			row.setHeight(h2);
			//ƵԪʽ
			for (int j = 0; j < 24; j++) {
				XSSFCell oldCell = oldRow2.getCell(j);
//				if(oldCell==null) {
//					oldCell=oldRow1.createCell(j);
//				}
				XSSFCell newCell = row.createCell(j);
				newCell.setCellStyle(oldCell.getCellStyle());
				newCell.setCellType(oldCell.getCellType());
			}
			//ϲԪ
			combine2(sheet, new int[] {i+startRow2}, new int[] {2,3,4,5});
			combine2(sheet, new int[] {i+startRow2}, new int[] {7,8,9,10});
			combine2(sheet, new int[] {i+startRow2}, new int[] {11,12,13,14,15,16,17});
			combine2(sheet, new int[] {i+startRow2}, new int[] {18,19});
			combine2(sheet, new int[] {i+startRow2}, new int[] {20,21});
			combine2(sheet, new int[] {i+startRow2}, new int[] {22,23});
		}
		//һбкϲ
		combine2(sheet, new int[] {startRow2,startRow2+processTableValue.size()-1}, new int[] {0});
		
		
		//product
		for(int i=0;i<productTableValue.size();i++) {
			List<String> value=productTableValue.get(i);
			XSSFRow row = sheet.getRow(i+ startRow1);
			row.getCell(1).setCellValue((value.get(1)==null||value.get(1).equals(""))?" ":value.get(1).toString());
			row.getCell(2).setCellValue((value.get(2)==null||value.get(2).equals(""))?" ":value.get(2).toString());
			//ͼƬ
			insertPicture(sheet, wb, i+ startRow1, 6, NameToPicpath.get((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString()));
			//row.getCell(6).setCellValue((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString());
			row.getCell(7).setCellValue((value.get(4)==null||value.get(4).equals(""))?" ":value.get(4).toString());
			row.getCell(11).setCellValue((value.get(5)==null||value.get(5).equals(""))?" ":value.get(5).toString());
			row.getCell(16).setCellValue((value.get(6)==null||value.get(6).equals(""))?" ":value.get(6).toString());
			row.getCell(17).setCellValue((value.get(7)==null||value.get(7).equals(""))?" ":value.get(7).toString());
			row.getCell(19).setCellValue((value.get(8)==null||value.get(8).equals(""))?" ":value.get(8).toString());
			row.getCell(20).setCellValue((value.get(9)==null||value.get(9).equals(""))?" ":value.get(9).toString());
			row.getCell(22).setCellValue((value.get(10)==null||value.get(10).equals(""))?" ":value.get(10).toString());
		}
		//process
		for(int i=0;i<processTableValue.size();i++) {
			List<String> value=processTableValue.get(i);
			System.out.println("value====>"+value);
			XSSFRow row = sheet.getRow(i+ startRow2);
			row.getCell(1).setCellValue((value.get(1)==null||value.get(1).equals(""))?" ":value.get(1).toString());
			row.getCell(2).setCellValue((value.get(2)==null||value.get(2).equals(""))?" ":value.get(2).toString());
			//ͼƬ
			//ͼƬ
			insertPicture(sheet, wb, i+ startRow2, 6, NameToPicpath.get((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString()));
			//row.getCell(6).setCellValue((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString());
			row.getCell(7).setCellValue((value.get(4)==null||value.get(4).equals(""))?" ":value.get(4).toString());
			row.getCell(11).setCellValue((value.get(5)==null||value.get(5).equals(""))?" ":value.get(5).toString());
			row.getCell(18).setCellValue((value.get(6)==null||value.get(6).equals(""))?" ":value.get(6).toString());
			row.getCell(20).setCellValue((value.get(7)==null||value.get(7).equals(""))?" ":value.get(7).toString());
			row.getCell(22).setCellValue((value.get(8)==null||value.get(8).equals(""))?" ":value.get(8).toString());
		}
		
		
		
		
		FileOutputStream output = new FileOutputStream(new File(outPutPath));
		wb.write(output);
		output.close();
		input.close();
		// file.setReadOnly();
		System.out.println("-------WRITE EXCEL OVER-------");
		return 0;
	}
	
	
	
	/**
	 * װ乤տEXCELУ
	 * 
	 * @param controlPlanBean ƼƻϢ
	 * @param input           ģļ
	 * @param outputFilePath  Ҫȫ·
	 * @throws IOException
	 */
	public static int writeZPGYKToExcel(TCSession session,List<List<String>> productTableValue, List<List<String>> processTableValue,
			List<String> headValue,File file,String outPutPath,String ID,String revID) throws IOException {
		file.setWritable(true);
		InputStream input = new FileInputStream(file);
		XSSFWorkbook wb = new XSSFWorkbook(input);
		XSSFSheet sheet = wb.getSheetAt(0);
		
		
		//ȡԵͼƬ
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringValues("ZF6_KZJH_TSTX"); 
		Map<String, String> NameToPicpath=new HashMap<String, String>();
		for(String str:strs) {
			System.out.println("NameToPicpath==="+str.split(":")[0]+"==="+getPic(session, str.split(":")[1]));
			NameToPicpath.put(str.split(":")[0], getPic(session, str.split(":")[1]));
		}
		
		
		//ͷ
		XSSFRow row1 = sheet.getRow(1);
		setCellValue(row1, 30, ID);
		setCellValue(row1, 34, revID);
		setCellValue(row1, 16, headValue.get(3).toString());
		setCellValue(row1, 20, headValue.get(4).toString());
		setCellValue(row1, 24, headValue.get(7).toString());
	
		
		//
		int startRow1=23;
		int startRow2=22;
		XSSFRow oldRow1 = sheet.getRow( startRow1);
		//XSSFRow oldRow2 = sheet.getRow( startRow2);
		short h1=  oldRow1.getHeight();
		//short h2=  oldRow2.getHeight();
		//һ
		int addrows=0;
		if(productTableValue.size()>=11||processTableValue.size()>=12) {
			if(productTableValue.size()>=(processTableValue.size()-1)) {
				addrows=productTableValue.size()-11;
			}else {
				addrows=processTableValue.size()-12;
			}
			sheet.shiftRows(startRow1+1,sheet.getLastRowNum(), addrows );
			
		}
		 
		for(int i=1;i<=addrows;i++) {//һв½
			XSSFRow row = sheet.createRow(i+ startRow1);
			row.setHeight(h1);
			//ƵԪʽ
			for (int j = 0; j < 35; j++) {
				XSSFCell oldCell = oldRow1.getCell(j);
//				if(oldCell==null) {
//					oldCell=oldRow1.createCell(j);
//				}
				XSSFCell newCell = row.createCell(j);
				newCell.setCellStyle(oldCell.getCellStyle());
				newCell.setCellType(oldCell.getCellType());
			}
			//ϲԪ
			combine2(sheet, new int[] {i+startRow1}, new int[] {1,2});
			combine2(sheet, new int[] {i+startRow1}, new int[] {4,5,6});
			combine2(sheet, new int[] {i+startRow1}, new int[] {7,8,9,10});
			combine2(sheet, new int[] {i+startRow1}, new int[] {12,13});
			combine2(sheet, new int[] {i+startRow1}, new int[] {15,16});
			combine2(sheet, new int[] {i+startRow1}, new int[] {17,18});
			combine2(sheet, new int[] {i+startRow1}, new int[] {20,21});
			combine2(sheet, new int[] {i+startRow1}, new int[] {23,24,25});
			combine2(sheet, new int[] {i+startRow1}, new int[] {26,27,28});
			combine2(sheet, new int[] {i+startRow1}, new int[] {29,30});
			combine2(sheet, new int[] {i+startRow1}, new int[] {31,32});
			combine2(sheet, new int[] {i+startRow1}, new int[] {33,34});
		}
//		//һбкϲ
//		combine2(sheet, new int[] {startRow1,startRow1+productTableValue.size()-1}, new int[] {0});
//		
//		//ڶ
//		startRow2=startRow2+productTableValue.size()-1;
//		if(processTableValue.size()>1) {
//			 sheet.shiftRows(startRow2+1,sheet.getLastRowNum(), processTableValue.size()-1 );
//		}
//		
//		for(int i=1;i<processTableValue.size();i++) {//һв½
//			XSSFRow row = sheet.createRow(i+ startRow2);
//			row.setHeight(h2);
//			//ƵԪʽ
//			for (int j = 0; j < 24; j++) {
//				XSSFCell oldCell = oldRow2.getCell(j);
////				if(oldCell==null) {
////					oldCell=oldRow1.createCell(j);
////				}
//				XSSFCell newCell = row.createCell(j);
//				newCell.setCellStyle(oldCell.getCellStyle());
//				newCell.setCellType(oldCell.getCellType());
//			}
//			//ϲԪ
//			combine2(sheet, new int[] {i+startRow2}, new int[] {2,3,4,5});
//			combine2(sheet, new int[] {i+startRow2}, new int[] {7,8,9,10});
//			combine2(sheet, new int[] {i+startRow2}, new int[] {11,12,13,14,15,16,17});
//			combine2(sheet, new int[] {i+startRow2}, new int[] {18,19});
//			combine2(sheet, new int[] {i+startRow2}, new int[] {20,21});
//			combine2(sheet, new int[] {i+startRow2}, new int[] {22,23});
//		}
//		//һбкϲ
//		combine2(sheet, new int[] {startRow2,startRow2+processTableValue.size()-1}, new int[] {0});
		
		
		//product
		for(int i=0;i<productTableValue.size();i++) {
			List<String> value=productTableValue.get(i);
			XSSFRow row = sheet.getRow(i+ startRow1);
			row.getCell(0).setCellValue((value.get(1)==null||value.get(1).equals(""))?" ":value.get(1).toString());
			row.getCell(1).setCellValue((value.get(2)==null||value.get(2).equals(""))?" ":value.get(2).toString());
			//ͼƬ
			insertPicture(sheet, wb, i+ startRow1, 3, NameToPicpath.get((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString()));
			//row.getCell(6).setCellValue((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString());
			row.getCell(4).setCellValue((value.get(4)==null||value.get(4).equals(""))?" ":value.get(4).toString());
			row.getCell(7).setCellValue((value.get(5)==null||value.get(5).equals(""))?" ":value.get(5).toString());
			row.getCell(11).setCellValue((value.get(6)==null||value.get(6).equals(""))?" ":value.get(6).toString());
			row.getCell(12).setCellValue((value.get(7)==null||value.get(7).equals(""))?" ":value.get(7).toString());
			row.getCell(14).setCellValue((value.get(8)==null||value.get(8).equals(""))?" ":value.get(8).toString());
			row.getCell(15).setCellValue((value.get(9)==null||value.get(9).equals(""))?" ":value.get(9).toString());
			row.getCell(17).setCellValue((value.get(10)==null||value.get(10).equals(""))?" ":value.get(10).toString());
		}
		//process
		for(int i=0;i<processTableValue.size();i++) {
			List<String> value=processTableValue.get(i);
			System.out.println("value====>"+value);
			XSSFRow row = sheet.getRow(i+ startRow2);
			row.getCell(19).setCellValue((value.get(1)==null||value.get(1).equals(""))?" ":value.get(1).toString());
			row.getCell(20).setCellValue((value.get(2)==null||value.get(2).equals(""))?" ":value.get(2).toString());
			//ͼƬ
			//ͼƬ
			insertPicture(sheet, wb, i+ startRow2, 22, NameToPicpath.get((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString()));
			//row.getCell(6).setCellValue((value.get(3)==null||value.get(3).equals(""))?" ":value.get(3).toString());
			row.getCell(23).setCellValue((value.get(4)==null||value.get(4).equals(""))?" ":value.get(4).toString());
			row.getCell(26).setCellValue((value.get(5)==null||value.get(5).equals(""))?" ":value.get(5).toString());
			row.getCell(29).setCellValue((value.get(6)==null||value.get(6).equals(""))?" ":value.get(6).toString());
			row.getCell(31).setCellValue((value.get(7)==null||value.get(7).equals(""))?" ":value.get(7).toString());
			row.getCell(33).setCellValue((value.get(8)==null||value.get(8).equals(""))?" ":value.get(8).toString());
		}
		
		
		
		
		FileOutputStream output = new FileOutputStream(new File(outPutPath));
		wb.write(output);
		output.close();
		input.close();
		// file.setReadOnly();
		System.out.println("-------WRITE EXCEL OVER-------");
		return 0;
	}
	
	
	
	/**
	 * 
	 * @param session
	 * @param puid
	 * @return ͼƬ·
	 */
	public static String getPic(TCSession session,String puid) {
		
		String outFilePathp="";
		try {
			TCComponentDataset Dataset = (TCComponentDataset)session
			        .stringToComponent(puid);
			 TCComponentTcFile[] tcFile;
			 TCComponentTcFile picFile;
			 tcFile =Dataset.getTcFiles();
				picFile=tcFile[0];
				outFilePathp = System.getenv("TEMP") + "\\"+picFile.toString();
				CopyPic(picFile.getFmsFile(),outFilePathp);
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return outFilePathp;	
	}
	
	//ͼƬ
			public static void CopyPic(File path1,String path2) {
				// ļֽ
		        FileInputStream fis = null;
		        // ļֽ
		        FileOutputStream fos = null;
		        try {
		            // ļֽ
		            fis = new FileInputStream(path1);
		            // ļֽ
		            fos = new FileOutputStream(path2);
		            //׼һbyte[]飬洢ֽ룬СΪ1024ֽڣ1KB
		            byte[] bytes = new byte[1024];
		            int readCount = 0;
		            // ʼд
		            while ((readCount = fis.read(bytes)) != -1) {
		                // жֽд
		                fos.write(bytes, 0, readCount);
		            }
		            // ˢ¹ܵǿ
		            fos.flush();

		        } catch (FileNotFoundException e) {
		            e.printStackTrace();
		        } catch (IOException e) {
		            e.printStackTrace();
		        } finally {
		            if (fis != null) {
		                try {
		                    fis.close();
		                } catch (IOException e) {
		                    e.printStackTrace();
		                }
		            }
		            if (fos != null) {
		                try {
		                    fos.close();
		                } catch (IOException e) {
		                    e.printStackTrace();
		                }
		            }
		        }
			}
	
	
	
	
	
	/**
	 * õԪ
	 * 
	 * @param row1
	 * @param index
	 * @param str
	 */
	public static void setCellValue(XSSFRow row1, int index, String str) {
		XSSFCell cell = row1.getCell(index);
		if(cell==null) {
			cell=row1.createCell(index);
		}
		cell.setCellType(XSSFCell.CELL_TYPE_STRING);
		cell.setCellValue(str);
	}

	/**
	 * õԪ
	 * 
	 * @param row1
	 * @param index
	 * @param str
	 */
	public static void setCellValue(Row row1, int index, String str) {
		Cell cell = row1.getCell(index);
		cell.setCellType(XSSFCell.CELL_TYPE_STRING);
		cell.setCellValue(str);
	}
	
	public static boolean combine(XSSFSheet sheet, int[] rows, int[] columns) {
		boolean isOK = false;
		if (rows.length <=1 && columns.length <=1) {//ԵԪϲ
		}else {
			if(columns.length == 1&&columns[0]==1) {
				System.out.println("-------ϲ1----");
				for(int row=0;row<rows.length;row++) {
					removeMergedRegion(sheet,rows[row]+12,0);
				}
				sheet.addMergedRegion(new CellRangeAddress(rows[0]+12,
						rows[rows.length - 1]+12, 0,
						1));
			}else if(columns.length == 1&&columns[0]==2){
				System.out.println("-------ϲ2----");
				sheet.addMergedRegion(new CellRangeAddress(rows[0]+12,
						rows[rows.length - 1]+12, columns[0],
						columns[columns.length - 1]));
			}else if(columns.length == 1&&columns[0]==3) {
				System.out.println("-------ϲ3----");
				for(int row=0;row<rows.length;row++) {
					removeMergedRegion(sheet,rows[row]+12,3);
				}
				sheet.addMergedRegion(new CellRangeAddress(rows[0]+12,
						rows[rows.length - 1]+12, 3,
						4));
			}else {
				sheet.addMergedRegion(new CellRangeAddress(rows[0]+12,
						rows[rows.length - 1]+12, columns[0]+1,
						columns[columns.length - 1]+1));
			}
			
			isOK = true;
		}
		return isOK;
	}
	
	public static boolean combine2(XSSFSheet sheet, int[] rows, int[] columns) {
		boolean isOK = false;
		if (rows.length <=1 && columns.length <=1) {//ԵԪϲ
		}else {
			sheet.addMergedRegion(new CellRangeAddress(rows[0],
					rows[rows.length - 1], columns[0],
					columns[columns.length - 1]));
			isOK = true;
		}
		return isOK;
	}
	
	 public static void removeMergedRegion(XSSFSheet sheet,int row ,int column)  
     {  
	      int sheetMergeCount = sheet.getNumMergedRegions();//ȡеĵԪ 
	      int index = 0;//ڱҪƳǸԪ
	      for (int i = 0; i < sheetMergeCount; i++) { 
	       CellRangeAddress ca = sheet.getMergedRegion(i); //ȡiԪ
	       int firstColumn = ca.getFirstColumn();  
	       int lastColumn = ca.getLastColumn();  
	       int firstRow = ca.getFirstRow();  
	       int lastRow = ca.getLastRow();  
	       if(row >= firstRow && row <= lastRow)  
	       {  
	        if(column >= firstColumn && column <= lastColumn)  
	        {  
	           index = i;
	        }  
	       }  
	      }
	      sheet.removeMergedRegion(index);//ƳϲԪ
     }  
	
	/**
	 * ȡ
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param relationType ϵ
	 */
	public static File getExcelToItem(TCSession session, TCComponentItemRevision item, String relationType,
			String fileType) {
		try {
			TCComponent[] zyzdsChildrens = item.getRelatedComponents(relationType);
			if (zyzdsChildrens == null || zyzdsChildrens.length < 1) {
				return null;
			}
			for (TCComponent zyzdsChildren : zyzdsChildrens) {
				if (fileType.equals(zyzdsChildren.getType())) {
					TCComponentDataset dateSet = (TCComponentDataset) zyzdsChildren;
					TCComponentTcFile[] tcFile = dateSet.getTcFiles();
					return tcFile[0].getFmsFile();
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	public static void insertPicture(XSSFSheet sheet,XSSFWorkbook wb ,int row,int col,String fileUrl) { //, double scaleX, double scaleY
		 //, double scaleX, double scaleY
		try {

			int row2=row;
			ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
			if(fileUrl==null||fileUrl.equals("")||!new File(fileUrl).exists()) {
				return;
			}
	    	BufferedImage bufferImg = ImageIO.read(new File(fileUrl));
	    	ImageIO.write(bufferImg, "png", byteArrayOut);
	    	Drawing drawing = sheet.createDrawingPatriarch();
	    	XSSFClientAnchor anchor = new XSSFClientAnchor();
	    	int picHeight = 500;
	    	int picWidth = 1050;
	    	int rowHeight = 0;
	    	for(int i =row;i<=row2;i++) {
	    		rowHeight += sheet.getRow(i).getHeight();
	    	}
	    	int strLength = sheet.getRow(row).getCell(col).getStringCellValue().length();
	    	int colWidth = sheet.getColumnWidth(col);
	    	row2 +=1;
	    	System.out.println("ǰУ"+row);
	        System.out.println("ǰβУ"+row2);
	    	System.out.println("ǰУ"+col);
	    	System.out.println("иߣ"+rowHeight);
	    	System.out.println("ǰп"+colWidth);

	    	colWidth = sheet.getColumnWidth(col);
	    	
	    	int t3 = (int)(picHeight/15);//ͼƬռԪ߶
	    	int t4 = (int)(picWidth/32);//ͼƬռԪ

//	    	int t6 = (int)(strLength%t5!=0?strLength/t5+1:strLength/t5);//Ԫ
//	    	int t7 = (int)(t6*417/15);//ռԪ߶
	    	int t8 = t3*2;//赥Ԫ߶
//	    	System.out.println(""+t6);
//	    	System.out.println("ָ߶ȣ"+t7);
	    	System.out.println("ǰԪ߶="+(int)(rowHeight/15));
	    	System.out.println("赥Ԫ߶="+t8);
	    	if((int)(rowHeight/15)<t8) {
	    		System.out.println("Ԫ߶Ȳ");
//	    		sheet.getRow(row).setHeight((short) ( t8*15));
	    	}
	    	int tempcolwid = colWidth - picWidth;
	    	if(tempcolwid>0) {
	    		tempcolwid /= 2;
	    		int t = (int)(rowHeight/15);
	    		int t2 = (int)(tempcolwid/32);
	    		System.out.println("t="+t);
	    		System.out.println("t2="+t2);
	    		anchor.setCol1(col);
	    		anchor.setCol2(col);
	    		anchor.setRow1(row);
	    		anchor.setRow2(row2);
	    		System.out.println("tw"+XSSFShape.EMU_PER_PIXEL);
	    		System.out.println("tw"+t);
	    		anchor.setDx1(XSSFShape.EMU_PER_PIXEL * t2); 
	    		anchor.setDx2(XSSFShape.EMU_PER_PIXEL * (t2+t4)); 
	    		if(row+1==row2) {//
	    			System.out.println("");
//	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * 100);
	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t/5)); //-XSSFShape.EMU_PER_PIXEL*(t/3)
//	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * 1);
	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (t3-4*t/5-2)); //-XSSFShape.EMU_PER_PIXEL*(t/3)
	    		}else {//кϲ
	    			System.out.println("");
	    			int tempRow = row;
	    			int row1Height = 0;
	    	    	row1Height = sheet.getRow(tempRow).getHeight();
	    	    	int t9 = (int)(row1Height/15);
	    	    	do {
	    	    		if(t9>(t/2)||tempRow==row2)break;
	    	    		tempRow++;
	    	    		row1Height = sheet.getRow(tempRow).getHeight();
	    	    		t9 +=(int)(row1Height/15);
	    	    	}while(true);
	    	    	if(tempRow == row2)System.out.println(""+row+"У"+col+"δҵʵУ");
	    	    	anchor.setRow1(tempRow);
	    	    	anchor.setRow2(tempRow+1);
	    	    	System.out.println("ʱУ"+tempRow);
	    	    	System.out.println("ʱи߶ȣ"+row1Height/15);
//	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * 150);
//	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * 500);
	    			anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t9-t/2));
	    			anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (t3+t9-t/2-row1Height/15));
	    		}
//	    		anchor.setDy1(XSSFShape.EMU_PER_PIXEL * (t - t2/2)); 
//	    		anchor.setDy2(XSSFShape.EMU_PER_PIXEL * (-1*t + t2/2)); 
	    	}
	        System.out.println("y1="+anchor.getDy1());
	        System.out.println("y2="+anchor.getDy2());
	    	
	    	anchor.setAnchorType(ClientAnchor.MOVE_AND_RESIZE);
	    	Picture picture = drawing.createPicture(anchor, wb.addPicture(byteArrayOut.toByteArray(), HSSFWorkbook.PICTURE_TYPE_JPEG));
//	    	picture.resize(1d);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
	
//	public static void insertPicture(XSSFSheet sheetAt,XSSFWorkbook wb ,int row,int col,String path) { //, double scaleX, double scaleY
//		try {
//			if(path==null||path.equals("")) {
//				System.out.println("δҵͼƬѡ");
//				return;
//			}else if(!new File(path).exists()) {
//				System.out.println("·"+path+"ͼƬѡ");
//				return;
//			}
//			ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
//			BufferedImage bufferImg = ImageIO.read(new File(path));
//            int width = bufferImg.getWidth();
//            int height = bufferImg.getHeight();
//            double i = (double)width/(double)height;
//            
//            ImageIO.write(bufferImg, "png", byteArrayOut);
//			//ͼĶһsheetֻܻȡһһҪע㣩
//            XSSFDrawing patriarch = sheetAt.createDrawingPatriarch();
////            //anchorҪͼƬ
////
////            /**
////             * @param dx1 ͼƬϽڿʼԪcol1,row1еĺ
////             * @param dy1 ͼƬϽڿʼԪcol1,row1е
////             * @param dx2 ͼƬ½ڽԪcol2,row2еĺ
////             * @param dy2 ͼƬ½ڽԪcol2,row2е
////             * @param col1 ʼԪк, base 0, ͼƬϽڿʼԪ
////             * @param row1 ʼԪк, base 0, ͼƬϽڿʼԪ
////             * @param col2 Ԫк, base 0, ͼƬ½ڽԪ
////             * @param row2 Ԫк, base 0, ͼƬ½ڽԪ
////             */
//            //XSSFClientAnchor anchor = new XSSFClientAnchor(dx1, dy1, dx2, dy2,(short) col1, row1, (short) col2, row2);
//            XSSFClientAnchor anchor = new XSSFClientAnchor();
//            anchor.setRow1(row);
//            anchor.setRow2(row+1);
//            //System.out.println("-----"+i);
//            anchor.setCol1(col);
//            anchor.setCol2(col+1);
//            
////            anchor.setDx1(10);
////            anchor.setDy1(10);
//           
//            anchor.setAnchorType(ClientAnchor.DONT_MOVE_AND_RESIZE);
//
//           
////            ͼƬwb.addPicture(byteArrayOut.toByteArray(), XSSFWorkbook.PICTURE_TYPE_PNG);
//            XSSFPicture createPicture = patriarch.createPicture(anchor, wb.addPicture(byteArrayOut.toByteArray(), XSSFWorkbook.PICTURE_TYPE_PNG));
////	        
//            System.out.println(createPicture);
//		} catch (Exception e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//    }
	

	/**
	 * ıݼ
	 * 
	 * @param tccomponentDataset
	 * @param quote
	 * @param type
	 * @param path
	 * @throws TCException
	 */
	public static void changeDataSet(TCComponentDataset tccomponentDataset, String quote, String type, String path)
			throws TCException {
		String myPath[] = { path };
		String myQuote[] = { quote };// "excel"
		String myType[] = { type };// "MSExcelX"
		String myPlain[] = { "Plain" };

		// ɾݼ
		deleDateSetRef(tccomponentDataset);
		// ݼ滻
		tccomponentDataset.setFiles(myPath, myType, myPlain, myQuote);

	}
	
	/**
	 * ɾݼ
	 * 
	 * @param dataset
	 * @throws TCException
	 */
	private static void deleDateSetRef(TCComponentDataset dataset) throws TCException {

		TCComponentTcFile[] tcFiles = dataset.getTcFiles();
		for (int i = 0; i < tcFiles.length; i++) {
			// õݼ
			String str_temp = getNamedRefType(dataset, tcFiles[i]);
			// ɾ
			dataset.removeNamedReference(str_temp);
		}

	}

	/**
	 * õݼ
	 * 
	 * @param datasetComponent
	 * @param tccomponent
	 * @return
	 * @throws TCException
	 */
	private static String getNamedRefType(TCComponentDataset datasetComponent, TCComponentTcFile tccomponent)
			throws TCException {
		String s;
		s = "";
		TCProperty tcproperty;
		TCProperty tcproperty1;
		TCComponent atccomponent[];
		String as[];
		int i;
		int j;
		int k;
		try {
			tcproperty = datasetComponent.getTCProperty("ref_list");
			tcproperty1 = datasetComponent.getTCProperty("ref_names");
			if (tcproperty == null || tcproperty1 == null)
				return s;
		} catch (TCException tcexception) {
			return s;
		}
		atccomponent = tcproperty.getReferenceValueArray();
		as = tcproperty1.getStringValueArray();
		if (atccomponent == null || as == null)
			return s;
		i = atccomponent.length;
		if (i != as.length)
			return s;
		j = -1;
		k = 0;
		do {
			if (k >= i)
				break;
			if (tccomponent == atccomponent[k]) {
				j = k;
				break;
			}
			k++;
		} while (true);
		if (j != -1)
			s = as[j];
		return s;
	}
	
	/**
	 * ȡ
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param relationType ϵ
	 */
	public static TCComponentDataset getExcelToDataset(TCSession session, TCComponentItemRevision item,
			String relationType, String fileType) {
		try {
			TCComponent[] zyzdsChildrens = item.getRelatedComponents(relationType);
			if (zyzdsChildrens == null || zyzdsChildrens.length < 1) {
				return null;
			}
			for (TCComponent zyzdsChildren : zyzdsChildrens) {
				if (fileType.equals(zyzdsChildren.getType())) {
					return (TCComponentDataset) zyzdsChildren;
//					TCComponentTcFile[] tcFile = dateSet.getTcFiles();
//					return tcFile[0].getFmsFile();
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	
	/**
	 * 
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param tcResource   ļ·
	 * @param relationType ϵ
	 * @param fileName     ļ
	 */
	public static void setExcelToItem(TCSession session, TCComponentItemRevision item, String tcResource,
			String fileName, String relationType, String excelType, boolean isDelete) {
		try {
			String as1[] = { tcResource };// ļ·
			String as2[] = { "excel" };
			String as3[] = { excelType };
			String as4[] = { "Plain" };
			TCComponentDatasetType tccomponentDatasetType = (TCComponentDatasetType) session
					.getTypeComponent("Dataset");
			TCComponentDataset tccomponentDataset = tccomponentDatasetType.create(fileName, "excel", excelType);
			tccomponentDataset.setFiles(as1, as3, as4, as2);
			AIFComponentContext[] zyzdsChildrens = item.getChildren();
			TCComponentItemRevision zyzdsRev = item;
			for (AIFComponentContext zyzdsChildren : zyzdsChildrens) {
				if (excelType.equals(zyzdsChildren.getComponent().getType())) {
					TCComponentDataset dateSet = (TCComponentDataset) zyzdsChildren.getComponent();
					if (dateSet.getStringProperty("object_name").equals(fileName)) {
						dateSet.delete();
						zyzdsRev.remove(relationType, dateSet);
					}
				}
			}
			item.add(relationType, tccomponentDataset);
			if (isDelete) {
				new File(tcResource).delete();
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	
	
	
	
	
}
