package com.connor.zf.controlplanlibrary;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.UUID;
import com.connor.zf.controlplan.SqlUtilT;
import com.connor.zf.controlplan.TreeBean;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class TMom012ControlPlanLibraryOperation extends AbstractAIFOperation {

	private List<List<String>> dataValueList;
	private TCSession session;
	private List<String> deleteRows;

	public TMom012ControlPlanLibraryOperation(TCSession session,
			List<List<String>> dataValueList, List<String> deleteRows) {
		this.session = session;
		this.dataValueList = dataValueList;
		this.deleteRows = deleteRows;
		
	}

	@Override
	public void executeOperation() throws Exception {
		ResultSet rs = null;
		InputStream input = null;
		try {
			SqlUtilT.getTCConnection();
			System.out.println("opration----------");
//			// ȡSQL
//			input = new BufferedInputStream(getClass().getResourceAsStream(
//					"/sql.properties"));
//			Properties pro = new Properties();
//			pro.load(input);
			// ɾ
			for (int i = 0; i < deleteRows.size(); i++) {
				// ȡݿ
				SqlUtilT.getTCConnection();
				String deleteSQL = String.format("delete from ZF6_CONTROLPLANLIBRARY where PLMEID = \'%s\'",
						deleteRows.get(i));
				SqlUtilT.delete(deleteSQL);
				//SqlUtilT.freeAll();
			}
			// ѯźID
			// ݿд
			
			System.out.println("ƼƻⱣdataValueList====>"+dataValueList);
			for (int i = 0; i < dataValueList.size(); i++) {
				//SqlUtilT.getTCConnection();
				List<String> rowList = dataValueList.get(i);
				if (rowList.get(0) != null && !rowList.get(0).equals("")) {
					// ȡݿ
					String updateSQL = String.format(
							"update ZF6_CONTROLPLANLIBRARY set ID = ?,JQZHJJGZ = ?,BH = ?,CP = ?,GC = ?,TSTXFL = ?,CPGC = ?,JSCLJS = ?,XM = ?,RL = ?,"
							+ "PL = ?,ZRR = ?,KZFF = ?,FYJH = ? where PLMEID = \'%s\'",
							rowList.get(0));
					//SqlUtilT.getTCConnection();
					SqlUtilT.update(
							new String[] { rowList.get(1), rowList.get(2),
									rowList.get(3), rowList.get(4),
									rowList.get(5), rowList.get(6),
									rowList.get(7), rowList.get(8),
									rowList.get(9), rowList.get(10),
									rowList.get(11),rowList.get(12),
									rowList.get(13), rowList.get(14)}, updateSQL);
				} else {
					String insertSQL = "insert into ZF6_CONTROLPLANLIBRARY values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
					//SqlUtilT.getTCConnection();
					SqlUtilT.write(
							new String[] {
									UUID.randomUUID().toString()
											.replace("-", ""), rowList.get(1), rowList.get(2),
									rowList.get(3),rowList.get(4),rowList.get(5),
									rowList.get(6),rowList.get(7),rowList.get(8),
									rowList.get(9),rowList.get(10),rowList.get(11),
									rowList.get(12),rowList.get(13),rowList.get(14),
									rowList.get(15)},
							insertSQL);
				}
				
			}
			
			//SqlUtilT.freeAll();
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
			throw e;
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.connection.commit();
			System.out.println("opration----------");
			SqlUtilT.freeAll();
		}
	}
}
