package com.connor.zf.zygyk;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.UUID;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JViewport;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;

import com.connor.zf.controlplan.MultiComboBox;
import com.connor.zf.controlplan.SqlUtilT;
import com.connor.zf.controlplan.TMomMethodUtil;
import com.connor.zf.controlplan.outPutExcel;
import com.connor.zf.editClassAttr.JAutoCompleteComboBox;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.commands.reserve.ReserveOperation;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.services.rac.core.ReservationService;

public class ZYGYKDialog extends JFrame implements ActionListener {

	private AbstractAIFApplication app;
	private TCSession session;
	private InterfaceAIFComponent comp;
	private TCComponent form;
	private TCProperty[] properties;
	private TCComponentItemRevision itemRevision;
	private TCComponentItemRevision meop;
	private List<Integer> processRows=new ArrayList<Integer>();;// ǰû޸ĵк

	private List<List<String>> productData;
	private List<List<String>> processData;

	private List<String> productPlmeidList;
	private List<String> processPlmeidList;

	private List<String> productDeleteList = new ArrayList<String>();
	private List<String> processDeleteList = new ArrayList<String>();

	private HashMap<String, String> GYKLXTOUID=new HashMap<String, String>();
	private List<String> headList = new ArrayList<String>();
	// Ҽ˵
	private static JPopupMenu menu;
	// Ҽ˵
	private JMenuItem addRowItem;
	private JMenuItem addRowsItem;
	private JMenuItem remItem;
	// ؼ
	private JLabel GYKLXLabel;//տ
	private JAutoCompleteComboBox GYKLXField;
	private JLabel CPXHLabel;//Ʒͺ
	private JTextField CPXHField;
	private JLabel GXMCLabel;//
	private JTextField GXMCField;
	private JLabel SLYSGGLabel;//ɰʯ
	private JTextField SLYSGGField;
	private JLabel SLYSCZLabel;//ɰʯ
	private JTextField SLYSCZField;
	private JLabel SBXHLabel;//豸ͺ
	private JTextField SBXHField;
	private JLabel CHSBXHLabel;//豸ͺ
	private JTextField CHSBXHField;
	private JLabel YHSBXHLabel;//ػ豸ͺ
	private JTextField YHSBXHField;
	private JLabel DJDPXHLabel;//ߵƬͺ
	private JTextField DJDPXHField;
	private JLabel LJMCLabel;//
	private JTextField LJMCField;
	
	private JLabel konghang;//
	
	
	// ѡ
	private JTabbedPane tabbedPane;
	private TCComponentDataset Dataset;
	private TCComponentTcFile picFile;
	private String outFilePathp=null;
	private TCComponent[] comps;
	private PicDialog picDialog;
	
	private String[] productHeader = new String[] { "PLMEID", "", "Ŀ", "Ҫ", "Ҫ", "鷽", "Ա׼", "ԼƵ", 
				"Ա׼", "Ƶ", "Ӧƻ" };
	private CTable productTable;// Ʒ
	private String[] processHeader = new String[] { "PLMEID", "", "Ŀ", "Ҫ", "Ҫ","鷽", "", "Ƶ","Ӧƻ"};
	private CTable processTable;// 

	// ť
	private JPanel rootPanel;
	private JButton reImportButton;
	private JButton ImportGYK;
	private JButton selectPicture;
	private JButton okButton;
	private JButton celButton;

	public ZYGYKDialog(AbstractAIFApplication app, TCSession session, InterfaceAIFComponent comp,TCComponentItemRevision meop,
			List<List<String>> productData, List<List<String>> processData, List<String> productPlmeidList,
			List<String> processPlmeidList,List<String> headList) {
		// TODO Auto-generated constructor stub
		this.app = app;
		this.session = session;
		this.comp = comp;
		this.meop=meop;
		this.productData = productData;
		this.processData = processData;
		this.processPlmeidList = processPlmeidList;
		this.productPlmeidList = productPlmeidList;
		this.headList=headList;
		this.itemRevision= (TCComponentItemRevision) this.comp;
		init();
	}

	private void init() {
		//ȡʻ
		Toolkit kit = Toolkit.getDefaultToolkit(); //幤߰
		Dimension screenSize = kit.getScreenSize(); //ȡĻĳߴ
		int screenWidth = screenSize.width; //ȡĻĿ
		int screenHeight = screenSize.height; //ȡĻĸ
		this.setLocation(screenWidth / 2 - 1150 / 2, screenHeight / 2 - 650 / 2);//ôھʾ
		// TODO Auto-generated method stub
		this.setTitle("ҵտ");
		this.setPreferredSize(new Dimension(1150, 650));
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				dispose();
			}
		});
		this.GYKLXLabel = new JLabel("տ");
		this.GYKLXLabel.setPreferredSize(new Dimension(80, 30));
		this.GYKLXField = new JAutoCompleteComboBox();
		this.GYKLXField.setPreferredSize(new Dimension(120, 30));
		this.GYKLXField.setSelectedItem(headList.get(2));
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringValues("ZF6_GYK_Template");
		System.out.println("տۺ======"+Arrays.toString(strs));
		GYKLXField.setEditable(false);
		for (String str : strs) {
			if(str.indexOf("տ")>=0) {
				GYKLXField.addItem(str.split(":")[0]);
				GYKLXTOUID.put(str.split(":")[0], str.split(":")[1]);
			}
		}
		this.CPXHLabel = new JLabel("Ʒͺ");
		this.CPXHLabel.setPreferredSize(new Dimension(100, 30));
		this.CPXHField = new JTextField(headList.get(3));
		this.CPXHField.setPreferredSize(new Dimension(100, 30));
		this.GXMCLabel = new JLabel("");
		this.GXMCLabel.setPreferredSize(new Dimension(100, 30));
		try {
			this.GXMCField = new JTextField((headList.get(4)==null||headList.get(4).equals("")?meop.getStringProperty("object_name"):headList.get(4)));
		} catch (TCException e3) {
			// TODO Auto-generated catch block
			e3.printStackTrace();
		}
		this.GXMCField.setPreferredSize(new Dimension(100, 30));
		this.SLYSGGLabel = new JLabel("ɰ/ʯ");
		this.SLYSGGLabel.setPreferredSize(new Dimension(100, 30));
		this.SLYSGGField = new JTextField(headList.get(5));
		this.SLYSGGField.setPreferredSize(new Dimension(100, 30));
		this.SLYSCZLabel = new JLabel("ɰ/ʯ");
		this.SLYSCZLabel.setPreferredSize(new Dimension(100, 30));
		this.SLYSCZField = new JTextField(headList.get(6));
		this.SLYSCZField.setPreferredSize(new Dimension(100, 30));
		this.SBXHLabel = new JLabel("豸ͺ");
		this.SBXHLabel.setPreferredSize(new Dimension(100, 30));
		this.SBXHField = new JTextField(headList.get(7));
		this.SBXHField.setPreferredSize(new Dimension(120, 30));
		this.CHSBXHLabel = new JLabel("豸ͺ");
		this.CHSBXHLabel.setPreferredSize(new Dimension(100, 30));
		this.CHSBXHField = new JTextField(headList.get(8));
		this.CHSBXHField.setPreferredSize(new Dimension(100, 30));
		this.YHSBXHLabel = new JLabel("ػ豸ͺ");
		this.YHSBXHLabel.setPreferredSize(new Dimension(100, 30));
		this.YHSBXHField = new JTextField(headList.get(9));
		this.YHSBXHField.setPreferredSize(new Dimension(100, 30));
		this.DJDPXHLabel = new JLabel("ߡƬͺ");
		this.DJDPXHLabel.setPreferredSize(new Dimension(110, 30));
		this.DJDPXHField = new JTextField(headList.get(10));
		this.DJDPXHField.setPreferredSize(new Dimension(90, 30));
		this.LJMCLabel = new JLabel("");
		this.LJMCLabel.setPreferredSize(new Dimension(100, 30));
		this.LJMCField = new JTextField(headList.get(11));
		this.LJMCField.setPreferredSize(new Dimension(100, 30));
		
		
		JPanel titlePanel = new JPanel(new PropertyLayout());
		titlePanel.add("1.1.left.top", this.GYKLXLabel);
		titlePanel.add("1.2.left.top", this.GYKLXField);
		titlePanel.add("1.3.left.top", this.CPXHLabel);
		titlePanel.add("1.4.left.top", this.CPXHField);
		titlePanel.add("1.5.left.top", this.GXMCLabel);
		titlePanel.add("1.6.left.top", this.GXMCField);
		titlePanel.add("1.7.left.top", this.SLYSGGLabel);
		titlePanel.add("1.8.left.top", this.SLYSGGField);
		titlePanel.add("1.9.left.top", this.SLYSCZLabel);
		titlePanel.add("1.10.left.top", this.SLYSCZField);
		titlePanel.add("2.1.left.top", this.SBXHLabel);
		titlePanel.add("2.2.left.top", this.SBXHField);
		titlePanel.add("2.3.left.top", this.CHSBXHLabel);
		titlePanel.add("2.4.left.top", this.CHSBXHField);
		titlePanel.add("2.5.left.top", this.YHSBXHLabel);
		titlePanel.add("2.6.left.top", this.YHSBXHField);
		titlePanel.add("2.7.left.top", this.DJDPXHLabel);
		titlePanel.add("2.8.left.top", this.DJDPXHField);
		titlePanel.add("2.9.left.top", this.LJMCLabel);
		titlePanel.add("2.10.left.top", this.LJMCField);
		try {
			if(comp.getProperty("release_status_list")!="") {
				setPanelEnabled(titlePanel,false);
			}
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		

		if (this.productData.size() > 0) {
			this.productTable = getjTable(null, null, productHeader, this.productData.size());
		} else {
			this.productTable = getjTable(null, null, productHeader, 1);
		}
		//ñп
		for(int i=0;i<productTable.getColumnCount();i++) {
			productTable.getColumnModel().getColumn(i).setPreferredWidth(171);
		}
		
		this.productTable.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent mouseevent) {
				// TODO Auto-generated method stub
				if (mouseevent.getClickCount() == 1) {
					
					((CTMap) productTable.getModel()).setRow(productTable.getSelectedRow());
					((CTMap) productTable.getModel()).setColumn(productTable.getSelectedColumn());
				}
				if (mouseevent.getButton() == MouseEvent.BUTTON3) {
					//޷༭м
					try {
						if(comp.getProperty("release_status_list")!="") {
						MessageBox.post("ѷ޷༭","ʧ",MessageBox.ERROR);
						return;
						}
					} catch (Exception e2) {
						// TODO Auto-generated catch block
						e2.printStackTrace();
					}
					menu.show(productTable, mouseevent.getX(), mouseevent.getY());
				}
			}
		});

		if (this.processData.size() > 0) {
			this.processTable = getjTable(null, null, processHeader,
					this.processData.size());
		} else {
			this.processTable = getjTable(null, null, processHeader, 1);
		}

		this.processTable.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent mouseevent) {
				// TODO Auto-generated method stub
				if (mouseevent.getClickCount() == 1) {
					
					((CTMap) processTable.getModel()).setRow(processTable.getSelectedRow());
					((CTMap) processTable.getModel()).setColumn(processTable.getSelectedColumn());
				}
				if (mouseevent.getButton() == MouseEvent.BUTTON3) {
					menu.show(processTable, mouseevent.getX(), mouseevent.getY());
				}
			}
		});

		tabbedPane = new JTabbedPane();

		tabbedPane.addTab("Ʒ", new JScrollPane(this.productTable));
		tabbedPane.addTab("", new JScrollPane(this.processTable));

		//setText();
		setProductTable();
		setProcessTable();
		
		rootPanel = new JPanel(new FlowLayout());
		this.okButton = new JButton("");
		this.okButton.setPreferredSize(new Dimension(100, 30));
		this.celButton = new JButton("ȡ");
		this.celButton.setPreferredSize(new Dimension(100, 30));
		this.ImportGYK = new JButton("ҵտ");
		this.ImportGYK.setPreferredSize(new Dimension(150, 30));
		this.reImportButton = new JButton("µ");
		this.reImportButton.setPreferredSize(new Dimension(120, 30));
		rootPanel.add(ImportGYK);
		rootPanel.add(okButton);
		rootPanel.add(celButton);
		rootPanel.add(reImportButton);

		// ʼҼ˵
		menu = new JPopupMenu();

		addRowItem = new JMenuItem("");
		addRowsItem = new JMenuItem("Ӷ");
		remItem = new JMenuItem("Ƴ");

		menu.add(addRowItem);
		menu.add(addRowsItem);
		menu.add(remItem);

		// 
		this.createActionEvent();
		this.setLayout(new BorderLayout());
		this.add(titlePanel, BorderLayout.NORTH);
		this.add(tabbedPane, BorderLayout.CENTER);
		this.add(rootPanel, BorderLayout.SOUTH);
		this.pack();
		this.show();
	}

//	/***
//	 * ÿؼֵ
//	 */
//	private void setText() {
//		this.companyNameField.setText(this.properties[0].getStringValue());
//		this.itemIdField.setText(this.properties[1].getStringValue());
//		this.equipmentIdField.setText(this.properties[2].getStringValue());
//		this.meopField.setText(this.properties[3].getStringValue());
//		this.equipmentNameField.setText(this.properties[4].getStringValue());
//	}

	/***
	 * ÿؼֵ
	 */
	private void getText() {
		headList.set(2, this.GYKLXField.getText());//տ
		headList.set(3, this.CPXHField.getText());////Ʒͺ
		headList.set(4, this.GXMCField.getText());//
		headList.set(5, this.SLYSGGField.getText());//ɰʯ
		headList.set(6, this.SLYSCZField.getText());//ɰʯ
		headList.set(7, this.SBXHField.getText());//豸ͺ
		headList.set(8, this.CHSBXHField.getText());//豸ͺ
		headList.set(9, this.YHSBXHField.getText());//ػ豸ͺ
		headList.set(10, this.DJDPXHField.getText());//ߵƬͺ
		headList.set(11, this.LJMCField.getText());//
	}

	private void setProductTable() {
		System.out.println("ʼƷ====="+productData);
		if (productData.size() > 0) {
			for (int i = 0; i < productData.size(); i++) {
				for (int j = 0; j < productData.get(i).size(); j++) {
					productTable.setValueAt(productData.get(i).get(j), i, j);
				}
			}
		} else {
			productTable.setValueAt(UUID.randomUUID().toString().replace("-", ""), 0, 0);
		}
	}

	private void setProcessTable() {
		if (processData.size() > 0) {
			for (int i = 0; i < processData.size(); i++) {
				for (int j = 0; j < processData.get(i).size(); j++) {
					processTable.setValueAt(processData.get(i).get(j), i, j);
				}
			}
		} else {
			processTable.setValueAt(UUID.randomUUID().toString().replace("-", ""), 0, 0);
		}
	}


	// Ӽ
	public void createActionEvent() {
		this.ImportGYK.addActionListener(this);
		this.okButton.addActionListener(this);
		this.celButton.addActionListener(this);
		this.reImportButton.addActionListener(this);
		this.addRowItem.addActionListener(this);
		this.addRowsItem.addActionListener(this);
		this.remItem.addActionListener(this);
	}

	public CTable getjTable(CTable partsTable, DefaultTableModel dtm, Object[] titleNames, int rows) {
		int simpleLen = 100;
		int totleLen = 1000;
		if (partsTable == null) {
			CTMap map = new CTMap(rows, titleNames.length);
			map.setColumnIdentifiers(titleNames);
			
			
			partsTable = new CTable(map);
			Adapter adapter = new Adapter(partsTable);
			// partsTable.setRowHeight(1, 50);
			// partsTable.setRowHeight(2, 100);
			partsTable.setRowHeight(40);
			// 
			partsTable.HiddenCell(0);
//			partsTable.HiddenCell(titleNames.length - 1);
//			partsTable.HiddenCell(titleNames.length - 2);

			// //ʾȾ
			TableCellTextAreaRenderer renderer = new TableCellTextAreaRenderer();
			for(int i=0;i<rows;i++) {
				processRows.add(i);
			}
			renderer.setProcessRows(processRows);
			//renderer.setIsRelease(true);
//			try {
//				//˾޷༭
//				if(comp.getProperty("release_status_list")!="") {
//					map.setEditable(false);
//					renderer.setBackground(new Color(220,220,220));
//				}else {
//					map.setEditable(true);
//				}
//			} catch (Exception e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
			
			// //þ
			partsTable.setDefaultRenderer(Object.class, renderer);
			if (simpleLen * titleNames.length >= totleLen) {
				for (int i = 0; i < titleNames.length; i++) {
					partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
				}
				partsTable.setAutoResizeMode(0);
			} else {
				partsTable.setAutoResizeMode(1);
			}
		}
		
		
		//˲ñ༭
		try {
			if(comp.getProperty("release_status_list")!="") {
				partsTable.setEnabled(false);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return partsTable;
	}
	
	
	

	//ÿؼȨ
	public void setPanelEnabled(JPanel panel, boolean enabled) {
		for (int i = 0; i < panel.getComponentCount(); i++) {
			if (panel.getComponent(i) instanceof JPanel) {
				JPanel chidPanel = (JPanel) panel.getComponent(i);
				for (int j = 0; j < chidPanel.getComponentCount(); j++) {

					chidPanel.getComponent(j).setEnabled(enabled);//һ
					if (chidPanel.getComponent(j) instanceof MultiComboBox) {
						MultiComboBox multiComboBox = (MultiComboBox) chidPanel.getComponent(j);
						multiComboBox.editor.enable(enabled);
						if(enabled) {multiComboBox.popup.show();}else {multiComboBox.popup.hide();}
					}
					if (chidPanel.getComponent(j) instanceof JScrollPane) {
						JScrollPane scrollPane = (JScrollPane) chidPanel.getComponent(j);
						JViewport jViewport = scrollPane.getViewport();
						jViewport.getView().setEnabled(enabled);
					}
				}
			}
			panel.getComponent(i).setEnabled(enabled);
			if (panel.getComponent(i) instanceof MultiComboBox) {
				MultiComboBox multiComboBox = (MultiComboBox) panel.getComponent(i);
			
				multiComboBox.editor.enable(enabled);
				if(enabled) {multiComboBox.popup.show();}else {multiComboBox.popup.hide();}
			}
			if (panel.getComponent(i) instanceof JScrollPane) {
				JScrollPane scrollPane = (JScrollPane) panel.getComponent(i);
				JViewport jViewport = scrollPane.getViewport();
				jViewport.getView().setEnabled(enabled);
			}
		}
	}	
	

	
	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
			Object source = e.getSource();
		
		if (source.equals(this.okButton)) {
			
			//޷༭м
			try {
				if(comp.getProperty("release_status_list")!="") {
				MessageBox.post("ѷ޷༭棡","ʧ",MessageBox.ERROR);
				return;
				}
			} catch (Exception e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			if (productTable.getSelectedRow() >= 0 && productTable.getSelectedColumn() >= 0) {
				(productTable.getCellEditor(productTable.getSelectedRow(), productTable.getSelectedColumn())).stopCellEditing();
			}
			if (processTable.getSelectedRow() >= 0 && processTable.getSelectedColumn() >= 0) {
				(processTable.getCellEditor(processTable.getSelectedRow(), processTable.getSelectedColumn())).stopCellEditing();
			}
			saveEvent(true);

		}else if (source.equals(this.reImportButton)) {
			System.out.println("µ");
			//޷༭м
			try {
				if(comp.getProperty("release_status_list")!="") {
				MessageBox.post("ѷ޷µ룡","ʧ",MessageBox.ERROR);
				return;
				}
			} catch (Exception e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			int i = JOptionPane.showConfirmDialog(null, "µɾݣ¼ؿƼƻݣȷǷµ롣", "µ", JOptionPane.YES_NO_OPTION);
			if (i == JOptionPane.YES_OPTION) {
				remAllRow(this.productTable,"Ʒ");
				remAllRow(this.processTable,"");
				dispose();
				ZYGYKCommand command = new ZYGYKCommand(app,
						session,comp,true);
				try {
					command.executeModal();
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			} else if (i == JOptionPane.NO_OPTION) {
				return;
			}
		}
		else if (source.equals(this.ImportGYK)) {
			System.out.println("տ");
			saveEvent(false);
//			//޷༭м
//			try {
//				if(comp.getProperty("release_status_list")!="") {
//				MessageBox.post("ѷѡ·","ʧ",MessageBox.ERROR);
//				return;
//				}
//			} catch (Exception e2) {
//				// TODO Auto-generated catch block
//				e2.printStackTrace();
//			}
//			try {
//				ImportCard(false);
//			} catch (TCException e1) {
//				// TODO Auto-generated catch block
//				e1.printStackTrace();
//			}
//		}
//		else if (source.equals(this.selectPicture)) {
//			//޷༭м
//			try {
//				if(comp.getProperty("release_status_list")!="") {
//				MessageBox.post("ѷ޷ѡ","ʧ",MessageBox.ERROR);
//				return;
//				}
//			} catch (Exception e2) {
//				// TODO Auto-generated catch block
//				e2.printStackTrace();
//			}
//			if(isExsist()==0) {
//				selectpictureButtonEvent();
//			}else {//ӹϵ´ͼƬʱͼƬ
//				int isReplace= JOptionPane.showConfirmDialog(null, "ѴڵͼǷѡ", "ʾ", JOptionPane.YES_NO_OPTION);
//				if(isReplace == JOptionPane.YES_OPTION){
//					try {
//						itemRevision.remove("IMAN_specification",itemRevision.getReferenceListProperty("IMAN_specification"));
//					} catch (TCException e1) {
//						// TODO Auto-generated catch block
//						e1.printStackTrace();
//					}
//					selectpictureButtonEvent();
//				}else {
//					return;
//				}
//			}
			
		}
		else if (source.equals(this.celButton)) {
			dispose();
		} 
		else if (source.equals(this.addRowItem)) {
			//޷༭м
			try {
				if(comp.getProperty("release_status_list")!="") {
				MessageBox.post("ѷ޷У","ʧ",MessageBox.ERROR);
				return;
				}
			} catch (Exception e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			addRow(1);
		} else if (source.equals(this.addRowsItem)) {
			//޷༭м
			try {
				if(comp.getProperty("release_status_list")!="") {
				MessageBox.post("ѷ޷ӶУ","ʧ",MessageBox.ERROR);
				return;
				}
			} catch (Exception e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			new AddRowsDialog();
			
		} else if (source.equals(this.remItem)) {
			//޷༭м
			try {
				if(comp.getProperty("release_status_list")!="") {
				MessageBox.post("ѷ޷ƳУ","ʧ",MessageBox.ERROR);
				return;
				}
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			remRow();
		} else {
			dispose();
		}
	}
	
	private boolean checkMust() {
		// TODO Auto-generated method stub
		boolean flag=false;
		GYKLXField.setEditable(true);
		System.out.println("checkMust===>"+GYKLXField.getText());
		if(GYKLXField.getText()==null||GYKLXField.getText().equals("")) {
			flag=true;
		}
		return flag;
		
	}

	
	
	
	private void saveEvent(boolean flag) {
		if(checkMust()) {
			GYKLXField.setEditable(false);
			MessageBox.post("տδд","ʧ",MessageBox.ERROR);
			return;
		}
		System.out.println("ʱͣ"+this.GYKLXField.getText());
		this.productData = getTableValue(this.productTable);
		this.processData = getTableValue(this.processTable);
		getText();
		GYKLXField.setEditable(false);
		ZYGYKOperation operation = new ZYGYKOperation(app, session, comp,
				productData,processData, productPlmeidList, processPlmeidList,
				productDeleteList, processDeleteList, headList);

		try {
			operation.executeOperation();
			setPlmeidList(productPlmeidList, productTable);
			setPlmeidList(processPlmeidList, processTable);
			
			if(flag) {
				this.rootPanel.setBackground(Color.GREEN);
				new Thread() {
					@Override
					public void run() {
						try {
							this.sleep(1000);
							rootPanel.setBackground(Color.WHITE);
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
				}.start();
			}else {
				ImportCard();
				this.dispose();
			}
			
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	//տ
	private void ImportCard() throws TCException, IOException{
		System.out.println("GYKLXField.getText()===>"+GYKLXField.getText());
		File file = TMomMethodUtil.getFile(session, GYKLXField.getText(), "MSExcelX","ZF6_GYK_Template");
		String outFileName=((TCComponentItemRevision) comp).getStringProperty("item_id")  
				+((TCComponentItemRevision) comp).getStringProperty("object_name");
				//System.out.println(this.tMomControlPlanBean.toString());
				String outFilePath = System.getenv("TEMP") + "\\" + outFileName + ".xlsx";
				
				if(GYKLXField.getText().indexOf("װ")>=0) {
					outPutExcel.writeZPGYKToExcel(session,productData,processData,headList,file,outFilePath,
							((TCComponentItemRevision) comp).getStringProperty("item_id"),((TCComponentItemRevision) comp).getStringProperty("current_revision_id"));
				}else {
					outPutExcel.writeGYKToExcel(session,productData,processData,headList,file,outFilePath,
							((TCComponentItemRevision) comp).getStringProperty("item_id"),((TCComponentItemRevision) comp).getStringProperty("current_revision_id"),GYKLXField.getText());
				}
				
				
				if (outPutExcel.getExcelToItem(session, (TCComponentItemRevision) comp,
						"IMAN_specification", "MSExcelX") != null) {
					outPutExcel.changeDataSet(
							outPutExcel.getExcelToDataset(session, itemRevision, "IMAN_specification", "MSExcelX"),
							"excel", "MSExcelX", outFilePath);
					new File(outFilePath).delete();
				} else {
					outPutExcel.setExcelToItem(session, itemRevision, outFilePath, outFileName, "IMAN_specification",
							"MSExcelX", true);
				}
//				if(new File(outFilePath).exists()) {
//					new File(outFilePath).delete();
//				}
		MessageBox.post("Excelɹ", "ɹ", MessageBox.INFORMATION);
		
	}
	
	
//	//
//	private void saveData(){
//		if (toolingDetailTable.getSelectedRow() >= 0 && toolingDetailTable.getSelectedColumn() >= 0) {
//			(toolingDetailTable.getCellEditor(toolingDetailTable.getSelectedRow(), toolingDetailTable.getSelectedColumn())).stopCellEditing();
//		}
//		if (machiningParameterTable.getSelectedRow() >= 0 && machiningParameterTable.getSelectedColumn() >= 0) {
//			(machiningParameterTable.getCellEditor(machiningParameterTable.getSelectedRow(), machiningParameterTable.getSelectedColumn())).stopCellEditing();
//		}
//		if (controlRequirementTable.getSelectedRow() >= 0 && controlRequirementTable.getSelectedColumn() >= 0) {
//			(controlRequirementTable.getCellEditor(controlRequirementTable.getSelectedRow(), controlRequirementTable.getSelectedColumn())).stopCellEditing();
//		}
//		this.toolingDetailData = getTableValue(this.toolingDetailTable);
//		this.machiningParameterData = getTableValue(this.machiningParameterTable);
//		this.controlRequirementData = getTableValue(this.controlRequirementTable);
//
//		List<String> valueList = getText();
//
//		ZYGYKOperation operation = new ZYGYKOperation(app, session, comp,
//				toolingDetailData, machiningParameterData, controlRequirementData, toolingDetailPlmeidList,
//				machiningParameterPlmeidList, controlRequirementPlmeidList, toolingDetailDeleteList,
//				machiningParameterDeleteList, controlRequirementDeleteList, form, properties, valueList);
//		try {
//			operation.executeOperation();
//			// ȡ汾
//			form = itemRevision.getRelatedComponent("IMAN_master_form_rev");
//			if (form != null) {
//				properties = form.getTCProperties(properName);
//			}
//			
//		} catch (Exception e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		
//	}
//	
//	private JobProcessFormBean getData()
//	{
//		JobProcessFormBean bean = new JobProcessFormBean();
//		bean.setGsmc(this.properties[0].getStringValue());
//		bean.setLjdh(this.properties[1].getStringValue());
//		bean.setSbxh(this.properties[2].getStringValue());
//		bean.setBgx(this.properties[3].getStringValue());
//		bean.setSbmc(this.properties[4].getStringValue());
//		bean.setToolingDetailData(toolingDetailData);
//		bean.setMachiningParameterData(machiningParameterData);
//		bean.setControlRequirementData(controlRequirementData);
//		return bean;
//	}
//	
	
	//޸ϢرȨ
	private void closePermission() {
		//رȨ޸
		if(((TCComponent) comp).isCheckedOut()) {
			ReservationService service=ReservationService.getService((TCSession)app.getSession());
			service.checkin(new TCComponent[] {(TCComponent) this.comp});//ǩ
		}
	}

	private void setPlmeidList(List<String> plmeidList, CTable table) {
		// TODO Auto-generated method stub
		List<List<String>> dataValeList = new ArrayList<List<String>>();

		for (int j = 0; j < table.getRowCount(); j++) {
			if (!plmeidList.contains(table.getValueAt(j, 0))) {
				plmeidList.add(table.getValueAt(j, 0).toString());
			}
		}
	}

	private List<List<String>> getTableValue(CTable table) {
		// TODO Auto-generated method stub
		List<List<String>> dataValeList = new ArrayList<List<String>>();

		CTMap map = ((CTMap) table.getModel());
		for (int j = 0; j < table.getRowCount(); j++) {
			List<String> rowValue = new ArrayList<String>();
			for (int j2 = 0; j2 < map.getColumnCount(); j2++) {
				rowValue.add((String) table.getValueAt(j, j2));
			}
			dataValeList.add(rowValue);
		}
		return dataValeList;
	}
	
	
	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		super.dispose();
		//رȨ޸
		closePermission();
	}

	/**
	 * 
	 */
	private void addRow(int index) {
		// TODO Auto-generated method stub
		CTable table = productTable;
		switch (this.tabbedPane.getSelectedIndex()) {
		case 1:
			table = processTable;
			break;
		default:
			break;
		}
		CTMap map = ((CTMap) table.getModel());
		map.insertRow(table.getSelectedRow() + index);
		table.setValueAt(UUID.randomUUID().toString().replace("-", ""), table.getSelectedRow() + index, 0);
		table.revalidate();//
		table.repaint();//ػ
	}
	
	
	
	/**
	 * Ƴ
	 */
	private void remRow() {
		// TODO Auto-generated method stub
		CTable table = productTable;
		switch (this.tabbedPane.getSelectedIndex()) {
		case 1:
			table = processTable;
			break;

		default:
			break;
		}
		CTMap map = ((CTMap) table.getModel());

		switch (this.tabbedPane.getSelectedIndex()) {
		case 0:
			if (map.getValueAt(table.getSelectedRow(), 0) != null
					&& this.productPlmeidList.contains(map.getValueAt(table.getSelectedRow(), 0))) {
				this.productDeleteList.add(map.getValueAt(table.getSelectedRow(), 0).toString());
			}
			
			break;
		case 1:
			if (map.getValueAt(table.getSelectedRow(), 0) != null
					&& this.processPlmeidList.contains(map.getValueAt(table.getSelectedRow(), 0))) {
				this.processDeleteList.add(map.getValueAt(table.getSelectedRow(), 0).toString());
			}
			break;
		
		default:
			break;
		}
		
		map.removeRow(table.getSelectedRow());
		table.revalidate();//
		table.repaint();//ػ
	}
	
	/**
	 * µʱƳϢ
	 */
	private void remAllRow(CTable table,String tableName) {
		List<String> deleteAllList=new ArrayList<String>();
		for (int j = 0; j < table.getRowCount(); j++) {
			deleteAllList.add(table.getValueAt(j, 0).toString());
		}
		switch (tableName) {
		case "Ʒ":
			for(int i=0;i<deleteAllList.size();i++) {
			SqlUtilT.getTCConnection();
			String deleteSQL = String.format("DELETE FROM ZF6_PRODUCTCHARACTER WHERE PLMEID = \'%s\'",
					deleteAllList.get(i));
			SqlUtilT.delete(deleteSQL);
			SqlUtilT.freeAll();
			}
			break;
		case "":
			for(int i=0;i<deleteAllList.size();i++) {
				SqlUtilT.getTCConnection();
				String deleteSQL = String.format("DELETE FROM ZF6_PROCESSCHARACTER WHERE PLMEID = \'%s\'",
						deleteAllList.get(i));
				SqlUtilT.delete(deleteSQL);
				SqlUtilT.freeAll();
				}
			break;
		
		default:
			break;
		}
	}
	
	 class AddRowsDialog extends AbstractAIFDialog implements ActionListener {

		private JPanel panel;
		private JLabel label;
		private JTextField textField;
		private JButton button;
		private int rows=0;

		private Object source;

		public AddRowsDialog() {
			// TODO Auto-generated constructor stub
			super();
			init();
		}

		private void init() {
		
			// TODO Auto-generated method stub
			this.panel = new JPanel(new PropertyLayout());
			this.label = new JLabel("");
			this.textField = new JTextField(20);
			this.textField.addKeyListener(new KeyAdapter() {
				@Override
				public void keyPressed(KeyEvent arg0) {
					if (arg0.getKeyCode() == KeyEvent.VK_ENTER) {
						okEvent();
					} else {
						super.keyPressed(arg0);
					}
				}
			});
			this.button = new JButton("ȷ");
			this.button.addActionListener(this);
			this.panel.add("1.1.left.top", label);
			this.panel.add("1.2.left.top", textField);
			this.panel.add("1.3.left.top", button);

			this.add(this.panel, BorderLayout.CENTER);
			this.pack();
			this.showDialog();
		}
		
		@Override
		public void actionPerformed(ActionEvent actionevent) {
			// TODO Auto-generated method stub
			Object source = actionevent.getSource();
			if (source.equals(this.button)) {
				okEvent();
			}
		}
		private void okEvent() {
			if (!isStr2Num(textField.getText())) {
				MessageBox.post("ȷ!", "!", MessageBox.ERROR);
				return ;
			}
			if (Integer.parseInt(textField.getText())<0) {
				MessageBox.post("С0", "!", MessageBox.ERROR);
				return ;
			}
			rows=Integer.parseInt(textField.getText());
			for(int i=1;i<=rows;i++) {
				addRow(i);
			}
			//this.disposeDialog();
			this.dispose();
		}
		
		
		/**
		 * 鿴һַǷתΪ
		 * 
		 * @param str ַ
		 * @return true ; false 
		 */
		public boolean isStr2Num(String str) {
			try {
				Integer.parseInt(str);
				return true;
			} catch (NumberFormatException e) {
				return false;
			}
		}
		
	}
	//ͼƬ
		public void CopyPic(File path1,String path2) {
			// ļֽ
	        FileInputStream fis = null;
	        // ļֽ
	        FileOutputStream fos = null;
	        try {
	            // ļֽ
	            fis = new FileInputStream(path1);
	            // ļֽ
	            fos = new FileOutputStream(path2);
	            //׼һbyte[]飬洢ֽ룬СΪ1024ֽڣ1KB
	            byte[] bytes = new byte[1024];
	            int readCount = 0;
	            // ʼд
	            while ((readCount = fis.read(bytes)) != -1) {
	                // жֽд
	                fos.write(bytes, 0, readCount);
	            }
	            // ˢ¹ܵǿ
	            fos.flush();

	        } catch (FileNotFoundException e) {
	            e.printStackTrace();
	        } catch (IOException e) {
	            e.printStackTrace();
	        } finally {
	            if (fis != null) {
	                try {
	                    fis.close();
	                } catch (IOException e) {
	                    e.printStackTrace();
	                }
	            }
	            if (fos != null) {
	                try {
	                    fos.close();
	                } catch (IOException e) {
	                    e.printStackTrace();
	                }
	            }
	        }
		}
		
		/**
		 * ͼѡť¼
		 * 
		 * @param e
		 */
		public void selectpictureButtonEvent() {
			//MessageBox.post(, "", MessageBox.ERROR);
			TCComponentFolder fileFolder;
			try {
				if(getPuid()==null) {
					MessageBox.post("δӦѡ", "", MessageBox.ERROR);
				}else {
					fileFolder = (TCComponentFolder)session
					        .stringToComponent(getPuid());
					if(fileFolder!=null) {
						comps = fileFolder.getReferenceListProperty("contents");
						picDialog=new PicDialog(comps,System.getenv("TEMP"),fileFolder.getStringProperty("object_name"));
					}else {
						MessageBox.post("δҵͼ", "", MessageBox.ERROR);
					}
				}
				
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		//ѡRB3_PICTURE_LIBRARYֵҸͼļеUID
		public String getPuid() {
			TCPreferenceService service = session.getPreferenceService();
		      String[] modelFiles = service.getStringValues("RB3_PICTURE_LIBRARY");
		      if (modelFiles == null)
		      {
		        System.out.println("δҵѡ");
		        return null;
		      }
		      String puid = null;
		      for (int i = 0; i < modelFiles.length; i++) {
					if(session.getCurrentGroup().toString().indexOf(modelFiles[i].split("-")[0])>-1)
					{
						puid = modelFiles[i].split("-")[1];
						return puid;
					}
				  }
		      return null;
		}
		public class PicDialog extends JFrame {
			private CTMap pmap;
			private CTable pmainTable;
			private int tag;
			private String pathname;
			private String LibraryName;
			boolean select=true;
			private String[] header = new String[] { "ͼƬб"};
			private TCComponent[] comps;
			public PicDialog(TCComponent[] comps,String pathname,String LibraryName) {
				// TODO Auto-generated constructor stub
				super();
				this.comps=comps;
				this.pathname=pathname;
				this.LibraryName=LibraryName;
				pinit();
			}
			private void pinit() {
				this.setTitle(this.LibraryName);
				this.setPreferredSize(new Dimension(500, 600));
				// TODO Auto-generated method stub
				pmainTable = getNewjTable(null, null,header, 1);
				pmainTable.setRowHeight(40);
				pmainTable.getColumnModel().getColumn(0).setPreferredWidth(20);
				JScrollPane jslp1 = new JScrollPane(); // jtaӹ
				jslp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
				jslp1.setViewportView(pmainTable);
				for(int i=0;i<comps.length-1;i++) {
				this.pmap.insertRow(0);
				}
				for (int i =0 ; i < comps.length; i++) {
					//String len=dataList.get(i).substring(0,dataList.get(i).length()-4);
					pmainTable.setValueAt(comps[i].toString(), i, 0);
					}
				pmainTable.addMouseListener(new MouseAdapter() {
						@Override
						public void mouseClicked(MouseEvent mouseevent) {
							
							// TODO Auto-generated method stub
							if (mouseevent.getClickCount() == 2) {
								tag=pmainTable.getSelectedRow();
								//comps[0].getProperty("object_type")
								try {
									if(comps[tag].getProperty("object_type").equals("ļ")) {
										TCComponent[] compss=comps[tag].getReferenceListProperty("contents");
										PicDialog picDialogs= new PicDialog(compss,pathname,LibraryName);
										select=false;
									}
								if(select) {	
									//ѡиͼƬӵӹϵ
									TCComponentDataset dat = (TCComponentDataset) comps[tag];
									itemRevision.add("IMAN_specification", dat);
//									 TCComponentTcFile[] tcFile;
//									tcFile = dat.getTcFiles();
//									picFile=tcFile[0];
//									outFilePathp = pathname + "\\"+comps[tag].toString();
//									CopyPic(picFile.getFmsFile(),outFilePathp);
								}
								} catch (TCException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
			                    dispose();
			                    //}
			                    }}});
				getContentPane().add(jslp1, BorderLayout.CENTER);
				int w=(Toolkit.getDefaultToolkit().getScreenSize().width-500)/3;
		        int h=(Toolkit.getDefaultToolkit().getScreenSize().height-450)/3;
		        setLocation(w,h);
				this.pack();
				this.show();	
			}
			public String GetOutFilePathp() {
				return outFilePathp;
			}
			public CTable getNewjTable(CTable partsTable, DefaultTableModel dtm, Object[] titleNames, int rows) {
				int simpleLen = 100;
				int totleLen = 1000;
				if (partsTable == null) {
					pmap = new CTMap(rows, titleNames.length);
					pmap.setColumnIdentifiers(titleNames);
					pmap.setEditable(true);
					partsTable = new CTable(pmap);
					// ʾȾ
					TableCellTextAreaRenderer renderer = new TableCellTextAreaRenderer();
					partsTable.setDefaultRenderer(Object.class, renderer);
					// partsTable.setRowHeight(1, 50);
					if (simpleLen * titleNames.length >= totleLen) {
						for (int i = 0; i < titleNames.length; i++) {
							partsTable.getColumnModel().getColumn(i).setPreferredWidth(simpleLen);
						}
						partsTable.setAutoResizeMode(0);
					} else {
						partsTable.setAutoResizeMode(1);
					}
				}
				return partsTable;
			}
			
		}
}

