package com.connor.hs2.plm.PFMEA.design;

import java.awt.BorderLayout;
import java.awt.Color;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.plaf.metal.MetalProgressBarUI;

import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.soaictstubs.booleanSeq_tHolder;

public class DesignPFMEAOperation extends AbstractAIFOperation {

//	private TCProperty[] properties;
	private TCProperty[] itemProperties;
	private InterfaceAIFComponent comp;
	private PFMEABean pfmeaBean;
	private String[][] dataValue;
	private List<List<String>> dataValueList;
	private List<String> plmeidList;
	private TCSession session;
	private TCComponentItemRevision itemRevision;
	private TCComponent meprocess;
	private List<String> deleteRows;
	private boolean isOwning;
	private String UID;
	private boolean firstFlag;
	public DesignPFMEAOperation(TCComponentItemRevision itemRevision,
			TCComponent meprocess, TCSession session, TCProperty[] properties,
			TCProperty[] itemProperties, PFMEABean pfmeaBean,
			 List<List<String>> dataValueList,List<String> plmeidList,
			List<String> deleteRows, boolean isOwning,InterfaceAIFComponent comp,String UID,boolean firstFlag) {
		this.itemRevision = itemRevision;
		this.meprocess = meprocess;
		this.session = session;
//		this.properties = properties;
		this.itemProperties = itemProperties;
		this.pfmeaBean = pfmeaBean;
//		this.dataValue = dataValue;
		this.dataValueList = dataValueList;
		this.plmeidList = plmeidList;
		this.deleteRows = deleteRows;
		this.isOwning = isOwning;
		this.comp=comp;
		this.UID=UID;
		this.firstFlag=firstFlag;
	}

	@Override
	public void executeOperation() throws Exception {
		//+++ӽ
		JFrame frame = new JFrame("ڱ...");
		//frame.setUndecorated(true); // ûб
		 frame.setSize(300, 70);
         frame.setLocationRelativeTo(null);
         frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
         frame.setLayout(new BorderLayout());
         JProgressBar progressBar = new JProgressBar();
         progressBar.setOrientation(JProgressBar.HORIZONTAL);
         progressBar.setSize(300, 50);
         progressBar.setMinimum(0);
         progressBar.setMaximum(100);
         progressBar.setBorderPainted(true);
         progressBar.setUI(new MetalProgressBarUI());
         progressBar.setBackground(Color.white);
         progressBar.setForeground(Color.green);
         progressBar.setStringPainted(true);
         frame.setAlwaysOnTop(true);
         frame.add(progressBar);
         frame.setVisible(true);
		//+++
		ResultSet rs = null;
		InputStream input = null;
		try {

			
			PropertyToSQL();
			
			progressBar.setValue(1);//++++
			// ȡSQL
			input = new BufferedInputStream(getClass().getResourceAsStream(
					"/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			// ȡݿ
			// ѯźID
			String selectSQL = String.format(
					pro.getProperty("SETPFMEASELECT2"), meprocess.getUid());
			SqlUtilT.getTCConnection();
			rs = SqlUtilT.read(selectSQL);
			Map<String, String> itemIdMap = new HashMap<String, String>();
			while (rs.next()) {
				itemIdMap.put(rs.getString("REQUIREMENT"),
						rs.getString("MEOPID"));
			}
			//System.out.println("opdeleteRows====>"+deleteRows.toString());
			//System.out.println("opdataValueList====>"+dataValueList.toString());
			// ɾ
//			SqlUtilT.getTCConnection();
			for (int i = 0; i < deleteRows.size(); i++) {
				String deleteSQL = String.format(
						pro.getProperty("SETPFMEADELETE"), deleteRows.get(i));
//				SqlUtilT.getTCConnection();
				SqlUtilT.delete(deleteSQL);
			}
			progressBar.setValue(10);//++++
			// ȡݿ
			//SqlUtilT.getTCConnection();
			// ݿд
			int Speed=1;
			System.out.println(dataValueList.toString());
			int num2=dataValueList.size()/90;
			for (int i = 0; i < dataValueList.size(); i++) {
				List<String> rowList = dataValueList.get(i);
				if (rowList.get(0) != null && !rowList.get(0).equals("") && plmeidList.contains(rowList.get(0))) {
					// ȡݿ
					String updateSQL = String.format(
							pro.getProperty("SETPFMEAUPDATE"), rowList.get(0),UID);
//					SqlUtilT.getTCConnection();
					SqlUtilT.update(
							new String[] { rowList.get(1), rowList.get(2),
									rowList.get(3), rowList.get(4),
									rowList.get(5), rowList.get(6),
									rowList.get(7), rowList.get(8),
									rowList.get(9), rowList.get(10),
									rowList.get(11), rowList.get(12),
									rowList.get(13), rowList.get(14),
									rowList.get(15), rowList.get(16),
									rowList.get(17), rowList.get(18),
									rowList.get(19), rowList.get(20),
									rowList.get(21), rowList.get(22),
									rowList.get(23), rowList.get(24),
									rowList.get(25), rowList.get(26),
									rowList.get(30), rowList.get(31),
									rowList.get(32), rowList.get(33),
									rowList.get(34), rowList.get(35),
									rowList.get(36), rowList.get(37)},updateSQL);
//					SqlUtilT.freeAll();
				} else if(rowList.get(0) != null && !rowList.get(0).equals("")){
					String insertSQL = pro.getProperty("INSERTPFMEA");
					
					SqlUtilT.write2(new String[] {
							rowList.get(0),
							meprocess.getUid(), itemIdMap.get(rowList.get(4)),
							rowList.get(1), rowList.get(2), rowList.get(3),
							rowList.get(4), rowList.get(5), rowList.get(6),
							rowList.get(7), rowList.get(8), rowList.get(9),
							rowList.get(10), rowList.get(11), rowList.get(12),
							rowList.get(13), rowList.get(14), rowList.get(15),
							rowList.get(16), rowList.get(17), rowList.get(18),
							rowList.get(19), rowList.get(20), rowList.get(21),
							rowList.get(22), rowList.get(23), rowList.get(25),
							rowList.get(26), rowList.get(27), rowList.get(24),
							rowList.get(28), rowList.get(29), rowList.get(30),
							rowList.get(31), rowList.get(32), rowList.get(33), 
							rowList.get(34), rowList.get(35), rowList.get(36),
							rowList.get(37),UID,rowList.get(rowList.size()-1)}, insertSQL);
					System.out.println("++++++++"+insertSQL);
//					SqlUtilT.freeAll();
				}
				if(i==num2*(Speed-9)) {
					Speed++;
					progressBar.setValue(Speed);//++++
				}
			}
			progressBar.setValue(100);
			frame.setTitle("");
			frame.dispose();
			SqlUtilT.connection.commit();
			//MessageBox.post("ɹ", "ɹ", MessageBox.WARNING);
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
			throw e;
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}
	}

	private void PropertyToSQL() {
		// TODO Auto-generated method stub
//		
//		propertyList.add(rs.getString("companyName"));
//		propertyList.add(rs.getString("project"));
//		propertyList.add(rs.getString("address"));
//		propertyList.add(rs.getString("pfmeaStart_date"));
//		propertyList.add(rs.getString("pfmeaUpdate_date"));
//		propertyList.add(rs.getString("processDuty"));
//		propertyList.add(rs.getString("customerName"));
//		propertyList.add(rs.getString("pfmeaKey_date"));
//		propertyList.add(rs.getString("modelPlatform"));
//		propertyList.add(rs.getString("functionalTeams"));
//		propertyList.add(rs.getString("productCode"));
//		
//		INSERT INTO AHMC_PFMEA_NODE VALUES(?,?,?,?,?,?,?,?,?,?,?)
		SqlUtilT.getTCConnection();

		try {
			
			if(firstFlag) {
				
				String sqlString = "INSERT INTO AHMC_PROPERTY VALUES(?,?,?,?,?,?,?,?,?,?,?,?)";
				
				SqlUtilT.write2(new String[] {pfmeaBean.getCompanyName(),pfmeaBean.getProject(),pfmeaBean.getAddress(),pfmeaBean.getPfmeaStartDate()
						,pfmeaBean.getPfmeaUpdateDate(),pfmeaBean.getProcessDuty(),pfmeaBean.getCustomerName(),pfmeaBean.getSecurityClassification(),pfmeaBean.getModelPlatform(),pfmeaBean.getFunctionalTeams(),
						"",UID},sqlString);
			}else {
				
				String sqlString = "UPDATE AHMC_PROPERTY set companyName=? , project = ? ,address=?,pfmeaStart_date=?,pfmeaUpdate_date=?,"
						+ "processDuty=?,customerName=?,pfmeaKey_date=?,modelPlatform=?,functionalTeams=?,productCode=? where COMPUID = '"+UID+"'";
				SqlUtilT.update(sqlString, new String[] {pfmeaBean.getCompanyName(),pfmeaBean.getProject(),pfmeaBean.getAddress(),pfmeaBean.getPfmeaStartDate()
						,pfmeaBean.getPfmeaUpdateDate(),pfmeaBean.getProcessDuty(),pfmeaBean.getCustomerName(),pfmeaBean.getSecurityClassification(),pfmeaBean.getModelPlatform(),pfmeaBean.getFunctionalTeams(),
						""}); 
				
			}
			
			
			
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			try {
				SqlUtilT.connection.commit();
				
				SqlUtilT.freeAll();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
		}
		
		
		
	}

}
