package com.connor.renben.process.plm.util;
import java.io.File;

import javax.swing.filechooser.FileFilter;

public class ImageFilter extends FileFilter {

	public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}
		String fileName = f.getName();
		int index = fileName.lastIndexOf('.');
		String extension = "";
		if (index > 0 && index < fileName.length() - 1) {
			extension = fileName.substring(index + 1).toLowerCase();
		}
		if (extension != null) {
			if (extension.equals("gif") || extension.equals("jpeg")
					|| extension.equals("jpg") || extension.equals("png")) {
				return true;
			} else {
				return false;
			}
		}
		return false;
	}

	public String getDescription() {
		return "ͼƬļ(*.jpg, *.jpeg, *.gif, *.png)";
	}
}