package com.connor.renben.process.plm.util;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellEditor;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellEditor;

public class TreeTableCellEditor extends DefaultTreeCellEditor {

	JTable table;

	@Override
	public Component getTreeCellEditorComponent(JTree tree, Object value,
			boolean isSelected, boolean expanded, boolean leaf, int row) {
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
		Object ud = node.getUserObject();
		if (!(ud instanceof JTable) || !leaf) {
			return super.getTreeCellEditorComponent(tree, value, isSelected,
					expanded, leaf, row);
		}
		return (JTable) ud;
	}

	public TreeTableCellEditor(JTree tree, DefaultTreeCellRenderer renderer,
			TreeCellEditor editor) {
		super(tree, renderer, editor);
	}

	public TreeTableCellEditor(JTree tree, DefaultTreeCellRenderer renderer) {
		super(tree, renderer);
	}
}
