package com.connor.zf.controlplan;

import java.sql.ResultSet;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.common.NotDefinedException;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.commands.reserve.ReserveOperation;
import com.teamcenter.rac.kernel.TCAccessControlService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentGroup;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentRole;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.services.rac.core.ReservationService;

public class TMom004SetControlPlanHandler extends AbstractHandler {

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		AbstractAIFApplication app = AIFUtility.getCurrentApplication();
		TCSession session = (TCSession) app.getSession();
		if(app.getTargetComponent()==null
				||!(app.getTargetComponent() instanceof TCComponentItemRevision)
				||!(app.getTargetComponent().getType().toUpperCase().indexOf("KZJH") >= 0)) {
			MessageBox.post("δѡпƼƻ汾ѡ", "", MessageBox.ERROR);
			return null;
		}
		String UID;
		UID=app.getTargetComponent().getUid();
		TMom004SetControlPlanCommand command = new TMom004SetControlPlanCommand(
				app,app.getTargetComponent() ,session,UID,false);
		if(UID==null) {
			MessageBox.post("ѡ", "", MessageBox.ERROR);
			
			return null;
		}
		try {
			command.executeModal();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			MessageBox.post("дƼƻʧܣ", "", MessageBox.ERROR);
		}
		return null;
	}

}
