package com.connor.zf.controlplanlibrary;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;

import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;



public class CTable extends JTable {
	Map<Point, TableCellEditor> map;
	TableCellTextAreaRenderer renderer = new TableCellTextAreaRenderer();
	TextAreaCellEditor cellEditor = new TextAreaCellEditor();
	ComboBoxCellEditor comboBoxCellEditor = new ComboBoxCellEditor(
			new Object[] { 2, 3, 4, 5, 6, 7, 8, 9, 10 });
	TCSession session;
	boolean isaddEn;
//	ComboBoxCellEditor gaugeComboBoxCellEditor = new ComboBoxCellEditor(TMomMethodUtil.getPreferenceValues("RB3_GAUGE_VALUES"));
//	ComboBoxCellEditor frequencyComboBoxCellEditor = new ComboBoxCellEditor(TMomMethodUtil.getPreferenceValues("RB3_FREQUENCY_VALUES"));
//	
//	ComboBoxCellEditor owningComboBoxCellEditor = new ComboBoxCellEditor(TMomMethodUtil.getPreferenceValues("RB3_OWNING_VALUES"));
//	ComboBoxCellEditor reactionPlanComboBoxCellEditor = new ComboBoxCellEditor(TMomMethodUtil.getPreferenceValues("RB3_REACTION_VALUES"));
//	ComboBoxCellEditor controlMethodComboBoxCellEditor = new ComboBoxCellEditor(TMomMethodUtil.getPreferenceValues("RB3_CONTROLMETHOD_VALUES"));
	public CTable(TableModel model,TCSession session,boolean isaddEn) {
		super(model);
		setUI(new CTUI());
		this.session=session;
		this.isaddEn=isaddEn;
		getTableHeader().setReorderingAllowed(false);
		setCellSelectionEnabled(true);
		setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
//		// Ӽ̼
//		this.addKeyListener(new KeyAdapter() {
//			@Override
//			public void keyPressed(KeyEvent arg0) {
//				// TODO Auto-generated method stub
//				if(arg0.getKeyChar() == KeyEvent.VK_DELETE)
//				{
//					int[] selectRows = CTable.this.getSelectedRows();
//					int[] selectColumns = CTable.this.getSelectedColumns();
//					for (int i = 0; i < selectRows.length; i++) {
//						for (int j = 0; j < selectColumns.length; j++) {
//							CTable.this.setValueAt("", selectRows[i], selectColumns[j]);
//						}
//					}
//				}
//				super.keyPressed(arg0);
//			}
//		});
		map = new HashMap();
	}

	public String getToolTipText(MouseEvent e) {
		int row = this.rowAtPoint(e.getPoint());
		int col = this.columnAtPoint(e.getPoint());
		String tiptextString = null;
		if (row > -1 && col > -1) {
			Object value = this.getValueAt(row, col);
			if (null != value && !"".equals(value))
				tiptextString = value.toString();// ʾԪ
		}
		return tiptextString;
	}

	// @Override
	// protected void processKeyEvent(KeyEvent keyevent) {
	// // TODO Auto-generated method stub
	// if(keyevent.getKeyCode()==KeyEvent.VK_ENTER){
	// if(keyevent.isControlDown())
	// {
	// System.out.println(1);
	// }
	// this.editCellAt(this.getSelectedRow(),this.getSelectedColumn());
	// }
	// }

	public Rectangle getCellRect(int row, int column, boolean includeSpacing) {
		Rectangle sRect = super.getCellRect(row, column, includeSpacing);
		if ((row < 0) || (column < 0) || (getRowCount() <= row)
				|| (getColumnCount() <= column)) {
			return sRect;
		}
		CellSpan cellAtt = (CellSpan) getModel();
		if (!cellAtt.isVisible(row, column)) {
			int temp_row = row;
			int temp_column = column;
			row += cellAtt.getSpan(temp_row, temp_column)[CellSpan.ROW];
			column += cellAtt.getSpan(temp_row, temp_column)[CellSpan.COLUMN];
		}
		int[] n = cellAtt.getSpan(row, column);

		int index = 0;
		int columnMargin = getColumnModel().getColumnMargin();
		Rectangle cellFrame = new Rectangle();
		int aCellHeight = rowHeight + rowMargin;
		cellFrame.y = row * aCellHeight;
		cellFrame.height = n[CellSpan.ROW] * aCellHeight;

		Enumeration eeration = getColumnModel().getColumns();
		while (eeration.hasMoreElements()) {
			TableColumn aColumn = (TableColumn) eeration.nextElement();
			cellFrame.width = aColumn.getWidth();
			if (index == column)
				break;
			cellFrame.x += cellFrame.width;
			index++;
		}
		for (int i = 0; i < n[CellSpan.COLUMN] - 1; i++) {
			TableColumn aColumn = (TableColumn) eeration.nextElement();
			cellFrame.width += aColumn.getWidth() + columnMargin;
		}

		if (!includeSpacing) {
			Dimension spacing = getIntercellSpacing();
			cellFrame.setBounds(cellFrame.x + spacing.width / 2, cellFrame.y
					+ spacing.height / 2, cellFrame.width - spacing.width,
					cellFrame.height - spacing.height);
		}
		return cellFrame;
	}

	// 
	public void HiddenCell(int column) {
		TableColumn tc = this.getTableHeader().getColumnModel()
				.getColumn(column);
		tc.setMaxWidth(0);
		tc.setPreferredWidth(0);
		tc.setWidth(0);
		tc.setMinWidth(0);
		this.getTableHeader().getColumnModel().getColumn(column).setMaxWidth(0);
		this.getTableHeader().getColumnModel().getColumn(column).setMinWidth(0);
	}

	private int[] rowColumnAtPoint(Point point) {
		int[] retValue = { -1, -1 };
		int row = point.y / (rowHeight + rowMargin);
		if ((row < 0) || (getRowCount() <= row))
			return retValue;
		int column = getColumnModel().getColumnIndexAtX(point.x);

		CellSpan cellAtt = (CellSpan) getModel();

		if (cellAtt.isVisible(row, column)) {
			retValue[CellSpan.COLUMN] = column;
			retValue[CellSpan.ROW] = row;
			return retValue;
		}
		retValue[CellSpan.COLUMN] = column
				+ cellAtt.getSpan(row, column)[CellSpan.COLUMN];
		retValue[CellSpan.ROW] = row
				+ cellAtt.getSpan(row, column)[CellSpan.ROW];
		return retValue;
	}

	public int rowAtPoint(Point point) {
		return rowColumnAtPoint(point)[CellSpan.ROW];
	}

	public int columnAtPoint(Point point) {
		return rowColumnAtPoint(point)[CellSpan.COLUMN];
	}

	public void columnSelectionChanged(ListSelectionEvent e) {
		repaint();
	}

	public void valueChanged(ListSelectionEvent e) {
		int firstIndex = e.getFirstIndex();
		int lastIndex = e.getLastIndex();
		if (firstIndex == -1 && lastIndex == -1) { // Selection cleared.
			repaint();
		}
		Rectangle dirtyRegion = getCellRect(firstIndex, 0, false);
		int numCoumns = getColumnCount();
		int index = firstIndex;
		for (int i = 0; i < numCoumns; i++) {
			dirtyRegion.add(getCellRect(index, i, false));
		}
		index = lastIndex;
		for (int i = 0; i < numCoumns; i++) {
			dirtyRegion.add(getCellRect(index, i, false));
		}
		repaint(dirtyRegion.x, dirtyRegion.y, dirtyRegion.width,
				dirtyRegion.height);
	}

	public void setCombo(int row, int col, TableCellEditor ce) {
		map.put(new Point(row, col), ce);
	}

	@Override
	public TableCellEditor getCellEditor(int row, int column) {

		if(isaddEn) {
			if(column==6) {
				TCPreferenceService service = session.getPreferenceService();
				String[] strs = service.getStringValues("ZF6_KZJH_TSTX"); 
				
				String[] strss=new String[strs.length];
				for(int i=0;i<strss.length;i++) {
					strss[i]=strs[i].split(":")[0];
				}
				JComboBox tubePurposeBox = new JComboBox(strss);
				TableCellEditor tubePurposeCellEditor = new DefaultCellEditor(tubePurposeBox);
				return tubePurposeCellEditor;
			}else if(column==9) {
				TCPreferenceService service = session.getPreferenceService();
				String[] strs = service.getStringValues("ZF6_KZJH_XM"); 
				JComboBox tubePurposeBox = new JComboBox(strs);
				TableCellEditor tubePurposeCellEditor = new DefaultCellEditor(tubePurposeBox);
				return tubePurposeCellEditor;
			}
			return cellEditor;
		}
		else {
			return cellEditor;
		}
		
	
//		if (this.getColumnName(column).equals("ضS")
//				|| this.getColumnName(column).equals("ƵO")
//				|| this.getColumnName(column).equals("̽D")) {
//			return comboBoxCellEditor;
//		}
//		else if (this.getColumnName(column).equals("New_SEV")
//				|| this.getColumnName(column).equals("New_OCC")
//				|| this.getColumnName(column).equals("New_DET")) {
//			return comboBoxCellEditor;
//		} 
//		else if (this.getColumnName(column).equals("/"))
//		{
//			gaugeComboBoxCellEditor.setEditable(true);
//			return gaugeComboBoxCellEditor;	
//		}
//		else if (this.getColumnName(column).equals("Ƶ"))
//		{
//			frequencyComboBoxCellEditor.setEditable(true);
//			return frequencyComboBoxCellEditor;	
//		}
//		else if (this.getColumnName(column).equals("")) {
//			owningComboBoxCellEditor.setEditable(true);
//			return owningComboBoxCellEditor;
//		}
//		else if (this.getColumnName(column).equals("Ʒ")) {
//			controlMethodComboBoxCellEditor.setEditable(true);
//			return controlMethodComboBoxCellEditor;
//		}
//		else if (this.getColumnName(column).equals("Ӧƻ")) {
//			reactionPlanComboBoxCellEditor.setEditable(true);
//			return reactionPlanComboBoxCellEditor;
//		} 
//		else {
//			return cellEditor;
//		}
		// Point point = new Point(row,column);
		// if(map.containsKey(point)){
		// return map.get(point);
		// }else{
		// return super.getCellEditor(row, column);
		// }
	}

	@Override
	public TableCellRenderer getCellRenderer(int row, int column) {
		// TODO Auto-generated method stub
		return renderer;
	}

	public void setRowHeight(int row, int rowHeight) {
		super.setRowHeight(row, rowHeight);
	}

	// @Override
	// public boolean isCellSelected(int i, int j) {
	// if( i == 1 || i == 3)
	// {
	// //this.clearSelection();
	// return false;
	// }
	// else
	// {
	// return super.isCellSelected(i, j);
	// }
	// }

}