package com.connor.zf.controlplanlibrary;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Properties;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import com.connor.renben.process.plm.util.Adapter;
import com.connor.renben.process.plm.util.DraggableTabbedPane;
import com.connor.zf.controlplan.SqlUtilT;
import com.connor.zf.controlplan.TreeBean;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFCommand;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCSession;

public class TMom012ControlPlanLibraryCommand extends AbstractAIFCommand {

	private TCSession session;
	private AbstractAIFApplication app;
	private String commandId;
	private String titleName = "Ƽƻ";
	private String titleLabel = "CONTROL PLAN/Ƽƻ";
	private InterfaceAIFComponent comp;
	private TCComponent form;
	private boolean isOwning = false;
	// private List<List<Integer>> processRowList = new
	// ArrayList<List<Integer>>();
	private TCComponentUser user;// ǰ¼û
	private List<List<Object>> dataList = new ArrayList<List<Object>>();// е
	private Properties pro = new Properties();
	private String[] header = new String[] {"PLMEID", "ID",
			"װáоߡװ","", "Ʒ","","Է", "Ʒ//淶/", 
			"", "Ŀ","","Ƶ","", "Ʒ","Ӧƻ","ڵPLMEID" };
	// ǩҳ
	// private JTabbedPane tabbedPane;
	// private DraggableTabbedPane tabbedPane;
	private List<TreeBean> beans = new ArrayList<TreeBean>();

	public TMom012ControlPlanLibraryCommand() {
		super();
	}

	public TMom012ControlPlanLibraryCommand(AbstractAIFApplication app, TCSession session, String commandId) {
		this.session = session;
		this.app = app;
		this.commandId = commandId;
		this.comp = app.getTargetComponent();
		this.user = session.getUser();
	}

	
	/**
	 * ȡݿе
	 */
	private void getData() {
		// TODO Auto-generated method stub
		ResultSet rs = null;
		InputStream input = null;
		try {
			// ȡݿ
			SqlUtilT.getTCConnection();
			String sql = "select * from ZF6_CONTROLPLANLIBRARYTREE order by ID ";
			// String sql = String.format("select * from RB3_CONTROLPLAN_TREE");
			rs = SqlUtilT.read(sql);
			while (rs.next()) {
				TreeBean bean = new TreeBean();
				bean.setPlmeid(rs.getString("PLMEID"));
				bean.setId(rs.getString("ID"));
				bean.setName(rs.getString("NAME"));
				beans.add(bean);
			}
			Collections.sort(beans, new NaturalOrderComparator<>(true));
			beans.forEach(item -> System.out.println(item));
			// createTabbedPane(beans);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}
	}

	class NaturalOrderComparator<T> implements Comparator<T> {

		private final boolean caseInsensitive;

		public NaturalOrderComparator(boolean caseInsensitive) {
			this.caseInsensitive = caseInsensitive;
		}

		private int compareRight(String a, String b) {
			int bias = 0;
			int ia = 0;
			int ib = 0;
			for (; ; ia++, ib++) {
				char ca = charAt(a, ia);
				char cb = charAt(b, ib);

				if (!Character.isDigit(ca) && !Character.isDigit(cb)) {
					return bias;
				} else if (!Character.isDigit(ca)) {
					return -1;
				} else if (!Character.isDigit(cb)) {
					return +1;
				} else if (ca < cb) {
					if (bias == 0) {
						bias = -1;
					}
				} else if (ca > cb) {
					if (bias == 0) {
						bias = +1;
					}
				} else if (ca == 0 && cb == 0) {
					return bias;
				}
			}
		}

		@Override
		public int compare(T o1, T o2) {
			
			TreeBean bean1 = (TreeBean)o1;
			TreeBean bean2 = (TreeBean)o2;
			
			String a = bean1.getId();
			String b = bean2.getId();
			int ia = 0, ib = 0;
			int nza = 0, nzb = 0;
			char ca, cb;
			int result;
			while (true) {
				nza = nzb = 0;
				ca = charAt(a, ia);
				cb = charAt(b, ib);

				while (ca == '0') {
					nza++;
					if (!Character.isDigit(charAt(a, ia + 1))) {
						break;
					}
					ca = charAt(a, ++ia);
				}
				while (cb == '0') {
					nzb++;
					if (!Character.isDigit(charAt(b, ib + 1))) {
						break;
					}
					cb = charAt(b, ++ib);
				}

				if (Character.isDigit(ca) && Character.isDigit(cb)) {
					if ((result = compareRight(a.substring(ia), b.substring(ib))) != 0) {
						return result;
					}
				}
				if (ca == 0 && cb == 0) {
					return nza - nzb;
				}
				if (ca < cb) {
					return -1;
				} else if (ca > cb) {
					return +1;
				}
				++ia;
				++ib;
			}
		}

		private char charAt(String s, int i) {
			if (i >= s.length()) {
				return 0;
			} else {
				return caseInsensitive ? Character.toUpperCase(s.charAt(i)) : s.charAt(i);
			}
		}
	}

	@Override
	public void executeModal() throws Exception {
		// ȡ汾
		try {
			InputStream input = null;
			// ȡSQL
			input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
			pro.load(input);
			// ȡνṹڵ
			getData();
			new Thread() {
				@Override
				public void run() {
					TMom012ControlPlanLibraryDialog dislog = new TMom012ControlPlanLibraryDialog(app, session,
							commandId, form, beans, header, isOwning, titleName, titleLabel);
				}
			}.start();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		super.executeModal();
	}
}
