package com.connor.zf.controlplanlibrary;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Locale;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.UUID;
import com.connor.zf.controlplan.SqlUtilT;
import com.connor.zf.controlplan.TreeBean;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.ListSelectionModel;
import javax.swing.RowSorter;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

import com.connor.renben.process.plm.util.Adapter;
import com.connor.renben.process.plm.util.MyTableModel;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;

public class TMom012ControlPlanLibraryDialog extends JFrame
		implements ActionListener {

	private AbstractAIFApplication app;
	private TCSession session;
	private String titleName;
	private String title;
	private String commandId;
	private String[] header2 = new String[]{"PLMEID","ID",""};
	private String[] header;
	private List<String> deleteRows = new ArrayList<String>();
	private List<TreeBean> beans;
	private int index = -1;
	private boolean isMeopSave = false;
	private SpecialDialog specialDialog;
	private String nodeName;// ڵ
	private String nodeID;// ڵ
	private int selectRow = -1;
	private int selectColumn = -1;
	//жϵԪʾǷȡ
	private boolean isFocusOwner = false;
	// ؼ
	private JPanel titlePanel;// 
	private JLabel titleLabel;
	private JTextPane selectCellValuePane;
	//
	private CTable leftTable;
	private CTable mainTable;

	//Ҽ˵
	private static JPopupMenu mainMenu;
	private JMenuItem addItem;
	private JMenuItem addItems;
	private JMenuItem remItem;
	private static JPopupMenu leftMenu;
	private JMenuItem addNodeItem;
	private JMenuItem remNodeItem;
	private JMenuItem updateNodItem;
	private JMenuItem shrinkColumnItem;
	private JMenuItem celShrinkColumnItem;
	
	private JPanel rootPanel;// ť
	//private JButton addButton;// 
	//private JButton addNodeButton;// ӽڵ
	//private JButton remButton;// Ƴ
	//private JButton remNodeButton;// Ƴڵ
	private JButton saveButton;// 
	//private JButton addSpecialButton;// 


	public TMom012ControlPlanLibraryDialog(AbstractAIFApplication app,
			TCSession session, String commandId, TCComponent form,
			List<TreeBean> beans, String[] header, boolean isOwning,
			String titleName, String title) {
		super();
		this.beans = beans;
		this.app = app;
		this.session = session;
		this.commandId = commandId;
		this.titleName = titleName;
		this.title = title;
		this.header = header;
		init();
	}

	private void init() {
		this.setTitle(this.titleName);
		this.setPreferredSize(new Dimension(800, 600));
		// ʼⲿֿؼ
		this.titlePanel = new JPanel();
		this.titleLabel = new JLabel(this.title);
		this.titleLabel.setFont(new Font("", 1, 18));
		this.titlePanel.add(titleLabel);

		this.leftTable = getNewjTable(null, null, header2, beans.size());
		
		// 
		leftTable.HiddenCell(0);
		leftTable.setRowHeight(30);
		//п
		leftTable.getColumnModel().getColumn(2)
				.setPreferredWidth(200);
		// 
		leftTable.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent mouseevent) {
				// TODO Auto-generated method stub
				if(mouseevent.getButton() == MouseEvent.BUTTON3)
				{
					leftMenu.show(leftTable, mouseevent.getX(), mouseevent.getY());
				}
			}
		});
		for (int i = 0; i < beans.size(); i++) {
			this.leftTable.setValueAt(beans.get(i).getPlmeid(), i, 0);
			this.leftTable.setValueAt(beans.get(i).getId(), i, 1);
			this.leftTable.setValueAt(beans.get(i).getName(), i, 2);
		}
		leftTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				// TODO Auto-generated method stub
				if(index == -1)
				{
					refreshTable();
					index = leftTable.getSelectedRow();
				}
				else if(index != -1 && index != leftTable.getSelectedRow())
				{
					if (mainTable.getSelectedRow() >= 0
							&& mainTable.getSelectedColumn() >= 0) {
						(mainTable.getCellEditor(mainTable.getSelectedRow(),
								mainTable.getSelectedColumn())).stopCellEditing();
					}
					if(isMeopSave)
					{
						okEvent(true);
						refreshTable();
						index = leftTable.getSelectedRow();
					}else {
						refreshTable();
						index = leftTable.getSelectedRow();
					}
					
				}
			}
		});
		this.mainTable = getNewjTable(null, null, header, 0);
		// 
			mainTable.HiddenCell(0);
			mainTable.HiddenCell(header.length - 1);
		// 
		mainTable.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent mouseevent) {
				// TODO Auto-generated method stub
				if (mouseevent.getClickCount() ==1) {
					((CTMap)mainTable.getModel()).setRow(mainTable.getSelectedRow());
					((CTMap)mainTable.getModel()).setColumn(mainTable.getSelectedColumn());
					
					if(isFocusOwner && selectRow != -1 && selectColumn != -1)
					{
						mainTable.setValueAt(selectCellValuePane.getText(), selectRow, selectColumn);
					}
					
					if(mainTable.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()) != null)
					{
						selectCellValuePane.setText("");
						selectCellValuePane.setText(mainTable.getValueAt(mainTable.getSelectedRow(), mainTable.getSelectedColumn()).toString());
					}
					else
					{
						selectCellValuePane.setText("");
					}
				}
				selectRow = mainTable.getSelectedRow();
				selectColumn = mainTable.getSelectedColumn();
				isFocusOwner = false;
				if(mouseevent.getButton() == MouseEvent.BUTTON3)
				{
					mainMenu.show(mainTable, mouseevent.getX(), mouseevent.getY());
				}
			}
		});
		mainTable.getModel().addTableModelListener(new TableModelListener() {
			
			@Override
			public void tableChanged(TableModelEvent tablemodelevent) {
				// TODO Auto-generated method stub
				if(tablemodelevent.getType() == TableModelEvent.UPDATE){
					isMeopSave = true;
					System.out.println("ִʧȥ");
					(mainTable.getCellEditor(mainTable.getSelectedRow(),
							mainTable.getSelectedColumn())).stopCellEditing();
				}
			}
		});
		mainTable.addKeyListener(new KeyAdapter() {
			
			@Override
			public void keyPressed(KeyEvent arg0) {
				// TODO Auto-generated method stub
				//delete
				if (arg0.getKeyChar() == KeyEvent.VK_DELETE) {
					int[] selectRows = mainTable.getSelectedRows();
					int[] selectColumns = mainTable.getSelectedColumns();
					
					for (int i = 0; i < selectRows.length; i++) {
						
						for (int j = 0; j < selectColumns.length; j++) {
							if(selectColumns.length==mainTable.getColumnCount()) {//Ctrl+Aȫѡʱ
								if(j>0&&j<mainTable.getColumnCount()-1) {
									mainTable.setValueAt("", selectRows[i], selectColumns[j]);
									
									}
							}else {
//								(mainTable.getCellEditor(selectRows[i],
//										selectColumns[j])).stopCellEditing();
								mainTable.setValueAt("", selectRows[i], selectColumns[j]);
								System.out.println("ִв");
								
							}
						}
					}
					
				}
				
				super.keyPressed(arg0);
			}
		});
		this.selectCellValuePane = new JTextPane();
		this.selectCellValuePane.addFocusListener(new FocusListener() {
			//private int row;
			//private int column;
			@Override
			public void focusLost(FocusEvent focusevent) {
				// TODO Auto-generated method stub
//				if(selectRow != -1 && selectColumn != -1)
//				{
//					mainTable.setValueAt(selectCellValuePane.getText(), selectRow, selectColumn);
//				}
			}
			
			@Override
			public void focusGained(FocusEvent focusevent) {
				// TODO Auto-generated method stub
				isFocusOwner = true;
				//this.row = mainTable.getSelectedRow();
				//this.column = mainTable.getSelectedColumn();
			}
		});
		selectCellValuePane.setPreferredSize(new Dimension(700, 40));
		
		Adapter adapter = new Adapter(mainTable);
		JScrollPane scrollPane = new JScrollPane(mainTable);
		scrollPane.getVerticalScrollBar().setUnitIncrement(2);
		JScrollPane scrollPane2 = new JScrollPane(leftTable);
		scrollPane2.setPreferredSize(new Dimension(300, 600));
		scrollPane2.getVerticalScrollBar().setUnitIncrement(2);
		
//		JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
//		splitPane.setOneTouchExpandable(true);// ÷ָʾͷ
//		splitPane.setContinuousLayout(true);// ͷػͼ
//		splitPane.setTopComponent(new JScrollPane(selectCellValuePane));
//		splitPane.setBottomComponent(scrollPane);
		
		JSplitPane splitPane2 = new JSplitPane();
		splitPane2.setOneTouchExpandable(true);// ÷ָʾͷ
		splitPane2.setContinuousLayout(true);// ͷػͼ
		splitPane2.setLeftComponent(scrollPane2);
		splitPane2.setRightComponent(scrollPane);

		this.mainMenu = new JPopupMenu();
		this.addItem = new JMenuItem("");
		this.addItems = new JMenuItem("Ӷ");
		this.remItem = new JMenuItem("Ƴ");
		this.shrinkColumnItem = new JMenuItem("Сѡ");
		this.celShrinkColumnItem = new JMenuItem("ȡСѡ");
		this.mainMenu.add(this.addItem);
		this.mainMenu.add(this.addItems);
		this.mainMenu.add(this.remItem);
		this.mainMenu.add(this.shrinkColumnItem);
		this.mainMenu.add(this.celShrinkColumnItem);
		
		this.leftMenu = new JPopupMenu();
		this.addNodeItem = new JMenuItem("ӽڵ");
		this.remNodeItem = new JMenuItem("Ƴڵ");
		this.updateNodItem = new JMenuItem("½ڵ");
		this.leftMenu.add(this.addNodeItem);
		this.leftMenu.add(this.remNodeItem);
		this.leftMenu.add(this.updateNodItem);
		
		this.rootPanel = new JPanel(new FlowLayout());
//		this.addNodeButton = new JButton("ӽڵ");
//		this.addButton = new JButton("");
//		this.remButton = new JButton("Ƴ");
//		this.remNodeButton = new JButton("Ƴڵ");
		this.saveButton = new JButton("");
		//this.addSpecialButton = new JButton("");
//		this.rootPanel.add(addNodeButton);
//		this.rootPanel.add(addButton);
//		this.rootPanel.add(remButton);
//		this.rootPanel.add(remNodeButton);
		this.rootPanel.add(new JScrollPane(selectCellValuePane));
		this.rootPanel.add(saveButton);
		//this.rootPanel.add(addSpecialButton);

		JPanel centerPanel = new JPanel(new BorderLayout());
		centerPanel.add(titlePanel, BorderLayout.NORTH);

		// 
		this.createActionEvent();
		this.setLayout(new BorderLayout());
		this.add(centerPanel, BorderLayout.NORTH);
		this.add(splitPane2, BorderLayout.CENTER);
		this.add(rootPanel, BorderLayout.SOUTH);
		this.pack();
		this.show();

	}
	
	
	private void refreshTable() {
		System.out.println("--------ˢ-------");
		// TODO Auto-generated method stub
		//ˢҲ
		ResultSet rs = null;
		InputStream input = null;
		try {
			
			SqlUtilT.getTCConnection();
			
			String sql = String.format("select * from ZF6_CONTROLPLANLIBRARY where PARENTPLMEID = \'%s\' order by CAST(ID AS INT)", leftTable.getValueAt(leftTable.getSelectedRow(), 0));
			rs = SqlUtilT.read(sql);
			List<List<String>> rowList = new ArrayList<List<String>>();
			while (rs.next()) {
				List<String> list = new ArrayList<String>();
				list.add(rs.getString("PLMEID"));
				list.add(rs.getString("ID"));
				list.add(rs.getString("JQZHJJGZ"));
				list.add(rs.getString("BH"));
				list.add(rs.getString("CP"));
				list.add(rs.getString("GC"));
				list.add(rs.getString("TSTXFL"));
				list.add(rs.getString("CPGC"));
				list.add(rs.getString("JSCLJS"));
				list.add(rs.getString("XM"));
				list.add(rs.getString("RL"));
				list.add(rs.getString("PL"));
				list.add(rs.getString("ZRR"));
				list.add(rs.getString("KZFF"));
				list.add(rs.getString("FYJH"));
				list.add(rs.getString("PARENTPLMEID"));
				rowList.add(list);
			}
			if (rowList.size() > 0) {
				CTMap map = new CTMap(rowList.size(),header.length);
				map.setColumnIdentifiers(header);
				map.setEditable(true);
				mainTable.setModel(map);
				mainTable.getColumnModel().getColumn(2)
				.setPreferredWidth(300);
				for (int j = 0; j < rowList.size(); j++) {
					for (int k = 0; k < rowList.get(j).size(); k++) {
						mainTable.setValueAt(rowList.get(j).get(k), j, k);
					}
				}
				map.addTableModelListener(new TableModelListener() {
					
					@Override
					public void tableChanged(TableModelEvent tablemodelevent) {
						// TODO Auto-generated method stub
						if(tablemodelevent.getType() == TableModelEvent.UPDATE){
							isMeopSave = true;
						}
					}
				});
			} else {
				CTMap map = new CTMap(1,header.length);
				map.setColumnIdentifiers(header);
				map.setEditable(true);
				mainTable.setModel(map);
				mainTable.getColumnModel().getColumn(2)
				.setPreferredWidth(300);
				map.setValueAt(leftTable.getValueAt(leftTable.getSelectedRow(), 0), 0,
						mainTable.getColumnCount() - 1);
				map.addTableModelListener(new TableModelListener() {
					
					@Override
					public void tableChanged(TableModelEvent tablemodelevent) {
						// TODO Auto-generated method stub
						if(tablemodelevent.getType() == TableModelEvent.UPDATE){
							isMeopSave = true;
						}
					}
				});
			}
			mainTable.HiddenCell(0);
			mainTable.HiddenCell(header.length - 1);
//			mainTable.HiddenCell(header.length - 2);
			mainTable.invalidate();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			System.out.println("-------ˢݹر----------");
			 SqlUtilT.freeAll();
		}
	}
	
	
	
	/**
	 * 
	 */
	private void refreshLeftTable() {
		// TODO Auto-generated method stub
		//ˢҲ
		ResultSet rs = null;
		InputStream input = null;
		try {
			
			SqlUtilT.getTCConnection();
			
			String sql = "select * from ZF6_CONTROLPLANLIBRARYTREE order by ID";
			rs = SqlUtilT.read(sql);
			List<TreeBean> bneanList = new ArrayList<TreeBean>();
			while (rs.next()) {
				TreeBean bean = new TreeBean();
				bean.setPlmeid(rs.getString("PLMEID"));
				bean.setId(rs.getString("ID"));
				bean.setName(rs.getString("NAME"));
				bneanList.add(bean);
			}
			Collections.sort(bneanList, new NaturalOrderComparator<>(true));
			bneanList.forEach(item -> System.out.println(item));
			if (bneanList.size() > 0) {
				CTMap map = new CTMap(bneanList.size(),header2.length);
				map.setColumnIdentifiers(header2);
				//map.setEditable(true);
				leftTable.setModel(map);
				leftTable.setRowHeight(30);
				leftTable.getColumnModel().getColumn(2)
				.setPreferredWidth(200);
				for (int i = 0; i < bneanList.size(); i++) {
					this.leftTable.setValueAt(bneanList.get(i).getPlmeid(), i, 0);
					this.leftTable.setValueAt(bneanList.get(i).getId(), i, 1);
					this.leftTable.setValueAt(bneanList.get(i).getName(), i, 2);
				}
			}
			leftTable.HiddenCell(0);
			leftTable.invalidate();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			 SqlUtilT.freeAll();
		}
	}
	
	class NaturalOrderComparator<T> implements Comparator<T> {

		private final boolean caseInsensitive;

		public NaturalOrderComparator(boolean caseInsensitive) {
			this.caseInsensitive = caseInsensitive;
		}

		private int compareRight(String a, String b) {
			int bias = 0;
			int ia = 0;
			int ib = 0;
			for (; ; ia++, ib++) {
				char ca = charAt(a, ia);
				char cb = charAt(b, ib);

				if (!Character.isDigit(ca) && !Character.isDigit(cb)) {
					return bias;
				} else if (!Character.isDigit(ca)) {
					return -1;
				} else if (!Character.isDigit(cb)) {
					return +1;
				} else if (ca < cb) {
					if (bias == 0) {
						bias = -1;
					}
				} else if (ca > cb) {
					if (bias == 0) {
						bias = +1;
					}
				} else if (ca == 0 && cb == 0) {
					return bias;
				}
			}
		}

		@Override
		public int compare(T o1, T o2) {
			
			TreeBean bean1 = (TreeBean)o1;
			TreeBean bean2 = (TreeBean)o2;
			
			String a = bean1.getId();
			String b = bean2.getId();
			int ia = 0, ib = 0;
			int nza = 0, nzb = 0;
			char ca, cb;
			int result;
			while (true) {
				nza = nzb = 0;
				ca = charAt(a, ia);
				cb = charAt(b, ib);

				while (ca == '0') {
					nza++;
					if (!Character.isDigit(charAt(a, ia + 1))) {
						break;
					}
					ca = charAt(a, ++ia);
				}
				while (cb == '0') {
					nzb++;
					if (!Character.isDigit(charAt(b, ib + 1))) {
						break;
					}
					cb = charAt(b, ++ib);
				}

				if (Character.isDigit(ca) && Character.isDigit(cb)) {
					if ((result = compareRight(a.substring(ia), b.substring(ib))) != 0) {
						return result;
					}
				}
				if (ca == 0 && cb == 0) {
					return nza - nzb;
				}
				if (ca < cb) {
					return -1;
				} else if (ca > cb) {
					return +1;
				}
				++ia;
				++ib;
			}
		}

		private char charAt(String s, int i) {
			if (i >= s.length()) {
				return 0;
			} else {
				return caseInsensitive ? Character.toUpperCase(s.charAt(i)) : s.charAt(i);
			}
		}
	}
	// Ӽ
	public void createActionEvent() {
		this.addItem.addActionListener(this);
		this.addItems.addActionListener(this);
		this.addNodeItem.addActionListener(this);
		this.updateNodItem.addActionListener(this);
		this.shrinkColumnItem.addActionListener(this);
		this.celShrinkColumnItem.addActionListener(this);
		this.remItem.addActionListener(this);
		this.remNodeItem.addActionListener(this);
		this.saveButton.addActionListener(this);
		//this.addSpecialButton.addActionListener(this);
	}

	// Jtableͨ÷
	public CTable getNewjTable(CTable partsTable, DefaultTableModel dtm,
			Object[] titleNames, int rows) {
		int simpleLen = 100;
		int totleLen = 100;
		if (partsTable == null) {
			CTMap map;
			if(rows==0) {
				map = new CTMap(rows+1, titleNames.length);
			}else {
				map = new CTMap(rows, titleNames.length);
			}
			
			//CTMap map = new CTMap(rows, titleNames.length);
			map.setColumnIdentifiers(titleNames);
			map.setEditable(false);
			partsTable = new CTable(map,session,true);
			partsTable.setRowHeight(50);
			//partsTable.HiddenCell(0);
			// 
			//partsTable.HiddenCell(titleNames.length - 1);
			// partsTable.HiddenCell(titleNames.length-2);
			// partsTable.setRowHeight(1, 50);
			TableCellTextAreaRenderer2 renderer = new TableCellTextAreaRenderer2();
			partsTable.setDefaultRenderer(Object.class, renderer);
			if (simpleLen * titleNames.length >= totleLen) {
				for (int i = 0; i < titleNames.length; i++) {
					partsTable.getColumnModel().getColumn(i)
							.setPreferredWidth(simpleLen);
				}
				partsTable.setAutoResizeMode(0);
			} else {
				partsTable.setAutoResizeMode(1);
			}
		}
		return partsTable;
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		Object source = arg0.getSource();
		if (source.equals(this.addItem)) {
//			Component component = tabbedPane.getSelectedComponent();
//			if (component instanceof JScrollPane) {
//				JScrollPane scrollPane = (JScrollPane) component;
//				Component tableComponent = scrollPane.getViewport().getView();
//				if (tableComponent instanceof CTable) {
					CTable table = this.mainTable;
					if (table.getSelectedRow() > -1) {
						((CTMap) table.getModel()).insertRow(table
								.getSelectedRow() + 1);
						
							table.setValueAt(
									table.getValueAt(table.getSelectedRow(),
											table.getColumnCount() - 1),
									table.getSelectedRow() + 1,
									table.getColumnCount() - 1);
							
						table.revalidate();
						table.repaint();
						//this.tabbedPane.updateUI();
					}
//				}
//			}
		}  else if (source.equals(this.addItems)) {
			CTable table = this.mainTable;
			AddRowsDialog addRowsDialog = new AddRowsDialog(table);
		}
		else if (source.equals(this.addNodeItem)) {
			
			
			final JFrame frame = new JFrame();
			frame.setLocationRelativeTo(this);
			frame.setSize(new Dimension(400, 200));
			JLabel label = new JLabel("ڵ");
			final JTextField field = new JTextField(20);
			JLabel idlabel = new JLabel("ڵID");
			final JTextField idfield = new JTextField(20);
			JButton okButton = new JButton("ȷ");
			okButton.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent arg0) {
					// TODO Auto-generated method stub
					nodeName = field.getText();
					nodeID = idfield.getText();
					// node.add(new DefaultMutableTreeNode("ս"));
					String selectSql = "";
					String insterSql = "insert into ZF6_CONTROLPLANLIBRARYTREE values(?,?,?)";
						
					try {
//						SqlUtilT.getTCConnection();
//						rs = SqlUtilT.read(selectSql);
//						while (rs.next()) {
//							id = rs.getString("id");
//						}
						UUID uid = UUID.randomUUID();
						TreeBean bean = new TreeBean();
						bean.setPlmeid(uid.toString().replace("-", ""));
						bean.setId(nodeID);
						bean.setName(nodeName);
					//	tabbedPane.add(nodeName, new JScrollPane(table));
						// ȡݿ
						SqlUtilT.getTCConnection();
						SqlUtilT.write(
								new String[] { uid.toString().replace("-", ""),
										nodeID, nodeName},
								insterSql);
							refreshLeftTable();
							
						frame.dispose();
						//tabbedPane.updateUI();
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} finally {
						SqlUtilT.freeAll();
					}
				}
			});
			JButton celButton = new JButton("ȡ");
			celButton.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent arg0) {
					frame.dispose();
				}
			});
			JPanel jPanel = new JPanel(new PropertyLayout());
			jPanel.add("1.1.left.top", idlabel);
			jPanel.add("1.2.left.top", idfield);
			jPanel.add("2.1.left.top", label);
			jPanel.add("2.2.left.top", field);
			JPanel rootJPanel = new JPanel(new FlowLayout());
			rootJPanel.add(okButton);
			rootJPanel.add(celButton);
			JPanel panel = new JPanel(new BorderLayout());
			panel.add(new JScrollPane(jPanel), BorderLayout.CENTER);
			panel.add(rootJPanel, BorderLayout.SOUTH);
			frame.add(panel);
			frame.show();
		}else if (source.equals(this.updateNodItem)) {
			CTable table = this.leftTable;
			final JFrame frame = new JFrame();
			frame.setLocationRelativeTo(this);
			frame.setSize(new Dimension(400, 200));
			JLabel label = new JLabel("ڵ");
			final JTextField field = new JTextField(20);
			field.setText(table.getValueAt(table.getSelectedRow(), 2) == null ? "": table.getValueAt(table.getSelectedRow(), 2).toString());
			JLabel idlabel = new JLabel("ڵID");
			final JTextField idfield = new JTextField(20);
			idfield.setText(table.getValueAt(table.getSelectedRow(),1 ) == null ? "" : table.getValueAt(table.getSelectedRow(),1 ).toString());
			JButton okButton = new JButton("ȷ");
			okButton.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent arg0) {
					// TODO Auto-generated method stub
					nodeName = field.getText() == null ? "" : field.getText();
					nodeID = idfield.getText() == null ? "" : idfield.getText();
					String updateSql = "";
						updateSql = String
								.format("update ZF6_CONTROLPLANLIBRARYTREE set ID=?,NAME = ? where PLMEID = \'%s\'",
										leftTable.getValueAt(leftTable.getSelectedRow(), 0).toString());
						
					try {
						SqlUtilT.getTCConnection();
						SqlUtilT.write(
								new String[] { nodeID, nodeName },
										updateSql);
							refreshLeftTable();
							
						frame.dispose();
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} finally {
						SqlUtilT.freeAll();
					}
				}
			});
			
			
			JButton celButton = new JButton("ȡ");
			celButton.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent arg0) {
					frame.dispose();
				}
			});
			JPanel jPanel = new JPanel(new PropertyLayout());
			jPanel.add("1.1.left.top", idlabel);
			jPanel.add("1.2.left.top", idfield);
			jPanel.add("2.1.left.top", label);
			jPanel.add("2.2.left.top", field);
			JPanel rootJPanel = new JPanel(new FlowLayout());
			rootJPanel.add(okButton);
			rootJPanel.add(celButton);
			JPanel panel = new JPanel(new BorderLayout());
			panel.add(new JScrollPane(jPanel), BorderLayout.CENTER);
			panel.add(rootJPanel, BorderLayout.SOUTH);
			frame.add(panel);
			frame.show();
		} else if (source.equals(this.remItem)) {
//			Component component = tabbedPane.getSelectedComponent();
//			if (component instanceof JScrollPane) {
//				JScrollPane scrollPane = (JScrollPane) component;
//				Component tableComponent = scrollPane.getViewport().getView();
//				if (tableComponent instanceof CTable) {
			int i=JOptionPane.showConfirmDialog(null, "ǷɾѡУ", "ɾ", JOptionPane.YES_NO_OPTION);
	        if(i!=JOptionPane.YES_OPTION){
	        	return;
	        }
					CTable table = this.mainTable;
					if (table.getSelectedRow() >= 0
							&& table.getSelectedColumn() > 0) {
						(table.getCellEditor(table.getSelectedRow(),
								table.getSelectedColumn())).stopCellEditing();
						if (((CTMap) table.getModel()).getValueAt(
								table.getSelectedRow(), 0) != null) {
							deleteRows.add(((CTMap) table.getModel())
									.getValueAt(table.getSelectedRow(), 0)
									.toString());
						}
						((CTMap) table.getModel()).removeRow(table
								.getSelectedRow());
						table.revalidate();
						table.repaint();
						//this.tabbedPane.updateUI();
					}
//				}
//			}
		} else if (source.equals(this.remNodeItem)) {
//			Component component = tabbedPane.getSelectedComponent();
//			if (component instanceof JScrollPane) {
//				JScrollPane scrollPane = (JScrollPane) component;
//				Component tableComponent = scrollPane.getViewport().getView();
//				if (tableComponent instanceof CTable) {
					CTable table = this.mainTable;
//					String deleteNodeSql = "";
					String deleteTreeSql = "";
						deleteTreeSql = String
								.format("delete from ZF6_CONTROLPLANLIBRARYTREE where PLMEID = \'%s\'",
										leftTable.getValueAt(leftTable.getSelectedRow(), 0).toString());
//						deleteNodeSql = String
//								.format("delete from RB3_CONTROLPLAN_NODE where PARENT_ID = \'%s\'",
//										leftTable.getValueAt(leftTable.getSelectedRow(), 1).toString());
						
					SqlUtilT.getTCConnection();
					SqlUtilT.delete(deleteTreeSql);
					SqlUtilT.freeAll();
//					SqlUtilT.getTCConnection();
//					SqlUtilT.delete(deleteNodeSql);
//					SqlUtilT.freeAll();
						refreshLeftTable();
						
		} else if (source.equals(this.saveButton)) {
			okEvent(true);
		
			//this.disposeDialog();
			//this.dispose();
		}
		else if (source.equals(shrinkColumnItem)) {
			for (int i = 0; i < mainTable.getSelectedColumns().length; i++) {
				mainTable.getColumnModel().getColumn(mainTable.getSelectedColumns()[i]).setPreferredWidth(5);
			}
			mainTable.revalidate();
			mainTable.repaint();
		}
		else if (source.equals(celShrinkColumnItem)) {
			for (int i = 0; i < mainTable.getSelectedColumns().length; i++) {
				mainTable.getColumnModel().getColumn(mainTable.getSelectedColumns()[i]).setPreferredWidth(100);
			}
			mainTable.revalidate();
			mainTable.repaint();
		}
		else {
			//this.disposeDialog();
			this.dispose();
			// this.setVisible(false);
		}
	}

	private void okEvent(boolean isSave) {
		isMeopSave = false;
		if (mainTable.getSelectedRow() >= 0
				&& mainTable.getSelectedColumn() >= 0) {
			(mainTable.getCellEditor(mainTable.getSelectedRow(),
					mainTable.getSelectedColumn())).stopCellEditing();
		}
		// TODO Auto-generated method stub
		// ݱ浽
		try {
//			// Ƴ
//			Component component = tabbedPane.getSelectedComponent();
//			if (component instanceof JScrollPane) {
//				JScrollPane scrollPane = (JScrollPane) component;
//				Component tableComponent = scrollPane.getViewport().getView();
//				if (tableComponent instanceof CTable) {
//					CTable table = ((CTable) tableComponent);
//					
//				}
//			}
			// ȡJTableе
			List<List<String>> dataValeList = getTableValue();
			ResultSet rs = null;
			InputStream input = null;
			try {
				SqlUtilT.getTCConnection();
				System.out.println("opration----------");
//				// ȡSQL
//				input = new BufferedInputStream(getClass().getResourceAsStream(
//						"/sql.properties"));
//				Properties pro = new Properties();
//				pro.load(input);
				// ɾ
				for (int i = 0; i < deleteRows.size(); i++) {
					// ȡݿ
					SqlUtilT.getTCConnection();
					String deleteSQL = String.format("delete from ZF6_CONTROLPLANLIBRARY where PLMEID = \'%s\'",
							deleteRows.get(i));
					SqlUtilT.delete(deleteSQL);
					//SqlUtilT.freeAll();
				}
				// ѯźID
				// ݿд
				
				System.out.println("ƼƻⱣdataValueList====>"+dataValeList);
				for (int i = 0; i < dataValeList.size(); i++) {
					//SqlUtilT.getTCConnection();
					List<String> rowList = dataValeList.get(i);
					if (rowList.get(0) != null && !rowList.get(0).equals("")) {
						// ȡݿ
						String updateSQL = String.format(
								"update ZF6_CONTROLPLANLIBRARY set ID = ?,JQZHJJGZ = ?,BH = ?,CP = ?,GC = ?,TSTXFL = ?,CPGC = ?,JSCLJS = ?,XM = ?,RL = ?,"
								+ "PL = ?,ZRR = ?,KZFF = ?,FYJH = ? where PLMEID = \'%s\'",
								rowList.get(0));
						//SqlUtilT.getTCConnection();
						SqlUtilT.update(
								new String[] { rowList.get(1), rowList.get(2),
										rowList.get(3), rowList.get(4),
										rowList.get(5), rowList.get(6),
										rowList.get(7), rowList.get(8),
										rowList.get(9), rowList.get(10),
										rowList.get(11),rowList.get(12),
										rowList.get(13), rowList.get(14)}, updateSQL);
					} else {
						String insertSQL = "insert into ZF6_CONTROLPLANLIBRARY values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
						//SqlUtilT.getTCConnection();
						SqlUtilT.write(
								new String[] {
										UUID.randomUUID().toString()
												.replace("-", ""), rowList.get(1), rowList.get(2),
										rowList.get(3),rowList.get(4),rowList.get(5),
										rowList.get(6),rowList.get(7),rowList.get(8),
										rowList.get(9),rowList.get(10),rowList.get(11),
										rowList.get(12),rowList.get(13),rowList.get(14),
										rowList.get(15)},
								insertSQL);
					}
					
				}
				
				//SqlUtilT.freeAll();
			} catch (Exception e) {
				MessageBox.post(e.toString(), "", MessageBox.ERROR);
				e.printStackTrace();
				throw e;
			} finally {
				if (rs != null) {
					SqlUtilT.free(rs);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.connection.commit();
				System.out.println("opration----------");
				SqlUtilT.freeAll();
			}
//				TMom012ControlPlanLibraryOperation operation = new TMom012ControlPlanLibraryOperation(
//						this.session, dataValeList, deleteRows);
//				session.queueOperation(operation);
			this.rootPanel.setBackground(Color.GREEN);
			new Thread() {
				@Override
				public void run() {
					try {
						this.sleep(1000);
						rootPanel.setBackground(Color.WHITE);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}.start();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			this.rootPanel.setBackground(Color.RED);
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
	}

	private List<List<String>> getTableValue() {
		// TODO Auto-generated method stub
		List<List<String>> dataList = new ArrayList<List<String>>();
//		Component[] components = tabbedPane.getComponents();
//		for (int i = 0; i < components.length; i++) {
//			if (components[i] instanceof JScrollPane) {
//				JScrollPane scrollPane = (JScrollPane) components[i];
//				Component tableComponent = scrollPane.getViewport().getView();
//				if (tableComponent instanceof CTable) {
					CTable table = this.mainTable;
					//Ƴ
					if (table.getSelectedRow() >= 0 && table.getSelectedColumn() >= 0) {
						(table.getCellEditor(table.getSelectedRow(),
								table.getSelectedColumn())).stopCellEditing();
					}
					for (int j = 0; j < table.getRowCount(); j++) {
						List<String> rowValue = new ArrayList<String>();
						for (int j2 = 0; j2 < table.getColumnCount(); j2++) {
								rowValue.add(table.getValueAt(j, j2) == null ? ""
										: table.getValueAt(j, j2).toString());
							
						}
						dataList.add(rowValue);
					}
					System.out.println("ռ====>"+dataList);
		return dataList;
	}

	private int[] Union(int[] a1, int[] a2) {
		List<Integer> list1 = new ArrayList<Integer>();
		List<Integer> list2 = new ArrayList<Integer>();
		for (int i : a1) {
			list1.add(i);
		}
		for (int i : a2) {
			list2.add(i);
		}
		list1.removeAll(list2);
		list2.addAll(list1);
		int[] result = new int[list2.size()];
		for (int i = 0; i < list2.size(); i++) {
			result[i] = list2.get(i);
		}
		return result;
	}
	
	private class AddRowsDialog extends AbstractAIFDialog implements ActionListener {

		private JPanel panel;
		private JLabel label;
		private JTextField textField;
		private JButton button;

		private CTable table;

		public AddRowsDialog(CTable table) {
			super();
			this.table = table;
			init();
		}

		private void init() {
			this.panel = new JPanel(new PropertyLayout());
			this.label = new JLabel("");
			this.textField = new JTextField(20);
			this.textField.addKeyListener(new KeyAdapter() {
				@Override
				public void keyPressed(KeyEvent arg0) {
					if (arg0.getKeyCode() == KeyEvent.VK_ENTER) {
						okEvent();
					} else {
						super.keyPressed(arg0);
					}
				}
			});
			this.button = new JButton("ȷ");
			this.button.addActionListener(this);
			this.panel.add("1.1.left.top", label);
			this.panel.add("1.2.left.top", textField);
			this.panel.add("1.3.left.top", button);

			this.add(this.panel, BorderLayout.CENTER);
			this.pack();
			this.showDialog();
		}

		@Override
		public void actionPerformed(ActionEvent actionevent) {
			// TODO Auto-generated method stub
			Object source = actionevent.getSource();
			if (source.equals(this.button)) {
				okEvent();
			}
		}

		private void okEvent() {
			// TODO Auto-generated method stub
				if (!isStr2Num(textField.getText())) {
					MessageBox.post("ȷ!", "!", MessageBox.ERROR);
					return;
				}
				for (int i1 = Integer.parseInt(textField.getText()); i1 > 0; i1--) {
					if (table.getSelectedRow() > -1) {
						((CTMap) table.getModel()).insertRow(table
								.getSelectedRow() + 1);
						
							table.setValueAt(
									table.getValueAt(table.getSelectedRow(),
											table.getColumnCount() - 1),
									table.getSelectedRow() + 1,
									table.getColumnCount() - 1);
							
						table.revalidate();
						table.repaint();
						//this.tabbedPane.updateUI();
					}
				}
				this.disposeDialog();
				this.dispose();
			
		}

	}
	
	
	
	
	
	/** 
	* 鿴һַǷתΪ 
	* @param str ַ 
	* @return true ; false  
	*/  
	public boolean isStr2Num(String str) {   
		try {  
		    Integer.parseInt(str);  
		    return true;  
		} catch (NumberFormatException e) {  
		    return false;  
		}  
	}

	private class SpecialDialog extends AbstractAIFDialog implements
			ActionListener {
		private JPanel tablePanel;// ؼ
		private JTable table;

		private JPanel rootPanel;// ť
		private JButton okButton;// ȷ
		private JButton celButton;// ȡ

		public SpecialDialog() {
			// TODO Auto-generated constructor stub
			super();
			init();
		}

		private void init() {
			//ȡʻ
			Locale defaultLocale=Locale.getDefault();
			ResourceBundle rb=ResourceBundle.getBundle("com.connor.renben.process.plm.message.Message",defaultLocale);
			// TODO Auto-generated method stub
			this.setTitle(rb.getString("xztsfh12_display.TITLE"));
			this.table = getjTable(this.table, null, new Object[] { 1, 2, 3, 4,
					5, 6, 7, 8 }, new Object[][] { { 1, 2, 3, 4, 5, 6, 7, 8 },
					{ 9, 0, "q", "w", "e", "r", "t", "y" } });
			this.setLocationRelativeTo(this);
			this.table.setRowHeight(30);
			this.table.getTableHeader().setVisible(false);
			this.table.setFont(new Font("Y14.5M", 0, 15));
			this.tablePanel = new JPanel(new BorderLayout());
			this.tablePanel.add(this.table);

			this.okButton = new JButton(rb.getString("qd_display.TITLE"));
			this.okButton.addActionListener(this);
			this.celButton = new JButton(rb.getString("qx_display.TITLE"));
			this.celButton.addActionListener(this);
			this.rootPanel = new JPanel(new FlowLayout());
			this.rootPanel.add(this.okButton);
			this.rootPanel.add(this.celButton);

			this.add(this.tablePanel, BorderLayout.CENTER);
			this.add(this.rootPanel, BorderLayout.SOUTH);
			this.pack();
			this.show();
		}

		// Jtableͨ÷
		public JTable getjTable(JTable partsTable, DefaultTableModel dtm,
				Object[] titleNames, Object[][] values) {
			int simpleLen = 100;
			int totleLen = 1000;
			if (partsTable == null) {
				partsTable = new JTable(this.getTableModel(dtm, titleNames,
						values));
				partsTable.setCellSelectionEnabled(true);
				if (simpleLen * titleNames.length >= totleLen) {
					for (int i = 0; i < titleNames.length; i++) {
						partsTable.getColumnModel().getColumn(i)
								.setPreferredWidth(simpleLen);
					}
					partsTable.setAutoResizeMode(0);
				} else {
					partsTable.setAutoResizeMode(1);
				}
			}
			return partsTable;
		}

		public DefaultTableModel getTableModel(DefaultTableModel dtm,
				Object[] titleNames, Object[][] values) {
			MyTableModel tableModel = null;
			if (dtm == null) {
				tableModel = new MyTableModel(values, titleNames);
			}
			return tableModel;
		}

		@Override
		public void actionPerformed(ActionEvent actionevent) {
			// TODO Auto-generated method stub
			Object source = actionevent.getSource();
			if (source.equals(this.okButton)) {
				// DefaultMutableTreeNode node = (DefaultMutableTreeNode)
				// TMom012ControlPlanLibraryDialog.tree.getSelectionPath().getLastPathComponent();
				// node.add(new DefaultMutableTreeNode("ս"));
//				Component component = tabbedPane.getSelectedComponent();
//				if (component instanceof JScrollPane) {
//					JScrollPane scrollPane = (JScrollPane) component;
//					Component tableComponent = scrollPane.getViewport()
//							.getView();
//					if (tableComponent instanceof CTable) {
						CTable table = mainTable;
						int row = table.getSelectedRow();
						int column = table.getSelectedColumn();
						// λ
						String columnName = table.getColumnName(table
								.getSelectedColumn());

						int cursorIndex = ((TextAreaCellEditor) (table
								.getCellEditor(row, column))).getIndex();
						System.out.println("index+" + cursorIndex);
						(table.getCellEditor(row, column)).stopCellEditing();
						// TMom010SetPFMEADialog.table.getDefaultEditor(Object.class).stopCellEditing();
						StringBuilder sb = new StringBuilder(table.getValueAt(
								row, column).toString());

						// ѭ,indexλò-1,һֱ
						Integer index = 0;
						while ((index = sb.toString().indexOf("\n", index)) != -1) {

							// ÿѭһξҪȷһβҵλ
							index = index + "\n".length();
							// ÿһμ
							cursorIndex++;
						}
						// 
						Object special = table.getValueAt(row,
								table.getColumnCount() - 1);
						if (special == null || special.toString() == "") {
							table.setValueAt(columnName + "-" + cursorIndex,
									row, table.getColumnCount() - 1);
						} else {
							table.setValueAt(special + "|" + columnName + "-"
									+ cursorIndex, row,
									table.getColumnCount() - 1);
						}
						System.out.println(sb.length());
						String s = sb.insert(
								cursorIndex,
								this.table.getValueAt(
										this.table.getSelectedRow(),
										this.table.getSelectedColumn())
										.toString()).toString();
						table.setValueAt(s, table.getSelectedRow(),
								table.getSelectedColumn());
						System.out.println(table.getValueAt(row, column)
								.toString());
//					}
//				}
			} else {
				this.dispose();
			}
		}
	}
}
