package com.connor.zf.plm001;

import java.awt.print.Printable;
import java.util.ArrayList;

import com.connor.zf.utils.TMomFinalUtil;
import com.connor.zf.utils.TMomMethodUtil;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class TMom005CreateOPByModuleOperation extends AbstractAIFOperation {
	private InterfaceAIFComponent targets;// ѡж
	private String selectItems;// ѡ
	private TCSession session;
	private Object[] arrayOfObject;
	
	public TMom005CreateOPByModuleOperation(TCSession session,
			InterfaceAIFComponent targets, String selectItems) {
		this.session = session;
		this.targets = targets;
		this.selectItems = selectItems;
	}

	public TMom005CreateOPByModuleOperation(TCSession session,InterfaceAIFComponent targets,Object[] arrayOfObject) {
		this.session = session;
		this.targets = targets;
		this.arrayOfObject = arrayOfObject;
	}

	@Override
	public void executeOperation() throws Exception {
		ArrayList<TCComponentItem> itemlists = new ArrayList<TCComponentItem>();
		TCComponentItem item = null;
		
		if (this.targets instanceof TCComponentBOMLine) {
			item = ((TCComponentBOMLine) this.targets).getItem();
		}
		// ȡItemId
//		String[] itemID = null;
//		if (selectItems.indexOf(" | ") > -1) {
//			itemID = selectItems.split(" | ");
//		} else {
//			itemID = new String[] { selectItems };
//		}
		String[] itemID = new String[arrayOfObject.length];
		for (int i = 0; i < arrayOfObject.length; i++) {
			String[] split = arrayOfObject[i].toString().split(";");
			itemID[i] = split[0];
		}
		// ȡѡеĶ
		TCComponentItemType itemType = (TCComponentItemType) this.session
				.getTypeComponent("Item");
		TCComponentItemType gxType = (TCComponentItemType) session
				.getTypeComponent("ZF6_BZGX");
		String classID="";
		if (itemID != null && itemID.length > 0) {
			for (int i = 0; i < itemID.length; i++) {
				TCComponentItem childrenItem = itemType.find(itemID[i]
						.substring(0, itemID[i].length() - 1));
				//ͨString͵ϺźͶҶ+++
				if (itemID[i].indexOf("/") >= 0) {
					childrenItem = itemType.find(itemID[i].split("/")[0]);
					classID=(childrenItem.getLatestItemRevision()).getClassificationClass();
				}
				if (!childrenItem.getType().equals("ZF6_BZGX")) {
					MessageBox.post("ѡ" + childrenItem.getType(), "", MessageBox.ERROR);
					return;
				}
				TCComponent[] mepComponents = item.getLatestItemRevision()
						.getRelatedComponents("ps_children");
				int mepCount = 0;
				for (int j = 0; j < mepComponents.length; j++) {
					if (mepComponents[j].getType().indexOf("ZF6_BZGX") >= 0) {
						mepCount++;
					}
				}
				TCComponentItem newItem = saveAsItem(childrenItem,"ZF6_GX");
				// BOM
				TCComponent[] childrenComponents = childrenItem
						.getLatestItemRevision().getRelatedComponents(
								"ps_children");
				if (childrenComponents.length > 0) {
					ArrayList<TCComponentItem> childrenItemlists = new ArrayList<TCComponentItem>();
					for (int k = 0; k < childrenComponents.length; k++) {
						String mould = childrenComponents[k]
								.getStringProperty("object_type");
						if (childrenComponents[k].getStringProperty(
								"object_type").indexOf("mould") < 0) {
							if (childrenComponents[k] instanceof TCComponentItemRevision) {
								TCComponentBOMLine bomLine = (TCComponentBOMLine) childrenComponents[k];
								TCComponentItem newChildItem = saveAsItem(bomLine.getItem(),"ZF6_GB");
								childrenItemlists.add(newChildItem);
							}
						}
					}

					if (newItem != null && childrenItemlists != null
							&& childrenItemlists.size() > 0) {
						recreateBom(newItem, childrenItemlists, true,classID);
					}
				}
				itemlists.add(newItem);
			}
		}
		if (item != null && itemlists != null && itemlists.size() > 0) {
			
			recreateBom(item, itemlists, false,classID);
			
			MessageBox.post("ģ崴ɹ", "ɹ", MessageBox.WARNING);
		}
	}

	/**
	 * Ϊ
	 * 
	 * @param item
	 */
	public TCComponentItem saveAsItem(TCComponentItem item,String type) {
		TCComponentItem newItem = null;
		try {
			String itemID = "";
//			if (item.getType().equals("ZF6_BZGX")) {
//				itemID = TMomMethodUtil.getRuleItemID(session,
//						processItem.getStringProperty("item_id"), null,
//						TMomFinalUtil.GX_CODE);
//			} else {
//				itemID = item.getTypeComponent().getNewID();
//			}
//			newItem = item.getLatestItemRevision().saveAsItem(
//					itemID,
//					item.getLatestItemRevision().getStringProperty(
//							"item_revision_id"));
			TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent(type);
			itemID = itemType.getNewID();
			newItem = TMomMethodUtil.createNewItemSoa(session, itemID,
					item.getLatestItemRevision().getStringProperty("item_revision_id"), 
					"ZF6_GX", 
					item.getStringProperty("object_name"), 
					"", "", null, null, null);
			TCComponentItemRevision newRevision = newItem.getLatestItemRevision();
			TCComponentItemRevision oldRevision = item.getLatestItemRevision();
			//string
			newRevision.setStringProperty("zf6_yxxs", oldRevision.getStringProperty("zf6_yxxs"));
			newRevision.setStringProperty("zf6_bzde", oldRevision.getStringProperty("zf6_bzde"));
			newRevision.setStringProperty("zf6_scphdm", oldRevision.getStringProperty("zf6_scphdm"));
			newRevision.setStringProperty("zf6_ywfy", oldRevision.getStringProperty("zf6_ywfy"));
			//boolean
			newRevision.setLogicalProperty("zf6_sfbzgx", oldRevision.getLogicalProperty("zf6_sfbzgx"));
			newRevision.setLogicalProperty("zf6_sffj", oldRevision.getLogicalProperty("zf6_sffj"));
			newRevision.setLogicalProperty("zf6_sfcg", oldRevision.getLogicalProperty("zf6_sfcg"));
			newRevision.setLogicalProperty("zf6_sfyzgx", oldRevision.getLogicalProperty("zf6_sfyzgx"));
			TCComponent[] datas = item
					.getReferenceListProperty("IMAN_reference");
			if (datas.length > 0) {
				newItem.remove("IMAN_reference", datas);
			}
			for (int j = 0; j < datas.length; j++) {
				if (datas[j] instanceof TCComponentItem) {
					TCComponentItem dataItem = (TCComponentItem) datas[j];
					// TCComponentItemType dataType=(TCComponentItemType)
					// session.getTypeComponent(dataItem.getStringProperty("object_type"));
					TCComponentItem newDataItem = dataItem
							.getLatestItemRevision().saveAsItem(
									dataItem.getTypeComponent().getNewID(),
									dataItem.getLatestItemRevision()
											.getStringProperty(
													"item_revision_id"));
					newItem.add("IMAN_reference", newDataItem);
				}
			}
		} catch (TCException e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
		return newItem;
	}

	/**
	 * ´BOM
	 * 
	 * @param item
	 * @param itemlists
	 * @throws TCException
	 */
	public void recreateBom(TCComponentItem item,
			ArrayList<TCComponentItem> itemlists, boolean isDelete,String classID)
			throws TCException {
		TCComponentBOMWindow bomWindow = null;
		TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
				.getTypeComponent("BOMWindow");
		bomWindow = bomWindowType.create(null);
		TCComponentBOMLine topline = bomWindow.setWindowTopLine(item,
				item.getLatestItemRevision(), null, null);
		bomWindow.lock();
		topline.lock();
		if (isDelete) {
			if (topline.hasChildren()) {
				AIFComponentContext[] childrens = topline.getChildren();
				for (AIFComponentContext children : childrens) {
					((TCComponentBOMLine) children.getComponent()).cut();
				}
			}
		}
		for (TCComponentItem n_item : itemlists) {
			
			TCComponentItemRevision revision = n_item.getLatestItemRevision();
			topline.add(n_item, revision, null, false, "");
			//+++++
			AIFComponentContext[] childrens = topline.getChildren();
			for (AIFComponentContext children : childrens) {
				//Ѱӵbomline
				String[] itemflagString= n_item.toString().split("-");
				String[] bomflagString= children.toString().split("/");
				
				if(itemflagString[0].equals(bomflagString[0])) {
					//ȡIDǰ桰BZGXֶβҪ
					((TCComponentBOMLine) children.getComponent()).setStringProperty("RB3_GXH",
							classID.substring(classID.indexOf("X")+1,classID.length()));
				}
			}
			//++++++
		}
		bomWindow.unlock();
		bomWindow.save();
		//+++򱣴浽permissionsݿ
		//SavePermissions permissions = new SavePermissions(session, topline.getItem());
		
		//permissions.insertData();
		//+++
	}

}
