 package com.connor.zf.plm002;

import java.awt.AWTException;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Robot;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.JButton;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.RowSorter;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import javax.swing.tree.TreePath;

import org.jdesktop.swingx.decorator.HighlighterFactory;
import org.jdesktop.swingx.treetable.DefaultMutableTreeTableNode;

import com.connor.zf.plm.bean.NodeBean;

import com.connor.zf.utils.TCUtil;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.commands.newitem.NamingRule;
import com.teamcenter.rac.commands.newitem.NamingRulesHelper;
import com.teamcenter.rac.commands.revise.RevisionNamingRuleHelper;
import com.teamcenter.rac.kernel.SoaUtil;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOPWindow;
import com.teamcenter.rac.kernel.TCComponentBOPWindowType;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentNameRule;
import com.teamcenter.rac.kernel.TCComponentNameRuleType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCExceptionPartial;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core._2006_03.DataManagement;
import com.teamcenter.services.rac.core._2008_06.DataManagement.SaveAsNewItemInfo;
import com.teamcenter.services.rac.core._2008_06.DataManagement.SaveAsNewItemOutput2;
import com.teamcenter.services.rac.core._2008_06.DataManagement.SaveAsNewItemResponse2;

public class CopyProcessRouteDialog extends AbstractAIFDialog implements ActionListener,MouseListener{
	
	private TCSession session;
	private TCComponentItemRevision tarRevision;
	private String tarType;
	
	private JLabel partIDLabel;
	private JTextField partIDField;
	private JLabel partNameLabel;
	private JTextField partNameField;
	private JLabel routeIDLabel;
	private JTextField routeIDField;
	private JLabel routeNameLabel;
	private JTextField routeNameField;
	private JButton selectButton;
	
	private JTextField idField = new JTextField();//id
	private JTextField revField = new JTextField();//Ű汾
	
	String[] oneColumnNames = {"Ʒ","Ʒ","汾","·߱","·"};
	String[] twoColumnNames = {"","ѡ","",""};
	private JTable impTable;
	private DefaultTableModel impModel;
//	private JTable processTable;
//	private DefaultTableModel processModel;
	private JTreeTable processTable;
	private JTreeTableModel processModel;
	
	private JButton okButton;
	private JButton celButton;
	
	private Vector<Vector<Object>> dataVector = new Vector<Vector<Object>>();// Ϣ
	private Object[][] values;
	private DefaultMutableTreeTableNode rootNode;
	//Ź·ߵnodeṹ
	private HashMap<String, DefaultMutableTreeTableNode> nodeMap = new HashMap<String, DefaultMutableTreeTableNode>();
	
	
	public CopyProcessRouteDialog(TCSession session,InterfaceAIFComponent targetComponent,String tarType) {
		super(false);
		this.session = session;
		//this.tarRevision = (TCComponentItemRevision) targetComponent;
		this.tarType = tarType;
		init();
	}
	
	

	private void init() {
		this.setTitle("·߸");
		this.setPreferredSize(new Dimension(666,666));
		
		partIDLabel = new JLabel("Ʒ룺");
		partIDLabel.setPreferredSize(new Dimension(100,25));
		partIDField = new JTextField();
		partIDField.setPreferredSize(new Dimension(180,25));
		
		partNameLabel = new JLabel("Ʒ");
		partNameLabel.setPreferredSize(new Dimension(100,25));
		partNameField = new JTextField();
		partNameField.setPreferredSize(new Dimension(180,25));
		
		routeIDLabel = new JLabel("·߱ţ");
		routeIDLabel.setPreferredSize(new Dimension(100,25));
		routeIDField = new JTextField();
		routeIDField.setPreferredSize(new Dimension(180,25));
		
		routeNameLabel = new JLabel("·ƣ");
		routeNameLabel.setPreferredSize(new Dimension(100,25));
		routeNameField = new JTextField();
		routeNameField.setPreferredSize(new Dimension(180,25));
		
		selectButton = new JButton("ѯ");
		selectButton.addActionListener(this);
		
		JPanel selectPanel = new JPanel(new PropertyLayout());
		selectPanel.add("1.1.center",partIDLabel);
		selectPanel.add("1.2.center",partIDField);
		selectPanel.add("1.3.center",partNameLabel);
		selectPanel.add("1.4.center",partNameField);
		selectPanel.add("2.1.center",routeIDLabel);
		selectPanel.add("2.2.center",routeIDField);
		selectPanel.add("2.3.center",routeNameLabel);
		selectPanel.add("2.4.center",routeNameField);
		selectPanel.add("2.5.center",selectButton);
		
		impModel = new DefaultTableModel() {
			@Override
			public boolean isCellEditable(int row, int col) {
				return false;
			}
		};
		impModel.setDataVector(null, oneColumnNames);
		impTable = new JTable(impModel);	
		impTable.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if(e.getClickCount() == 2) {
					//ѡ
					int rowIndex = impTable.getSelectedRow();
					System.out.println("ǰѡеΪ" + rowIndex);
					String processID = impTable.getValueAt(rowIndex, 3).toString();				
					processModel = (JTreeTableModel) processTable.getTreeTableModel();
					//rootNode = nodeMap.get(processID);
					processModel.setRoot(nodeMap.get(processID));
					processTable.repaint();
					processTable.expandAll();
				}			
			}
		});
        JScrollPane itemPanel = new JScrollPane(impTable);
		itemPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(), "Ϣ"));
		
		this.processTable = getJTreeTable(null, null, twoColumnNames);
		this.processTable.addMouseListener(this);
		
		JScrollPane processPanel = new JScrollPane(processTable);
		processPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(), "Ϣ"));
		JPanel tablePanel = new JPanel(new GridLayout(0,1,2,5));
		tablePanel.add(itemPanel);
		tablePanel.add(processPanel);
		
		okButton = new JButton("ȷ");
		celButton = new JButton("ȡ");
		okButton.addActionListener(this);
		celButton.addActionListener(this);
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(okButton);
		buttonPanel.add(celButton);
		
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.NORTH,selectPanel);
		this.add(BorderLayout.CENTER,tablePanel);
		this.add(BorderLayout.SOUTH,buttonPanel);
		showDialog();
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.celButton) {
			this.disposeDialog();
		}else if(e.getSource() == this.selectButton) {
			//select();
			selects();
		}else if(e.getSource() == this.okButton) {
			try {
				copy();
			} catch (TCException e1) {
				e1.printStackTrace();
			}
		}
	}
	
	private void selects() {
		String partID = partIDField.getText();
		String partName = partNameField.getText();
		String routeID = routeIDField.getText();
		String routeName = routeNameField.getText();
		if(partID.isEmpty() && partName.isEmpty() && routeID.isEmpty() && routeName.isEmpty()) {
			MessageBox.post("дѯ","ʾ",2);
			return;
		}
		dataVector.clear();
		nodeMap.clear();
		Vector<String> keyV = new Vector<>();
		Vector<String> valueV = new Vector<>();
		if(!partID.isEmpty()) {
			keyV.add("Ʒ");
			valueV.add(partID);
		}
		if(!partName.isEmpty()) {
			keyV.add("Ʒ");
			valueV.add(partName);
		}
		if(!routeID.isEmpty()) {
			keyV.add("·ID");
			valueV.add(routeID);
		}
		if(!routeName.isEmpty()) {
			keyV.add("·");
			valueV.add(routeName);
		}
		String preName = "";
		switch (tarType) {
		case "ZF6_LBJRevision":
			preName = "·߲ѯ";
			break;
		case "ZF6_YZRevision":
			preName = "·߲ѯ";
			break;
		case "ZF6_YCLRevision":
			preName = "·߲ѯ";
			break;
		default:
			break;
		}
		try {
			TCComponent[] result = TCUtil.query(session, preName, keyV, valueV);
			System.out.println("ѯĶ󳤶Ϊ" + result.length);
			result = TCUtil.TCsort(result, new int[] { 1, -1 }, "item_id", "item_revision_id");
			TCComponentBOPWindowType bomWinType = (TCComponentBOPWindowType) session.getTypeComponent("BOPWindow");
			TCComponentBOPWindow window = (TCComponentBOPWindow) bomWinType.createBOPWindow(null);
			if(result.length > 0) {
				for (TCComponent tcComponent : result) {
					AIFComponentContext[] whereReferenced = tcComponent.whereReferenced();
					System.out.println("óΪ" + whereReferenced.length);
					for (int i = 0; i < whereReferenced.length; i++) {
						String refType = whereReferenced[i].getComponent().getType();
						System.out.println("ѡжΪ" + tarType + "----öΪ" + refType);
						if(refType.equals(tarType)) {
							TCComponentItemRevision rev = (TCComponentItemRevision) whereReferenced[i].getComponent();
							TCComponentItemRevision meprocess = (TCComponentItemRevision) tcComponent;
							TCComponentItem pitem = meprocess.getItem();
							String id = rev.getStringProperty("item_id");					
							Vector<Object> vector = new Vector<Object>();
							vector.add(id);
							vector.add(rev.getStringProperty("object_name"));
							vector.add(rev.getStringProperty("item_revision_id"));
							vector.add(tcComponent.getStringProperty("item_id"));
							vector.add(tcComponent.getStringProperty("object_name"));
							this.dataVector.add(vector);											
							TCComponentBOMLine ebom = window.setWindowTopLine(pitem, meprocess, null, null);
							NodeBean rootBean = new NodeBean("","","",null);
							DefaultMutableTreeTableNode root = new DefaultMutableTreeTableNode(rootBean);
							buildStructure(ebom,root);
							break;
						}
					}				
				}
			}
			this.values = new Object[this.dataVector.size()][];
			for (int i = 0; i < this.dataVector.size(); i++) {
				Vector<Object> rowVector = this.dataVector.get(i);
				for (int j = 0; j < rowVector.size(); j++) {
					Object[] rowData = new Object[rowVector.size()];

					rowData[j] = rowVector.get(j);
					this.values[i] = rowData;
				}
			}
			this.addData(impTable,oneColumnNames);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * ·Ľṹ·--ӹ
	 * @param ebom
	 * @throws TCException 
	 */
	private void buildStructure(TCComponentBOMLine ebom, DefaultMutableTreeTableNode root) throws TCException {
		NodeBean bean = new NodeBean(ebom.getStringProperty("bl_item_item_id"),
				ebom.getStringProperty("bl_item_object_name"), "1", ebom);
		DefaultMutableTreeTableNode node = new DefaultMutableTreeTableNode(bean);
		root.add(node);
		AIFComponentContext[] children = ebom.getChildren();
		for (int i = 0; i < children.length; i++) {
			TCComponentBOMLine procedure = (TCComponentBOMLine) children[i].getComponent();
			NodeBean bean1 = new NodeBean(procedure.getStringProperty("bl_item_item_id"),
					procedure.getStringProperty("bl_item_object_name"), "1", procedure);
			DefaultMutableTreeTableNode node1 = new DefaultMutableTreeTableNode(bean1);
			node.add(node1);
			AIFComponentContext[] children2 = procedure.getChildren();
			for (int j = 0; j < children2.length; j++) {
				TCComponentBOMLine procedure2 = (TCComponentBOMLine) children2[j].getComponent();
				NodeBean bean2 = new NodeBean(procedure2.getStringProperty("bl_item_item_id"),
						procedure2.getStringProperty("bl_item_object_name"), "1", procedure2);
				DefaultMutableTreeTableNode node2 = new DefaultMutableTreeTableNode(bean2);
				node1.add(node2);
			}
		}
		nodeMap.put(ebom.getStringProperty("bl_item_item_id"), root);
	}



	/**
	 * ִвѯ
	 * @throws Exception 
	 */
	private void select(){
		String partID = partIDField.getText();
		String partName = partNameField.getText();
		String routeID = routeIDField.getText();
		String routeName = routeNameField.getText();
		if(partID.isEmpty() && partName.isEmpty() && routeID.isEmpty() && routeName.isEmpty()) {
			MessageBox.post("дѯ","ʾ",2);
			return;
		}
		dataVector.clear();
		Vector<String> keyV = new Vector<>();
		Vector<String> valueV = new Vector<>();
		try {
			//жϲѯĽǷظ
			HashSet<String> idSet = new HashSet<String>();
			//IDƲΪգ
			if(!partID.isEmpty() || !partName.isEmpty()) {
				if(!partID.isEmpty()) {
					keyV.add(" ID");
					valueV.add(partID);
				}
				if(!partName.isEmpty()) {
					keyV.add("");
					valueV.add(partName);
				}
				keyV.add("");
				valueV.add("ZF6_LBJRevision;ZF6_YZRevision;ZF6_YCLRevision");
				TCComponent[] result = TCUtil.query(session, "汾...", keyV, valueV);
				if(result.length > 0) {
					for (TCComponent tcComponent : result) {
						idSet.add(tcComponent.getStringProperty("item_id"));
						TCComponent[] relatedComponents = tcComponent.getRelatedComponents("ZF6_R_GYLX");
						for (int i = 0; i < relatedComponents.length; i++) {
							TCComponent route = relatedComponents[i];
							//ϹյĲѯ
							String id = route.getStringProperty("item_id");
							String name = route.getStringProperty("object_name");
							if(!routeID.isEmpty() && routeName.isEmpty()) {
								if((routeID.contains("*") && id.contains(routeID.replace("*", ""))) 
										|| (!routeID.contains("*") && id.equals(routeID))) {
									Vector<Object> vector = new Vector<Object>();
									vector.add(tcComponent.getStringProperty("item_id"));
									vector.add(tcComponent.getStringProperty("object_name"));
									vector.add(id);
									vector.add(name);
									this.dataVector.add(vector);
								}
							}else if(!routeName.isEmpty() && routeID.isEmpty()){
								if((routeName.contains("*") && name.contains(routeName.replace("*", ""))) 
										|| (!routeName.contains("*") && name.equals(routeName))) {
									Vector<Object> vector = new Vector<Object>();
									vector.add(tcComponent.getStringProperty("item_id"));
									vector.add(tcComponent.getStringProperty("object_name"));
									vector.add(id);
									vector.add(name);
									this.dataVector.add(vector);
								}
							}else if(!routeID.isEmpty() && !routeName.isEmpty()){
								if((routeID.contains("*") && id.contains(routeID.replace("*", ""))) 
										|| (!routeID.contains("*") && id.equals(routeID))) {
									if((routeName.contains("*") && name.contains(routeName.replace("*", ""))) 
											|| (!routeName.contains("*") && name.equals(routeName))) {
									Vector<Object> vector = new Vector<Object>();
									vector.add(tcComponent.getStringProperty("item_id"));
									vector.add(tcComponent.getStringProperty("object_name"));
									vector.add(id);
									vector.add(name);
									this.dataVector.add(vector);
									}
								}
							}else {
								Vector<Object> vector = new Vector<Object>();
								vector.add(tcComponent.getStringProperty("item_id"));
								vector.add(tcComponent.getStringProperty("object_name"));
								vector.add(id);
								vector.add(name);
								this.dataVector.add(vector);
							}
						}					
					}			
				}
			}		
			//IDƲΪգ鹤
			if(!routeID.isEmpty() || !routeName.isEmpty()) {
				if(!routeID.isEmpty()) {
					keyV.add(" ID");
					valueV.add(routeID);
				}
				if(!routeName.isEmpty()) {
					keyV.add("");
					valueV.add(routeName);
				}
				keyV.add("");
				valueV.add("ZF6_GYLXRevision");
				TCComponent[] result = TCUtil.query(session, "汾...", keyV, valueV);
				if(result.length > 0) {
					for (TCComponent tcComponent : result) {
						AIFComponentContext[] whereReferenced = tcComponent.whereReferenced();
						for (int i = 0; i < whereReferenced.length; i++) {
							String refType = whereReferenced[i].getComponent().getType();
							if(refType.equals("ZF6_LBJRevision") || refType.equals("ZF6_YZRevision")
									|| refType.equals("ZF6_YCLRevision")) {
								TCComponentItemRevision rev = (TCComponentItemRevision) whereReferenced[i].getComponent();
								String id = rev.getStringProperty("item_id");
								if(!idSet.contains(id)) {
									Vector<Object> vector = new Vector<Object>();
									vector.add(id);
									vector.add(rev.getStringProperty("object_name"));
									vector.add(tcComponent.getStringProperty("item_id"));
									vector.add(tcComponent.getStringProperty("object_name"));
									this.dataVector.add(vector);
								}
							}
						}				
					}
				}
			}				
			this.values = new Object[this.dataVector.size()][];
			for (int i = 0; i < this.dataVector.size(); i++) {
				Vector<Object> rowVector = this.dataVector.get(i);
				for (int j = 0; j < rowVector.size(); j++) {
					Object[] rowData = new Object[rowVector.size()];

					rowData[j] = rowVector.get(j);
					this.values[i] = rowData;
				}
			}
			this.addData(impTable,oneColumnNames);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * ִиƹ·߲
	 * @throws TCException 
	 */
	private void copy() throws TCException {
		InterfaceAIFComponent targetComponent = AIFUtility.getCurrentApplication().getTargetComponent();
		System.out.println("ǰѡеĶΪ" + targetComponent);
		if("ZF6_LBJRevision".equals(targetComponent.getType()) || "ZF6_YZRevision".equals(targetComponent.getType())
				|| "ZF6_YCLRevision".equals(targetComponent.getType())) {
		}else {
			MessageBox.post("ѡȷİ汾!!!", "", MessageBox.ERROR);
			return ;
		}
		tarRevision = (TCComponentItemRevision) targetComponent;
		DefaultMutableTreeTableNode top = (DefaultMutableTreeTableNode) processTable.getTreeTableModel().getRoot();
		rootNode = (DefaultMutableTreeTableNode)top.getChildAt(0);
		NodeBean rootBean = (NodeBean) rootNode.getUserObject();
		TCComponentItemType itemType;
		//õϸID
		TCComponentNameRuleType nameRuleType = (TCComponentNameRuleType) session.getTypeComponent("NameRule");
		TCComponentNameRule nameRule = nameRuleType.find("ZF6_GYLXMMGZ");
		String[] patterns = nameRule.getPatterns();
		String tar_item_id = rootBean.getTarger().getItem().getStringProperty("item_id");
		String[] split = tar_item_id.split("-");
		for (String pattern : patterns) {
			if(pattern.contains(split[0])) {
				updateLastUsedPref(pattern);
				getAssignedIds();
				break;
			}
		}
		
		itemType = (TCComponentItemType) session.getTypeService().getTypeComponent(rootBean.getTarger().getItem().getType());
		System.out.println("½IDΪ" + idField.getText() + "======汾Ϊ" + revField.getText());
		TCComponentItem newItem = rootBean.getTarger().getItemRevision().saveAsItem(idField.getText(), revField.getText());
		TCComponentItemRevision newRev = newItem.getLatestItemRevision();
		TCComponentBOPWindowType bomWinType = (TCComponentBOPWindowType) session.getTypeComponent("BOPWindow");
		TCComponentBOPWindow window = (TCComponentBOPWindow) bomWinType.createBOPWindow(null);
		//µĹ·߶
		TCComponentBOMLine routebom = window.setWindowTopLine(newItem, newRev, null, null);
		//ɾԭĽṹ
		if (routebom.hasChildren()) {
			AIFComponentContext[] childrens = routebom.getChildren();
			for (AIFComponentContext children : childrens) {
				((TCComponentBOMLine) children.getComponent()).cut();
			}
		}		
		//ŹID,;ɹӹ
		HashMap<String, ArrayList<TCComponentItemRevision>> ssMap = new HashMap<String, ArrayList<TCComponentItemRevision>>();
		//һ㹤
		for (int i = 0; i < rootNode.getChildCount(); i++) {
			DefaultMutableTreeTableNode childNode = (DefaultMutableTreeTableNode) rootNode.getChildAt(i);
			NodeBean childBean = (NodeBean) childNode.getUserObject();		
			if(childBean.getLabel().equals("1") && !childBean.getId().isEmpty()){
				itemType = (TCComponentItemType) session.getTypeService().getTypeComponent(childBean.getTarger().getItem().getType());
				TCComponentItem newChildItem = childBean.getTarger().getItemRevision().saveAsItem(itemType.getNewID(), "");
				TCComponentItemRevision newChildRev = newChildItem.getLatestItemRevision();
				routebom.add(newChildItem, newChildRev, null, false, "");
				//жǷӹ
				if(childNode.getChildCount() > 0) {
					ArrayList<TCComponentItemRevision> list = new ArrayList<TCComponentItemRevision>();
					for (int k = 0; k < childNode.getChildCount(); k++) {
						DefaultMutableTreeTableNode ssNode = (DefaultMutableTreeTableNode) childNode.getChildAt(k);
						NodeBean ssBean = (NodeBean) ssNode.getUserObject();	
						if(ssBean.getLabel().equals("1")) {
							list.add(ssBean.getTarger().getItemRevision());
						}					
					}
					ssMap.put(newChildItem.getStringProperty("item_id"),list);
				}
			}
		}
		routebom.save();
		routebom.unlock();
		routebom.refresh();
		if(routebom.getBOMView() != null)
		{
			routebom.getBOMView().save();
			routebom.getBOMView().refresh();
		}
		//ɾ¹ӽṹ
		if (routebom.hasChildren()) {
			AIFComponentContext[] childrens = routebom.getChildren();
			for (AIFComponentContext children : childrens) {
				TCComponentBOMLine childLine = (TCComponentBOMLine) children.getComponent();
				if(childLine.hasChildren()) {
					for (AIFComponentContext aifComponentContext : childLine.getChildren()) {
						((TCComponentBOMLine) aifComponentContext.getComponent()).cut();
					}				
				}
				
			}
		}
		routebom.save();
		routebom.unlock();
		routebom.refresh();
		if(routebom.getBOMView() != null)
		{
			routebom.getBOMView().save();
			routebom.getBOMView().refresh();
		}
		//ڶӹ 
		AIFComponentContext[] children = routebom.getChildren();
		for (AIFComponentContext aifComponentContext : children) {
			TCComponentBOMLine bomline = (TCComponentBOMLine) aifComponentContext.getComponent();
			String cid = bomline.getItem().getStringProperty("item_id");
			if(ssMap.containsKey(cid)) {
				ArrayList<TCComponentItemRevision> list = ssMap.get(cid);
				if(list != null && list.size() > 0) {
					itemType = (TCComponentItemType) session.getTypeService().getTypeComponent(list.get(0).getItem().getType());
					for (TCComponentItemRevision rev : list) {		
						if(rev.getType().equals("ZF6_SCXRevision")) {
							bomline.add(rev.getItem(),rev, null, false, "");	
						}else {
							TCComponentItem newSsItem = rev.saveAsItem(itemType.getNewID(), "");
							bomline.add(newSsItem, newSsItem.getLatestItemRevision(), null, false, "");	
						}
									
					}
				}			
			}
		}
		routebom.save();
		routebom.unlock();
		routebom.refresh();
		if(routebom.getBOMView() != null)
		{
			routebom.getBOMView().save();
			routebom.getBOMView().refresh();
		}
		window.save();
		window.unlock();
		window.refresh();
		//µĹ·߷ŵѡ
		tarRevision.add("ZF6_R_GYLX", newRev);
		MessageBox.post("Ƴɹ", "ʾ", 2);
		//ÿ
		idField.setText("");
		revField.setText("");
	}
	
	public void addData(JTable table,String[] columnNames) {
		DefaultTableModel tableModel = (DefaultTableModel) table
				.getModel();
		tableModel.setRowCount(0);
		RowSorter<TableModel> sorter = new TableRowSorter<TableModel>(tableModel);
		table.setRowSorter(sorter);
		for (int i = 0; i < dataVector.size(); i++) {
			tableModel.addRow(this.dataVector.get(i));
		}
		// ݲ޸
		table.setEnabled(true);
		// ±
		table.invalidate();
	}
	
	public JTreeTable getJTreeTable(JTreeTable partsTable, DefaultTableModel dtm, Object[] titleNames) {
		if (partsTable == null) {
			processModel = new JTreeTableModel(rootNode);
			List<Integer> isNotEditableRow = new ArrayList<Integer>();
			processModel.setIsNotEditableRow(isNotEditableRow);
			partsTable = new JTreeTable(processModel);
			partsTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			// partsTable.setRowHeight(1, 50);
			// partsTable.setRowHeight(2, 100);
			partsTable.setRowHeight(30);
			partsTable.expandAll(); // չȫڵ
			
			partsTable.setAutoResizeMode(JTable.AUTO_RESIZE_SUBSEQUENT_COLUMNS);// ñп
//			partsTable.getColumnModel().getColumn(0).setPreferredWidth(50); // õһп
//			partsTable.getColumnModel().getColumn(1).setPreferredWidth(50); // õһп
//			partsTable.getColumnModel().getColumn(2).setPreferredWidth(283); // õһп
//			partsTable.getColumnModel().getColumn(3).setPreferredWidth(283); // õһп		
			partsTable.setHighlighters(HighlighterFactory.createSimpleStriping());
		}
		return partsTable;
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		if(e.getClickCount() > 0)
		{
			// ѡ
			int selectColumn = processTable.getTableHeader().columnAtPoint(e.getPoint());
			if (selectColumn != 1) {
				return;
			}
			TreePath treePath = processTable.getPathForLocation(e.getX(), e.getY());
			if (treePath != null) {
              	DefaultMutableTreeTableNode node = (DefaultMutableTreeTableNode) treePath.getLastPathComponent();
              	NodeBean nodeBean = (NodeBean) node.getUserObject();

              	DefaultMutableTreeTableNode parentNode = (DefaultMutableTreeTableNode) node.getParent();          	
              	if(parentNode != null)
              	{
        			NodeBean parentNodeBean = (NodeBean) parentNode.getUserObject(); 
        			if(parentNodeBean.getLabel().equals("0") && nodeBean.getLabel().equals("0"))
                  	{
                  		MessageBox.post("ϲδѡ²㲻ѡ", "", MessageBox.ERROR);
      					return;
                  	}               
					try {
						if(nodeBean.getLabel().equals("0"))
	                  	{              		
	                  		nodeBean.setLabel("1");
	                  	}
	                  	else if(nodeBean.getLabel().equals("1"))
	                  	{
	                  		nodeBean.setLabel("0");
	                  		//isHaveBom(node, nodeBean.getEbomId(), "0", itemType);
	                  	}
						Robot robot = new Robot();
						robot.keyPress(KeyEvent.VK_TAB);
	                  	robot.keyRelease(KeyEvent.VK_TAB);
					} catch (AWTException e1) {						
						e1.printStackTrace();
					}
                  	
              	}
			}
		}
		
	}

	@Override
	public void mousePressed(MouseEvent paramMouseEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent paramMouseEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent paramMouseEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent paramMouseEvent) {
		// TODO Auto-generated method stub
		
	}
	
	/**
	 * ͨSOAΪITEM
	 * 
	 * @param session
	 *            Ự
	 * @param itemID
	 *            ID
	 * @param itemRev
	 *            İ汾
	 * @param itemType
	 *            
	 * @param itemName
	 *            
	 * @param itemDesc
	 *            
	 * @param unit
	 *            ĵλ
	 * @param itemPropMap
	 *            ITEM
	 * @param itemRevPropMap
	 *            İ汾
	 * @param itemRevMasterPropMap
	 *            İ汾
	 */
	public static TCComponentItem saveAsNewItemSoa(TCSession session,
			String itemID, String itemRev, String itemType, String itemName,
			String itemDesc) {
		TCComponentItem newComp = null;
		try {
			DataManagementService datamanagementservice = DataManagementService
					.getService(session);		
			//newComp = saveAsNewItemResponse.inputToNewItem
			SaveAsNewItemInfo info[] = new SaveAsNewItemInfo[1];

			info[0].description = itemDesc;
			info[0].newItemId = itemID;
			info[0].name = itemName;
			info[0].newRevId = itemRev;
			SaveAsNewItemResponse2 saveAsNewItemResponse = datamanagementservice.saveAsNewItem2(info);
			Map<String, SaveAsNewItemOutput2> saveAsOutputMap = saveAsNewItemResponse.saveAsOutputMap;
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("[item_id= " + itemID + " / rev =" + itemRev
					+ " / name= " + itemName + "]ʧ");
		}
		return newComp;
	}
	
	final String ITEMTYPE = "ZF6_GYLX";
	protected void updateLastUsedPref(String string) {
		try {
			//String string = (String) this.ruleBox.getSelectedItem();
			String string2 = "";// (String) this.revisionIdCombobox.getSelectedItem();
			boolean bl = false;
			boolean bl2 = false;
			String[] arrstring = new String[] { "item_id", "item_revision_id" };
			String[] arrstring2 = new String[] { ITEMTYPE, ITEMTYPE };
			NamingRule[] arrnamingRule = NamingRulesHelper.getInstance().getNamingRules(this.session, arrstring2, arrstring);
			String string3 = arrnamingRule[0].getCondition();
			String string4 = arrnamingRule[1].getCondition();
			if (string3 == null) {
				string3 = "";
			}
			if (string4 == null) {
				string4 = "";
			}
			bl = arrnamingRule[0].patternPresent(string);
			bl2 = arrnamingRule[1].patternPresent(string2);
			string = bl ? string : "";
			// string2 = bl2 ? (String) this.revisionIdCombobox.getSelectedItem() : "";
			StringBuilder stringBuilder = new StringBuilder();
			stringBuilder.append(string3);
			stringBuilder.append(":");
			stringBuilder.append(ITEMTYPE);
			stringBuilder.append(":");
			stringBuilder.append("item_id");
			stringBuilder.append(":");
			stringBuilder.append(string);
			String string5 = stringBuilder.toString();
			StringBuilder stringBuilder2 = new StringBuilder();
			stringBuilder2.append(string4);
			stringBuilder2.append(":");
			stringBuilder2.append(ITEMTYPE);
			stringBuilder2.append(":");
			stringBuilder2.append("item_revision_id");
			stringBuilder2.append(":");
			stringBuilder2.append(string2);
			String string6 = stringBuilder2.toString();
			String[] arrstring3 = null;
			if (string2.equals("") && !string.equals("")) {
				arrstring3 = new String[] { string5 };
			} else if (!string2.equals("") && string.equals("")) {
				arrstring3 = new String[] { string6 };
			} else if (!string2.equals("") && !string.equals("")) {
				arrstring3 = new String[] { string5, string6 };
			}
			if (arrstring3 != null) {
				// this.prefService = this.session.getPreferenceService();
				String[] arrstring4 = session.getPreferenceService().getStringArray(1, "TC_LAST_USED_PATTERNS");
				ArrayList<String> arrayList = new ArrayList<String>();
				int n = 0;
				int n2 = 0;
				int n3 = 0;
				int n4 = 0;
				while (n4 < arrstring4.length) {
					String string7 = arrstring4[n4];
					if (!string7.equals("")) {
						StringTokenizer stringTokenizer = new StringTokenizer(string7, ":");
						stringTokenizer.nextToken();
						String string8 = stringTokenizer.nextToken();
						String string9 = stringTokenizer.nextToken();
						if (ITEMTYPE.equals(string8)) {
							++n;
							if (string9.equals("item_id") && arrstring3[0] != null) {
								arrayList.add(n4, arrstring3[0]);
								++n2;
							}
							if (string9.equals("item_revision_id")) {
								if (arrstring3.length == 1 && arrstring3[0] != null) {
									arrayList.add(n4, arrstring3[0]);
									++n3;
								}
								if (arrstring3.length > 1 && arrstring3[1] != null) {
									arrayList.add(n4, arrstring3[1]);
									++n3;
								}
							}
						} else {
							arrayList.add(n4, arrstring4[n4]);
						}
					}
					++n4;
				}
				n4 = 0;
				n4 = arrstring4.length == 1 && arrstring4[0].equals("") ? 0 : arrstring4.length;
				int n5 = 0;
				int n6 = 0;
				int n7 = 0;
				while (n7 < arrstring3.length) {
					if (n < 1 && n2 < 1 && n3 < 1) {
						arrayList.add(n4, arrstring3[n7]);
						++n4;
					}
					if (n2 > 0 && n3 < 1 && !string2.equals("") && n5 == 0) {
						arrayList.add(n4, arrstring3[1]);
						++n5;
					}
					if (n3 > 0 && n2 < 1 && !string.equals("") && n6 == 0) {
						arrayList.add(n4, arrstring3[0]);
						++n6;
					}
					++n7;
				}
				String[] arrstring5 = arrayList.toArray(new String[arrayList.size()]);
				session.getPreferenceService().setStringArray(1, "TC_LAST_USED_PATTERNS", arrstring5);
			}
		} catch (TCException tCException) {
		}
	}

	public void getAssignedIds() {
		TCComponentItemType tCComponentItemType = null;
		boolean bl = true;
		boolean bl2 = true;
		try {
			tCComponentItemType = (TCComponentItemType) this.session.getTypeComponent(ITEMTYPE);
			DataManagementService dataManagementService = DataManagementService.getService((TCSession) this.session);
			RevisionNamingRuleHelper.getInstance().loadRevNamingRuleDetails(this.session, ITEMTYPE, null);
			int[] arrn = RevisionNamingRuleHelper.getInstance().getRevisionNamingRuleFormats();
			int n = arrn[0];
			int n2 = arrn[1];
			if (this.idField.getText().length() == 0) {
				DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties[] arrgenerateItemIdsAndInitialRevisionIdsProperties = new DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties[] {
						new DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties() };
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].item = null;
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].itemType = ITEMTYPE;
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].count = 1;
				DataManagement.GenerateItemIdsAndInitialRevisionIdsResponse generateItemIdsAndInitialRevisionIdsResponse = dataManagementService
						.generateItemIdsAndInitialRevisionIds(arrgenerateItemIdsAndInitialRevisionIdsProperties);
				if (generateItemIdsAndInitialRevisionIdsResponse.serviceData.sizeOfPartialErrors() > 0) {
					this.idField.setText("");
					this.idField.requestFocusInWindow();
					TCExceptionPartial tCExceptionPartial = SoaUtil.checkPartialErrorsNoThrow((com.teamcenter.soa.client.model.ServiceData) generateItemIdsAndInitialRevisionIdsResponse.serviceData);
					MessageBox.post(this, (Throwable) tCExceptionPartial);
					return;
				}
				String string = null;
				String string2 = null;
				Map map = generateItemIdsAndInitialRevisionIdsResponse.outputItemIdsAndInitialRevisionIds;
				Iterator iterator = map.entrySet().iterator();
				if (iterator.hasNext()) {
					Map.Entry entry = (Entry) iterator.next();
					DataManagement.ItemIdsAndInitialRevisionIds[] arritemIdsAndInitialRevisionIds = (DataManagement.ItemIdsAndInitialRevisionIds[]) entry.getValue();
					DataManagement.ItemIdsAndInitialRevisionIds itemIdsAndInitialRevisionIds = arritemIdsAndInitialRevisionIds[0];
					string = itemIdsAndInitialRevisionIds.newItemId;
					if (n != 0) {
						/*
						 * if (n2 == 0) { this.assignRevIdWithRevisionRule(); }
						 */
					} else {
						string2 = itemIdsAndInitialRevisionIds.newRevId;
						this.revField.setText(string2);
					}
					bl = itemIdsAndInitialRevisionIds.isItemModify;
					bl2 = itemIdsAndInitialRevisionIds.isRevModify;
				}
				this.idField.setText(string);
				return;
			}
			boolean bl3 = true;
			// bl3 = this.validateId();
			/*
			 * if (!bl3) { this.idField.setText(""); this.idField.requestFocusInWindow();
			 * return; }
			 */
			if (n != 0) {
				if (n2 == 0) {
					// this.assignRevIdWithRevisionRule();
				}
			} else {
				String string = tCComponentItemType.getNewRev(null);
				bl2 = tCComponentItemType.isNewRevModifiable(null, string);
				this.revField.setText(string);
			}
			if (!bl2) {
				this.revField.setEditable(false);
			}
		} catch (TCException tCException) {
			MessageBox.post((Window) this, (Throwable) tCException);
		}
	}
}
