package com.connor.zf.plm002;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class CopyProcessRouteHandler extends AbstractHandler{

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();
		TCSession session = (TCSession) app.getSession();
		InterfaceAIFComponent targetComponent = app.getTargetComponent();
		if("ZF6_LBJRevision".equals(targetComponent.getType()) || "ZF6_YZRevision".equals(targetComponent.getType())
				|| "ZF6_YCLRevision".equals(targetComponent.getType())) {
			new CopyProcessRouteDialog(session, targetComponent,targetComponent.getType());
		}else {
			MessageBox.post("ѡȷİ汾!!!", "", MessageBox.ERROR);
			return null;
		}
		return null;
	}
	
}
