package com.connor.zf.plm003;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class CreateToolingHandler extends AbstractHandler{

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();
		TCSession session = (TCSession) app.getSession();
		String preValue = session.getPreferenceService().getStringValue("ZF6_GZSJ_Type");
		InterfaceAIFComponent targetComponent = app.getTargetComponent();
		if(!preValue.contains(targetComponent.getType())) {
			MessageBox.post("ѡпװĶ汾!!!", "", MessageBox.ERROR);
			return null;
		}
		
		new CreateToolingDialog(session, targetComponent);
		return null;
	}

}
