package com.connor.zf.plm003;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import javax.xml.bind.JAXBException;

import com.connor.zf.plm.xmlUtil.CNCompontent;
import com.connor.zf.plm.xmlUtil.CNPart;
import com.connor.zf.plm.xmlUtil.CNPartList;
import com.connor.zf.plm.xmlUtil.CNProperty;
import com.connor.zf.plm.xmlUtil.CNXmlUtil;


public class Test {
	public static void main(String[] args) throws JAXBException, IOException {
		String filePath = "C:\\Users\\admin\\Desktop\\\\XML\\.xml";
		Object object = CNXmlUtil.xmlToBean(filePath, CNPartList.class);
		CNPartList parts = (CNPartList) object;
		List<CNPart> partList = parts.getPartList();

		for (int i = 0; i < partList.size(); i++) {
			System.out.println(partList.get(i).getType());
			for (CNCompontent comp : partList.get(i).getCompontentList()) {
				System.out.println(comp.getType());
				System.out.println(comp.getCompententType());
				for (CNProperty prop : comp.getPropertyList()) {
					System.out.println(prop.getDisplayName());
				}
			}
		}
		
		String newSeq = "001000";
		newSeq = newSeq.replaceFirst("^0*", "");
		System.out.println(newSeq);
		
		 HashMap<String, String> itemProMap = new HashMap<String, String>();
		 itemProMap.put("1", "");
		 itemProMap.put("2", "");
		 System.out.println(itemProMap.get("1"));
	}
}
