package com.connor.zf.util;

import java.util.List;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axiom.om.OMNamespace;
import org.apache.axis2.AxisFault;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Options;
import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.transport.http.HTTPConstants;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCAccessControlService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCComponentUserType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.TCUserService;

//import net.sf.json.JSONArray;

/**
 * ͷUtil
 * @author 61666
 *
 */
public class SoaServerUtil {

	public static void sendToClass(String wsoPUID, String classID, String json, String url) {
		// AbstractAIFApplication app;
		// app=AIFUtility.getCurrentApplication();
		// TCSession session;
		// session=(TCSession) app.getSession();
		// TCPreferenceService preferenceService;
		// preferenceService=session.getPreferenceService();
		// String account=preferenceService.getStringValue("Autocode_PriverUser_ID");
		// String url;
		// url = preferenceService.getStringValue("Autocode_SendClassServer_URL");
		try {
			ServiceClient sc = new ServiceClient();
			Options opts = new Options();
			// url = "http://10.201.5.203:19090/ErpWebService.asmx?WSDL";
			EndpointReference end = new EndpointReference(url);
			opts.setTo(end);
			opts.setAction("SendToClass");
			sc.setOptions(opts);

			OMFactory fac = OMAbstractFactory.getOMFactory();
			OMNamespace omNs = fac.createOMNamespace("http://tempuri.org/", "");
			OMElement method = fac.createOMElement("SendToClass", omNs);
			OMElement value = fac.createOMElement("wsoPuiid", omNs);
			value.setText(wsoPUID);
			OMElement value1 = fac.createOMElement("classID", omNs);
			value1.setText(classID);
			OMElement value2 = fac.createOMElement("JsonContainer", omNs);
			// "[{\"value\":\"1\",\"propertyID\":-500003},{\"value\":\"1\",\"propertyID\":-500011}]"
			value2.setText(json);

			method.addChild(value);
			method.addChild(value1);
			method.addChild(value2);

			OMElement res = sc.sendReceive(method);
			res.getFirstElement().getText();
			System.out.println(res.getFirstElement().getText());
		} catch (AxisFault e) {
			e.printStackTrace();
		}

	}
	
	public static String updateToClass(String wsoPUID, String classID, String json, String url, String icoUid) {
		// AbstractAIFApplication app;
		// app=AIFUtility.getCurrentApplication();
		// TCSession session;
		// session=(TCSession) app.getSession();
		// TCPreferenceService preferenceService;
		// preferenceService=session.getPreferenceService();
		// String account=preferenceService.getStringValue("Autocode_PriverUser_ID");
		// String url;
		// url = preferenceService.getStringValue("Autocode_SendClassServer_URL");
		String reMsgString="";
		try {
			ServiceClient sc = new ServiceClient();
			Options opts = new Options();
			// url = "http://10.201.5.203:19090/ErpWebService.asmx?WSDL";
			EndpointReference end = new EndpointReference(url);
			opts.setTo(end);
			opts.setAction("UpdateToClass");
			sc.setOptions(opts);

			OMFactory fac = OMAbstractFactory.getOMFactory();
			OMNamespace omNs = fac.createOMNamespace("http://tempuri.org/", "");
			OMElement method = fac.createOMElement("UpdateToClass", omNs);
			OMElement value = fac.createOMElement("wsoPuiid", omNs);
			value.setText(wsoPUID);
			OMElement value1 = fac.createOMElement("classID", omNs);
			value1.setText(classID);
			OMElement value2 = fac.createOMElement("JsonContainer", omNs);
			
			OMElement value3 = fac.createOMElement("icoPUID", omNs);
			// "[{\"value\":\"1\",\"propertyID\":-500003},{\"value\":\"1\",\"propertyID\":-500011}]"
			value2.setText(json);
			value3.setText(icoUid);
			
			method.addChild(value);
			method.addChild(value1);
			method.addChild(value2);
			method.addChild(value3);
			OMElement res = sc.sendReceive(method);
			reMsgString=res.getFirstElement().getText();
			System.out.println(res.getFirstElement().getText());
			
		} catch (AxisFault e) {
			e.printStackTrace();
		}
		
		return reMsgString;

	}
	public static void deleteAndSendToClass(String icoPUID,String wsoPUID, String classID, String json, String url) {
		// AbstractAIFApplication app;
		// app=AIFUtility.getCurrentApplication();
		// TCSession session;
		// session=(TCSession) app.getSession();
		// TCPreferenceService preferenceService;
		// preferenceService=session.getPreferenceService();
		// String account=preferenceService.getStringValue("Autocode_PriverUser_ID");
		// String url;
		// url = preferenceService.getStringValue("Autocode_SendClassServer_URL");
		try {
			ServiceClient sc = new ServiceClient();
			Options opts = new Options();
			// url = "http://10.201.5.203:19090/ErpWebService.asmx?WSDL";
			EndpointReference end = new EndpointReference(url);
			opts.setTo(end);
			opts.setAction("SendToClass");
			sc.setOptions(opts);

			OMFactory fac = OMAbstractFactory.getOMFactory();
			OMNamespace omNs = fac.createOMNamespace("http://tempuri.org/", "");
			OMElement method = fac.createOMElement("editToClass", omNs);
			OMElement icovalue = fac.createOMElement("icoPUID", omNs);
			icovalue.setText(icoPUID);
			OMElement value = fac.createOMElement("wsoPuiid", omNs);
			value.setText(wsoPUID);
			OMElement value1 = fac.createOMElement("classID", omNs);
			value1.setText(classID);
			OMElement value2 = fac.createOMElement("JsonContainer", omNs);
			// "[{\"value\":\"1\",\"propertyID\":-500003},{\"value\":\"1\",\"propertyID\":-500011}]"
			value2.setText(json);
			method.addChild(icovalue);
			method.addChild(value);
			method.addChild(value1);
			method.addChild(value2);

			OMElement res = sc.sendReceive(method);
			res.getFirstElement().getText();
			System.out.println(res.getFirstElement().getText());
		} catch (AxisFault e) {
			e.printStackTrace();
		}

	}
	// public static void main(String[] args) {
	// deleteClass("1111", "");
	// }
	// ɾʱ
	public static void deleteClass(String icoPUID, String url) {
		try {
			ServiceClient sc = new ServiceClient();
			Options opts = new Options();
			// url = "http://10.201.5.203:19090/ErpWebService.asmx?WSDL";//TODO
			// ѡAutocode_SendClassServer_URL
			// url = preferenceService.getStringValue("Autocode_SendClassServer_URL");//TODO
			// ѡAutocode_SendClassServer_URL
			EndpointReference end = new EndpointReference(url);
			opts.setTo(end);
			opts.setAction("DeleteClass");
			opts.setProperty(HTTPConstants.CHUNKED, "false");
			sc.setOptions(opts);

			OMFactory fac = OMAbstractFactory.getOMFactory();
			OMNamespace omNs = fac.createOMNamespace("http://tempuri.org/", "");
			OMElement method = fac.createOMElement("DeleteClass", omNs);
			OMElement value = fac.createOMElement("icoPuid", omNs);
			value.setText(icoPUID);
			// OMElement value1 = fac.createOMElement("classID", omNs);
			//// value1.setText(classID);
			// OMElement value2 = fac.createOMElement("JsonContainer", omNs);
			// "[{\"value\":\"1\",\"propertyID\":-500003},{\"value\":\"1\",\"propertyID\":-500011}]"
			// value2.setText(json);

			method.addChild(value);
			// method.addChild(value1);
			// method.addChild(value2);

			OMElement res = sc.sendReceive(method);
			res.getFirstElement().getText();
			System.out.println(res.getFirstElement().getText());
		} catch (AxisFault e) {
			e.printStackTrace();
		}

	}

//	public static String objectToJson(List<ClassProperty> props) {
//		String str = null;
//		try {
//			JSONArray json = JSONArray.fromObject(props);// javaתΪjson
//			str = json.toString();// jsonתΪַ
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		System.out.println("JSON =>" + str);
//		return str;
//	}

	public static void grantReadPrivilege(TCSession tcSession, TCComponent tccomponent) {
		AbstractAIFApplication app;
		app = AIFUtility.getCurrentApplication();
		TCSession session;
		session = (TCSession) app.getSession();
		TCPreferenceService preferenceService;
		preferenceService = session.getPreferenceService();
		String account = preferenceService.getStringValue("Autocode_PriverUser_ID");
		try {
			TCAccessControlService accessControlService = tcSession.getTCAccessControlService();
			TCComponentUserType type = (TCComponentUserType) tcSession.getTypeComponent("User");
			TCComponentUser user = type.find(account);

			if (user == null) {
				return;
			}
			if (tcSession.getUser().equals(user)) {
				return;
			}

			String[] as2 = new String[] { "READ" };

			if (tccomponent instanceof TCComponentItemRevision) {
				TCComponentItem tempItem = ((TCComponentItemRevision) tccomponent).getItem();
				openByPass(tcSession);
				accessControlService.grantPrivilege(tempItem, user, as2);
				closeByPass(tcSession);

				openByPass(tcSession);
				accessControlService.grantPrivilege(tccomponent, user, as2);
				closeByPass(tcSession);
			} else {
				openByPass(tcSession);
				accessControlService.grantPrivilege(tccomponent, user, as2);
				closeByPass(tcSession);
			}
		} catch (TCException e) {
			e.printStackTrace();
		}
	}

	public static void grantWritePrivilege(TCSession tcSession, TCComponent tccomponent) {
		AbstractAIFApplication app;
		app = AIFUtility.getCurrentApplication();
		TCSession session;
		session = (TCSession) app.getSession();
		TCPreferenceService preferenceService;
		preferenceService = session.getPreferenceService();
		String account = preferenceService.getStringValue("Autocode_PriverUser_ID");
		try {
			TCAccessControlService accessControlService = tcSession.getTCAccessControlService();
			TCComponentUserType type = (TCComponentUserType) tcSession.getTypeComponent("User");

			TCComponentUser user = type.find(account);
			if (user == null) {
				return;
			}
			if (tcSession.getUser().equals(user)) {
				return;
			}

			String[] as2 = new String[] { "READ", "WRITE", "DELETE" };

			if (tccomponent instanceof TCComponentItemRevision) {
				TCComponentItem tempItem = ((TCComponentItemRevision) tccomponent).getItem();
				setByPass(true,tcSession);
				accessControlService.grantPrivilege(tempItem, user, as2);
				setByPass(false,tcSession);

				setByPass(true,tcSession);
				accessControlService.grantPrivilege(tccomponent, user, as2);
				setByPass(false,tcSession);
			} else {
				setByPass(true,tcSession);
				accessControlService.grantPrivilege(tccomponent, user, as2);
				setByPass(false,tcSession);
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void openByPass(TCSession session) throws TCException {
		TCUserService userservice = session.getUserService();
		Object[] obj = new Object[1];
		obj[0] = "";
		userservice.call("Connor_set_bypass", obj);
	}

	public static void closeByPass(TCSession session) throws TCException {
		TCUserService userservice = session.getUserService();
		Object[] obj = new Object[1];
		obj[0] = "";
		userservice.call("Connor_close_bypass", obj);
		
//		session.getUserService().call("Connor_set_bypass", new Object[]{});//bypass
//		session.getUserService().call("Connor_close_bypass", new Object[]{});//bypass
	}
	public static void setByPass(boolean val,TCSession session) throws TCException {
		TCUserService userservice = session.getUserService();
		if (userservice == null) {
			userservice = session.getUserService();
		}
		Object[] obj = new Object[1];
		obj[0] = "origin";
		if (val) {
//			userservice.call("ORIGIN_set_bypass", obj);
			userservice.call("Connor_set_bypass", obj);
		} else {
//			userservice.call("ORIGIN_close_bypass", obj);
			userservice.call("Connor_close_bypass", obj);
		}
	}

}

