package com.connor.zf.zygyk;

import java.awt.Checkbox;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JTextPane;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.EventListenerList;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

import com.teamcenter.rac.util.MessageBox;

public class TableCellCheckboxRenderer extends JCheckBox implements
		TableCellRenderer {
	private List<Integer> processRows;
	protected EventListenerList listenerList = new EventListenerList();
	protected ChangeEvent changeEvent = new ChangeEvent(this);
	private CTMap tableModel;
	private JTableHeader tableHeader;

	public List<Integer> getProcessRows() {
		return processRows;
	}

	public void setProcessRows(List<Integer> processRows) {
		this.processRows = processRows;
	}

	public TableCellCheckboxRenderer(final CTable table) {
		this.tableModel = (CTMap) table.getModel();
        this.tableHeader = table.getTableHeader();
        this.setName("4");
       // selectBox = new JCheckBox(tableModel.getColumnName(1));
        this.setSelected(false);
        tableHeader.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                if (e.getClickCount() > 0) {
                    // ѡ
                    int selectColumn = tableHeader.columnAtPoint(e.getPoint());
                    if (table.getColumnName(selectColumn).equals("4")) {
                        boolean value = !TableCellCheckboxRenderer.this.isSelected();
                        TableCellCheckboxRenderer.this.setSelected(value);
                        table.selectAllOrNull(value ? "1" : "0");
                        tableHeader.repaint();
                    }
                }
            }
        });
	}

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		// TODO Auto-generated method stub
//		if(value != null)
//		{
//			String valueStr = (boolean)value ? "true" : "false";
//			//System.out.println(valueStr);
//	        JLabel label = new JLabel(valueStr);
//	        label.setHorizontalAlignment(SwingConstants.CENTER); // ͷǩ
//	        this.setHorizontalAlignment(SwingConstants.CENTER);// ͷǩ
//	        this.setBorderPainted(true);
//	        this.setSelected((boolean)value);
//		}
//		else
//		{
//			String valueStr = (String) value;
//	        JLabel label = new JLabel(valueStr);
//	        label.setHorizontalAlignment(SwingConstants.CENTER); // ͷǩ
//	        this.setHorizontalAlignment(SwingConstants.CENTER);// ͷǩ
//	        this.setBorderPainted(true);
//			this.setSelected(false);
//		}
//		String valueStr = (String) value;
//        JLabel label = new JLabel(valueStr);
//        label.setHorizontalAlignment(SwingConstants.CENTER); // ͷǩ
        this.setHorizontalAlignment(SwingConstants.CENTER);// ͷǩ
        this.setBorderPainted(true);
        if(value != null)
        {
        	this.setSelected(value.toString().equals("1"));
        }
        else
        {
        	this.setSelected(false);
        }
//		if()
//		String valueStr = (String) value;
//        JLabel label = new JLabel(valueStr);
//        label.setHorizontalAlignment(SwingConstants.CENTER); // ͷǩ
//        this.setHorizontalAlignment(SwingConstants.CENTER);// ͷǩ
//        this.setBorderPainted(true);
		return this;
	}
	/** 
	* 鿴һַǷתΪ 
	* @param str ַ 
	* @return true ; false  
	*/  
	public boolean isStr2Num(String str) {   
		try {  
		    Integer.parseInt(str);  
		    return true;  
		} catch (NumberFormatException e) {  
		    return false;  
		}  
	}  
}